//
//  CameraFactory.swift
//  Runner
//
//  Created by Yayan Dwi on 24/04/20.
//  Copyright © 2020 The Chromium Authors. All rights reserved.
//

import Foundation

class CameraFactory : NSObject, FlutterPlatformViewFactory {
    
    var plugin : SwiftPalioLitePlugin?
    
    init(plugin: SwiftPalioLitePlugin) {
        self.plugin = plugin
    }
    
    func create(withFrame frame: CGRect, viewIdentifier viewId: Int64, arguments args: Any?) -> FlutterPlatformView {
        let cameraView = CameraView(cameraView: UIImageView(frame: frame), id: viewId)
//        let screenSize: CGRect = UIScreen.main.bounds
//        let screenWidth = screenSize.width
//        let screenHeight = screenSize.height
//        let viewWidth = screenWidth/3
//        let viewHeight = 4/3*viewWidth
//        cameraView.cameraView?.translatesAutoresizingMaskIntoConstraints = true
//        cameraView.cameraView?.heightAnchor.constraint(equalToConstant: screenHeight).isActive = true
//        cameraView.cameraView?.widthAnchor.constraint(equalToConstant: screenWidth).isActive = true
//        cameraView.cameraView?.contentMode = .scaleAspectFill
//        cameraView.cameraView?.layer.cornerRadius = 5
//        cameraView.cameraView?.clipsToBounds = true
//        cameraView.cameraView?.isHidden = true
        plugin?.cameraView = cameraView
        print("Camera View Created")
        return cameraView
    }
    
}
