import 'dart:io';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter_translate/flutter_translate.dart';
import 'package:fluttertoast/fluttertoast.dart';
import 'package:path_provider/path_provider.dart';
import 'package:provider/provider.dart';

// import 'package:un_ios_app/Widget/widget_Image_Download.dart';
// import 'package:un_ios_app/api.dart';
import 'package:palio_lite/app_color.dart';
// import 'package:un_ios_app/db_helper.dart';

class ChangeState with ChangeNotifier {
  List<Map<dynamic, dynamic>> _dataContact = [];

  List<Map<dynamic, dynamic>> _srcContact = [];

  List<Map<dynamic, dynamic>> get dataContact => _dataContact;

  List<Map<dynamic, dynamic>> get getSrcContact => _srcContact;

  set dataContact(List<Map<dynamic, dynamic>> value) {
    _dataContact.addAll(value);
    notifyListeners();
  }

  set srcContact(Map<dynamic, dynamic> value) {
    _srcContact.add(value);
    notifyListeners();
  }

  set removeSrcContact(int value) {
    _srcContact.removeAt(value);
    notifyListeners();
  }

  set clearSrcContact(bool value) {
    _srcContact.clear();
    notifyListeners();
  }

  set addAllSrcContact(List<Map<dynamic, dynamic>> value) {
    _srcContact.addAll(value);
    notifyListeners();
  }
}

class AddMemberGroup extends StatelessWidget {
  final String idGroup;
  final List<Map<String, dynamic>> fPinAdd;

  AddMemberGroup({required this.idGroup, required this.fPinAdd});

  @override
  Widget build(BuildContext context) {
    return ChangeNotifierProvider(
      create: (_) => ChangeState(),
      child: Consumer<ChangeState>(
        builder: (context, changeState, _) =>
            AddMemberGroups(changeState, fPinAdd, idGroup),
      ),
    );
  }
}

class AddMemberGroups extends StatefulWidget {
  final ChangeState changeState;
  final String idGroup;
  final List<Map<String, dynamic>> fPinAdd;

  AddMemberGroups(this.changeState, this.fPinAdd, this.idGroup);

  _AddMemberGroups createState() => _AddMemberGroups();
}

class _AddMemberGroups extends State<AddMemberGroups> {
  TextEditingController _editingController = new TextEditingController();

  _searchPerson(name) async {
    if (name.toString().isNotEmpty) {
      widget.changeState.clearSrcContact = true;
      for (int i = 0; i < widget.changeState.dataContact.length; i++) {
        if (widget.changeState.dataContact[i]["name"]
            .toLowerCase()
            .contains(name.toLowerCase())) {
          widget.changeState.srcContact = widget.changeState.dataContact[i];
        }
      }
    } else {
      widget.changeState.clearSrcContact = true;
      widget.changeState.addAllSrcContact = widget.changeState.dataContact;
    }
  }

  @override
  void initState() {
    getData();
    super.initState();
  }

  void getData() async {
    // var resultQuery = await DBHelper().queryCustom(
    //     "SELECT f_pin, first_name,last_name, image_id FROM BUDDY where official_account<>'1' and type <> '1' and f_pin <> '02121368af'");
    var resultQuery = [
      {"first_name": "aaaaaaxa", "f_pin": "1", "image": "a"},
      {"first_name": "bbb", "f_pin": "2", "image": "b"},
      {"first_name": "ccc", "f_pin": "3", "image": "c"}
    ];
    List<Map<dynamic, dynamic>> temporary = [];
    for (var i = 0; i < resultQuery.length; i++) {
      bool has = false;
      for (var j = 0; j < widget.fPinAdd.length; j++) {
        if (widget.fPinAdd[j]["id"] == resultQuery[i]["f_pin"]) {
          has = true;
          break;
        }
      }
      if (!has) {
        temporary.add({
          "name": resultQuery[i]["first_name"],
          "picture": resultQuery[i]["image_id"],
          "f_pin": resultQuery[i]["f_pin"]
        });
      }
    }
    temporary.sort((a, b) => (a["name"]).compareTo(b["name"]));
    widget.changeState.addAllSrcContact = temporary;
    widget.changeState.dataContact = temporary;
  }

  @override
  Widget build(BuildContext context) {
    return Material(
      child: Container(
        child: Column(
          children: <Widget>[
            Row(
              mainAxisAlignment: MainAxisAlignment.start,
              children: [
                Padding(
                  padding: EdgeInsets.all(10),
                  child: Align(
                    alignment: Alignment.centerLeft,
                    child: InkWell(
                        onTap: () {
                          Navigator.pop(context);
                        },
                        child: Icon(Icons.arrow_back_ios)),
                  ),
                ),
                Padding(
                  padding: EdgeInsets.all(10),
                  child: Align(
                    alignment: Alignment.centerLeft,
                    child: Text(
                      "Add new member",
                      style: TextStyle(fontSize: 18),
                    ),
                  ),
                ),
              ],
            ),
            Container(
              decoration: BoxDecoration(
                  color: Colors.grey[100],
                  border: Border(
                      bottom:
                          BorderSide(color: Colors.grey[200]!, width: 2.0))),
              padding: EdgeInsets.all(2.0),
              child: Row(
                mainAxisAlignment: MainAxisAlignment.spaceAround,
                children: <Widget>[
                  Container(
                    width: MediaQuery.of(context).size.width * 0.75,
                    child: Theme(
                      child: TextField(
                          controller: _editingController,
                          onChanged: (val) async {
                            await _searchPerson(val);
                          },
                          cursorColor: AppColor.primaryColor,
                          decoration: InputDecoration(
                              filled: true,
                              fillColor: Colors.white,
                              contentPadding: EdgeInsets.all(5.0),
                              prefixIcon: Icon(Icons.search),
                              focusedBorder: OutlineInputBorder(
                                  borderRadius: BorderRadius.circular(3.0),
                                  borderSide: BorderSide(color: Colors.grey)),
                              border: OutlineInputBorder(
                                  borderRadius: BorderRadius.circular(3.0),
                                  borderSide: BorderSide(color: Colors.grey)))),
                      data:
                          Theme.of(context).copyWith(primaryColor: Colors.grey),
                    ),
                  )
                ],
              ),
            ),
            Flexible(
              child: ListView.builder(
                  itemCount: widget.changeState.getSrcContact.length,
                  itemBuilder: (builder, index) {
                    var data = widget.changeState.getSrcContact[index];
                    return ListTile(
                      leading: Container(
                        width: 40,
                        height: 40,
                        decoration: BoxDecoration(
                            shape: BoxShape.circle, color: Colors.grey),
                      ),
                      title: Text(data["name"]),
                      onTap: () async {
                        // var respond = await API.addGroupMember(
                        //     widget.idGroup, data["f_pin"]);
                        // if (respond == "00") {
                        //   widget.changeState.removeSrcContact = index;
                        // }
                      },
                    );
                  }),
            )
          ],
        ),
      ),
    );
  }
}
