import 'dart:async';
import 'dart:collection';
import 'dart:math';
import 'dart:ui';

import 'package:fading_edge_scrollview/fading_edge_scrollview.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter_translate/flutter_translate.dart';
import 'package:fluttertoast/fluttertoast.dart';
import 'package:page_transition/page_transition.dart';
import 'package:palio_lite/api.dart';
import 'package:palio_lite/app_color.dart';
import 'package:palio_lite/call/widgets/zoom.dart';
import 'package:palio_lite/call/widgets/bubble_vc.dart';
import 'package:palio_lite/call/widgets/camera.dart';
import 'package:palio_lite/call/widgets/editor_vc.dart';
import 'package:palio_lite/call/widgets/remote.dart';
import 'package:palio_lite/chat/widgets/widget_Image_Download.dart';
import 'package:palio_lite/db_helper.dart';
import 'package:shared_preferences/shared_preferences.dart';

import '../shared_obj.dart';
import 'add_call.dart';

class VideoCall extends StatefulWidget {
  String name;
  final String deviceId;
  final String cameraId;
  final int isInitiatior;
  final String image;
  final bool isContactCenter;

  VideoCall(
      {required this.name,
      required this.deviceId,
      required this.cameraId,
      required this.isInitiatior,
      required this.image,
      this.isContactCenter = false});

  _VideoCall createState() => _VideoCall();
}

class _VideoCall extends State<VideoCall> {
  int sizeFlag = 3;
  bool muted = false,
      backCam = false,
      accept = false,
      speaker = true,
      end = false,
      busy = false,
      vibrate = false;
  int? isInitiator;
  var _videoCallIndex = <int>[];
  String textHistory = "";
  static const MAX_DEST = 3;

  bool first = true;
  final _infoStrings = <String>[];
  LinkedHashSet<String> destinationList = LinkedHashSet();
  LinkedHashSet<String> nameList = LinkedHashSet();
  List<dynamic> personData = [];
  Timer? _timer;
  String subTitle = 'Video Call';
  String duration = "";
  double animatedWidth = 120.0;
  double opac = 1.0;

  ScrollController _controller = ScrollController();
  List<Map<dynamic, dynamic>> samplemessages = [];

  String title = "";

  _getPersonData() async {
    personData = await DBHelper().queryCustom(
        "SELECT f_pin, first_name, last_name, image_id,connected, offline_mode FROM BUDDY");
  }

  Future<void> setVideoCallFlag(int flag) async {
    final SharedPreferences prefs = await SharedPreferences.getInstance();
    prefs.setInt("isVideoCall", flag);
  }

  Future<String> getFPIN() async {
    final SharedPreferences prefs = await SharedPreferences.getInstance();
    return prefs.getString('hasLogin')!;
  }

  void statusCall() {
    API.statusCall = (int state, String message) async {
      if (mounted) {
        switch (state) {
          case 32:
            if (destinationList.length < MAX_DEST) {
              String deviceId = message.split(",")[1];
              for (int i = 0; i < personData.length; i++) {
                if (personData[i]['f_pin'] == deviceId &&
                    !destinationList.contains(personData[i]['f_pin'])) {
                  destinationList.add(personData[i]['f_pin']);
                  nameList.add(personData[i]["first_name"]);
                }
              }
            }
            print("Add Destination Length : " +
                destinationList.length.toString());
            setState(() {});
            title = "Connected";

            setState(() {
              accept = true;
            });
            break;

          case 38:
            print("Destination Length : " + destinationList.length.toString());
            String deviceId = message.split(",")[0];
            print("Device id : " + deviceId);
            String myFpin = await getFPIN();
            String attachmentFlag;
            if (textHistory == null && state == 38) {
              textHistory = "Incoming Video Call";
              attachmentFlag = "12";
            } else {
              textHistory = "Missed Video Call";
              attachmentFlag = "19";
            }
            var result;
            if (deviceId != myFpin && widget.isInitiatior == 1) {
              result = await API.sendMessage(
                  lPin: deviceId,
                  messageText: textHistory,
                  attachmentFlag: attachmentFlag,
                  messageScopeId: "3",
                  status: "2");
            }
            if (deviceId != myFpin) {
              if (destinationList.length >= 2) {
                for (int i = 0; i < personData.length; i++) {
                  if (personData[i]['f_pin'] == deviceId) {
                    destinationList.remove(personData[i]["f_pin"]);
                    nameList.remove(personData[i]["first_name"]);
                    if (mounted) {
                      setState(() {});
                    }
                  }
                }
              } else if ((destinationList.length == 1 &&
                      destinationList.contains(deviceId)) ||
                  destinationList.length == 0) {
                title = 'End Calling';
                SharedObj.stopRingtone();
                SharedObj.clearNotificationCall();
                end = true;
                if (mounted) {
                  setState(() {});
                }

                Future.delayed(Duration(seconds: 1), () {
                  if (mounted) {
                    if (_timer != null) {
                      _timer?.cancel();
                    }
                    API.terminateCall(deviceId);
                    Navigator.of(context).pop({
                      "messageId": result,
                      "textHistory": "$textHistory",
                      "attachmentFlag": "$attachmentFlag"
                    });
                  }
                });
              }
            }
            break;
          case -4:
          case 28:
            print("Destination Length : " + destinationList.length.toString());
            String deviceId = message.split(",")[0];
            print("Device id : " + deviceId);
            String attachmentFlag;
            if (textHistory == null && state == 28) {
              textHistory = "Incoming Video Call";
              attachmentFlag = "12";
            } else if (textHistory == null && state == -4) {
              textHistory = "Missed Video Call";
              attachmentFlag = "19";
            } else {
              attachmentFlag = "19";
            }
            String myFpin = await getFPIN();
            var result;
            if (deviceId != myFpin && widget.isInitiatior == 1) {
              result = await API.sendMessage(
                  lPin: deviceId,
                  messageText: textHistory,
                  attachmentFlag: attachmentFlag,
                  messageScopeId: "3",
                  status: "2");
            }
            if (destinationList.length >= 2) {
              for (int i = 0; i < personData.length; i++) {
                if (personData[i]['f_pin'] == deviceId) {
                  destinationList.remove(personData[i]["f_pin"]);
                  nameList.remove(personData[i]["first_name"]);
                }
              }
              print("Remove Destination Length : " +
                  destinationList.length.toString());
              setState(() {});
            } else if ((destinationList.length == 1 &&
                    destinationList.contains(deviceId)) ||
                destinationList.length == 0) {
              title = "End Calling";

              SharedObj.stopRingtone();
              end = true;
              if (state == -4) busy = true;
              setState(() {});

              Future.delayed(Duration(seconds: 1), () {
                if (mounted) {
                  if (_timer != null) {
                    _timer?.cancel();
                  }
                  API.terminateCall(deviceId);
                  Navigator.of(context).pop({
                    "messageId": result,
                    "textHistory": "$textHistory",
                    "attachmentFlag": "$attachmentFlag"
                  });
                }
              });
            }
        }
      }
    };
  }

  void initVibrate() {
    _timer = new Timer.periodic(Duration(seconds: 1), (Timer timer) async {
      if (vibrate) {
        API.vibrate();
      }
    });
  }

  Future<bool> getVibration() async {
    final SharedPreferences prefs = await SharedPreferences.getInstance();
    vibrate = prefs.getBool("vibrate") ?? false;
    return vibrate;
  }

  @override
  void initState() {
    super.initState();
    _getPersonData();
    bool offline = false;
    for (var i = 0; i < personData.length; i++) {
      if (personData[i]["f_pin"] == widget.deviceId) {
        offline = personData[i]["offline_mode"] == '1';
        break;
      }
    }
    // offline = true;
    if (offline) {
      Fluttertoast.showToast(msg: "Unable to call because user disable calls");
      Navigator.pop(context);
    } else {
//    dummyParticipant[0] = widget.name;
      _controller = new ScrollController();
      // setState(() {});
      statusCall();
      getVibration();
      // API.setSpeaker(speaker);
      isInitiator = widget.isInitiatior;
      print("is Initiator VC : " + isInitiator.toString());
      if (isInitiator == 1) {
        print("Init VCall : " + widget.deviceId);
        Future.delayed(Duration(seconds: 2), () {
          if (mounted) {
            API.initiateVideoCall(widget.deviceId, widget.cameraId);
            // API.setSpeaker(speaker);
          }
        });
      } else {
        // initVibrate();
      }
    }

//    WidgetsBinding.instance.addPostFrameCallback((_) => initialize());
//    super.initState();
  }

  @override
  void dispose() {
    SharedObj.stopRingtone();
    SharedObj.clearNotificationCall();
    nameList.clear();
    destinationList.clear();
    if (_timer != null) {
      _timer?.cancel();
    }
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
          automaticallyImplyLeading: false,
          backgroundColor: AppColor.primaryColor,
          title: Text("Video Call(s)")),
      body: Stack(
        children: <Widget>[
          _remoteView(),
          Align(
            alignment: Alignment.topCenter,
            child: _destinationName(),
          ),
          Visibility(
            visible: !accept,
            child: _profile(),
          ),
          Align(
            alignment: Alignment.center,
            child: _status(),
          ),
          Container(
            padding: EdgeInsets.only(left: 5),
            child: _Views(),
          ),

//          Column(
//            mainAxisAlignment: MainAxisAlignment.spaceBetween,
//            children: <Widget>[
//              _topSection()
//            ],
//          ),
//          _chat()
//           _toolBar(),
          Container(
            alignment: Alignment.bottomCenter,
            padding: EdgeInsets.symmetric(vertical: 18),
            // child: _toolbar(),
            child: Column(
              mainAxisAlignment: MainAxisAlignment.end,
              crossAxisAlignment: CrossAxisAlignment.center,
              children: [
                _toolBar(),
                // Align(
                //   alignment: Alignment.bottomRight,
                //   child: _poweredBy(),
                // ),
              ],
            ),
          ),
        ],
      ),
    );
  }

  Widget _Views() {
    return AnimatedOpacity(
      duration: Duration(milliseconds: 120),
      opacity: opac,
      child: AnimatedContainer(
        duration: Duration(milliseconds: 120),
        width: animatedWidth,
        alignment: Alignment.centerLeft,
        child: Padding(
          padding: EdgeInsets.only(bottom: 50.0),
          child: Column(
            mainAxisAlignment: MainAxisAlignment.spaceBetween,
            children: <Widget>[
              Expanded(
                child: SingleChildScrollView(
                  physics: destinationList.length >= 3
                      ? ClampingScrollPhysics()
                      : NeverScrollableScrollPhysics(),
                  scrollDirection: Axis.vertical,
                  child: Column(
                    mainAxisAlignment: MainAxisAlignment.spaceEvenly,
                    children: <Widget>[
                      _cameraView(),
                      Padding(
                        padding: EdgeInsets.only(top: 3.0),
                        child: _remoteOtherView(
                          destinationList.length >= 2
                              ? nameList.elementAt(1)
                              : "",
                          destinationList.length >= 2 ? 160.0 : 1.0,
                        ),
                      ),
                      Padding(
                        padding: EdgeInsets.only(top: 3.0),
                        child: _remoteOtherView(
                          destinationList.length >= 3
                              ? nameList.elementAt(2)
                              : "",
                          destinationList.length >= 3 ? 160.0 : 1.0,
                        ),
                      ),
                      // Padding(
                      //   padding: EdgeInsets.only(top: 3.0),
                      //   child: _remoteOtherView(
                      //     destinationList.length >= 4
                      //         ? nameList.elementAt(3)
                      //         : "",
                      //     destinationList.length >= 4 ? 160.0 : 1.0,
                      //   ),
                      // ),
                      // Padding(
                      //   padding: EdgeInsets.only(top: 3.0),
                      //   child: _remoteOtherView(
                      //     destinationList.length >= 5
                      //         ? nameList.elementAt(4)
                      //         : "",
                      //     destinationList.length >= 5 ? 160.0 : 1.0,
                      //   ),
                      // ),
                      // Padding(
                      //   padding: EdgeInsets.only(top: 3.0),
                      //   child: _remoteOtherView(
                      //     destinationList.length >= 6
                      //         ? nameList.elementAt(5)
                      //         : "",
                      //     destinationList.length >= 6 ? 160.0 : 1.0,
                      //   ),
                      // ),
                      // Padding(
                      //   padding: EdgeInsets.only(top: 3.0),
                      //   child: _remoteOtherView(
                      //     destinationList.length >= 7
                      //         ? nameList.elementAt(6)
                      //         : "",
                      //     destinationList.length >= 7 ? 160.0 : 1.0,
                      //   ),
                      // ),
//                      Padding(
//                          padding: EdgeInsets.only(top: 3.0),
//                          child: Visibility(
//                            visible: destMap["7"] != "" &&
//                                destinationList.length >= 8,
//                            child: _remoteOtherView(
//                              destMap["7"] != "" && destinationList.length >= 8
//                                  ? destMap["7"]
//                                  : "",
//                              destMap["7"] != "" && destinationList.length >= 8
//                                  ? 160.0
//                                  : 1.0,
//                            ),
//                          )),
//                      Padding(
//                          padding: EdgeInsets.only(top: 3.0),
//                          child: Visibility(
//                            visible: destMap["8"] != "" &&
//                                destinationList.length >= 9,
//                            child: _remoteOtherView(
//                              destMap["8"] != "" && destinationList.length >= 9
//                                  ? destMap["8"]
//                                  : "",
//                              destMap["8"] != "" && destinationList.length >= 9
//                                  ? 160.0
//                                  : 1.0,
//                            ),
//                          )),
//                      Padding(
//                          padding: EdgeInsets.only(top: 3.0),
//                          child: Visibility(
//                            visible: destMap["9"] != "" &&
//                                destinationList.length >= 10,
//                            child: _remoteOtherView(
//                              destMap["9"] != "" && destinationList.length >= 10
//                                  ? destMap["9"]
//                                  : "",
//                              destMap["9"] != "" && destinationList.length >= 10
//                                  ? 160.0
//                                  : 1.0,
//                            ),
//                          )),
//                      Padding(
//                          padding: EdgeInsets.only(top: 3.0),
//                          child: Visibility(
//                            visible: destMap["10"] != "" &&
//                                destinationList.length >= 11,
//                            child: _remoteOtherView(
//                              destMap["10"] != "" &&
//                                      destinationList.length >= 11
//                                  ? destMap["10"]
//                                  : "",
//                              destMap["10"] != "" &&
//                                      destinationList.length >= 11
//                                  ? 160.0
//                                  : 1.0,
//                            ),
//                          )),
//                      Padding(
//                          padding: EdgeInsets.only(top: 3.0),
//                          child: Visibility(
//                            visible: destMap["11"] != "",
//                            child: _remoteOtherView(
//                              destMap["11"] != "" &&
//                                      destinationList.length >= 12
//                                  ? destMap["11"]
//                                  : "",
//                              destMap["11"] != "" &&
//                                      destinationList.length >= 12
//                                  ? 160.0
//                                  : 1.0,
//                            ),
//                          )),
//                      Padding(
//                          padding: EdgeInsets.only(top: 3.0),
//                          child: Visibility(
//                            visible: destMap["12"] != "",
//                            child: _remoteOtherView(
//                              destMap["12"] != "" &&
//                                      destinationList.length >= 13
//                                  ? destMap["12"]
//                                  : "",
//                              destMap["12"] != "" &&
//                                      destinationList.length >= 13
//                                  ? 160.0
//                                  : 1.0,
//                            ),
//                          )),
//                      Padding(
//                          padding: EdgeInsets.only(top: 3.0),
//                          child: Visibility(
//                            visible: destMap["13"] != "",
//                            child: _remoteOtherView(
//                              destMap["13"] != "" &&
//                                      destinationList.length >= 14
//                                  ? destMap["13"]
//                                  : "",
//                              destMap["13"] != "" &&
//                                      destinationList.length >= 14
//                                  ? 160.0
//                                  : 1.0,
//                            ),
//                          )),
//                      Padding(
//                          padding: EdgeInsets.only(top: 3.0),
//                          child: Visibility(
//                            visible: destMap["14"] != "",
//                            child: _remoteOtherView(
//                              destMap["14"] != "" &&
//                                      destinationList.length >= 15
//                                  ? destMap["14"]
//                                  : "",
//                              destMap["14"] != "" &&
//                                      destinationList.length >= 15
//                                  ? 160.0
//                                  : 1.0,
//                            ),
//                          )),
//                      Padding(
//                          padding: EdgeInsets.only(top: 3.0),
//                          child: Visibility(
//                            visible: destMap["15"] != "",
//                            child: _remoteOtherView(
//                              destMap["15"] != "" &&
//                                      destinationList.length >= 16
//                                  ? destMap["15"]
//                                  : "",
//                              destMap["15"] != "" &&
//                                      destinationList.length >= 16
//                                  ? 160.0
//                                  : 1.0,
//                            ),
//                          )),
                    ],
                  ),
                ),
              ),
            ],
          ),
        ),
      ),
    );
  }

  Widget _remoteView() {
    return GestureDetector(
      child: Align(
        alignment: Alignment.center,
        child: Visibility(
          child: Container(
            width: sizeFlag == 1
                ? 250
                : sizeFlag == 2
                    ? 350
                    : MediaQuery.of(context).size.width,
            height: sizeFlag == 1
                ? 300
                : sizeFlag == 2
                    ? 400
                    : MediaQuery.of(context).size.height,
            child: Zoom(),
            //  child: Container(
            //    decoration: BoxDecoration(
            //        image: DecorationImage(
            //            image: Image.asset(
            //      "assets/images/ic_person_girl.png",
            //    ).image)),
            //  ),
          ),
          visible: true,
        ),
      ),
      onTap: () {
        if (sizeFlag < 3) {
          sizeFlag++;
        } else {
          sizeFlag = 1;
        }
        setState(() {});
      },
    );
  }

  Widget _topSection() {
    return Container(
      padding: EdgeInsets.all(10),
      height: MediaQuery.of(context).size.height * 0.3,
      color: Colors.transparent,
      child: Row(
        mainAxisAlignment: MainAxisAlignment.spaceBetween,
        children: <Widget>[
          _cameraView(),
        ],
      ),
    );
  }

  void initialize() {
    if (isInitiator == 1) {
      API.initiateVideoCall(widget.deviceId, widget.cameraId);
    }
  }

  Widget _poweredBy() {
    return Container(
      alignment: Alignment.bottomRight,
      child: Row(
        crossAxisAlignment: CrossAxisAlignment.end,
        mainAxisAlignment: MainAxisAlignment.end,
        children: [
          Container(
            height: 25,
            alignment: Alignment.centerRight,
            child: Text(
              translate("poweredByPalio"),
              style: TextStyle(fontSize: 15),
            ),
          ),
          SizedBox(
            width: 5,
          ),
          Container(
            width: 25,
            height: 25,
//              color: Colors.grey,
            decoration: BoxDecoration(
                image: DecorationImage(
                    image: AssetImage("assets/images/palio.png",
                        package: "palio_lite"))),
          )
        ],
      ),
    );
  }

  Widget _toolBar() {
    if (!accept) {
      if (isInitiator == 0) {
        return _toolbarReceive();
      } else {
        return _toolbarInitiate();
      }
    } else if (accept && !end) {
      if (widget.isContactCenter) return _toolbarOnCallCC();
      return _toolbarOnCall();
    } else {
      return Container();
    }
  }

  Widget _toolbarOnCallCC() {
    return Row(
      mainAxisAlignment: MainAxisAlignment.spaceAround,
      children: <Widget>[
        Container(
          width: 40,
          height: 40,
          decoration: BoxDecoration(color: Colors.blue, shape: BoxShape.circle),
          child: IconButton(
            icon: Icon(
              speaker ? Icons.volume_up : Icons.volume_mute,
              color: Colors.white,
              size: 20.0,
            ),
            onPressed: () {
              setState(() {
                speaker = !speaker;
              });
              API.setSpeaker(speaker);
            },
          ),
        ),
        // Container(
        //   width: 40,
        //   height: 40,
        //   decoration: BoxDecoration(color: Colors.blue, shape: BoxShape.circle),
        //   child: IconButton(
        //     icon: Icon(
        //       muted ? Icons.mic_off : Icons.mic,
        //       color: Colors.white,
        //       size: 20.0,
        //     ),
        //     onPressed: () {
        //       setState(() {
        //         muted = !muted;
        //       });
        //       API.muteMicrophone(muted);
        //     },
        //   ),
        // ),
        Container(
          width: 40,
          height: 40,
          decoration: BoxDecoration(color: Colors.red, shape: BoxShape.circle),
          child: IconButton(
            icon: Icon(
              Icons.call_end,
              color: Colors.white,
              size: 20.0,
            ),
            onPressed: () {
              showDialog(
                  context: context,
                  builder: (context) {
                    return CupertinoAlertDialog(
                        insetAnimationCurve: Curves.easeInBack,
                        title: Text("Are you sure to end this call?"),
                        actions: <Widget>[
                          CupertinoDialogAction(
                            onPressed: () {
                              Navigator.pop(context);
                            },
                            child: Text("Cancel",
                                style: TextStyle(
                                    color: AppColor.primaryColor,
                                    fontSize: 20)),
                          ),
                          CupertinoDialogAction(
                            onPressed: () {
                              Navigator.pop(context);
                              if (_timer != null) {
                                _timer?.cancel();
                              }
                              if (widget.isInitiatior == 1 && !accept) {
                                textHistory = "Video Call Cancelled";
                              }
                              setState(() {});
                              API.terminateCall(widget.deviceId);
                              Navigator.pop(context);
                            },
                            child: Text("Yes",
                                style: TextStyle(
                                    color: AppColor.primaryColor,
                                    fontSize: 20)),
                          )
                        ]);
                  });
            },
          ),
        ),
      ],
    );
  }

  Widget _toolbarOnCall() {
    return Row(
      mainAxisAlignment: MainAxisAlignment.spaceAround,
      children: <Widget>[
        Container(
          width: 40,
          height: 40,
          decoration: BoxDecoration(color: Colors.blue, shape: BoxShape.circle),
          child: IconButton(
            icon: Icon(
              Icons.person_add,
              color: Colors.white,
              size: 20.0,
            ),
            onPressed: () async {
              if (destinationList.length < 16) {
                final dest = await Navigator.push(
                    context,
                    PageTransition(
                        type: PageTransitionType.fade,
                        child: AddCall(destinationList)));
                if (dest != null) {
                  List<dynamic> res = await DBHelper().queryCustom(
                      "SELECT offline_mode FROM BUDDY where f_pin = '${dest[1]}'");
                  if (res[0]["offline_mode"] == "1") {
                    Fluttertoast.showToast(
                        msg: "Unable to call because user disable calls");
                  } else {
                    API.addVideoCall(dest[1], "1");
                  }
                }

                setState(() {});
              }
            },
          ),
        ),

        Container(
          width: 40,
          height: 40,
          decoration: BoxDecoration(color: Colors.blue, shape: BoxShape.circle),
          child: IconButton(
            icon: Icon(
              speaker ? Icons.volume_up : Icons.volume_mute,
              color: Colors.white,
              size: 20.0,
            ),
            onPressed: () {
              setState(() {
                speaker = !speaker;
              });
              API.setSpeaker(speaker);
            },
          ),
        ),
        // Container(
        //   width: 40,
        //   height: 40,
        //   decoration: BoxDecoration(color: Colors.blue, shape: BoxShape.circle),
        //   child: IconButton(
        //     icon: Icon(
        //       muted ? Icons.mic_off : Icons.mic,
        //       color: Colors.white,
        //       size: 20.0,
        //     ),
        //     onPressed: () {
        //       setState(() {
        //         muted = !muted;
        //       });
        //       API.muteMicrophone(muted);
        //     },
        //   ),
        // ),
        Container(
          width: 40,
          height: 40,
          decoration: BoxDecoration(color: Colors.red, shape: BoxShape.circle),
          child: IconButton(
            icon: Icon(
              Icons.call_end,
              color: Colors.white,
              size: 20.0,
            ),
            onPressed: () {
              showDialog(
                  context: context,
                  builder: (context) {
                    return CupertinoAlertDialog(
                        insetAnimationCurve: Curves.easeInBack,
                        title: Text("Are you sure to end this call?"),
                        actions: <Widget>[
                          CupertinoDialogAction(
                            onPressed: () {
                              Navigator.pop(context);
                            },
                            child: Text("Cancel",
                                style: TextStyle(
                                    color: AppColor.primaryColor,
                                    fontSize: 20)),
                          ),
                          CupertinoDialogAction(
                            onPressed: () {
                              Navigator.pop(context);
                              if (_timer != null) {
                                _timer?.cancel();
                              }
                              if (widget.isInitiatior == 1 && !accept) {
                                textHistory = "Video Call Cancelled";
                              }
                              setState(() {});
                              API.terminateCall(widget.deviceId);
                              Navigator.pop(context);
                            },
                            child: Text("Yes",
                                style: TextStyle(
                                    color: AppColor.primaryColor,
                                    fontSize: 20)),
                          )
                        ]);
                  });
            },
          ),
        ),
      ],
    );
  }

  Widget _toolbarReceive() {
    return Row(
      mainAxisAlignment: MainAxisAlignment.spaceAround,
      children: <Widget>[
        Container(
          width: 40,
          height: 40,
          decoration: BoxDecoration(color: Colors.red, shape: BoxShape.circle),
          child: IconButton(
            icon: Icon(
              Icons.call_end,
              color: Colors.white,
              size: 20.0,
            ),
            onPressed: () {
              showDialog(
                  context: context,
                  builder: (context) {
                    return CupertinoAlertDialog(
                        insetAnimationCurve: Curves.easeInBack,
                        title: Text("Are you sure to end this call?"),
                        actions: <Widget>[
                          CupertinoDialogAction(
                            onPressed: () {
                              Navigator.pop(context);
                            },
                            child: Text("Cancel",
                                style: TextStyle(
                                    color: AppColor.primaryColor,
                                    fontSize: 20)),
                          ),
                          CupertinoDialogAction(
                            onPressed: () {
                              SharedObj.stopRingtone();
                              Navigator.pop(context);
                              if (_timer != null) {
                                _timer?.cancel();
                              }
                              if (widget.isInitiatior == 1 && !accept) {
                                textHistory = "Video Call Cancelled";
                              }
                              setState(() {});
                              API.terminateCall(widget.deviceId);
                            },
                            child: Text("Yes",
                                style: TextStyle(
                                    color: AppColor.primaryColor,
                                    fontSize: 20)),
                          )
                        ]);
                  });
            },
          ),
        ),
        Container(
          width: 40,
          height: 40,
          decoration: BoxDecoration(color: Colors.blue, shape: BoxShape.circle),
          child: IconButton(
            icon: Icon(
              CupertinoIcons.phone_solid,
              color: Colors.white,
              size: 20.0,
            ),
            onPressed: () {
              SharedObj.stopRingtone();
              if (_timer != null) {
                _timer?.cancel();
              }
              API.receiveVideoCall(widget.deviceId, widget.cameraId);
              accept = true;
              setState(() {});
            },
          ),
        ),
      ],
    );
  }

  Widget _toolbarInitiate() {
    return Row(
      mainAxisAlignment: MainAxisAlignment.spaceAround,
      children: <Widget>[
        Container(
          width: 40,
          height: 40,
          decoration: BoxDecoration(color: Colors.red, shape: BoxShape.circle),
          child: IconButton(
            icon: Icon(
              Icons.call_end,
              color: Colors.white,
              size: 20.0,
            ),
            onPressed: () {
              showDialog(
                  context: context,
                  builder: (context) {
                    return CupertinoAlertDialog(
                        insetAnimationCurve: Curves.easeInBack,
                        title: Text("Are you sure to end this call?"),
                        actions: <Widget>[
                          CupertinoDialogAction(
                            onPressed: () {
                              Navigator.pop(context);
                            },
                            child: Text("Cancel",
                                style: TextStyle(
                                    color: AppColor.primaryColor,
                                    fontSize: 20)),
                          ),
                          CupertinoDialogAction(
                            onPressed: () {
                              Navigator.pop(context);
                              if (_timer != null) {
                                _timer?.cancel();
                              }
                              if (widget.isInitiatior == 1 && !accept) {
                                textHistory = "Video Call Cancelled";
                              }
                              setState(() {});
                              API.terminateCall(widget.deviceId);
                            },
                            child: Text("Yes",
                                style: TextStyle(
                                    color: AppColor.primaryColor,
                                    fontSize: 20)),
                          )
                        ]);
                  });
            },
          ),
        ),
      ],
    );
  }

  Widget _destinationName() {
    return Align(
      alignment: Alignment.topCenter,
      child: Container(
        padding: EdgeInsets.all(5),
        color: Colors.black26,
        child: Text(
          widget.name,
          style: TextStyle(color: Colors.white, fontSize: 13),
        ),
      ),
    );
  }

  Widget _status() {
    return Visibility(
      visible: !accept || end || busy,
      child: Align(
        alignment: Alignment.center,
        child: Container(
          padding: EdgeInsets.all(5),
          color: Colors.black26,
          child: Text(
            (isInitiator == 1 && !accept && !end)
                ? "Waiting for answer"
                : (isInitiator == 0 && !accept && !end)
                    ? "Incoming Video Call"
                    : (end && busy)
                        ? "Busy"
                        : end
                            ? "Video Call Finished"
                            : "",
            style: TextStyle(color: Colors.white, fontSize: 13),
          ),
        ),
      ),
    );
  }

  Widget _cameraView() {
    return Visibility(
      visible: true,
      child: Container(
          width: 120,
          alignment: Alignment.topCenter,
          padding: EdgeInsets.only(top: 5),
          child: Container(
            width: 120,
            height: 120,
            decoration: BoxDecoration(
                color: Colors.white,
                borderRadius: BorderRadius.all(Radius.circular(10.0))),
            child: Camera(),
            // child: Container(
            //   decoration: BoxDecoration(
            //       image: DecorationImage(
            //           image: Image.asset(
            //             "assets/images/ic_person_girl.png",
            //           ).image)),
            // ),
          )),
    );
  }

  Widget _remoteOtherView(String name, double hgt) {
    return GestureDetector(
      child: Container(
          height: hgt,
          width: 120,
          //      color: Colors.white30,
          child: Container(
            width: 120,
            height: 120,
            decoration: BoxDecoration(
                color: hgt > 1.0 ? Colors.blueGrey : Colors.transparent,
                borderRadius: BorderRadius.all(Radius.circular(10.0))),
            child: Remote(),
          )),
      onTap: () {
        widget.name = name;
        setState(() {});
      },
    );
  }

  Widget _profile() {
    return Center(
      child: Column(
        children: <Widget>[
          ClipOval(
            child: Container(
                height: 120,
                width: 120,
                decoration: BoxDecoration(
                    shape: BoxShape.circle,
                    image: DecorationImage(
                        fit: BoxFit.cover, image: LocalImage(widget.image)))),
          ),
          SizedBox(
            height: 20,
          ),
          Text(
            widget.name,
            style: TextStyle(fontSize: 20, fontWeight: FontWeight.bold),
          )
        ],
      ),
    );
  }

  Widget _chat() {
    return Container(
      padding: EdgeInsets.only(top: MediaQuery.of(context).size.height * 0.3),
      child: Column(
        children: <Widget>[
          Expanded(
            child: FadingEdgeScrollView.fromScrollView(
              child: CustomScrollView(
                shrinkWrap: true,
                reverse: true,
                controller: _controller,
                slivers: <Widget>[
                  SliverList(
                      delegate: SliverChildBuilderDelegate((context, index) {
                    var data = samplemessages[index];
                    return Padding(
                      padding: EdgeInsets.only(top: 8.0),
                      child: GestureDetector(
                        child: BubbleVc(
                          originator: data['originator'],
                          content: data['content'],
                          thumbnail: data['thumbnail'],
                        ),
                        onTap: () {},
                      ),
                    );
                  }, childCount: samplemessages.length))
                ],
              ),
            ),
          ),
          EditorVc(
            onPressed: (val) async {
              var obj = {"originator": "Me", "content": val['content']};
              setState(() {
                samplemessages.insert(0, obj);
                _controller.jumpTo(_controller.position.minScrollExtent);
              });
            },
          ),
          Text(
            '',
            style: TextStyle(color: Colors.white, fontSize: 10),
          )
        ],
      ),
    );
  }
}
