import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

class BubbleVc extends StatelessWidget {
  final String originator;
  final String content;
  final String thumbnail;

  BubbleVc(
      {Key? key,
      required this.originator,
      required this.content,
      required this.thumbnail})
      : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Container(
      color: Colors.transparent,
      child: Padding(
        padding: EdgeInsets.only(left: (8.0), right: (8.0)),
        child: Row(
          mainAxisAlignment: MainAxisAlignment.start,
          mainAxisSize: MainAxisSize.min,
          children: <Widget>[
            Padding(
              padding: EdgeInsets.only(right: 10),
              child: CircleAvatar(
                backgroundColor: Colors.transparent,
                child: Container(
                    height: 35,
                    width: 35,
                    decoration: BoxDecoration(
                        shape: BoxShape.circle,
                        image: DecorationImage(
                            fit: BoxFit.cover,
                            image: AssetImage("assets/images/default_pp.png",
                                package: "palio_lite")))),
              ),
            ),
            Column(
              crossAxisAlignment: CrossAxisAlignment.start,
              children: <Widget>[
                Text(originator,
                    style: TextStyle(color: Colors.white, fontSize: 17)),
                Container(
                  width: MediaQuery.of(context).size.width * 0.8,
                  child: Wrap(
                    children: <Widget>[
                      Text(
                        content,
                        style: TextStyle(color: Colors.white, fontSize: 15),
                      )
                    ],
                  ),
                )
              ],
            ),
          ],
        ),
      ),
    );
  }
}
