import 'dart:io';

import 'package:flutter/material.dart';

class Camera extends StatefulWidget {
  @override
  State<StatefulWidget> createState() => _CameraState();
}

class _CameraState extends State<Camera> {
  Widget? _nativeView;

  Widget createCameraView(Function(int viewId) created, {Key? key}) {
    if (Platform.isIOS) {
      return UiKitView(
        key: key,
        viewType: 'CameraView',
        onPlatformViewCreated: (viewId) {
          if (created != null) {
            created(viewId);
          }
        },
      );
    } else {
      return AndroidView(
        key: key,
        viewType: 'CameraView',
        onPlatformViewCreated: (viewId) {
          if (created != null) {
            created(viewId);
          }
        },
      );
    }
  }

  @override
  void initState() {
    super.initState();
    _nativeView = createCameraView((viewId) {});
  }

  @override
  void dispose() {
    _nativeView = null;
    super.dispose();
  }

  @override
  Widget build(BuildContext context) => _nativeView!;
}
