import 'dart:math';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:flutter_translate/flutter_translate.dart';

class EditorVc extends StatefulWidget {
  final ValueChanged<Map<dynamic, dynamic>> onPressed;

  EditorVc({Key? key, required this.onPressed}) : super(key: key);

  @override
  State<StatefulWidget> createState() => _EditorVcState();
}

class _EditorVcState extends State<EditorVc> {
  TextEditingController _controller = TextEditingController();

  @override
  void dispose() {
    _controller.dispose();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return Stack(
      children: <Widget>[
        Container(
            padding: EdgeInsets.only(left: 15.0),
            margin: EdgeInsets.all(8.0),
            decoration: BoxDecoration(boxShadow: [
              BoxShadow(
                color: Colors.grey,
                blurRadius: 1.0,
              )
            ], color: Colors.white, borderRadius: BorderRadius.circular(20.0)),
            child: Column(
              children: <Widget>[
                Row(
                  children: <Widget>[
                    Flexible(
                        child: TextField(
                      textInputAction: TextInputAction.done,
                      controller: _controller,
                      minLines: 1,
                      maxLines: 3,
                      inputFormatters: [
                        LengthLimitingTextInputFormatter(150),
                      ],
                      decoration: InputDecoration.collapsed(
                        hintText: "Write comment",
                        hintStyle: TextStyle(color: Colors.grey),
                      ),
                      textCapitalization: TextCapitalization.sentences,
                    )),
                    RawMaterialButton(
                        constraints:
                            BoxConstraints(minWidth: 36.0, minHeight: 36.0),
                        shape: CircleBorder(),
                        fillColor: Colors.blueGrey,
                        child: Transform.rotate(
                          angle: -pi / 8,
                          child: Icon(
                            Icons.send,
                            color: Colors.white,
                          ),
                        ),
                        onPressed: () {
                          if (_controller.text.trim().isEmpty) {
                            return;
                          }
                          widget.onPressed({'content': _controller.text});

                          setState(() {
                            _controller.clear();
                          });
                        }),
                  ],
                ),
              ],
            )),
      ],
    );
  }
}
