import 'dart:async';

import 'package:flutter/material.dart';

class TimerController extends ValueNotifier<String> {
  TimerController({String value = ''}) : super(value);

  var _stopWatch = Stopwatch();

  var _duration = Duration(seconds: 1);

  void _startTimer() {
    Timer(_duration, _keepRunning);
  }

  void _keepRunning() {
    if (_stopWatch.isRunning) {
      _startTimer();
    }
    value = (_stopWatch.elapsed.inHours == 0
        ? ""
        : _stopWatch.elapsed.inHours.toString().padLeft(2, '0') + ":") +
        (_stopWatch.elapsed.inMinutes % 60).toString().padLeft(2, '0') +
        ":" +
        (_stopWatch.elapsed.inSeconds % 60).toString().padLeft(2, '0');
  }

  void start() {
    _stopWatch.start();
    _startTimer();
  }

  void stop() {
    _stopWatch.stop();
  }

  @override
  void dispose() {
    if (_stopWatch.isRunning) {
      stop();
    }
    super.dispose();
  }
}
