import 'dart:convert';
import 'dart:io';

import 'package:file_picker/file_picker.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:fluttertoast/fluttertoast.dart';
import 'package:image_picker/image_picker.dart';
import 'package:open_file/open_file.dart';
import 'package:palio_lite/api.dart';
import 'package:palio_lite/app_color.dart';
import 'package:palio_lite/chat/widgets/add_group.dart';
import 'package:palio_lite/chat/widgets/add_member.dart';
import 'package:palio_lite/chat/widgets/calendar_form.dart';
import 'package:palio_lite/chat/widgets/time_form.dart';
import 'package:path/path.dart' as path;
import 'package:path_provider/path_provider.dart';
import 'package:video_compress/video_compress.dart';
import 'package:video_thumbnail/video_thumbnail.dart';

class BroadcastPage extends StatefulWidget {
  @override
  _BroadcastPageState createState() => _BroadcastPageState();
}

class _BroadcastPageState extends State<BroadcastPage> {
  String targetAudience = "1", broadcastType = "1", broadcastMode = "1";
  List<String> groupChoosen = [],
      dataChosen = [],
      groupIdChosen = [],
      groupNameChosen = [],
      dataGroupChosen = [],
      nameChosen = [],
      fpinChosen = [],
      fileType = [],
      assets_menu_bottom = [
        'assets/images/ic_nuc_uploading_document.png',
        'assets/images/ic_nuc_uploading_img.png',
        'assets/images/ic_nuc_uploading_video.png',
      ];
  bool circularIndicator = false;
  List<File> filesSend = [], fileDocuments = [], videosThumb = [];
  File? fileImageChangeThumbnail, fileGet;
  int time = 0,
      timeValStart = DateTime.now().millisecondsSinceEpoch,
      timeValEnd = DateTime.now().millisecondsSinceEpoch,
      timeValDateStart = DateTime.now().millisecondsSinceEpoch,
      timeValDateEnd = DateTime.now().millisecondsSinceEpoch,
      tanggal = DateTime.now().day,
      bulan = DateTime.now().month,
      tahun = DateTime.now().year,
      jam = DateTime.now().hour,
      menit = DateTime.now().minute;
  final titleController = TextEditingController(text: ""),
      messageController = TextEditingController(text: ""),
      linkController = TextEditingController(text: ""),
      _scaffoldKey = GlobalKey<ScaffoldState>();
  var uint8list;

  void _onFilePhotoVideo(int type) {
    showDialog(
        context: context,
        builder: (context) {
          return CupertinoAlertDialog(
              insetAnimationCurve: Curves.easeInBack,
              title: Text("Cancel your upload ?"),
              actions: <Widget>[
                CupertinoDialogAction(
                  onPressed: () {
                    Navigator.pop(context);
                    Navigator.of(context).pop();
                  },
                  child: Text("Cancel",
                      style: TextStyle(
                          color: AppColor.primaryColor, fontSize: 20)),
                ),
                CupertinoDialogAction(
                  onPressed: () {
                    Navigator.of(context).pop();
                    fileDocuments.clear();
                    fileImageChangeThumbnail = null;
                    fileType.remove("file");
                    setState(() {});
                    if (type == 0) {
                      _openCamera(context);
                    } else if (type == 1) {
                      _openGallery(context);
                    } else if (type == 2) {
                      _openVideoCamera(context);
                    } else if (type == 3) {
                      _openVideoGallery(context);
                    }
                  },
                  child: Text("Yes",
                      style: TextStyle(
                          color: AppColor.primaryColor, fontSize: 20)),
                )
              ]);
        });
  }

  void _onFileDocument() {
    showDialog(
        context: context,
        builder: (context) {
          return CupertinoAlertDialog(
              insetAnimationCurve: Curves.easeInBack,
              title: Text("Cancel your upload ?"),
              actions: <Widget>[
                CupertinoDialogAction(
                  onPressed: () {
                    Navigator.pop(context);
                  },
                  child: Text("Cancel",
                      style: TextStyle(
                          color: AppColor.primaryColor, fontSize: 20)),
                ),
                CupertinoDialogAction(
                  onPressed: () {
                    Navigator.of(context).pop();
                    filesSend.clear();
                    fileType.remove("video");
                    fileType.remove("image");
                    setState(() {});
                    _openFileManager(context);
                  },
                  child: Text("Yes",
                      style: TextStyle(
                          color: AppColor.primaryColor, fontSize: 20)),
                )
              ]);
        });
  }

  _openCamera(BuildContext context) async {
    PickedFile? pickedFile = await ImagePicker().getImage(
      source: ImageSource.camera,
      maxHeight: 720,
      maxWidth: 1280,
    );
    if (pickedFile != null) {
      fileGet = File(pickedFile.path);
    }
    if (fileGet != null) {
      setState(() {
        filesSend.add(fileGet!);
        fileType.add('image');
        videosThumb.add(fileGet!);
      });
    }
    Navigator.of(context).pop();
  }

  _openGallery(BuildContext context) async {
    PickedFile? pickedFile =
        await ImagePicker().getImage(source: ImageSource.gallery);
    if (pickedFile != null) {
      fileGet = File(pickedFile.path);
    }
    if (fileGet != null) {
      if (fileGet!.lengthSync() * 0.001 >= 250.0) {
        Fluttertoast.showToast(
            msg: "You can only attach file that are less than 250.0 KB");
        Navigator.of(context).pop();
        return null;
      }
      setState(() {
        filesSend.add(fileGet!);
        fileType.add('image');
        videosThumb.add(fileGet!);
      });
    }
    Navigator.of(context).pop();
  }

  _getVideoThumb(String pathVideo) async {
    var myPath = await getApplicationDocumentsDirectory();
    String thumbPath = myPath.path;
    uint8list = await VideoThumbnail.thumbnailFile(
      video: pathVideo,
      thumbnailPath: thumbPath,
      imageFormat: ImageFormat.JPEG,
      maxHeight: 720,
      maxWidth: 1280,
      quality: 80,
    );
    setState(() {
      videosThumb.add(File(uint8list));
    });
  }

  _openVideoCamera(BuildContext context) async {
    PickedFile? pickedFile =
        await ImagePicker().getVideo(source: ImageSource.camera);
    if (pickedFile != null) {
      fileGet = File(pickedFile.path);
    }
    if (fileGet != null) {
      await VideoCompress.setLogLevel(0);
      final info = await VideoCompress.compressVideo(
        fileGet!.path,
        quality: VideoQuality.MediumQuality,
        deleteOrigin: false,
        includeAudio: true,
      );
      if (info != null) {
        fileGet = info.file;
      }
      if (fileGet!.lengthSync() * 0.001 >= 2500.0) {
        Fluttertoast.showToast(
            msg: "You can only attach file that are less than 2.5 MB");
        Navigator.of(context).pop();
        return null;
      }
      filesSend.add(fileGet!);
      fileType.add('video');
      await _getVideoThumb(fileGet!.path);
      setState(() {});
    }
    Navigator.pop(context);
  }

  _openVideoGallery(BuildContext context) async {
    PickedFile? pickedFile =
        await ImagePicker().getVideo(source: ImageSource.gallery);
    if (pickedFile != null) {
      fileGet = File(pickedFile.path);
    }
    if (fileGet != null) {
      await VideoCompress.setLogLevel(0);
      final info = await VideoCompress.compressVideo(
        fileGet!.path,
        quality: VideoQuality.MediumQuality,
        deleteOrigin: false,
        includeAudio: true,
      );
      if (info != null) {
        fileGet = info.file;
      }
      if (fileGet!.lengthSync() * 0.001 >= 2500.0) {
        Fluttertoast.showToast(
            msg: "You can only attach file that are less than 2.5 MB");
        Navigator.of(context).pop();
        return null;
      }
      filesSend.add(fileGet!);
      fileType.add('video');
      await _getVideoThumb(fileGet!.path);
      setState(() {});
    }
    Navigator.pop(context);
  }

  _openFileManager(BuildContext context) async {
    FilePickerResult? result =
        await FilePicker.platform.pickFiles(type: FileType.any, allowMultiple: false);
    if (result != null && result.files.single != null) {
      fileGet = File(result.files.single.path!);
    }
    if (fileGet != null) {
      if (fileGet!.lengthSync() * 0.001 >= 250.0) {
        Fluttertoast.showToast(
            msg: "You can only attach file that are less than 250 KB");
        return null;
      }
      setState(() {
        fileImageChangeThumbnail = null;
        fileDocuments.add(fileGet!);
        if (fileDocuments.length > 0) {
          fileDocuments[0] = fileGet!;
        }
        fileType.add('file');
      });
    }
  }

  _openGalleryChangeThumbnail(BuildContext context) async {
    PickedFile? pickedFile =
        await ImagePicker().getImage(source: ImageSource.gallery);
    if (pickedFile != null) {
      fileGet = File(pickedFile.path);
    }
    this.setState(() {
      fileImageChangeThumbnail = fileGet;
    });
  }

  Widget _decideImageViewChangeThumbnail(File? thumb) {
    if (fileImageChangeThumbnail == null) {
      if (thumb != null) {
        return Container(
            height: 80.0,
            width: 80.0,
            decoration: BoxDecoration(
                image: DecorationImage(
                    fit: BoxFit.cover, image: FileImage(thumb))));
      } else {
        return SizedBox(
            height: 80.0,
            width: 80.0,
            child: IconButton(
              padding: EdgeInsets.only(right: 10.0),
              icon: Icon(
                Icons.insert_drive_file,
                size: 80.0,
                color: AppColor.primaryColor,
              ),
              onPressed: null,
            ));
      }
    } else {
      return Container(
          height: 80.0,
          width: 80.0,
          decoration: BoxDecoration(
              image: DecorationImage(
                  fit: BoxFit.cover,
                  image: FileImage(fileImageChangeThumbnail!))));
    }
  }

  Widget _decideFileView() {
    String basename = "";
    if (fileDocuments.length > 0) {
      basename = path.basename(fileDocuments[0].toString());
    }
    if (filesSend.length > 0 || fileDocuments.length > 0) {
      return Container(
        child: fileType[0] == 'video'
            ? Column(
                crossAxisAlignment: CrossAxisAlignment.start,
                children: [
                  Stack(
                    children: [
                      GestureDetector(
                        onTap: () {
                          OpenFile.open(filesSend[0].path);
                        },
                        child: Container(
                          margin: EdgeInsets.symmetric(
                              horizontal: 10.0, vertical: 10.0),
                          height: 200,
                          width: double.infinity,
                          decoration: BoxDecoration(
                              image: DecorationImage(
                                  fit: BoxFit.cover,
                                  image: FileImage(videosThumb[0]))),
                          child: Container(
                            alignment: Alignment.center,
                            child: Icon(Icons.play_circle_outline,
                                color: Colors.white.withOpacity(0.5), size: 50),
                          ),
                        ),
                      ),
                      Align(
                        alignment: Alignment.topRight,
                        child: Container(
                          margin: EdgeInsets.only(right: 10.0, top: 10.0),
                          child: Material(
                            color: Colors.black.withOpacity(0.3),
                            child: InkWell(
                              onTap: () {
                                setState(() {
                                  if (filesSend.length > 0) {
                                    filesSend.removeAt(0);
                                    videosThumb.removeAt(0);
                                    fileType.removeAt(0);
                                  } else {
                                    fileDocuments.clear();
                                    fileType.clear();
                                  }
                                });
                              },
                              child: Icon(Icons.cancel_outlined,
                                  color: Colors.white.withOpacity(0.5),
                                  size: 35),
                            ),
                          ),
                        ),
                      )
                    ],
                  ),
                  Container(
                    decoration: BoxDecoration(
                      border: Border(
                          bottom: BorderSide(
                        color: AppColor.primaryColor,
                        width: 2.0,
                      )),
                    ),
                  ),
                  Container(
                    width: double.infinity,
                    margin: EdgeInsets.only(top: 3.0, bottom: 3.0),
                    child: Text(
                      "Change thumbnail ?",
                      textAlign: TextAlign.center,
                      style: TextStyle(fontSize: 10.0, color: Colors.grey),
                    ),
                  ),
                  Row(
                    crossAxisAlignment: CrossAxisAlignment.center,
                    mainAxisAlignment: MainAxisAlignment.start,
                    children: <Widget>[
                      _decideImageViewChangeThumbnail(videosThumb[0]),
                      Container(
                        width: 60.0,
                        height: 60.0,
                        margin: EdgeInsets.only(left: 20.0),
                        decoration: BoxDecoration(
                          border: Border.all(color: AppColor.primaryColor),
                          borderRadius: BorderRadius.all(Radius.circular(
                                  5.0) //                 <--- border radius here
                              ),
                        ),
                        child: IconButton(
                          icon: Icon(
                            Icons.linked_camera,
                            size: 25.0,
                            color: Colors.blue[400],
                          ),
                          onPressed: () => _openGalleryChangeThumbnail(context),
                        ),
                      )
                    ],
                  )
                ],
              )
            : fileType[0] == 'image'
                ? Stack(
                    children: [
                      GestureDetector(
                        onTap: () {
                          OpenFile.open(filesSend[0].path);
                        },
                        child: Container(
                          margin: EdgeInsets.symmetric(
                              horizontal: 10.0, vertical: 10.0),
                          height: 200,
                          width: double.infinity,
                          decoration: BoxDecoration(
                              image: DecorationImage(
                                  fit: BoxFit.cover,
                                  image: FileImage(filesSend[0]))),
                        ),
                      ),
                      Align(
                        alignment: Alignment.topRight,
                        child: Container(
                          margin: EdgeInsets.only(right: 10.0, top: 10.0),
                          child: Material(
                            color: Colors.black.withOpacity(0.3),
                            child: InkWell(
                              onTap: () {
                                setState(() {
                                  if (filesSend.length > 0) {
                                    filesSend.removeAt(0);
                                    videosThumb.removeAt(0);
                                    fileType.removeAt(0);
                                  } else {
                                    fileDocuments.clear();
                                    fileType.clear();
                                  }
                                });
                              },
                              child: Icon(Icons.cancel_outlined,
                                  color: Colors.white.withOpacity(0.5),
                                  size: 35),
                            ),
                          ),
                        ),
                      )
                    ],
                  )
                : Column(
                    crossAxisAlignment: CrossAxisAlignment.start,
                    children: [
                      Stack(
                        children: [
                          Row(
                            crossAxisAlignment: CrossAxisAlignment.center,
                            mainAxisAlignment: MainAxisAlignment.start,
                            children: <Widget>[
                              SizedBox(
                                  height: 80.0,
                                  width: 80.0,
                                  child: new IconButton(
                                    padding: EdgeInsets.only(right: 10.0),
                                    icon: new Icon(
                                      Icons.insert_drive_file,
                                      size: 80.0,
                                      color: AppColor.primaryColor,
                                    ),
                                    onPressed: null,
                                  )),
                              Flexible(
                                child: Text(basename),
                              )
                            ],
                          ),
                          Align(
                            alignment: Alignment.topRight,
                            child: Container(
                              margin: EdgeInsets.only(right: 10.0),
                              child: Material(
                                color: Colors.black.withOpacity(0.3),
                                child: InkWell(
                                  onTap: () {
                                    setState(() {
                                      if (filesSend.length > 0) {
                                        filesSend.removeAt(0);
                                        videosThumb.removeAt(0);
                                        fileType.removeAt(0);
                                      } else {
                                        fileDocuments.clear();
                                        fileType.clear();
                                      }
                                    });
                                  },
                                  child: Icon(Icons.cancel_outlined,
                                      color: Colors.black.withOpacity(0.5),
                                      size: 35),
                                ),
                              ),
                            ),
                          )
                        ],
                      ),
                      Container(
                        decoration: BoxDecoration(
                          border: Border(
                              bottom: BorderSide(
                            color: AppColor.primaryColor,
                            width: 2.0,
                          )),
                        ),
                      ),
                      Container(
                        width: double.infinity,
                        margin: EdgeInsets.only(top: 3.0, bottom: 3.0),
                        child: Text(
                          "Change thumbnail ?",
                          textAlign: TextAlign.center,
                          style: TextStyle(fontSize: 10.0, color: Colors.grey),
                        ),
                      ),
                      Row(
                        crossAxisAlignment: CrossAxisAlignment.center,
                        mainAxisAlignment: MainAxisAlignment.start,
                        children: <Widget>[
                          _decideImageViewChangeThumbnail(null),
                          Container(
                            width: 60.0,
                            height: 60.0,
                            margin: EdgeInsets.only(left: 20.0),
                            decoration: BoxDecoration(
                              border: Border.all(color: AppColor.primaryColor),
                              borderRadius: BorderRadius.all(Radius.circular(
                                      5.0) //                 <--- border radius here
                                  ),
                            ),
                            child: IconButton(
                              icon: Icon(
                                Icons.linked_camera,
                                size: 25.0,
                                color: Colors.blue[400],
                              ),
                              onPressed: () =>
                                  _openGalleryChangeThumbnail(context),
                            ),
                          )
                        ],
                      )
                    ],
                  ),
      );
    } else {
      return SizedBox(
        height: 100.0,
      );
    }
  }

  _sendBroadcast() async {
    if (titleController.text.trim().isEmpty) {
      Fluttertoast.showToast(msg: "Enter broadcast's title");
    } else if (messageController.text.trim().isEmpty) {
      Fluttertoast.showToast(msg: "Enter broadcast's message");
    } else {
      setState(() {
        circularIndicator = true;
      });
      Fluttertoast.showToast(msg: "Broadcasting...");
      String title = titleController.text;
      String message = messageController.text;
      String link = linkController.text;
      // if (link.isNotEmpty) {
      //   if (!link.contains("https://") || !link.contains("http://")) {
      //     link = "https://" + link;
      //   }
      // }
      String file = "";
      String thumb = "";
      String typeFile = "";
      DateTime dateTime = DateTime.now();
      Directory directory = await getApplicationDocumentsDirectory();
      if (fileDocuments.length > 0) {
        if (fileDocuments.length == 1) {
          File files = fileDocuments[0].copySync(
              "${directory.path}/${"DOC-" + dateTime.millisecondsSinceEpoch.toString() + "-" + path.basename(fileDocuments[0].path)}");
          file = "DOC-" +
              dateTime.millisecondsSinceEpoch.toString() +
              "-" +
              path.basename(fileDocuments[0].path);
          typeFile = "3";
          if (fileImageChangeThumbnail != null) {
            File thumbs = fileImageChangeThumbnail!.copySync(
                "${directory.path}/${"DOCTHUMB-" + dateTime.millisecondsSinceEpoch.toString() + "-" + path.basename(fileImageChangeThumbnail!.path)}");
            thumb = "DOCTHUMB-" +
                dateTime.millisecondsSinceEpoch.toString() +
                "-" +
                path.basename(fileImageChangeThumbnail!.path);
          }
        } else {}
      } else {
        if (filesSend.length == 1) {
          var newFilename = path.basename(filesSend[0].path);
          if (fileType[0] == "image") {
            typeFile = "1";
            thumb = path.basename(filesSend[0].path);
          } else {
            typeFile = "2";
            thumb = path.basename(videosThumb[0].path);
          }
          filesSend[0].copySync("${directory.path}/$newFilename");
          file = newFilename;
        } else {}
      }
      String data = "";
      if (targetAudience == "4") {
        data = jsonEncode(groupIdChosen);
      } else if (targetAudience == "5") {
        data = jsonEncode(fpinChosen);
      } else {
        data = "";
      }
      // print(
      //     "broadcast ==> $title, $broadcastMode, $message, $timeValStart, $timeValEnd, $targetAudience, $data, $typeFile, $thumb, $file, $broadcastType, $link");
      var result = await API.broadcastMessage(
          title,
          broadcastMode,
          message,
          timeValStart,
          timeValEnd,
          targetAudience,
          data,
          typeFile,
          thumb,
          file,
          broadcastType,
          link);
      // print("result: $result");
      if (result == "00") {
        Fluttertoast.showToast(
            msg: "Successfully Broadcast Message",
            toastLength: Toast.LENGTH_LONG);
        Navigator.pop(context);
      } else {
        setState(() {
          circularIndicator = false;
        });
        Fluttertoast.showToast(
            msg: "Failed Broadcast Message, check your connection.",
            toastLength: Toast.LENGTH_LONG);
      }
    }
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        automaticallyImplyLeading: circularIndicator ? false : true,
        backgroundColor: AppColor.primaryColor,
        title: Text("Broadcast Message"),
      ),
      body: circularIndicator
          ? Center(child: CupertinoActivityIndicator())
          : Stack(
              children: [
                SingleChildScrollView(
                  child: Column(
                    crossAxisAlignment: CrossAxisAlignment.start,
                    mainAxisAlignment: MainAxisAlignment.start,
                    children: [
                      Container(
                        padding: EdgeInsets.only(left: 5.0, top: 5.0),
                        child: Text(
                          "Target Audience",
                          style: TextStyle(
                              fontSize: 16.0, color: Colors.grey[600]),
                        ),
                      ),
                      Container(
                        padding: EdgeInsets.only(left: 5.0, right: 5.0),
                        margin: EdgeInsets.only(left: 5.0, right: 5.0),
                        decoration: BoxDecoration(
                            border: Border(
                                bottom:
                                    BorderSide(width: 1, color: Colors.black))),
                        child: DropdownButtonHideUnderline(
                          child: DropdownButton(
                            value: targetAudience,
                            onChanged: (value) {
                              setState(() {
                                targetAudience = value as String;
                              });
                            },
                            isExpanded: true,
                            items: [
                              DropdownMenuItem(
                                value: "1",
                                child: Text("Customer"),
                              ),
                              DropdownMenuItem(
                                value: "2",
                                child: Text("Team Member"),
                              ),
                              DropdownMenuItem(
                                value: "3",
                                child: Text("All User"),
                              ),
                              DropdownMenuItem(
                                value: "4",
                                child: Text("Group"),
                              ),
                              DropdownMenuItem(
                                value: "5",
                                child: Text("Spesific User"),
                              )
                            ],
                          ),
                        ),
                      ),
                      targetAudience == "4"
                          ? Container(
                              margin: EdgeInsets.only(left: 5.0, right: 5.0),
                              padding: EdgeInsets.only(bottom: 10.0),
                              decoration: BoxDecoration(
                                  border: Border(
                                      bottom: BorderSide(
                                          width: 1, color: Colors.grey[300]!))),
                              width: double.infinity,
                              child: Column(
                                crossAxisAlignment: CrossAxisAlignment.start,
                                mainAxisAlignment: MainAxisAlignment.start,
                                children: [
                                  Container(
                                    padding: EdgeInsets.only(top: 20.0),
                                    child: Text(
                                      "Group*",
                                      style: TextStyle(
                                          fontSize: 16.0,
                                          color: Colors.grey[600]),
                                    ),
                                  ),
                                  Container(
                                    margin: EdgeInsets.only(bottom: 10.0),
                                    padding:
                                        EdgeInsets.only(left: 5.0, right: 5.0),
                                    child: Wrap(
                                      children: List.generate(
                                          groupChoosen.length,
                                          (index) => Container(
                                                padding: EdgeInsets.all(10.0),
                                                width: MediaQuery.of(context)
                                                        .size
                                                        .width *
                                                    0.45,
                                                height: 50,
                                                decoration: BoxDecoration(
                                                    border: Border.all(
                                                        color: Colors.black),
                                                    borderRadius:
                                                        BorderRadius.circular(
                                                            3.0)),
                                                child: Row(
                                                  mainAxisAlignment:
                                                      MainAxisAlignment
                                                          .spaceBetween,
                                                  children: <Widget>[
                                                    Expanded(
                                                      child: Row(
                                                        mainAxisAlignment:
                                                            MainAxisAlignment
                                                                .start,
                                                        children: <Widget>[
                                                          Icon(Icons.person,
                                                              color: Colors
                                                                  .grey[600]),
                                                          SizedBox(width: 10.0),
                                                          Text(
                                                            groupChoosen[index],
                                                            overflow:
                                                                TextOverflow
                                                                    .ellipsis,
                                                          ),
                                                        ],
                                                      ),
                                                    ),
                                                    GestureDetector(
                                                        onTap: () {
                                                          setState(() {
                                                            groupNameChosen
                                                                .removeAt(
                                                                    index);
                                                            groupIdChosen
                                                                .removeAt(
                                                                    index);
                                                            dataGroupChosen
                                                                .removeAt(
                                                                    index);
                                                          });
                                                        },
                                                        child: Icon(
                                                            Icons.cancel,
                                                            color: Colors.red))
                                                  ],
                                                ),
                                              )),
                                      spacing: 15.0,
                                      runSpacing: 10.0,
                                    ),
                                  ),
                                  AddGroup(
                                      listUpdate: dataChosen,
                                      listGroups: (name) {
                                        setState(() {
                                          if (!groupIdChosen
                                              .contains(name.split("~")[1])) {
                                            groupNameChosen
                                                .add(name.split("~")[0]);
                                            groupIdChosen
                                                .add(name.split("~")[1]);
                                            dataGroupChosen.add(name);
                                          }
                                        });
                                      })
                                ],
                              ),
                            )
                          : targetAudience == "5"
                              ? Container(
                                  margin:
                                      EdgeInsets.only(left: 5.0, right: 5.0),
                                  padding: EdgeInsets.only(bottom: 10.0),
                                  decoration: BoxDecoration(
                                      border: Border(
                                          bottom: BorderSide(
                                              width: 1,
                                              color: Colors.grey[300]!))),
                                  width: double.infinity,
                                  child: Column(
                                    crossAxisAlignment:
                                        CrossAxisAlignment.start,
                                    mainAxisAlignment: MainAxisAlignment.start,
                                    children: [
                                      Container(
                                        padding: EdgeInsets.only(top: 20.0),
                                        child: Text(
                                          "Participants*",
                                          style: TextStyle(
                                              fontSize: 16.0,
                                              color: Colors.grey[600]),
                                        ),
                                      ),
                                      Container(
                                        margin: EdgeInsets.only(bottom: 10.0),
                                        padding: EdgeInsets.only(
                                            left: 5.0, right: 5.0),
                                        child: Wrap(
                                          children: List.generate(
                                              nameChosen.length,
                                              (index) => Container(
                                                    padding:
                                                        EdgeInsets.all(10.0),
                                                    width:
                                                        MediaQuery.of(context)
                                                                .size
                                                                .width *
                                                            0.45,
                                                    height: 50,
                                                    decoration: BoxDecoration(
                                                        border: Border.all(
                                                            color:
                                                                Colors.black),
                                                        borderRadius:
                                                            BorderRadius
                                                                .circular(3.0)),
                                                    child: Row(
                                                      mainAxisAlignment:
                                                          MainAxisAlignment
                                                              .spaceBetween,
                                                      children: <Widget>[
                                                        Expanded(
                                                          child: Row(
                                                            mainAxisAlignment:
                                                                MainAxisAlignment
                                                                    .start,
                                                            children: <Widget>[
                                                              Icon(Icons.person,
                                                                  color: Colors
                                                                          .grey[
                                                                      600]),
                                                              SizedBox(
                                                                  width: 10.0),
                                                              Text(
                                                                nameChosen[
                                                                    index],
                                                                overflow:
                                                                    TextOverflow
                                                                        .ellipsis,
                                                              ),
                                                            ],
                                                          ),
                                                        ),
                                                        GestureDetector(
                                                            onTap: () {
                                                              setState(() {
                                                                nameChosen
                                                                    .removeAt(
                                                                        index);
                                                                fpinChosen
                                                                    .removeAt(
                                                                        index);
                                                                dataChosen
                                                                    .removeAt(
                                                                        index);
                                                              });
                                                            },
                                                            child: Icon(
                                                                Icons.cancel,
                                                                color:
                                                                    Colors.red))
                                                      ],
                                                    ),
                                                  )),
                                          spacing: 15.0,
                                          runSpacing: 10.0,
                                        ),
                                      ),
                                      AddMember(
                                          listUpdate: dataChosen,
                                          listMembers: (name) {
                                            setState(() {
                                              if (!fpinChosen.contains(
                                                  name.split("~")[1])) {
                                                nameChosen
                                                    .add(name.split("~")[0]);
                                                fpinChosen
                                                    .add(name.split("~")[1]);
                                                dataChosen.add(name);
                                              }
                                            });
                                          })
                                    ],
                                  ),
                                )
                              : Container(),
                      Container(
                        padding: EdgeInsets.only(left: 5.0, top: 20.0),
                        child: Text(
                          "Broadcast Type",
                          style: TextStyle(
                              fontSize: 16.0, color: Colors.grey[600]),
                        ),
                      ),
                      Container(
                        padding: EdgeInsets.only(left: 5.0, right: 5.0),
                        margin: EdgeInsets.only(left: 5.0, right: 5.0),
                        decoration: BoxDecoration(
                            border: Border(
                                bottom:
                                    BorderSide(width: 1, color: Colors.black))),
                        child: DropdownButtonHideUnderline(
                          child: DropdownButton(
                            value: broadcastType,
                            onChanged: (value) {
                              setState(() {
                                broadcastType = value as String;
                              });
                            },
                            isExpanded: true,
                            items: [
                              DropdownMenuItem(
                                value: "1",
                                child: Text("Push Notification"),
                              ),
                              DropdownMenuItem(
                                value: "2",
                                child: Text("In App"),
                              ),
                            ],
                          ),
                        ),
                      ),
                      Container(
                        padding: EdgeInsets.only(left: 5.0, top: 20.0),
                        child: Text(
                          "Broadcast Mode",
                          style: TextStyle(
                              fontSize: 16.0, color: Colors.grey[600]),
                        ),
                      ),
                      Container(
                        padding: EdgeInsets.only(left: 5.0, right: 5.0),
                        margin: EdgeInsets.only(left: 5.0, right: 5.0),
                        decoration: BoxDecoration(
                            border: Border(
                                bottom:
                                    BorderSide(width: 1, color: Colors.black))),
                        child: DropdownButtonHideUnderline(
                          child: DropdownButton(
                            value: broadcastMode,
                            onChanged: (value) {
                              setState(() {
                                broadcastMode = value as String;
                              });
                            },
                            isExpanded: true,
                            items: [
                              DropdownMenuItem(
                                value: "1",
                                child: Text("One-Time"),
                              ),
                              DropdownMenuItem(
                                value: "2",
                                child: Text("Daily"),
                              ),
                              DropdownMenuItem(
                                value: "3",
                                child: Text("Weekly"),
                              ),
                              DropdownMenuItem(
                                value: "4",
                                child: Text("Monthly"),
                              )
                            ],
                          ),
                        ),
                      ),
                      Container(
                        padding: EdgeInsets.only(left: 5.0, top: 20.0),
                        child: Text(
                          "Starting Date",
                          style: TextStyle(
                              fontSize: 16.0, color: Colors.grey[600]),
                        ),
                      ),
                      Container(
                        padding: EdgeInsets.only(
                            left: 10.0, right: 10.0, bottom: 10.0),
                        margin: EdgeInsets.only(
                          top: 5.0,
                          bottom: 10.0,
                          left: 5.0,
                          right: 5.0,
                        ),
                        decoration: BoxDecoration(
                            border: Border(
                                bottom: BorderSide(
                                    width: 1, color: Colors.grey[300]!))),
                        child: Row(
                          mainAxisAlignment: MainAxisAlignment.start,
                          children: <Widget>[
                            CalendarForm(
                                times: timeValDateStart,
                                date: (date) {
                                  List<String> dataTanggal = date.split("-");
                                  tahun = int.parse(dataTanggal[2]);
                                  bulan = int.parse(dataTanggal[1]);
                                  tanggal = int.parse(dataTanggal[0]);
                                  setState(() {
                                    timeValDateStart = DateTime(
                                            tahun, bulan, tanggal, jam, menit)
                                        .millisecondsSinceEpoch;
                                    if (timeValDateEnd <= timeValDateStart) {
                                      timeValDateEnd = DateTime(
                                              tahun, bulan, tanggal, jam, menit)
                                          .millisecondsSinceEpoch;
                                    }
                                  });
                                }),
                            SizedBox(width: 10.0),
                            TimeForm(
                                timeValue: timeValStart,
                                time: (time) {
                                  List<String> dataWaktu = time.split(":");
                                  menit = int.parse(dataWaktu[1]);
                                  jam = int.parse(dataWaktu[0]);
                                  setState(() {
                                    timeValStart = DateTime(
                                            tahun, bulan, tanggal, jam, menit)
                                        .millisecondsSinceEpoch;
                                    if (timeValEnd <= timeValStart) {
                                      timeValEnd = DateTime(
                                              tahun, bulan, tanggal, jam, menit)
                                          .millisecondsSinceEpoch;
                                    }
                                  });
                                })
                          ],
                        ),
                      ),
                      broadcastMode == "2" ||
                              broadcastMode == "3" ||
                              broadcastMode == "4"
                          ? Column(
                              crossAxisAlignment: CrossAxisAlignment.start,
                              mainAxisAlignment: MainAxisAlignment.start,
                              children: [
                                Container(
                                  padding:
                                      EdgeInsets.only(left: 5.0, top: 20.0),
                                  child: Text(
                                    "Ending Date",
                                    style: TextStyle(
                                        fontSize: 16.0,
                                        color: Colors.grey[600]),
                                  ),
                                ),
                                Container(
                                  padding: EdgeInsets.only(
                                      left: 10.0, right: 10.0, bottom: 10.0),
                                  margin: EdgeInsets.only(
                                    top: 5.0,
                                    bottom: 10.0,
                                    left: 5.0,
                                    right: 5.0,
                                  ),
                                  decoration: BoxDecoration(
                                      border: Border(
                                          bottom: BorderSide(
                                              width: 1,
                                              color: Colors.grey[300]!))),
                                  child: Row(
                                    mainAxisAlignment: MainAxisAlignment.start,
                                    children: <Widget>[
                                      CalendarForm(
                                          times: timeValDateEnd,
                                          dateStart: timeValDateStart,
                                          date: (date) {
                                            List<String> dataTanggal =
                                                date.split("-");
                                            tahun = int.parse(dataTanggal[2]);
                                            bulan = int.parse(dataTanggal[1]);
                                            tanggal = int.parse(dataTanggal[0]);
                                            setState(() {
                                              timeValDateEnd = DateTime(
                                                      tahun,
                                                      bulan,
                                                      tanggal,
                                                      jam,
                                                      menit)
                                                  .millisecondsSinceEpoch;
                                            });
                                          }),
                                      SizedBox(width: 10.0),
                                      TimeForm(
                                          timeValue: timeValEnd,
                                          dateEnd: timeValDateEnd,
                                          timeStart: timeValDateStart,
                                          time: (time) {
                                            List<String> dataWaktu =
                                                time.split(":");
                                            menit = int.parse(dataWaktu[1]);
                                            jam = int.parse(dataWaktu[0]);
                                            setState(() {
                                              timeValEnd = DateTime(
                                                      tahun,
                                                      bulan,
                                                      tanggal,
                                                      jam,
                                                      menit)
                                                  .millisecondsSinceEpoch;
                                            });
                                          })
                                    ],
                                  ),
                                )
                              ],
                            )
                          : Container(),
                      Container(
                        padding: EdgeInsets.only(left: 5.0, top: 20.0),
                        child: Text(
                          "Title*",
                          style: TextStyle(
                              fontSize: 16.0, color: Colors.grey[600]),
                        ),
                      ),
                      Container(
                          margin: EdgeInsets.only(
                              left: 10.0, right: 10.0, bottom: 5.0, top: 5.0),
                          child: Container(
                            child: TextFormField(
                              textInputAction: TextInputAction.newline,
                              inputFormatters: [
                                LengthLimitingTextInputFormatter(255),
                              ],
                              controller: titleController,
                              cursorColor: AppColor.primaryColor,
                              decoration: InputDecoration(
                                  focusedBorder: UnderlineInputBorder(
                                    borderSide: BorderSide(
                                        color: AppColor.primaryColor),
                                  ),
                                  border: UnderlineInputBorder(
                                    borderSide: new BorderSide(
                                        color: AppColor.primaryColor),
                                  ),
                                  hintText: "Enter Title",
                                  focusColor: AppColor.primaryColor,
                                  // labelText: "Title*",
                                  labelStyle:
                                      TextStyle(color: AppColor.primaryColor)),
                              keyboardType: TextInputType.multiline,
                              maxLines: null,
                            ),
                          )),
                      Container(
                        padding: EdgeInsets.only(left: 5.0, top: 20.0),
                        child: Text(
                          "Message*",
                          style: TextStyle(
                              fontSize: 16.0, color: Colors.grey[600]),
                        ),
                      ),
                      Container(
                          margin: EdgeInsets.only(
                              left: 10.0, right: 10.0, bottom: 5.0, top: 5.0),
                          child: Container(
                            child: TextFormField(
                              textInputAction: TextInputAction.newline,
                              inputFormatters: [
                                LengthLimitingTextInputFormatter(255),
                              ],
                              controller: messageController,
                              cursorColor: AppColor.primaryColor,
                              decoration: InputDecoration(
                                  focusedBorder: UnderlineInputBorder(
                                    borderSide: BorderSide(
                                        color: AppColor.primaryColor),
                                  ),
                                  border: UnderlineInputBorder(
                                    borderSide: new BorderSide(
                                        color: AppColor.primaryColor),
                                  ),
                                  hintText: "Enter Message...",
                                  focusColor: AppColor.primaryColor,
                                  // labelText: "Message*",
                                  labelStyle:
                                      TextStyle(color: AppColor.primaryColor)),
                              keyboardType: TextInputType.multiline,
                              maxLines: 5,
                            ),
                          )),
                      Container(
                        padding: EdgeInsets.only(left: 5.0, top: 20.0),
                        child: Column(
                          mainAxisAlignment: MainAxisAlignment.start,
                          mainAxisSize: MainAxisSize.max,
                          crossAxisAlignment: CrossAxisAlignment.start,
                          children: <Widget>[
                            Text(
                              "Attachment (optional)",
                              style: TextStyle(
                                  fontSize: 16.0, color: Colors.grey[600]),
                            ),
                            _decideFileView()
                          ],
                        ),
                      ),
                      Container(
                        child: Row(
                          mainAxisAlignment: MainAxisAlignment.end,
                          children: <Widget>[
                            IconButton(
                              icon: Image.asset(
                                assets_menu_bottom[1],
                                width: 25.0,
                                height: 30.0,
                                package: "palio_lite",
                              ),
                              onPressed: () async {
                                if (FocusScope.of(context).hasFocus) {
                                  FocusScope.of(context).unfocus();
                                  await Future.delayed(
                                      Duration(milliseconds: 100));
                                }
                                if (filesSend.length == 1) {
                                  Fluttertoast.showToast(
                                      msg: "You can only attach one file");
                                } else {
                                  showDialog(
                                      context: context,
                                      builder: (BuildContext context) =>
                                          SimpleDialog(
                                            children: <Widget>[
                                              ListTile(
                                                title: Text("Take Photo"),
                                                onTap: () {
                                                  if (fileDocuments.length >
                                                      0) {
                                                    _onFilePhotoVideo(0);
                                                  } else {
                                                    _openCamera(context);
                                                  }
                                                },
                                              ),
                                              ListTile(
                                                title:
                                                    Text("Take From Gallery"),
                                                onTap: () {
                                                  if (fileDocuments.length >
                                                      0) {
                                                    _onFilePhotoVideo(1);
                                                  } else {
                                                    _openGallery(context);
                                                  }
                                                },
                                              )
                                            ],
                                          ));
                                }
                              },
                            ),
                            IconButton(
                                icon: Image.asset(
                                  assets_menu_bottom[2],
                                  width: 27.0,
                                  height: 30.0,
                                  package: "palio_lite",
                                ),
                                onPressed: () async {
                                  if (FocusScope.of(context).hasFocus) {
                                    FocusScope.of(context).unfocus();
                                    await Future.delayed(
                                        Duration(milliseconds: 100));
                                  }
                                  if (filesSend.length == 1) {
                                    Fluttertoast.showToast(
                                        msg: "You can only attach one file");
                                  } else {
                                    showDialog(
                                        context: context,
                                        builder: (BuildContext context) =>
                                            SimpleDialog(
                                              children: <Widget>[
                                                ListTile(
                                                  title: Text("Record Video"),
                                                  onTap: () {
                                                    if (fileDocuments.length >
                                                        0) {
                                                      _onFilePhotoVideo(2);
                                                    } else {
                                                      _openVideoCamera(context);
                                                    }
                                                  },
                                                ),
                                                ListTile(
                                                  title:
                                                      Text("Take From Gallery"),
                                                  onTap: () {
                                                    if (fileDocuments.length >
                                                        0) {
                                                      _onFilePhotoVideo(3);
                                                    } else {
                                                      _openVideoGallery(
                                                          context);
                                                    }
                                                  },
                                                )
                                              ],
                                            ));
                                  }
                                }),
                            IconButton(
                                icon: Image.asset(
                                  assets_menu_bottom[0],
                                  width: 25.0,
                                  height: 30.0,
                                  package: "palio_lite",
                                ),
                                onPressed: () async {
                                  if (FocusScope.of(context).hasFocus) {
                                    FocusScope.of(context).unfocus();
                                    await Future.delayed(
                                        Duration(milliseconds: 100));
                                  }
                                  if (filesSend.length > 0) {
                                    _onFileDocument();
                                  } else {
                                    _openFileManager(context);
                                  }
                                })
                          ],
                        ),
                      ),
                      Container(
                        margin: EdgeInsets.only(left: 10.0, right: 10.0),
                        child: Divider(
                          thickness: 3,
                        ),
                      ),
                      Container(
                        padding: EdgeInsets.only(left: 5.0, top: 20.0),
                        child: Text(
                          "Link (optional)",
                          style: TextStyle(
                              fontSize: 16.0, color: Colors.grey[600]),
                        ),
                      ),
                      Container(
                          margin: EdgeInsets.only(
                              left: 10.0, right: 10.0, bottom: 5.0, top: 5.0),
                          child: Container(
                            child: TextFormField(
                              textInputAction: TextInputAction.done,
                              inputFormatters: [
                                LengthLimitingTextInputFormatter(255),
                              ],
                              controller: linkController,
                              cursorColor: AppColor.primaryColor,
                              decoration: InputDecoration(
                                  focusedBorder: UnderlineInputBorder(
                                    borderSide: BorderSide(
                                        color: AppColor.primaryColor),
                                  ),
                                  border: UnderlineInputBorder(
                                    borderSide: new BorderSide(
                                        color: AppColor.primaryColor),
                                  ),
                                  hintText: "Enter Link",
                                  focusColor: AppColor.primaryColor,
                                  labelStyle:
                                      TextStyle(color: AppColor.primaryColor)),
                              keyboardType: TextInputType.multiline,
                              maxLines: null,
                            ),
                          )),
                      SizedBox(height: 80),
                    ],
                  ),
                ),
                Align(
                  alignment: Alignment.bottomRight,
                  child: Container(
                    width: double.infinity,
                    color: Colors.white,
                    child: Column(
                      crossAxisAlignment: CrossAxisAlignment.start,
                      mainAxisSize: MainAxisSize.min,
                      children: [
                        Divider(
                          thickness: 1,
                        ),
                        Row(
                          mainAxisAlignment: MainAxisAlignment.end,
                          children: [
                            Container(
                              margin: EdgeInsets.only(right: 5.0, bottom: 5.0),
                              width: 150,
                              height: 50,
                              decoration: BoxDecoration(
                                color: Colors.blueGrey,
                                borderRadius: BorderRadius.circular(3.0),
                              ),
                              child: Material(
                                color: Colors.transparent,
                                child: InkWell(
                                  onTap: _sendBroadcast,
                                  child: Row(
                                    mainAxisAlignment: MainAxisAlignment.start,
                                    crossAxisAlignment:
                                        CrossAxisAlignment.center,
                                    children: [
                                      Expanded(
                                        flex: 1,
                                        child: Icon(Icons.check,
                                            color: Colors.grey[300]),
                                      ),
                                      Expanded(
                                        flex: 4,
                                        child: Container(
                                          alignment: Alignment.center,
                                          child: Text("BROADCAST",
                                              style: TextStyle(
                                                  color: Colors.grey[300],
                                                  fontSize: 12)),
                                        ),
                                      ),
                                    ],
                                  ),
                                ),
                              ),
                            )
                          ],
                        ),
                      ],
                    ),
                  ),
                )
              ],
            ),
    );
  }
}
