import 'dart:async';
import 'dart:convert';
import 'dart:io';

import 'package:exif/exif.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:flutter_speed_dial/flutter_speed_dial.dart';
import 'package:flutter_translate/flutter_translate.dart';
import 'package:fluttertoast/fluttertoast.dart';
import 'package:image/image.dart' as DartImage;
import 'package:image_picker/image_picker.dart';
import 'package:intl/intl.dart';
import 'package:page_transition/page_transition.dart';
import 'package:palio_lite/api.dart';

// import 'package:un_ios_app/Model/story_post.dart';
import 'package:palio_lite/app_color.dart';
import 'package:palio_lite/call/audio_call.dart';
import 'package:palio_lite/call/video_call.dart';
import 'package:palio_lite/chat/chat_screen.dart';
import 'package:palio_lite/chat/friend_list.dart';
import 'package:palio_lite/chat/widgets/about.dart';
import 'package:palio_lite/chat/widgets/dialog_ls.dart';
import 'package:palio_lite/chat/widgets/video_player.dart';
import 'package:palio_lite/chat/widgets/widget_Image_Download.dart';
import 'package:palio_lite/db_helper.dart';
import 'package:palio_lite/ip_list.dart';
import 'package:palio_lite/palio_button.dart';
import 'package:path_provider/path_provider.dart';
import 'package:qr_flutter/qr_flutter.dart';
import 'package:share/share.dart';
import 'package:shared_preferences/shared_preferences.dart';
import 'package:video_player/video_player.dart';

class PAProfile extends StatefulWidget {
  final Map profileDet;

  const PAProfile({Key? key, this.profileDet = const {}}) : super(key: key);

  @override
  _PAProfileState createState() => _PAProfileState();
}

class _PAProfileState extends State<PAProfile>
    with SingleTickerProviderStateMixin {
  bool isEdited = false;
  bool _dialVisible = true;
  TextEditingController? _nameController;
  TabController? _tabController;
  bool isPlayed = false;
  VideoPlayerController? _controller;
  String name = "";
  Timer? _timerRefreshBuddy;

  List<Widget> stories = [];

  String httpImage = IPList.imagePost;
  String httpVideo = IPList.videoImage;

  List<Map<dynamic, dynamic>> get getVTimeLineData => _vTimeLineData;

  List<Map<dynamic, dynamic>> get getVStoryData => _vStoryData;

  set vTimeLineData(Map<dynamic, dynamic> value) {
    _vTimeLineData.add(value);
  }

  set vStoryData(Map<dynamic, dynamic> value) {
    _vStoryData.add(value);
  }

  List<dynamic> resultQueryFriend = [];

  List<String> post_id_checker = [];

  // List<StoryPost> storyData = [];
  List<Map<dynamic, dynamic>> _vStoryData = [];
  List<Map<dynamic, dynamic>> _vTimeLineData = [];

  void onUpdatePost() {
    API.onPostUpdate = (String status, String message) {
      print("post update $status $message");
      if (status == "UploadStory") {
        print("from callback");
        stories = [];
        post_id_checker = [];
        // storyData = [];
        setState(() {
          _getStoryData();
        });
      }
    };
  }

  void _showQrCodeDialog() {
    showDialog(
        context: context,
        builder: (context) {
          return CupertinoAlertDialog(
              insetAnimationCurve: Curves.easeInBack,
              content: Container(
                  height: 260,
                  child: Column(
                    children: <Widget>[
                      QrImage(
                        padding: EdgeInsets.all(0),
                        data: widget.profileDet['f_pin'],
                        version: QrVersions.auto,
                        foregroundColor: AppColor.primaryColor,
                      ),
                      Align(
                        alignment: Alignment.center,
                        child: Container(
                            height: 30,
                            padding: EdgeInsets.only(
                                left: 10, right: 10, top: 5, bottom: 5),
                            child: Text(
                              widget.profileDet['f_pin'],
                              style: TextStyle(fontSize: 16),
                            ),
                            decoration: BoxDecoration(
                                color: Colors.white,
                                borderRadius: BorderRadius.circular(3))),
                      )
                    ],
                  )),
              actions: <Widget>[
                CupertinoDialogAction(
                  onPressed: () {
                    Share.share(
                        "Add me on:" + " '${widget.profileDet['f_pin']}'");
                    Navigator.pop(context);
                  },
                  child: Text(
                    "Share",
                    style:
                        TextStyle(color: AppColor.primaryColor, fontSize: 20),
                  ),
                ),
                CupertinoDialogAction(
                  onPressed: () {
                    Clipboard.setData(
                        ClipboardData(text: widget.profileDet['f_pin']));
                    Navigator.pop(context);
                  },
                  child: Text("Copy",
                      style: TextStyle(
                          color: AppColor.primaryColor, fontSize: 20)),
                ),
                CupertinoDialogAction(
                  onPressed: () => Navigator.pop(context),
                  child: Text("Cancel",
                      style: TextStyle(color: Colors.red, fontSize: 20)),
                )
              ]);
        });
  }

  @override
  void initState() {
    // SharedPreferences.getInstance().then((prefs) {
    //   String idMe = prefs.getString("hasLogin");
    //   API.pullBatchBuddyList(idMe);
    //   _timerRefreshBuddy = Timer(Duration(seconds: 2), () {
    //     setState(() {});
    //     API.pullBatchBuddyList(idMe);
    //   });
    // });

    _nameController = TextEditingController(text: widget.profileDet['name']);
    name = widget.profileDet['name'];
    _tabController = TabController(vsync: this, length: 2);
    // _tabController.addListener(_handleTabSelection);

    // _controller = VideoPlayerController.network(
    //     'http://commondatastorage.googleapis.com/gtv-videos-bucket/sample/ForBiggerMeltdowns.mp4');

    // _controller.addListener(() {
    //   if (mounted) {
    //     setState(() {});
    //   }
    // });

    // _controller.setLooping(false);
    // _controller.initialize();
    stories = [];
    post_id_checker = [];
    // storyData = [];
    setState(() {
      onUpdatePost();
      _getData();
      _getStoryData();
    });
    super.initState();
  }

  void _handleTabSelection() {
    // if (_controller.value.isPlaying) {
    //   _controller.pause();
    //   isPlayed = false;
    // }
    _controller?.dispose();
    setState(() {});
  }

  @override
  void dispose() {
    _tabController?.dispose();
    _nameController?.dispose();
    _controller?.dispose();
    // if (_controller != null) {
    //   if (_controller.value.isPlaying) _controller.pause();
    //   _controller.dispose();
    // }
    super.dispose();
  }

  List<Widget> _storyList() {
    List<Widget> storie = [];
    if (widget.profileDet['myProfile']) {
      stories.add(Container(
        alignment: Alignment.centerLeft,
        margin: EdgeInsets.only(top: 10),
        child: Column(
          crossAxisAlignment: CrossAxisAlignment.center,
          children: <Widget>[
            Stack(
              alignment: Alignment.center,
              children: <Widget>[
                Container(
                  width: 55,
                  height: 55,
                  decoration: BoxDecoration(
                      color: Colors.transparent,
                      shape: BoxShape.circle,
                      border: Border.all(
                        color: Colors.grey,
                        width: 1.0,
                      )),
                ),
                // RawMaterialButton(
                //   fillColor: Colors.white,
                //   onPressed: () {
                //     Navigator.push(
                //         context,
                //         PageTransition(
                //             type: PageTransitionType.fade,
                //             child: AddStoryTimeline(
                //               data: _vTimeLineData,
                //             )));
                //   },
                //   constraints: BoxConstraints.tight(Size(52, 52)),
                //   shape: new CircleBorder(),
                //   child: Icon(
                //     CupertinoIcons.add,
                //     color: AppColor.primaryColor,
                //   ),
                // )
              ],
            ),
            // Container(
            //   margin: EdgeInsets.only(top: 5),
            //   child: Text(
            //     "Make a Story",
            //     style: TextStyle(fontSize: 14),
            //   ),
            // )
          ],
        ),
      ));
    }
//    for (int i = 0; i < vTimeLineData.length - 7; i++) {
//
//      stories.add(GestureDetector(
//        onTap: () {
//          Navigator.push(
//              context,
//              PageTransition(
//                  type: PageTransitionType.fade,
//                  child: VerticalPersonalTimeLine(
//                    data: vTimeLineData[i]["username"],
//                  )));
//        },
//        child: Container(
//          margin: EdgeInsets.only(left: 8.0, right: 8.0, top: 10.0),
//          width: 70.0,
//          height: 80.0,
//          child: Column(
//            mainAxisSize: MainAxisSize.min,
//            children: <Widget>[
//              Container(
//                width: 55.0,
//                height: 55.0,
//                margin: EdgeInsets.only(bottom: 5.0, top: 4.0),
//                child: ClipRRect(
//                  borderRadius: new BorderRadius.circular(100.0),
//                  child: Stack(
//                    children: <Widget>[
//                      Container(
//                        width: 55,
//                        height: 55,
//                        child: CachedNetworkImage(
//                          imageUrl: vTimeLineData[i]["image"][0],
//                          fit: BoxFit.fill,
//                          placeholder: (context, url) => Image.asset(
//                            'assets/images/borobudur.jpeg',
//                            width: 55,
//                            height: 55,
//                            fit: BoxFit.fill,
//                          ),
//                          errorWidget: (context, url, error) => Image.asset(
//                            'assets/images/borobudur.jpeg',
//                            width: 55,
//                            height: 55,
//                            fit: BoxFit.fill,
//                          ),
//                        ),
//                      ),
//                    ],
//                  ),
//                ),
//              ),
//              Container(
//                padding: EdgeInsets.only(top: 2.0),
//                child: Text(
//                  vTimeLineData[i]["title"],
//                  overflow: TextOverflow.fade,
//                  softWrap: false,
//                  style:
//                      TextStyle(fontSize: 12.0, fontFamily: "Roboto Reguler"),
//                ),
//              ),
//            ],
//          ),
//        ),
//      ));
//    }

    return stories;
  }

  void _getStoryData() async {
    SharedPreferences prefs = await SharedPreferences.getInstance();
    // if (widget.profileDet['myProfile'])
    resultQueryFriend = await DBHelper().queryCustom(
        "SELECT f_pin, first_name, official_account, email, image_id, cell, upline_pin, quote, connected, privacy_flag, web, offline_mode, muted, address, bidang_industri, visi, misi, company_lat, company_lng FROM BUDDY where (f_pin <> '${widget.profileDet['f_pin']}' AND f_pin <> '')");
    // String dataTimeline = await API.retrieveTimeline(
    //     "0", "0", "1,2,3,4", "1,2,3,4,5,6,7,8,9,10,11,12", "");
    String dataTimeline =
        await API.retrievePostProfile(widget.profileDet['f_pin'], "0");
    String dataStory = await API.pullStoryListPersonal(
        "1,2,3,4", "0", widget.profileDet["f_pin"]);
    // print("data timeline personal:" + dataTimeline);
    // print("data story personal: " + dataStory);
    List<dynamic> jsonStory = dataStory != null ? jsonDecode(dataStory) : null;
    // print("json story personal: " + jsonStory.toString());
    List<dynamic> jsonTimeline =
        dataTimeline != null ? jsonDecode(dataTimeline) : null;

    // if (jsonStory != null) {
    //   for (var i = 0; i < jsonStory.length; i++) {
    //     List<String> dataStoryDetail = jsonStory[i].toString().split("|");
    //     StoryPost storyPost = StoryPost();
    //     storyPost.title = dataStoryDetail[1];
    //     storyPost.created_date = dataStoryDetail[0];
    //     storyPost.upload_date = dataStoryDetail[3];
    //     storyPost.post_id = dataStoryDetail[5];
    //     storyPost.story_id = dataStoryDetail[4];
    //     storyPost.thumbnail = dataStoryDetail[2];
    //     storyData.add(storyPost);
    //   }
    // }
    if (widget.profileDet['myProfile']) {
      stories.add(Container(
        alignment: Alignment.centerLeft,
        margin: EdgeInsets.only(top: 10),
        child: Column(
          crossAxisAlignment: CrossAxisAlignment.center,
          children: <Widget>[
            Stack(
              alignment: Alignment.center,
              children: <Widget>[
                Container(
                  width: 55,
                  height: 55,
                  decoration: BoxDecoration(
                      color: Colors.transparent,
                      shape: BoxShape.circle,
                      border: Border.all(
                        color: Colors.grey,
                        width: 1.0,
                      )),
                ),
                // RawMaterialButton(
                //   fillColor: Colors.white,
                //   onPressed: () {
                //     Navigator.push(
                //         context,
                //         PageTransition(
                //             type: PageTransitionType.fade,
                //             child: AddStoryTimeline(
                //               data: _vTimeLineData,
                //             )));
                //   },
                //   constraints: BoxConstraints.tight(Size(52, 52)),
                //   shape: new CircleBorder(),
                //   child: Icon(
                //     CupertinoIcons.add,
                //     color: AppColor.primaryColor,
                //   ),
                // )
              ],
            ),
            Container(
              margin: EdgeInsets.only(top: 5),
              child: Text(
                "Make a Story",
                style: TextStyle(fontSize: 14),
              ),
            )
          ],
        ),
      ));
    }

    // if (jsonTimeline != null) {
    //   for (var i = 0; i < jsonTimeline.length; i++) {
    //     DateTime date = new DateTime.fromMillisecondsSinceEpoch(
    //         int.parse(jsonTimeline[i]["A29"]));
    //     var format = new DateFormat('dd MMMM yyyy');
    //     List<dynamic> dataPersonAll = await DBHelper().queryCustom(
    //         "SELECT f_pin, first_name, last_name, image_id FROM BUDDY");
    //     List<dynamic> dataPerson = await DBHelper().queryCustom(
    //         "SELECT f_pin, first_name, last_name, image_id FROM BUDDY where f_pin='${jsonTimeline[i]["A00"]}'");
    //     print("f_pin: ${jsonTimeline[i]["A00"]}");
    //     print("dataPerson: ${dataPerson}");
    //     String time = format.format(date);
    //     var mediaType = jsonTimeline[i]["BN2"];
    //     List<String> listFile = List();
    //     List<String> listImage = List();
    //     List<String> listVideo = List();
    //     if (jsonTimeline[i]["BN"].contains("|")) {
    //       listFile = jsonTimeline[i]["BN"].split("|");
    //     } else {
    //       listFile.add(jsonTimeline[i]["BN"]);
    //     }
    //     for (var j = 0; j < listFile.length; j++) {
    //       if (mediaType == "2") {
    //         listVideo.add(httpVideo + listFile[j]);
    //       } else {
    //         listImage.add(httpImage + listFile[j]);
    //       }
    //     }
    //   }
    //   String f_pin = "";
    //   List<Map<dynamic, dynamic>> tempStoryData = List();
    //   print("length : " +
    //       storyData.length.toString() +
    //       " " +
    //       jsonTimeline.length.toString());
    //   for (var j = 0; j < storyData.length; j++) {
    //     for (var k = 0; k < jsonTimeline.length; k++) {
    //       if (jsonTimeline[k]["A00"] == widget.profileDet['f_pin']) {
    //         DateTime date = new DateTime.fromMillisecondsSinceEpoch(
    //             int.parse(jsonTimeline[k]["A29"]));
    //         var format = new DateFormat('dd MMMM yyyy');
    //         List<dynamic> dataPersonAll = await DBHelper().queryCustom(
    //             "SELECT f_pin, first_name, last_name, image_id FROM BUDDY");
    //         List<dynamic> dataPerson = await DBHelper().queryCustom(
    //             "SELECT f_pin, first_name, last_name, image_id FROM BUDDY where f_pin='${jsonTimeline[k]["A00"]}'");
    //         print("f_pin: ${jsonTimeline[k]["A00"]}");
    //         print("dataPerson: ${dataPerson}");
    //         String time = format.format(date);
    //         var mediaType = jsonTimeline[k]["BN2"];
    //         List<String> listFile = List();
    //         List<String> listImage = List();
    //         List<String> listVideo = List();
    //         if (jsonTimeline[k]["BN"].contains("|")) {
    //           listFile = jsonTimeline[k]["BN"].split("|");
    //         } else {
    //           listFile.add(jsonTimeline[k]["BN"]);
    //         }
    //         for (var j = 0; j < listFile.length; j++) {
    //           if (mediaType == "2") {
    //             listVideo.add(httpVideo + listFile[j]);
    //           } else {
    //             listImage.add(httpImage + listFile[j]);
    //           }
    //         }
    //         List<String> postList = storyData[j].post_id.split(",");
    //         for (var z = 0; z < postList.length; z++) {
    //           bool found = false;
    //           if (jsonTimeline[k]["PO1"].toString() == postList[z]) {
    //             found = true;
    //             tempStoryData.add({
    //               "timeline_id": "${jsonTimeline[k]["PO1"]}",
    //               "username": jsonTimeline[k]["A92"],
    //               "imagePerson": "",
    //               "user_id": jsonTimeline[k]["A00"],
    //               "date": time,
    //               "image": listImage,
    //               "last_update": jsonTimeline[k]["A11"],
    //               "thumbnail": !jsonTimeline[k]["BN3"].contains("|")
    //                   ? httpImage + jsonTimeline[k]["BN3"]
    //                   : httpImage + jsonTimeline[k]["BN3"].split("|")[0],
    //               "media": listVideo,
    //               "title": jsonTimeline[k]["A37"],
    //               "content": jsonTimeline[k]["A40"],
    //               "like_count": int.parse(jsonTimeline[k]["like"]),
    //               "comment_count": int.parse(jsonTimeline[k]["BL"]),
    //               "follower_count": int.parse(jsonTimeline[k]['PTZ']),
    //               "type_account": 0,
    //               "official_flag": 2,
    //               "media_type": int.parse(mediaType),
    //               "liked": int.parse(jsonTimeline[k]['FL1']),
    //               "following": int.parse(jsonTimeline[k]['PTZ']),
    //               "isOfficial": jsonTimeline[k]["oacc"],
    //               "dislike": int.parse(jsonTimeline[k]["dislike"]),
    //               "link": jsonTimeline[k]["Bk"],
    //               "is_me": jsonTimeline[k]["A00"] == idMe ? true : false,
    //               "document": listFile,
    //               "privacy": int.parse(jsonTimeline[k]["A27"])
    //             });
    //             f_pin = jsonTimeline[k]["A00"];
    //           }
    //           // if (found) {
    //           //   post_id_checker.add(storyData[j].story_id);
    //           // }
    //         }
    //       }
    //     }
    //
    //     if (tempStoryData.length > 0 &&
    //         !post_id_checker.contains(storyData[j].story_id)) {
    //       print("tempStory data : " + tempStoryData.toString());
    //       stories.add(GestureDetector(
    //         onTap: () {
    //           // Navigator.push(
    //           //     context,
    //           //     PageTransition(
    //           //         type: PageTransitionType.fade,
    //           //         child: VerticalPersonalTimeLine(
    //           //           f_pin: idMe,
    //           //           data: storyData[j].title,
    //           //           post_id: storyData[j].post_id.split(","),
    //           //           openFrom: "PERSONAL",
    //           //         )));
    //         },
    //         child: Container(
    //           alignment: Alignment.centerLeft,
    //           margin: EdgeInsets.only(top: 10),
    //           child: Column(
    //             crossAxisAlignment: CrossAxisAlignment.center,
    //             children: <Widget>[
    //               Stack(
    //                 alignment: Alignment.center,
    //                 children: <Widget>[
    //                   Container(
    //                     alignment: Alignment.center,
    //                     width: 55.0,
    //                     height: 55.0,
    //                     decoration: BoxDecoration(
    //                       color: Color(0xFFababab),
    //                       image: DecorationImage(
    //                         image: LocalImage(storyData[j].thumbnail),
    //                         fit: BoxFit.cover,
    //                       ),
    //                       borderRadius:
    //                           BorderRadius.all(Radius.circular(100.0)),
    //                       border: Border.all(
    //                         color: Colors.white,
    //                         width: 3.0,
    //                       ),
    //                     ),
    //                   )
    //                 ],
    //               ),
    //               Container(
    //                 margin: EdgeInsets.only(top: 5),
    //                 child: Text(
    //                   storyData[j].title,
    //                   style: TextStyle(fontSize: 14),
    //                 ),
    //               )
    //             ],
    //           ),
    //         ),
    //       ));
    //       print("stories length " + stories.length.toString());
    //       tempStoryData.clear();
    //     }
    //   }
    // }
    if (mounted) {
      setState(() {});
    }
  }

  void _getData() async {
    stories = [];
    post_id_checker = [];
    SharedPreferences prefs = await SharedPreferences.getInstance();
    String idMe = prefs.getString("hasLogin") ?? "";
    // if (widget.profileDet['myProfile'])
    resultQueryFriend = await DBHelper().queryCustom(
        "SELECT f_pin, first_name, official_account, email, image_id, cell, upline_pin, quote, connected, privacy_flag, web, offline_mode, muted, address, bidang_industri, visi, misi, company_lat, company_lng FROM BUDDY where (f_pin <> '${widget.profileDet['f_pin']}' AND f_pin <> '')");
    // String dataTimeline = await API.retrieveTimeline(
    //     "0", "0", "1,2,3,4", "1,2,3,4,5,6,7,8,9,10,11,12", "");
    String dataTimeline =
        await API.retrievePostProfile(widget.profileDet['f_pin'], "0");
    // String dataStory = await API.pullStoryListPersonal(
    //     "1,2,3,4", "0", widget.profileDet["f_pin"]);
    // print("data timeline personal:" + dataTimeline);
    // print("data story personal: " + dataStory);
    // List<dynamic> jsonStory = dataStory != null ? jsonDecode(dataStory) : null;
    // print("json story personal: " + jsonStory.toString());
    List<dynamic> jsonTimeline =
        dataTimeline != null ? jsonDecode(dataTimeline) : null;

    // if (jsonStory != null) {
    //   for (var i = 0; i < jsonStory.length; i++) {
    //     List<String> dataStoryDetail = jsonStory[i].toString().split("|");
    //     StoryPost storyPost = StoryPost();
    //     storyPost.title = dataStoryDetail[1];
    //     storyPost.created_date = dataStoryDetail[0];
    //     storyPost.upload_date = dataStoryDetail[3];
    //     storyPost.post_id = dataStoryDetail[5];
    //     storyPost.story_id = dataStoryDetail[4];
    //     storyPost.thumbnail = dataStoryDetail[2];
    //     storyData.add(storyPost);
    //   }
    // }
    // if (widget.profileDet['myProfile']) {
    //   stories.add(Container(
    //     alignment: Alignment.centerLeft,
    //     margin: EdgeInsets.only(top: 10),
    //     child: Column(
    //       crossAxisAlignment: CrossAxisAlignment.center,
    //       children: <Widget>[
    //         Stack(
    //           alignment: Alignment.center,
    //           children: <Widget>[
    //             Container(
    //               width: 55,
    //               height: 55,
    //               decoration: BoxDecoration(
    //                   color: Colors.transparent,
    //                   shape: BoxShape.circle,
    //                   border: Border.all(
    //                     color: Colors.grey,
    //                     width: 1.0,
    //                   )),
    //             ),
    //             RawMaterialButton(
    //               fillColor: Colors.white,
    //               onPressed: () {
    //                 Navigator.push(
    //                     context,
    //                     PageTransition(
    //                         type: PageTransitionType.fade,
    //                         child: AddStoryTimeline(
    //                           data: _vTimeLineData,
    //                         )));
    //               },
    //               constraints: BoxConstraints.tight(Size(52, 52)),
    //               shape: new CircleBorder(),
    //               child: Icon(
    //                 CupertinoIcons.add,
    //                 color: AppColor.primaryColor,
    //               ),
    //             )
    //           ],
    //         ),
    //         Container(
    //           margin: EdgeInsets.only(top: 5),
    //           child: Text(
    //             translate('makeStory'),
    //             style: TextStyle(fontSize: 14),
    //           ),
    //         )
    //       ],
    //     ),
    //   ));
    // }

    // List<String> post_id_checker = [];

    if (jsonTimeline != null) {
      for (var i = 0; i < jsonTimeline.length; i++) {
        DateTime date = new DateTime.fromMillisecondsSinceEpoch(
            int.parse(jsonTimeline[i]["A29"]));
        var format = new DateFormat('dd MMMM yyyy');
        List<dynamic> dataPersonAll = await DBHelper().queryCustom(
            "SELECT f_pin, first_name, last_name, image_id FROM BUDDY");
        List<dynamic> dataPerson = await DBHelper().queryCustom(
            "SELECT f_pin, first_name, last_name, image_id FROM BUDDY where f_pin='${jsonTimeline[i]["A00"]}'");
        print("f_pin: ${jsonTimeline[i]["A00"]}");
        print("dataPerson: ${dataPerson}");
        String time = format.format(date);
        var mediaType = jsonTimeline[i]["BN2"];
        List<String> listFile = [];
        List<String> listImage = [];
        List<String> listVideo = [];
        if (jsonTimeline[i]["BN"].contains("|")) {
          listFile = jsonTimeline[i]["BN"].split("|");
        } else {
          listFile.add(jsonTimeline[i]["BN"]);
        }
        for (var j = 0; j < listFile.length; j++) {
          if (mediaType == "2") {
            listVideo.add(httpVideo + listFile[j]);
          } else {
            listImage.add(httpImage + listFile[j]);
          }
        }
        if (jsonTimeline[i]["A00"] == widget.profileDet['f_pin']) {
          vTimeLineData = {
            "timeline_id": "${jsonTimeline[i]["PO1"]}",
            "username": jsonTimeline[i]["A92"],
            "imagePerson": "",
            "user_id": jsonTimeline[i]["A00"],
            "date": time,
            "image": listImage,
            "last_update": jsonTimeline[i]["A11"],
            "thumbnail": !jsonTimeline[i]["BN3"].contains("|")
                ? httpImage + jsonTimeline[i]["BN3"]
                : httpImage + jsonTimeline[i]["BN3"].split("|")[0],
            "media": listVideo,
            "title": jsonTimeline[i]["A37"],
            "content": jsonTimeline[i]["A40"],
            "like_count": int.parse(jsonTimeline[i]["like"]),
            "comment_count": int.parse(jsonTimeline[i]["BL"]),
            "follower_count": int.parse(jsonTimeline[i]['PTZ']),
            "type_account": 0,
            "official_flag": 2,
            "media_type": int.parse(mediaType),
            "liked": int.parse(jsonTimeline[i]['FL1']),
            "following": int.parse(jsonTimeline[i]['PTZ']),
            "isOfficial": jsonTimeline[i]["oacc"],
            "dislike": int.parse(jsonTimeline[i]["dislike"]),
            "link": jsonTimeline[i]["Bk"],
            "is_me": jsonTimeline[i]["A00"] == idMe ? true : false,
            "document": listFile,
            "privacy": int.parse(jsonTimeline[i]["A27"])
          };
        }
      }
      String f_pin = "";
      // List<Map<dynamic, dynamic>> tempStoryData = List();
      // print("length : " +
      //     storyData.length.toString() +
      //     " " +
      //     jsonTimeline.length.toString());
      // for (var j = 0; j < storyData.length; j++) {
      //   for (var k = 0; k < jsonTimeline.length; k++) {
      //     if (jsonTimeline[k]["A00"] == widget.profileDet['f_pin']) {
      //       DateTime date = new DateTime.fromMillisecondsSinceEpoch(
      //           int.parse(jsonTimeline[k]["A29"]));
      //       var format = new DateFormat('dd MMMM yyyy');
      //       List<dynamic> dataPersonAll = await DBHelper().queryCustom(
      //           "SELECT f_pin, first_name, last_name, image_id FROM BUDDY");
      //       List<dynamic> dataPerson = await DBHelper().queryCustom(
      //           "SELECT f_pin, first_name, last_name, image_id FROM BUDDY where f_pin='${jsonTimeline[k]["A00"]}'");
      //       print("f_pin: ${jsonTimeline[k]["A00"]}");
      //       print("dataPerson: ${dataPerson}");
      //       String time = format.format(date);
      //       var mediaType = jsonTimeline[k]["BN2"];
      //       List<String> listFile = List();
      //       List<String> listImage = List();
      //       List<String> listVideo = List();
      //       if (jsonTimeline[k]["BN"].contains("|")) {
      //         listFile = jsonTimeline[k]["BN"].split("|");
      //       } else {
      //         listFile.add(jsonTimeline[k]["BN"]);
      //       }
      //       for (var j = 0; j < listFile.length; j++) {
      //         if (mediaType == "2") {
      //           listVideo.add(httpVideo + listFile[j]);
      //         } else {
      //           listImage.add(httpImage + listFile[j]);
      //         }
      //       }
      //       List<String> postList = storyData[j].post_id.split(",");
      //       for (var z = 0; z < postList.length; z++) {
      //         bool found = false;
      //         if (jsonTimeline[k]["PO1"].toString() == postList[z]) {
      //           found = true;
      //           tempStoryData.add({
      //             "timeline_id": "${jsonTimeline[k]["PO1"]}",
      //             "username": jsonTimeline[k]["A92"],
      //             "imagePerson": "",
      //             "user_id": jsonTimeline[k]["A00"],
      //             "date": time,
      //             "image": listImage,
      //             "last_update": jsonTimeline[k]["A11"],
      //             "thumbnail": !jsonTimeline[k]["BN3"].contains("|")
      //                 ? httpImage + jsonTimeline[k]["BN3"]
      //                 : httpImage + jsonTimeline[k]["BN3"].split("|")[0],
      //             "media": listVideo,
      //             "title": jsonTimeline[k]["A37"],
      //             "content": jsonTimeline[k]["A40"],
      //             "like_count": int.parse(jsonTimeline[k]["like"]),
      //             "comment_count": int.parse(jsonTimeline[k]["BL"]),
      //             "follower_count": int.parse(jsonTimeline[k]['PTZ']),
      //             "type_account": 0,
      //             "official_flag": 2,
      //             "media_type": int.parse(mediaType),
      //             "liked": int.parse(jsonTimeline[k]['FL1']),
      //             "following": int.parse(jsonTimeline[k]['PTZ']),
      //             "isOfficial": jsonTimeline[k]["oacc"],
      //             "dislike": int.parse(jsonTimeline[k]["dislike"]),
      //             "link": jsonTimeline[k]["Bk"],
      //             "is_me": jsonTimeline[k]["A00"] == idMe ? true : false
      //           });
      //           f_pin = jsonTimeline[k]["A00"];
      //         }
      //         if (found) {
      //           post_id_checker.add(storyData[j].story_id);
      //         }
      //       }
      //     }
      //   }
      //
      //   if (tempStoryData.length > 0 &&
      //       post_id_checker.contains(storyData[j].story_id)) {
      //     print("tempStory data : " + tempStoryData.toString());
      //     stories.add(GestureDetector(
      //       onTap: () {
      //         Navigator.push(
      //             context,
      //             PageTransition(
      //                 type: PageTransitionType.fade,
      //                 child: VerticalPersonalTimeLine(
      //                   f_pin: idMe,
      //                   data: storyData[j].title,
      //                   post_id: storyData[j].post_id.split(","),
      //                   openFrom: "PERSONAL",
      //                 )));
      //       },
      //       child: Container(
      //         alignment: Alignment.centerLeft,
      //         margin: EdgeInsets.only(top: 10),
      //         child: Column(
      //           crossAxisAlignment: CrossAxisAlignment.center,
      //           children: <Widget>[
      //             Stack(
      //               alignment: Alignment.center,
      //               children: <Widget>[
      //                 Container(
      //                   alignment: Alignment.center,
      //                   width: 55.0,
      //                   height: 55.0,
      //                   decoration: BoxDecoration(
      //                     color: Color(0xFFababab),
      //                     image: DecorationImage(
      //                       image: LocalImage(storyData[j].thumbnail),
      //                       fit: BoxFit.cover,
      //                     ),
      //                     borderRadius:
      //                         BorderRadius.all(Radius.circular(100.0)),
      //                     border: Border.all(
      //                       color: Colors.white,
      //                       width: 3.0,
      //                     ),
      //                   ),
      //                 )
      //               ],
      //             ),
      //             Container(
      //               margin: EdgeInsets.only(top: 5),
      //               child: Text(
      //                 storyData[j].title,
      //                 style: TextStyle(fontSize: 14),
      //               ),
      //             )
      //           ],
      //         ),
      //       ),
      //     ));
      //     tempStoryData.clear();
      //   }
      // }
    }
    if (mounted) {
      setState(() {});
    }
  }

  void _changeName() {
    showDialog(
        context: context,
        builder: (context) {
          return CupertinoAlertDialog(
              insetAnimationCurve: Curves.easeInBack,
              title: Text("Change Name"),
              content: Container(
                margin: EdgeInsets.only(top: 10),
                child: CupertinoTextField(
                  controller: _nameController,
                  cursorColor: AppColor.primaryColor,
                  decoration: BoxDecoration(
                      color: Colors.transparent,
                      border: Border(bottom: BorderSide(width: 1.0))),
                ),
              ),
              actions: <Widget>[
                CupertinoDialogAction(
                  onPressed: () => Navigator.pop(context),
                  child: Text("Cancel",
                      style: TextStyle(
                          color: AppColor.primaryColor, fontSize: 20)),
                ),
                CupertinoDialogAction(
                  onPressed: () async {
                    if (FocusScope.of(context).hasFocus) {
                      FocusScope.of(context).unfocus();
                      await Future.delayed(Duration(milliseconds: 100));
                    }
                    if (_nameController!.text.trim().isNotEmpty) {
                      String firstname = "";
                      String lastname = "";
                      List<String> names = _nameController!.text.split(" ");
                      print("Array : " + names.toString());
                      if (names.length > 1) {
                        for (int i = 0; i < names.length - 1; i++) {
                          if (i == 0) {
                            firstname = firstname + names[i];
                          } else {
                            firstname = firstname + " " + names[i];
                          }
                          print("First Name : " + firstname);
                        }
                        lastname = names[names.length - 1];
                        print("Last Name : " + lastname);
                      } else {
                        firstname = _nameController!.text;
                        lastname = "";
                      }
                      showDialog(
                          barrierDismissible: false,
                          context: context,
                          builder: (_) {
                            return CupertinoAlertDialog(
                              title: Row(
                                mainAxisAlignment: MainAxisAlignment.start,
                                children: <Widget>[
                                  Container(
                                      child: CupertinoActivityIndicator(),
                                      width: 20,
                                      height: 20),
                                  SizedBox(width: 20.0),
                                  Text("Updating...",
                                      style: TextStyle(
                                          fontWeight: FontWeight.normal))
                                ],
                              ),
                            );
                          });
                      var result =
                          await API.updateUserName(firstname, lastname);
                      if (result == "00") {
                        final SharedPreferences prefs =
                            await SharedPreferences.getInstance();
                        String idMe = prefs.getString("hasLogin") ?? "";
                        await API.pullBatchBuddyList(idMe);
                        Navigator.pop(context);
                        Navigator.pop(context);
                        setState(() {
                          name = _nameController!.text;
                        });
                        Fluttertoast.showToast(
                            msg: "Updated Successfully",
                            toastLength: Toast.LENGTH_LONG);
                      } else if (result == "1a") {
                        Fluttertoast.showToast(
                            msg: "This name already exist, try another name",
                            toastLength: Toast.LENGTH_LONG);
                        Navigator.pop(context);
                      } else {
                        Fluttertoast.showToast(
                            msg: "Can't connected to service, please wait",
                            toastLength: Toast.LENGTH_LONG);
                        Navigator.pop(context);
                      }
                    } else {
                      Fluttertoast.showToast(
                          msg: "This field can't be empty",
                          toastLength: Toast.LENGTH_LONG);
                    }
                  },
                  child: Text("Next",
                      style: TextStyle(
                          color: AppColor.primaryColor, fontSize: 20)),
                )
              ]);
        });
  }

  void _changeImage() async {
    var fileGet = await ImagePicker().getImage(source: ImageSource.gallery);
    if (fileGet != null) {
      var thumb_id = await _resizeAndLabelImage(File(fileGet.path));
      showDialog(
          barrierDismissible: false,
          context: context,
          builder: (_) {
            return CupertinoAlertDialog(
              title: Row(
                mainAxisAlignment: MainAxisAlignment.start,
                children: <Widget>[
                  Container(
                      child: CupertinoActivityIndicator(),
                      width: 20,
                      height: 20),
                  SizedBox(width: 20.0),
                  Text("Updating...",
                      style: TextStyle(fontWeight: FontWeight.normal))
                ],
              ),
            );
          });
      var result = API.changeUserImage(thumb_id);
      if (result != null) {
        Navigator.pop(context);
        Navigator.pop(context);
        Fluttertoast.showToast(
            msg: "Updated Successfully", toastLength: Toast.LENGTH_LONG);
        widget.profileDet['image'] = thumb_id;
        setState(() {});
      } else {
        Navigator.pop(context);
        Navigator.pop(context);
        Fluttertoast.showToast(
            msg: "Can't connected to service, please wait",
            toastLength: Toast.LENGTH_LONG);
      }
    }
  }

  void _openCamera() async {
    var fileGet = await ImagePicker().getImage(
      source: ImageSource.camera,
      maxHeight: 720,
      maxWidth: 1280,
    );
    if (fileGet != null) {
      Directory directory = await getApplicationDocumentsDirectory();
      var thumb_id = await _resizeAndLabelImage(File(fileGet.path));
      showDialog(
          barrierDismissible: false,
          context: context,
          builder: (_) {
            return CupertinoAlertDialog(
              title: Row(
                mainAxisAlignment: MainAxisAlignment.start,
                children: <Widget>[
                  Container(
                      child: CupertinoActivityIndicator(),
                      width: 20,
                      height: 20),
                  SizedBox(width: 20.0),
                  Text("Updating...",
                      style: TextStyle(fontWeight: FontWeight.normal))
                ],
              ),
            );
          });
      var result = API.changeUserImage(thumb_id);
      if (result != null) {
        Navigator.pop(context);
        Navigator.pop(context);
        Fluttertoast.showToast(
            msg: "Updated Successfully", toastLength: Toast.LENGTH_LONG);
        widget.profileDet['image'] = thumb_id;
        setState(() {});
      } else {
        Navigator.pop(context);
        Navigator.pop(context);
        Fluttertoast.showToast(
            msg: "Can't connected to service, please wait",
            toastLength: Toast.LENGTH_LONG);
      }
    }
  }

  Future<String> _resizeAndLabelImage(File fileGet) async {
    Directory directory = await getApplicationDocumentsDirectory();
    List<int> imageBytes = await fileGet.readAsBytesSync();
    final exifData = await readExifFromFile(fileGet);
    // exifData.forEach((key, value) {
    //   print("exif key: $key, value: $value");
    // });
    DartImage.Image? image = DartImage.decodeImage(imageBytes);
    if (image == null) return "";
    int w = image.width;
    int h = image.height;
    print("image width ${w}");
    print("image height ${h}");
    DartImage.Image thumb;
    int s = w > h ? h : w;
    bool cropWidth = w > h;
    if (exifData.containsKey('Image Orientation')) {
      if (exifData['Image Orientation']!.printable.contains('90 CW')) {
        print('rotate 90');
        thumb = DartImage.copyRotate(image, -90);
      } else {
        thumb = image;
      }
    } else {
      thumb = image;
    }
    // thumb = image;
    w = thumb.width;
    h = thumb.height;
    print("thumb width ${thumb.width}");
    print("thumb height ${thumb.height}");
    int x = cropWidth ? ((w - h) / 2).round() : 0;
    int y = cropWidth ? 0 : ((h - w) / 2).round();
    thumb = DartImage.copyCrop(thumb, x, y, s, s);
    w = thumb.width;
    h = thumb.height;
    if (w > 480 || h > 480) {
      thumb = DartImage.copyResizeCropSquare(thumb, 480);
    } else {
      thumb = DartImage.copyResizeCropSquare(thumb, s);
    }
    print("thumb width ${thumb.width}");
    print("thumb height ${thumb.height}");
    var now =
        DateTime.now().millisecondsSinceEpoch.toRadixString(16).toUpperCase();
    var thumb_id = "profile-$now.jpg";
    print(thumb_id);
    new File("${directory.path}/$thumb_id")
      ..writeAsBytesSync(DartImage.encodeJpg(thumb));
    return thumb_id;
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
        appBar: AppBar(
          automaticallyImplyLeading: true,
          title: Text(name),
          backgroundColor: AppColor.primaryColor,
          actions: <Widget>[
            widget.profileDet['isFriend'] == 1
                ? InkWell(
                    onTap: () async {
                      var resultQueryBuddy = await DBHelper().queryCustom(
                          "SELECT ex_block FROM BUDDY WHERE f_pin=='${widget.profileDet['f_pin']}'");
                      if (resultQueryBuddy[0]["ex_block"] == "1" ||
                          resultQueryBuddy[0]["ex_block"] == "-1") {
                        if (resultQueryBuddy[0]["ex_block"] == "-1") {
                          Fluttertoast.showToast(
                              msg: "You are blocked by this user");
                        } else {
                          Fluttertoast.showToast(msg: "You block this user");
                        }
                      } else {
                        await Navigator.push(
                            context,
                            PageTransition(
                                type: PageTransitionType.fade,
                                child: AudioCall(
                                  name: name,
                                  image: widget.profileDet['image'],
                                  isInitiatior: 1,
                                  deviceId: widget.profileDet['f_pin'],
                                )));
                        PalioButtonState statePalio = PalioButtonState();
                        statePalio.incomingCall(context);
                      }
                      // if (widget.profileDet['isOnline'] == 0) {
                      //   showDialog(
                      //       context: context,
                      //       builder: (_) {
                      //         return OfflineCallDialogView();
                      //       });ƒ
                      // }
                    },
                    child: Container(
                      margin: EdgeInsets.only(right: 10, left: 10),
                      child: Icon(CupertinoIcons.phone_solid),
                    ),
                  )
                : Container(),
            widget.profileDet['isFriend'] == 1
                ? InkWell(
                    onTap: () async {
                      var resultQueryBuddy = await DBHelper().queryCustom(
                          "SELECT ex_block FROM BUDDY WHERE f_pin=='${widget.profileDet['f_pin']}'");
                      if (resultQueryBuddy[0]["ex_block"] == "1" ||
                          resultQueryBuddy[0]["ex_block"] == "-1") {
                        if (resultQueryBuddy[0]["ex_block"] == "-1") {
                          Fluttertoast.showToast(
                              msg: "You are blocked by this user");
                        } else {
                          Fluttertoast.showToast(msg: "You block this user");
                        }
                      } else {
                        await Navigator.push(
                            context,
                            PageTransition(
                                type: PageTransitionType.fade,
                                child: VideoCall(
                                  name: name,
                                  isInitiatior: 1,
                                  cameraId: "1",
                                  deviceId: widget.profileDet['f_pin'],
                                  image: widget.profileDet['image'],
                                )));
                        PalioButtonState statePalio = PalioButtonState();
                        statePalio.incomingCall(context);
                      }
                      // if (widget.profileDet['isOnline'] == 0) {
                      //   showDialog(
                      //       context: context,
                      //       builder: (_) {
                      //         return OfflineCallDialogView();
                      //       });
                      // }
                    },
                    child: Container(
                      margin: EdgeInsets.only(right: 10, left: 10),
                      child: Icon(CupertinoIcons.video_camera_solid),
                    ),
                  )
                : Container(),
            widget.profileDet['isFriend'] == 1
                ? InkWell(
                    onTap: () {
                      Navigator.pushReplacement(
                          context,
                          PageTransition(
                              type: PageTransitionType.fade,
                              child: ChatPage(
                                  fullName: name,
                                  image: 'assets/images/ic_launcher_round.png',
                                  identifier: widget.profileDet['f_pin'])));
                    },
                    child: Container(
                      margin: EdgeInsets.only(right: 20, left: 10),
                      child: Icon(CupertinoIcons.mail_solid),
                    ),
                  )
                : Container(),
            !widget.profileDet['myProfile'] &&
                    widget.profileDet['f_pin'] != "024ef50e8c"
                ? PopupMenuButton<int>(
                    onSelected: (int val) async {
                      print("INI VALUE $val");
                      if (val == 1) {
                        if (widget.profileDet['isFriend'] == 0) {
                          var resultAdd =
                              await API.addFriend(widget.profileDet['f_pin']);
                          if (resultAdd == "00") {
                            Fluttertoast.showToast(
                                msg: "New friends added successfully",
                                toastLength: Toast.LENGTH_LONG);
                          }
                        } else {
                          var retval = await API
                              .removeFriend(widget.profileDet['f_pin']);
                          if (retval != null) {
                            Fluttertoast.showToast(
                                msg: "Delete friend success",
                                toastLength: Toast.LENGTH_LONG);
                            setState(() {
                              Navigator.pop(context);
                            });
                          }
                        }
                      }
                    },
                    itemBuilder: (context) => [
                      PopupMenuItem(
                        value: 1,
                        child: Text(widget.profileDet['isFriend'] == 1
                            ? "Unfriend"
                            : "Add Friend"),
                      ),
                    ],
                  )
                : Container(),
            widget.profileDet['myProfile']
                ? InkWell(
                    onTap: () {
                      _changeName();
                      setState(() {});
                    },
                    child: Container(
                      margin: EdgeInsets.only(right: 10, left: 10),
                      child: Icon(CupertinoIcons.pencil),
                    ),
                  )
                : Container(),
            isEdited
                ? InkWell(
                    onTap: () {},
                    child: Container(
                      margin: EdgeInsets.only(right: 10, left: 10),
                      child: Icon(Icons.save),
                    ),
                  )
                : Container()
          ],
        ),
        body: Stack(
          children: <Widget>[
            DefaultTabController(
              length: 2,
              child: NestedScrollView(
                headerSliverBuilder: (context, value) {
                  return [
                    SliverAppBar(
                      automaticallyImplyLeading: false,
                      backgroundColor: Colors.white12,
                      expandedHeight: MediaQuery.of(context).size.height / 2,
                      flexibleSpace: FlexibleSpaceBar(
                        background: Column(
                          children: <Widget>[
                            Container(
                              height: 200,
                              decoration: BoxDecoration(
                                  image: DecorationImage(
                                      fit: BoxFit.cover,
                                      image: AssetImage(
                                          "assets/images/idn_nature_1.jpg",
                                          package: "palio_lite"))),
                              child: Stack(
                                children: <Widget>[
                                  Align(
                                      alignment: Alignment.center,
                                      child: GestureDetector(
                                        child: Container(
                                          alignment: Alignment.center,
                                          width: 130.0,
                                          height: 130.0,
                                          decoration: BoxDecoration(
                                            color: Color(0xFFababab),
                                            image: DecorationImage(
                                              image: LocalImage(
                                                  widget.profileDet['image']),
                                              fit: BoxFit.cover,
                                            ),
                                            borderRadius: BorderRadius.all(
                                                Radius.circular(100.0)),
                                            border: Border.all(
                                              color: Colors.white,
                                              width: 1.0,
                                            ),
                                          ),
                                        ),
                                        onTap: () {
                                          if (widget.profileDet['myProfile']) {
                                            showDialog(
                                                context: context,
                                                builder:
                                                    (BuildContext context) =>
                                                        SimpleDialog(
                                                          children: <Widget>[
                                                            ListTile(
                                                              title: Text(
                                                                  "Take Photo"),
                                                              onTap: () {
                                                                _openCamera();
                                                              },
                                                            ),
                                                            ListTile(
                                                              title: Text(
                                                                  "Take From Gallery"),
                                                              onTap: () {
                                                                _changeImage();
                                                              },
                                                            )
                                                          ],
                                                        ));
                                          }
                                        },
                                      )),
                                  // widget.profileDet['myProfile']
                                  //     ? Align(
                                  //         alignment: Alignment.centerRight,
                                  //         child: InkWell(
                                  //           onTap: () {
                                  //             _showQrCodeDialog();
                                  //           },
                                  //           child: Container(
                                  //               margin: EdgeInsets.only(
                                  //                   right: 18, bottom: 5),
                                  //               child: QrImage(
                                  //                 data:
                                  //                     widget.profileDet['name'],
                                  //                 version: QrVersions.auto,
                                  //                 size: 80.0,
                                  //                 foregroundColor:
                                  //                     Colors.black45,
                                  //               ),
                                  //               decoration: BoxDecoration(
                                  //                   color: Colors.white,
                                  //                   borderRadius:
                                  //                       BorderRadius.circular(
                                  //                           10))),
                                  //         ))
                                  //     : Container(),
                                  (widget.profileDet['official_account'] ==
                                              "5" ||
                                          widget.profileDet[
                                                  'official_account'] ==
                                              "1" ||
                                          widget.profileDet[
                                                  'official_account'] ==
                                              "11" ||
                                          widget.profileDet['user_type'] ==
                                              "23" ||
                                          widget.profileDet['user_type'] ==
                                              "24")
                                      ? Align(
                                          alignment: Alignment.bottomRight,
                                          child: Container(
                                              margin: EdgeInsets.only(
                                                  right: 10, bottom: 10),
                                              padding: EdgeInsets.only(
                                                  left: 8,
                                                  right: 8,
                                                  top: 5,
                                                  bottom: 5),
                                              child: Row(
                                                mainAxisSize: MainAxisSize.min,
                                                children: <Widget>[
                                                  Image.asset(
                                                    (widget.profileDet[
                                                                    'official_account'] ==
                                                                "5" ||
                                                            widget.profileDet[
                                                                    'official_account'] ==
                                                                "1")
                                                        ? "assets/images/ic_official_flag.png"
                                                        : widget.profileDet[
                                                                    'official_account'] ==
                                                                "11"
                                                            ? "assets/images/ic_verified_flag.png"
                                                            : widget.profileDet[
                                                                        'user_type'] ==
                                                                    "23"
                                                                ? 'assets/images/ic_internal.png'
                                                                : 'assets/images/call_center.png',
                                                    width: 14,
                                                    package: "palio_lite",
                                                  ),
                                                  Container(
                                                    margin: EdgeInsets.only(
                                                        left: 5),
                                                    child: Text(
                                                      (widget.profileDet[
                                                                      'official_account'] ==
                                                                  "5" ||
                                                              widget.profileDet[
                                                                      'official_account'] ==
                                                                  "1")
                                                          ? "Official"
                                                          : widget.profileDet[
                                                                      'official_account'] ==
                                                                  "11"
                                                              ? "Verified"
                                                              : widget.profileDet[
                                                                          'user_type'] ==
                                                                      "23"
                                                                  ? "Internal"
                                                                  : "Call Center",
                                                      style: TextStyle(
                                                          fontSize: 14),
                                                    ),
                                                  )
                                                ],
                                              ),
                                              decoration: BoxDecoration(
                                                  color: Colors.white,
                                                  borderRadius:
                                                      BorderRadius.circular(
                                                          5))),
                                        )
                                      : Container(),
                                ],
                              ),
                            ),
                            Container(
                              padding: EdgeInsets.all(10),
                              child: Column(
                                crossAxisAlignment: CrossAxisAlignment.start,
                                mainAxisAlignment: MainAxisAlignment.start,
                                mainAxisSize: MainAxisSize.max,
                                children: <Widget>[
                                  Container(
                                    padding: EdgeInsets.only(
                                        left: widget.profileDet['myProfile']
                                            ? 20
                                            : 40,
                                        right: widget.profileDet['myProfile']
                                            ? 20
                                            : 40),
                                    child: widget.profileDet['myProfile']
                                        ? Row(
                                            mainAxisAlignment:
                                                MainAxisAlignment.spaceBetween,
                                            children: <Widget>[
                                              InkWell(
                                                onTap: () {},
                                                child: Column(
                                                  children: <Widget>[
                                                    Text(
                                                      "${getVTimeLineData.length}",
                                                      style: TextStyle(
                                                          fontSize: 18),
                                                    ),
                                                    SizedBox(
                                                      height: 20,
                                                    ),
                                                    Text("Post",
                                                        style: TextStyle(
                                                            fontSize: 14))
                                                  ],
                                                ),
                                              ),
                                              InkWell(
                                                onTap: () {},
                                                child: Column(
                                                  children: <Widget>[
                                                    Text(
                                                        widget.profileDet[
                                                                    'follower'] !=
                                                                null
                                                            ? widget.profileDet[
                                                                    'follower']
                                                                .toString()
                                                            : '-',
                                                        style: TextStyle(
                                                            fontSize: 18)),
                                                    SizedBox(
                                                      height: 20,
                                                    ),
                                                    Text("Follower",
                                                        style: TextStyle(
                                                            fontSize: 14))
                                                  ],
                                                ),
                                              ),
                                              InkWell(
                                                onTap: () {},
                                                child: Column(
                                                  children: <Widget>[
                                                    Text(
                                                        widget.profileDet[
                                                                    'following'] !=
                                                                null
                                                            ? widget.profileDet[
                                                                    'following']
                                                                .toString()
                                                            : '-',
                                                        style: TextStyle(
                                                            fontSize: 18)),
                                                    SizedBox(
                                                      height: 20,
                                                    ),
                                                    Text("Following",
                                                        style: TextStyle(
                                                            fontSize: 14))
                                                  ],
                                                ),
                                              ),
                                              InkWell(
                                                onTap: () {
                                                  Navigator.push(
                                                      context,
                                                      PageTransition(
                                                          type:
                                                              PageTransitionType
                                                                  .fade,
                                                          child: FriendList()));
                                                },
                                                child: Column(
                                                  children: <Widget>[
                                                    Text(
                                                        "${resultQueryFriend.length}",
                                                        style: TextStyle(
                                                            fontSize: 18)),
                                                    SizedBox(
                                                      height: 20,
                                                    ),
                                                    Text("Friend",
                                                        style: TextStyle(
                                                            fontSize: 14))
                                                  ],
                                                ),
                                              )
                                            ],
                                          )
                                        : Row(
                                            mainAxisAlignment:
                                                MainAxisAlignment.spaceBetween,
                                            children: <Widget>[
                                              Column(
                                                children: <Widget>[
                                                  Text(
                                                    widget.profileDet['post'] !=
                                                            null
                                                        ? widget
                                                            .profileDet['post']
                                                            .toString()
                                                        : '0',
                                                    style:
                                                        TextStyle(fontSize: 18),
                                                  ),
                                                  SizedBox(
                                                    height: 20,
                                                  ),
                                                  Text("Post",
                                                      style: TextStyle(
                                                          fontSize: 14))
                                                ],
                                              ),
                                              Column(
                                                children: <Widget>[
                                                  Text(
                                                      widget.profileDet[
                                                                  'follower'] !=
                                                              null
                                                          ? widget.profileDet[
                                                                  'follower']
                                                              .toString()
                                                          : '0',
                                                      style: TextStyle(
                                                          fontSize: 18)),
                                                  SizedBox(
                                                    height: 20,
                                                  ),
                                                  Text("Follower",
                                                      style: TextStyle(
                                                          fontSize: 14))
                                                ],
                                              ),
                                              Column(
                                                children: <Widget>[
                                                  Text(
                                                      widget.profileDet[
                                                                  'following'] !=
                                                              null
                                                          ? widget.profileDet[
                                                                  'following']
                                                              .toString()
                                                          : '0',
                                                      style: TextStyle(
                                                          fontSize: 18)),
                                                  SizedBox(
                                                    height: 20,
                                                  ),
                                                  Text("Following",
                                                      style: TextStyle(
                                                          fontSize: 14))
                                                ],
                                              ),
                                            ],
                                          ),
                                  ),
                                  // SingleChildScrollView(
                                  //   scrollDirection: Axis.horizontal,
                                  //   child: Row(
                                  //     children: stories,
                                  //   ),
                                  // ),
                                ],
                              ),
                            ),
                            TabBar(
                              controller: _tabController,
                              indicatorColor: AppColor.primaryColor,
                              labelColor: AppColor.primaryColor,
                              tabs: [
                                Tab(
                                  icon: Icon(CupertinoIcons.time),
                                ),
                                Tab(
                                  icon: Icon(CupertinoIcons.person),
                                ),
                              ],
                            )
                          ],
                        ),
                      ),
                    ),
                  ];
                },
                body: TabBarView(
                  controller: _tabController,
                  children: [
                    Container(
                        padding: EdgeInsets.all(4.0),
                        child: GridView.builder(
                          itemCount: getVTimeLineData.length,
                          gridDelegate:
                              SliverGridDelegateWithFixedCrossAxisCount(
                                  crossAxisCount: 3,
                                  crossAxisSpacing: 4.0,
                                  mainAxisSpacing: 4.0),
                          itemBuilder: (BuildContext context, int index) {
                            return Container();
                          },
                        )),
                    About(
                      profileDet: widget.profileDet,
                    ),
                  ],
                ),
              ),
            ),
            // isPlayed
            //     ? VideoPlayerHeader(
            //         controller: _controller,
            //         inTimeline: true,
            //         isPlaying: (f) {
            //           if (!f)
            //             setState(() {
            //               isPlayed = f;
            //             });
            //         },
            //       )
            //     : Container()
          ],
        ));
  }
}
