import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter_translate/flutter_translate.dart';
import 'package:palio_lite/app_color.dart';

class SettingEmail extends StatefulWidget {
  _SettingEmail createState() => _SettingEmail();
}

class _SettingEmail extends State<SettingEmail> {
  bool showPass = false;

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        automaticallyImplyLeading: true,
        backgroundColor: AppColor.primaryColor,
        title: Text("Email account"),
      ),
      body: Padding(
        padding: EdgeInsets.all(10),
        child: Column(
          mainAxisAlignment: MainAxisAlignment.spaceBetween,
          children: <Widget>[
            Container(
              padding: EdgeInsets.all(5.0),
              child: SingleChildScrollView(
                child: Column(
                  children: <Widget>[
                    Column(
                      children: <Widget>[
                        Align(
                          alignment: Alignment.centerLeft,
                          child: Text("Account"),
                        ),
                        TextField(
                          cursorColor: AppColor.primaryColor,
                          decoration: InputDecoration(
                              fillColor: Colors.transparent,
                              focusedBorder: UnderlineInputBorder(
                                  borderSide:
                                      BorderSide(color: Color(0xFF364656))),
                              border: UnderlineInputBorder(
                                  borderSide:
                                      BorderSide(color: Color(0xFF364656))),
                              hintText: "ex.name@gmail.com",
                              filled: true),
                        )
                      ],
                    ),
                    Divider(
                      height: 10,
                    ),
                    Column(
                      children: <Widget>[
                        Align(
                          alignment: Alignment.centerLeft,
                          child: Text("Password"),
                        ),
                        TextField(
                          obscureText: !showPass,
                          cursorColor: AppColor.primaryColor,
                          decoration: InputDecoration(
                              suffixIcon: GestureDetector(
                                onTap: () {
                                  if (showPass) {
                                    showPass = false;
                                  } else {
                                    showPass = true;
                                  }
                                  setState(() {});
                                },
                                child: Icon(
                                  Icons.remove_red_eye,
                                  color: showPass ? Colors.blue : Colors.grey,
                                ),
                              ),
                              fillColor: Colors.transparent,
                              focusedBorder: UnderlineInputBorder(
                                  borderSide:
                                      BorderSide(color: AppColor.primaryColor)),
                              border: UnderlineInputBorder(
                                  borderSide:
                                      BorderSide(color: AppColor.primaryColor)),
                              hintText: "Password",
                              filled: true),
                        )
                      ],
                    ),
                    Divider(
                      height: 10,
                    ),
                    Row(
                      mainAxisAlignment: MainAxisAlignment.spaceBetween,
                      children: <Widget>[
                        Container(
                            width: MediaQuery.of(context).size.width * 0.55,
                            child: Column(
                              children: <Widget>[
                                Column(
                                  children: <Widget>[
                                    Align(
                                      alignment: Alignment.centerLeft,
                                      child: Text("IMAP Host"),
                                    ),
                                    TextField(
                                      controller: TextEditingController()
                                        ..text = "imap.gmail.com",
                                      cursorColor: AppColor.primaryColor,
                                      decoration: InputDecoration(
                                          fillColor: Colors.transparent,
                                          focusedBorder: UnderlineInputBorder(
                                              borderSide: BorderSide(
                                                  color: Color(0xFF364656))),
                                          border: UnderlineInputBorder(
                                              borderSide: BorderSide(
                                                  color: Color(0xFF364656))),
                                          hintText: "IMAP Host(ex.imap.gmail.com)",
                                          filled: true),
                                    )
                                  ],
                                ),
                                Divider(
                                  height: 10,
                                ),
                                Column(
                                  children: <Widget>[
                                    Align(
                                      alignment: Alignment.centerLeft,
                                      child: Text("POP3 Host"),
                                    ),
                                    TextField(
                                      controller: TextEditingController()
                                        ..text = "pop.gmail.com",
                                      cursorColor: AppColor.primaryColor,
                                      decoration: InputDecoration(
                                          fillColor: Colors.transparent,
                                          focusedBorder: UnderlineInputBorder(
                                              borderSide: BorderSide(
                                                  color: Color(0xFF364656))),
                                          border: UnderlineInputBorder(
                                              borderSide: BorderSide(
                                                  color: Color(0xFF364656))),
                                          hintText: "POP3 Host(ex.pop.gmail.com)",
                                          filled: true),
                                    )
                                  ],
                                ),
                                Divider(
                                  height: 10,
                                ),
                                Column(
                                  children: <Widget>[
                                    Align(
                                      alignment: Alignment.centerLeft,
                                      child: Text("SMTP Host"),
                                    ),
                                    TextField(
                                      controller: TextEditingController()
                                        ..text = "smtp.gmail.com",
                                      cursorColor: AppColor.primaryColor,
                                      decoration: InputDecoration(
                                          fillColor: Colors.transparent,
                                          focusedBorder: UnderlineInputBorder(
                                              borderSide: BorderSide(
                                                  color: Color(0xFF364656))),
                                          border: UnderlineInputBorder(
                                              borderSide: BorderSide(
                                                  color: Color(0xFF364656))),
                                          hintText: "SMTP Host(ex.smtp.gmail.com)",
                                          filled: true),
                                    )
                                  ],
                                ),
                              ],
                            )),
                        Container(
                          width: MediaQuery.of(context).size.width * 0.30,
                          child: Column(
                            children: <Widget>[
                              Column(
                                children: <Widget>[
                                  Align(
                                    alignment: Alignment.centerLeft,
                                    child: Text("IMAP Port"),
                                  ),
                                  TextField(
                                    controller: TextEditingController()
                                      ..text = "993",
                                    cursorColor: AppColor.primaryColor,
                                    decoration: InputDecoration(
                                        fillColor: Colors.transparent,
                                        focusedBorder: UnderlineInputBorder(
                                            borderSide: BorderSide(
                                                color: Color(0xFF364656))),
                                        border: UnderlineInputBorder(
                                            borderSide: BorderSide(
                                                color: Color(0xFF364656))),
                                        hintText: "IMAP Port",
                                        filled: true),
                                  )
                                ],
                              ),
                              Divider(
                                height: 10,
                              ),
                              Column(
                                children: <Widget>[
                                  Align(
                                    alignment: Alignment.centerLeft,
                                    child: Text("POP3 Port"),
                                  ),
                                  TextField(
                                    controller: TextEditingController()
                                      ..text = "995",
                                    cursorColor: AppColor.primaryColor,
                                    decoration: InputDecoration(
                                        fillColor: Colors.transparent,
                                        focusedBorder: UnderlineInputBorder(
                                            borderSide: BorderSide(
                                                color: Color(0xFF364656))),
                                        border: UnderlineInputBorder(
                                            borderSide: BorderSide(
                                                color: Color(0xFF364656))),
                                        hintText: "POP3 Port",
                                        filled: true),
                                  )
                                ],
                              ),
                              Divider(
                                height: 10,
                              ),
                              Column(
                                children: <Widget>[
                                  Align(
                                    alignment: Alignment.centerLeft,
                                    child: Text("SMTP Port"),
                                  ),
                                  TextField(
                                    controller: TextEditingController()
                                      ..text = "587",
                                    cursorColor: AppColor.primaryColor,
                                    decoration: InputDecoration(
                                        fillColor: Colors.transparent,
                                        focusedBorder: UnderlineInputBorder(
                                            borderSide: BorderSide(
                                                color: Color(0xFF364656))),
                                        border: UnderlineInputBorder(
                                            borderSide: BorderSide(
                                                color: Color(0xFF364656))),
                                        hintText: "SMTP Port",
                                        filled: true),
                                  )
                                ],
                              ),
                            ],
                          ),
                        )
                      ],
                    ),
                    Divider(
                      height: 20,
                    ),
                    Align(
                      alignment: Alignment.centerLeft,
                      child: Text(
                        "Please activate less secure option in your email account",
                        style: TextStyle(
                            fontSize: 11, fontStyle: FontStyle.italic),
                      ),
                    )
                  ],
                ),
              ),
            ),
            Row(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: <Widget>[
                Container(
                  width: MediaQuery.of(context).size.width * 0.45,
                  height: 50,
                  child: RawMaterialButton(
                    onPressed: () {
                      Navigator.of(context).pop(false);
                    },
                    padding: EdgeInsets.symmetric(horizontal: 10),
                    fillColor: Colors.blueAccent,
                    child: Stack(
                      children: <Widget>[
                        Align(
                          alignment: Alignment.centerLeft,
                          child: Icon(
                            Icons.cancel,
                            color: Colors.white,
                          ),
                        ),
                        Align(
                          alignment: Alignment.center,
                          child: Text(
                            "Cancel",
                            style: TextStyle(color: Colors.white),
                          ),
                        )
                      ],
                    ),
                  ),
                ),
                Container(
                  width: MediaQuery.of(context).size.width * 0.45,
                  height: 50,
                  child: RawMaterialButton(
                    onPressed: () {
                      Navigator.of(context).pop(true);
                    },
                    padding: EdgeInsets.symmetric(horizontal: 10),
                    fillColor: Colors.blueAccent,
                    child: Stack(
                      children: <Widget>[
                        Align(
                          alignment: Alignment.centerLeft,
                          child: Icon(
                            Icons.check,
                            color: Colors.white,
                          ),
                        ),
                        Align(
                          alignment: Alignment.center,
                          child: Text(
                            "OK",
                            style: TextStyle(color: Colors.white),
                          ),
                        )
                      ],
                    ),
                  ),
                )
              ],
            )
          ],
        ),
      ),
    );
  }
}
