import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:fluttertoast/fluttertoast.dart';
import 'package:page_transition/page_transition.dart';
import 'package:palio_lite/api.dart';
import 'package:palio_lite/app_color.dart';
import 'package:shared_preferences/shared_preferences.dart';

class About extends StatefulWidget {
  final Map profileDet;

  const About({Key? key, required this.profileDet}) : super(key: key);

  @override
  _AboutState createState() => _AboutState();
}

class _AboutState extends State<About> {
  String f_pin = "";
  String phoneNumber = "";
  bool idMe = false;
  TextEditingController _visionController = TextEditingController(),
      _missionController = TextEditingController(),
      _statusController = TextEditingController(),
      _industryController = TextEditingController(),
      _emlAddController = TextEditingController(),
      _phnNumController = TextEditingController(),
      _webSiteController = TextEditingController(),
      _addressController = TextEditingController();
  String status = "";

  Future<void> getIdMe(String f_pin) async {
    SharedPreferences prefs = await SharedPreferences.getInstance();
    idMe = prefs.getString("hasLogin") == f_pin;
    print("idMe: $idMe");
  }

  Future<String> getPhoneNumber() async {
    final SharedPreferences prefs = await SharedPreferences.getInstance();
    if (prefs.containsKey("phoneNumber")) {
      phoneNumber = prefs.getString("phoneNumber") ?? "";
      print("Phone Number $phoneNumber");
    }
    return phoneNumber;
  }

  @override
  void initState() {
    f_pin = widget.profileDet['f_pin'];
    getIdMe(f_pin);
    _visionController =
        TextEditingController(text: widget.profileDet['vision']);
    _missionController =
        TextEditingController(text: widget.profileDet['mission']);
    _statusController =
        TextEditingController(text: widget.profileDet['status']);
    status = widget.profileDet['status'];
    _statusController.addListener(() {});
    _industryController =
        TextEditingController(text: widget.profileDet['industry']);
    _emlAddController =
        TextEditingController(text: widget.profileDet['email_address']);
    _phnNumController =
        TextEditingController(text: widget.profileDet['phone_number']);
    _webSiteController =
        TextEditingController(text: widget.profileDet['website']);
    _addressController =
        TextEditingController(text: widget.profileDet['address']);
    getPhoneNumber();
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return SingleChildScrollView(
      child: Container(
        color: Colors.grey[200],
        child: Column(
          children: <Widget>[
            Card(
                margin: EdgeInsets.all(0),
                shape: RoundedRectangleBorder(
                  borderRadius: BorderRadius.only(
                      bottomRight: Radius.circular(5),
                      bottomLeft: Radius.circular(5)),
                ),
                elevation: 1,
                child: Container(
                  padding: EdgeInsets.all(15),
                  width: MediaQuery.of(context).size.width,
                  child: Column(
                    crossAxisAlignment: CrossAxisAlignment.start,
                    children: <Widget>[
                      Container(
                        width: MediaQuery.of(context).size.width,
                        child: Column(
                          crossAxisAlignment: CrossAxisAlignment.center,
                          children: <Widget>[
                            Text(
                              "About Us",
                              style: TextStyle(fontSize: 22),
                            ),
                            Container(
                                width: 35,
                                height: 4,
                                margin: EdgeInsets.all(5),
                                padding: EdgeInsets.all(3),
                                decoration: BoxDecoration(
                                    color: Colors.red,
                                    borderRadius: BorderRadius.circular(3)))
                          ],
                        ),
                      ),
                      widget.profileDet['official_flag'] != 1
                          ? Column(
                              crossAxisAlignment: CrossAxisAlignment.start,
                              children: <Widget>[
                                // TextField(
                                //     readOnly: widget.profileDet['myProfile']
                                //         ? false
                                //         : true,
                                //     controller: _statusController,
                                //     cursorColor: AppColor.primaryColor,
                                //     style: TextStyle(fontSize: 20),
                                //     decoration: InputDecoration(
                                //         border: InputBorder.none,
                                //         hintText: translate('status'))),
                                Text(
                                  "Status",
                                  textAlign: TextAlign.start,
                                  style: TextStyle(
                                    fontSize: 18,
                                  ),
                                ),
                                // ListTile(
                                //   contentPadding:
                                //       EdgeInsets.symmetric(horizontal: 0),
                                //   title: status != null
                                //       ? Text(
                                //           status,
                                //           style: TextStyle(fontSize: 20),
                                //         )
                                //       : Text(
                                //           "(no status)",
                                //           style: TextStyle(
                                //             fontSize: 20,
                                //             color: Colors.grey,
                                //           ),
                                //         ),
                                //   trailing: widget.profileDet["myProfile"]
                                //       ? InkWell(
                                //           child: Icon(CupertinoIcons.pencil),
                                //           onTap: () {
                                //             _changeStatus();
                                //           },
                                //         )
                                //       : null,
                                // ),
                                // ListTile(
                                //   leading: Icon(
                                //     CupertinoIcons.phone_solid,
                                //     size: 30,
                                //   ),
                                //   title: TextField(
                                //       readOnly: widget.profileDet['myProfile']
                                //           ? false
                                //           : true,
                                //       controller: _phnNumController,
                                //       cursorColor: AppColor.primaryColor,
                                //       style: TextStyle(fontSize: 20),
                                //       decoration: InputDecoration(
                                //           border: InputBorder.none,
                                //           hintText: translate('phoneNumber'))),
                                // ),
                              ],
                            )
                          : Column(
                              crossAxisAlignment: CrossAxisAlignment.start,
                              children: <Widget>[
                                widget.profileDet['myProfile'] ||
                                        _visionController.text.isNotEmpty
                                    ? Text(
                                        "Vision",
                                        style: TextStyle(fontSize: 18),
                                      )
                                    : Container(),
                                widget.profileDet['myProfile'] ||
                                        _visionController.text.isNotEmpty
                                    ? TextField(
                                        readOnly: widget.profileDet['myProfile']
                                            ? false
                                            : true,
                                        controller: _visionController,
                                        cursorColor: AppColor.primaryColor,
                                        style: TextStyle(fontSize: 20),
                                        decoration: InputDecoration(
                                            border: InputBorder.none))
                                    : Container(),
                                widget.profileDet['myProfile'] ||
                                        _missionController.text.isNotEmpty
                                    ? Container(
                                        margin: EdgeInsets.only(top: 20),
                                        child: Text(
                                          "Mission",
                                          style: TextStyle(fontSize: 18),
                                        ),
                                      )
                                    : Container(),
                                widget.profileDet['myProfile'] ||
                                        _missionController.text.isNotEmpty
                                    ? TextField(
                                        readOnly: widget.profileDet['myProfile']
                                            ? false
                                            : true,
                                        controller: _missionController,
                                        cursorColor: AppColor.primaryColor,
                                        style: TextStyle(fontSize: 20),
                                        decoration: InputDecoration(
                                            border: InputBorder.none))
                                    : Container(),
                              ],
                            ),
                      Column(
                        crossAxisAlignment: CrossAxisAlignment.start,
                        children: <Widget>[
                          // TextField(
                          //     readOnly: widget.profileDet['myProfile']
                          //         ? false
                          //         : true,
                          //     controller: _statusController,
                          //     cursorColor: AppColor.primaryColor,
                          //     style: TextStyle(fontSize: 20),
                          //     decoration: InputDecoration(
                          //         border: InputBorder.none,
                          //         hintText: translate('status'))),
                          // Text(
                          //   "Phone Number",
                          //   textAlign: TextAlign.start,
                          //   style: TextStyle(
                          //     fontSize: 18,
                          //   ),
                          // ),
                          // ListTile(
                          //   contentPadding: EdgeInsets.symmetric(horizontal: 0),
                          //   title: (widget.profileDet['phone_number'] !=
                          //               null) &&
                          //           widget.profileDet['phone_number'].isNotEmpty
                          //       ? Text(
                          //           widget.profileDet['phone_number'],
                          //           style: TextStyle(fontSize: 20),
                          //         )
                          //       : Text(
                          //           "-",
                          //           style: TextStyle(
                          //             fontSize: 20,
                          //             color: Colors.grey,
                          //           ),
                          //         ),
                          // ),
                        ],
                      )
                    ],
                  ),
                )),
            // widget.profileDet['official_flag'] == 0 ||
            widget.profileDet['official_flag'] == 1
                ? Card(
                    margin: EdgeInsets.only(top: 5),
                    shape: RoundedRectangleBorder(
                      borderRadius: BorderRadius.only(
                          topLeft: Radius.circular(5),
                          topRight: Radius.circular(5),
                          bottomRight: Radius.circular(5),
                          bottomLeft: Radius.circular(5)),
                    ),
                    elevation: 1,
                    child: Container(
                      padding: EdgeInsets.all(15),
                      width: MediaQuery.of(context).size.width,
                      child: Column(
                        crossAxisAlignment: CrossAxisAlignment.start,
                        children: <Widget>[
                          Container(
                            width: MediaQuery.of(context).size.width,
                            child: Column(
                              crossAxisAlignment: CrossAxisAlignment.center,
                              children: <Widget>[
                                Text(
                                  "Profile",
                                  style: TextStyle(fontSize: 22),
                                ),
                                Container(
                                    width: 35,
                                    height: 4,
                                    margin: EdgeInsets.all(5),
                                    padding: EdgeInsets.all(3),
                                    decoration: BoxDecoration(
                                        color: Colors.red,
                                        borderRadius: BorderRadius.circular(3)))
                              ],
                            ),
                          ),
                          Column(
                            crossAxisAlignment: CrossAxisAlignment.start,
                            children: <Widget>[
                              widget.profileDet['myProfile'] ||
                                      _industryController.text.isNotEmpty
                                  ? ListTile(
                                      leading: Icon(
                                        Icons.work,
                                        size: 30,
                                      ),
                                      title: TextField(
                                          readOnly:
                                              widget.profileDet['myProfile']
                                                  ? false
                                                  : true,
                                          controller: _industryController,
                                          cursorColor: AppColor.primaryColor,
                                          style: TextStyle(fontSize: 20),
                                          decoration: InputDecoration(
                                              border: InputBorder.none,
                                              hintText: "Industry")),
                                    )
                                  : Container(),
                              widget.profileDet['myProfile'] ||
                                      _emlAddController.text.isNotEmpty
                                  ? ListTile(
                                      leading: Icon(
                                        CupertinoIcons.mail_solid,
                                        size: 30,
                                      ),
                                      title: TextField(
                                          readOnly:
                                              widget.profileDet['myProfile']
                                                  ? false
                                                  : true,
                                          controller: _emlAddController,
                                          cursorColor: AppColor.primaryColor,
                                          style: TextStyle(fontSize: 20),
                                          decoration: InputDecoration(
                                              border: InputBorder.none,
                                              hintText: "Email Address")),
                                    )
                                  : Container(),
                              widget.profileDet['myProfile'] ||
                                      _webSiteController.text.isNotEmpty
                                  ? ListTile(
                                      leading: Icon(
                                        Icons.web,
                                        size: 30,
                                      ),
                                      title: TextField(
                                          readOnly:
                                              widget.profileDet['myProfile']
                                                  ? false
                                                  : true,
                                          controller: _webSiteController,
                                          cursorColor: AppColor.primaryColor,
                                          style: TextStyle(fontSize: 20),
                                          decoration: InputDecoration(
                                              border: InputBorder.none,
                                              hintText: "Website")),
                                    )
                                  : Container(),
                              widget.profileDet['myProfile'] ||
                                      _addressController.text.isNotEmpty
                                  ? ListTile(
                                      leading: Icon(
                                        Icons.home,
                                        size: 30,
                                      ),
                                      title: TextField(
                                          readOnly:
                                              widget.profileDet['myProfile']
                                                  ? false
                                                  : true,
                                          controller: _addressController,
                                          cursorColor: AppColor.primaryColor,
                                          style: TextStyle(fontSize: 20),
                                          decoration: InputDecoration(
                                              border: InputBorder.none,
                                              hintText: "Address")),
                                    )
                                  : Container(),
                            ],
                          )
                        ],
                      ),
                    ))
                : Container(),
            widget.profileDet['myProfile']
                ? Card(
                    margin: EdgeInsets.only(top: 5),
                    shape: RoundedRectangleBorder(
                      borderRadius: BorderRadius.only(
                          topLeft: Radius.circular(5),
                          topRight: Radius.circular(5),
                          bottomRight: Radius.circular(5),
                          bottomLeft: Radius.circular(5)),
                    ),
                    elevation: 1,
                    child: Column(
                      crossAxisAlignment: CrossAxisAlignment.start,
                      children: <Widget>[
                        ListTile(
                          title: Text("Private Account Mode"),
                          trailing: Switch(
                              activeColor: AppColor.primaryColor,
                              value: widget.profileDet['isMuted'] == "0"
                                  ? false
                                  : true,
                              onChanged: (bool val) async {
                                bool isChanged = false;
                                showDialog(
                                    barrierDismissible: false,
                                    context: context,
                                    builder: (_) {
                                      return CupertinoAlertDialog(
                                        title: Row(
                                          mainAxisAlignment:
                                              MainAxisAlignment.start,
                                          children: <Widget>[
                                            Container(
                                                child:
                                                    CupertinoActivityIndicator(),
                                                width: 20,
                                                height: 20),
                                            SizedBox(width: 20.0),
                                            Text("Updating...",
                                                style: TextStyle(
                                                    fontWeight:
                                                        FontWeight.normal))
                                          ],
                                        ),
                                      );
                                    });
                                Fluttertoast.showToast(
                                    msg: "Updating privacy mode...",
                                    toastLength: Toast.LENGTH_LONG);

                                String result = await API.setPrivate(val);
                                if (result != null) {
                                  Navigator.pop(context);
                                  Fluttertoast.showToast(
                                      msg: "Privacy mode update success",
                                      toastLength: Toast.LENGTH_LONG);
                                  isChanged = true;
                                } else {
                                  Navigator.pop(context);
                                  Fluttertoast.showToast(
                                      msg:
                                          "Can't connected to service, please wait",
                                      toastLength: Toast.LENGTH_LONG);
                                }
                                if (isChanged) {
                                  widget.profileDet['isMuted'] =
                                      widget.profileDet['isMuted'] == "0"
                                          ? "1"
                                          : "0";
                                }
                                setState(() {});
                              }),
                        ),
                        Divider(
                          color: Colors.grey,
                        ),
                        ListTile(
                          title: Text("Accept Call"),
                          trailing: Switch(
                              activeColor: AppColor.primaryColor,
                              value: widget.profileDet['isOffline'] == "0"
                                  ? true
                                  : false,
                              onChanged: (bool val) async {
                                bool isChanged = false;
                                showDialog(
                                    barrierDismissible: false,
                                    context: context,
                                    builder: (_) {
                                      return CupertinoAlertDialog(
                                        title: Row(
                                          mainAxisAlignment:
                                              MainAxisAlignment.start,
                                          children: <Widget>[
                                            Container(
                                                child:
                                                    CupertinoActivityIndicator(),
                                                width: 20,
                                                height: 20),
                                            SizedBox(width: 20.0),
                                            Text("Updating...",
                                                style: TextStyle(
                                                    fontWeight:
                                                        FontWeight.normal))
                                          ],
                                        ),
                                      );
                                    });
                                Fluttertoast.showToast(
                                    msg: "Updating incoming call...",
                                    toastLength: Toast.LENGTH_LONG);
                                String result = await API.setAcceptCall(val);
                                if (result != null) {
                                  Navigator.pop(context);
                                  Fluttertoast.showToast(
                                      msg: "Incoming call update success",
                                      toastLength: Toast.LENGTH_LONG);
                                  isChanged = true;
                                } else {
                                  Navigator.pop(context);
                                  Fluttertoast.showToast(
                                      msg:
                                          "Can't connected to service, please wait",
                                      toastLength: Toast.LENGTH_LONG);
                                }
                                if (isChanged) {
                                  status = _statusController.text;
                                }
                                setState(() {
                                  widget.profileDet['isOffline'] =
                                      widget.profileDet['isOffline'] == "0"
                                          ? "1"
                                          : "0";
                                });
                              }),
                        ),
                        Divider(
                          color: Colors.grey,
                        ),
                      ],
                    ))
                : Container()
          ],
        ),
      ),
    );
  }

  void _changeStatus() {
    showDialog(
        context: context,
        builder: (context) {
          return CupertinoAlertDialog(
              insetAnimationCurve: Curves.easeInBack,
              title: Text("Change Status"),
              content: Container(
                margin: EdgeInsets.only(top: 10),
                child: CupertinoTextField(
                  controller: _statusController,
                  cursorColor: AppColor.primaryColor,
                  decoration: BoxDecoration(
                      color: Colors.transparent,
                      border: Border(bottom: BorderSide(width: 1.0))),
                ),
              ),
              actions: <Widget>[
                CupertinoDialogAction(
                  onPressed: () => Navigator.pop(context),
                  child: Text("Cancel",
                      style: TextStyle(
                          color: AppColor.primaryColor, fontSize: 20)),
                ),
                CupertinoDialogAction(
                  onPressed: () async {
                    bool isChanged = false;
                    Fluttertoast.showToast(
                        msg: "Updating status...",
                        toastLength: Toast.LENGTH_LONG);
                    API.updateUserStatus(_statusController.text).then((result) {
                      if (result != null) {
                        Fluttertoast.showToast(
                            msg: "Status update success",
                            toastLength: Toast.LENGTH_LONG);
                        isChanged = true;
                      } else {
                        Fluttertoast.showToast(
                            msg: "Can't connected to service, please wait",
                            toastLength: Toast.LENGTH_LONG);
                      }
                      if (isChanged) {
                        status = _statusController.text;
                      }
                      setState(() {});
                    });
                    Navigator.pop(context);
                  },
                  child: Text("Next",
                      style: TextStyle(
                          color: AppColor.primaryColor, fontSize: 20)),
                )
              ]);
        });
  }
}
