import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter/painting.dart';
import 'package:flutter_typeahead/flutter_typeahead.dart';
import 'package:palio_lite/app_color.dart';
import 'package:palio_lite/db_helper.dart';
import 'package:shared_preferences/shared_preferences.dart';

class AddGroup extends StatefulWidget {
  final Function(String) listGroups;
  final List<String> listUpdate;

  AddGroup({required this.listGroups, required this.listUpdate});

  @override
  _AddGroupState createState() => _AddGroupState();
}

class _AddGroupState extends State<AddGroup> {
  TextEditingController name = TextEditingController();

  List<String> _temporaryContact = [];
  List<String> _temporaryFpin = [];
  bool onDisable = true;
  String f_pin = "";

  void getMyself() async {
    final SharedPreferences prefs = await SharedPreferences.getInstance();
    f_pin = prefs.getString("hasLogin")!;
  }

  void getPeople() async {
    List<dynamic> resultQuery =
        await DBHelper().queryCustom("SELECT group_id, f_name FROM GROUPZ");
    for (var i = 0; i < resultQuery.length; i++) {
      _temporaryContact.add(resultQuery[i]["f_name"]);
      _temporaryFpin.add(resultQuery[i]["group_id"]);
    }
    print("group : " + _temporaryContact.toString());
    print("id : " + _temporaryFpin.toString());
  }

  @override
  void initState() {
    super.initState();
    getPeople();
  }

  @override
  Widget build(BuildContext context) {
    return onDisable
        ? Container(
            margin: EdgeInsets.only(left: 5.0),
            width: 50,
            height: 40,
            decoration: BoxDecoration(
                border: Border.all(color: Colors.black),
                borderRadius: BorderRadius.circular(3.0)),
            child: IconButton(
                onPressed: () {
                  setState(() {
                    onDisable = !onDisable;
                  });
                },
                icon: Icon(
                  Icons.person_add,
                  color: Colors.grey[600],
                )),
          )
        : Container(
            margin: EdgeInsets.only(left: 5.0),
            width: MediaQuery.of(context).size.width * 0.8,
            child: TypeAheadField(
              textFieldConfiguration: TextFieldConfiguration(
                autofocus: true,
                controller: name,
                cursorColor: AppColor.primaryColor,
                decoration: InputDecoration(
                    contentPadding: EdgeInsets.only(left: 10.0),
                    focusedBorder: OutlineInputBorder(
                        borderRadius: BorderRadius.circular(3.0),
                        borderSide: BorderSide(color: Colors.black)),
                    border: OutlineInputBorder(
                        borderRadius: BorderRadius.circular(3.0),
                        borderSide: BorderSide(color: Colors.black)),
                    hintText: "\uD83D\uDD0D " + "Type group's name...",
                    suffixIcon: IconButton(
                      onPressed: () {
                        if (name.text.isNotEmpty) {
                          setState(() {
                            name.clear();
                          });
                        } else {
                          setState(() {
                            onDisable = !onDisable;
                          });
                        }
                      },
                      icon: Icon(Icons.clear, color: Colors.grey),
                    )),
              ),
              hideOnEmpty: true,
              hideOnLoading: true,
              autoFlipDirection: true,
              getImmediateSuggestions: true,
              suggestionsCallback: (pattern) async {
                List<String> listFilter = [];
                for (var i = 0; i < _temporaryContact.length; i++) {
                  if (_temporaryContact[i]
                          .toLowerCase()
                          .contains(pattern.toLowerCase()) &&
                      pattern.trim().isNotEmpty) {
                    listFilter
                        .add(_temporaryContact[i] + "~" + _temporaryFpin[i]);
                    print("Found " +
                        pattern +
                        " " +
                        _temporaryContact[i] +
                        " " +
                        _temporaryFpin[i]);
                  }
                }
                for (var x = 0; x < widget.listUpdate.length; x++) {
                  if (listFilter.contains(widget.listUpdate[x])) {
                    print("found same " + widget.listUpdate[x]);
                    listFilter.remove(widget.listUpdate[x]);
                  }
                }
                return listFilter;
              },
              itemBuilder: (context, suggest) {
                return ListTile(title: Text(suggest.toString().split("~")[0]));
              },
              onSuggestionSelected: (suggest) {
                widget.listGroups(suggest as String);
                setState(() {
                  name.clear();
                  onDisable = !onDisable;
                });
              },
            ),
          );
  }
}
