import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter/painting.dart';
import 'package:flutter_translate/flutter_translate.dart';
import 'package:flutter_typeahead/flutter_typeahead.dart';
import 'package:palio_lite/app_color.dart';
import 'package:palio_lite/db_helper.dart';
import 'package:shared_preferences/shared_preferences.dart';

class AddMember extends StatefulWidget {
  final Function(String) listMembers;
  final List<String> listUpdate;

  AddMember({required this.listMembers, required this.listUpdate});

  @override
  _AddMemberState createState() => _AddMemberState();
}

class _AddMemberState extends State<AddMember> {
  TextEditingController name = TextEditingController();

  List<String> _temporaryContact = [];
  List<String> _temporaryFpin = [];
  bool onDisable = true;
  String f_pin = "";

  void getMyself() async {
    final SharedPreferences prefs = await SharedPreferences.getInstance();
    f_pin = prefs.getString("hasLogin")!;
  }

  void getPeople() async {
    final SharedPreferences prefs = await SharedPreferences.getInstance();
    String idMe = prefs.getString("hasLogin")!;
    List<dynamic> resultQuery = await DBHelper().queryCustom(
        "SELECT f_pin, first_name, last_name,official_account, image_id FROM BUDDY where f_pin <> '$idMe' and f_pin <> '02121368af'");
    for (var i = 0; i < resultQuery.length; i++) {
      if (resultQuery[i]["f_pin"] != f_pin) {
        if (resultQuery[i]["last_name"].toString().isEmpty) {
          _temporaryContact.add(resultQuery[i]["first_name"]);
        } else {
          _temporaryContact.add(
              resultQuery[i]["first_name"] + " " + resultQuery[i]["last_name"]);
        }
        _temporaryFpin.add(resultQuery[i]["f_pin"]);
      }
    }
  }

  @override
  void initState() {
    super.initState();
    getMyself();
    getPeople();
  }

  @override
  Widget build(BuildContext context) {
    return onDisable
        ? Container(
            margin: EdgeInsets.only(left: 5.0),
            width: 50,
            height: 40,
            decoration: BoxDecoration(
                border: Border.all(color: Colors.black),
                borderRadius: BorderRadius.circular(3.0)),
            child: IconButton(
                onPressed: () {
                  setState(() {
                    onDisable = !onDisable;
                  });
                },
                icon: Icon(
                  Icons.person_add,
                  color: Colors.grey[600],
                )),
          )
        : Container(
            margin: EdgeInsets.only(left: 5.0),
            width: MediaQuery.of(context).size.width * 0.8,
            child: TypeAheadField(
              textFieldConfiguration: TextFieldConfiguration(
                autofocus: true,
                controller: name,
                cursorColor: AppColor.primaryColor,
                decoration: InputDecoration(
                    contentPadding: EdgeInsets.only(left: 10.0),
                    focusedBorder: OutlineInputBorder(
                        borderRadius: BorderRadius.circular(3.0),
                        borderSide: BorderSide(color: Colors.black)),
                    border: OutlineInputBorder(
                        borderRadius: BorderRadius.circular(3.0),
                        borderSide: BorderSide(color: Colors.black)),
                    hintText: "\uD83D\uDD0D " + "Type friend's name...",
                    suffixIcon: IconButton(
                      onPressed: () {
                        if (name.text.isNotEmpty) {
                          setState(() {
                            name.clear();
                          });
                        } else {
                          setState(() {
                            onDisable = !onDisable;
                          });
                        }
                      },
                      icon: Icon(Icons.clear, color: Colors.grey),
                    )),
              ),
              hideOnEmpty: true,
              hideOnLoading: true,
              autoFlipDirection: true,
              getImmediateSuggestions: true,
              suggestionsCallback: (pattern) async {
                List<String> listFilter = [];
                for (var i = 0; i < _temporaryContact.length; i++) {
                  if (_temporaryContact[i]
                          .toLowerCase()
                          .contains(pattern.toLowerCase()) &&
                      pattern.trim().isNotEmpty) {
                    listFilter
                        .add(_temporaryContact[i] + "~" + _temporaryFpin[i]);
                    print("Found " +
                        pattern +
                        " " +
                        _temporaryContact[i] +
                        " " +
                        _temporaryFpin[i]);
                  }
                }
                for (var x = 0; x < widget.listUpdate.length; x++) {
                  if (listFilter.contains(widget.listUpdate[x])) {
                    print("found same " + widget.listUpdate[x]);
                    listFilter.remove(widget.listUpdate[x]);
                  }
                }
                return listFilter;
              },
              itemBuilder: (context, suggest) {
                return ListTile(title: Text(suggest.toString().split("~")[0]));
              },
              onSuggestionSelected: (suggest) {
                widget.listMembers(suggest as String);
                setState(() {
                  name.clear();
                  onDisable = !onDisable;
                });
              },
            ),
          );
  }
}
