import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter_translate/flutter_translate.dart';
import 'package:palio_lite/app_color.dart';

class OfflineCallDialogView extends StatefulWidget {
  @override
  _OfflineCallDialogViewLS createState() => new _OfflineCallDialogViewLS();
}

class _OfflineCallDialogViewLS extends State<OfflineCallDialogView> {
  @override
  void dispose() {
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return CupertinoAlertDialog(
      title: Text(
        "Hi. I can't talk right now. Please leave your message.",
        style: TextStyle(
            color: AppColor.primaryColor,
            fontSize: 16,
            fontWeight: FontWeight.w300),
        textAlign: TextAlign.start,
      ),
      content: Container(
          margin: EdgeInsets.only(top: 20),
          padding: EdgeInsets.all(10),
          child: Row(
            children: <Widget>[
              Container(
                  margin: EdgeInsets.only(right: 5),
                  width: 70.0,
                  height: 70.0,
                  decoration: new BoxDecoration(
                      shape: BoxShape.circle,
                      image: new DecorationImage(
                          fit: BoxFit.fill,
                          image: new NetworkImage(
                              "https://i.imgur.com/BoN9kdC.png")))),
              Icon(
                CupertinoIcons.mic_solid,
                color: Colors.white,
                size: 30,
              ),
              Container(
                margin: EdgeInsets.only(left: 3),
                child: Column(
                  crossAxisAlignment: CrossAxisAlignment.start,
                  children: <Widget>[
                    Text("Send Voice Message",
                        style: TextStyle(color: Colors.white, fontSize: 12)),
                    SizedBox(
                      height: 3,
                    ),
                    Text(
                      "Tap to talk...",
                      style: TextStyle(
                          color: Colors.white,
                          fontSize: 10,
                          fontStyle: FontStyle.italic),
                    )
                  ],
                ),
              )
            ],
          ),
          decoration: BoxDecoration(
              color: AppColor.primaryColor,
              borderRadius: BorderRadius.circular(8))),
      actions: <Widget>[
        CupertinoDialogAction(
          onPressed: () => Navigator.pop(context),
          child: Text("Cancel",
              style: TextStyle(color: AppColor.primaryColor, fontSize: 20)),
        ),
      ],
    );
  }
}
