import 'dart:async';
import 'package:flutter/material.dart';
import 'package:camera/camera.dart';

class CameraApp extends StatefulWidget {
  @override
  _CameraAppState createState() => _CameraAppState();
}

class _CameraAppState extends State<CameraApp> {
  CameraController? controller;
  List<CameraDescription>? cameras;
  bool _isReady = false;

  @override
  void initState() {
    super.initState();
    print("step satu");
    _setupCameras();
//    controller = CameraController(cameras[0], ResolutionPreset.medium);
    print("step dua");
//    controller.initialize().then((_) {
//      print("step tiga");
//      if (!mounted) {
//        print("step tiga gagal");
//        return;
//      }
//      print("step empat");
//      setState(() {});
//    });
  }

  Future<void> _setupCameras() async {
    try {
      // initialize cameras.
      cameras = await availableCameras();
      // initialize camera controllers.
      controller = new CameraController(cameras![0], ResolutionPreset.medium);
      await controller!.initialize();
    } on CameraException catch (_) {
      print("error");
    }
    if (!mounted) return;
    setState(() {
      _isReady = true;
    });
  }

  @override
  void dispose() {
    controller!.dispose();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    if (!_isReady) {
      return Container();
    }
    return AspectRatio(
        aspectRatio: controller!.value.aspectRatio!,
        child: CameraPreview(controller!));
  }
}
