import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:fluttertoast/fluttertoast.dart';
import 'package:page_transition/page_transition.dart';
import 'package:palio_lite/app_color.dart';
import 'package:palio_lite/conference/inisiator_ls_screen.dart';

class DialogStartLSView extends StatefulWidget {
  String f_pin;
  String name;

  DialogStartLSView({required this.f_pin, required this.name});

  @override
  _DialogStartLS createState() => new _DialogStartLS();
}

class _DialogStartLS extends State<DialogStartLSView> {
  Privacy? selectedPrivacy;
  String name = "";
  String f_pin = "";
  String privacy = "";

  List<Privacy> privacyStatus = <Privacy>[
    Privacy(
        1,
        "Friends",
        Icon(
          CupertinoIcons.group,
          color: AppColor.primaryColor,
        )),
    Privacy(
        2,
        "Public",
        Icon(
          CupertinoIcons.share,
          color: AppColor.primaryColor,
        )),
  ];

  @override
  void dispose() {
    super.dispose();
  }

  @override
  void initState() {
    super.initState();
    name = widget.name;
    f_pin = widget.f_pin;
    privacy = "";
  }

  @override
  Widget build(BuildContext context) {
    return CupertinoAlertDialog(
      title: Text("Live Video Promotion",
          style: TextStyle(color: AppColor.primaryColor)),
      content: Wrap(
        children: <Widget>[
          Container(
            child: Column(
              mainAxisSize: MainAxisSize.min,
              children: <Widget>[
                Align(
                  alignment: Alignment.centerLeft,
                  child: Material(
                    color: Colors.transparent,
                    child: DropdownButton<Privacy>(
                      hint: Text("Broadcast To"),
                      value: selectedPrivacy,
                      onChanged: (Privacy? value) {
                        setState(() {
                          selectedPrivacy = value;
                          if (selectedPrivacy?.id == 1) {
                            privacy = "0";
                          } else {
                            privacy = "3";
                          }
                        });
                      },
                      items: privacyStatus.map((Privacy privacy) {
                        return DropdownMenuItem<Privacy>(
                          value: privacy,
                          child: Row(
                            children: <Widget>[
                              privacy.icon,
                              SizedBox(
                                width: 20,
                              ),
                              Text(
                                privacy.desc,
                                style: TextStyle(color: Colors.black),
                              ),
                              SizedBox(
                                width: 10,
                              ),
                            ],
                          ),
                        );
                      }).toList(),
                    ),
                  ),
                ),
              ],
            ),
          )
        ],
      ),
      actions: <Widget>[
        FlatButton(
          child: Text(
            "Cancel",
            style: TextStyle(color: AppColor.primaryColor),
          ),
          onPressed: () {
            Navigator.of(context).pop();
          },
        ),
        FlatButton(
          child: Text(
            "START",
            style: TextStyle(color: AppColor.primaryColor),
          ),
          onPressed: () {
            Navigator.of(context).pop();

            if (selectedPrivacy == null) {
              Fluttertoast.showToast(
                  msg: "Select the target live broadcast first",
                  toastLength: Toast.LENGTH_LONG,
                  gravity: ToastGravity.BOTTOM,
                  timeInSecForIosWeb: 1,
                  backgroundColor: AppColor.primaryColor,
                  textColor: Colors.white,
                  fontSize: 16.0);
              return;
            }

            Navigator.push(
                context,
                PageTransition(
                    type: PageTransitionType.fade,
                    child: InisiateLs(
                      name: name,
                      f_pin: f_pin,
                      privacy: privacy,
                    )));
            print("Live stream choose");
          },
        )
      ],
    );
  }
}

class Privacy {
  int id;
  String desc;
  Icon icon;

  Privacy(this.id, this.desc, this.icon);
}
