// import 'dart:async';
// import 'dart:convert';
// import 'dart:io';
// import 'dart:math';
//
// import 'package:cached_network_image/cached_network_image.dart';
// import 'package:flutter/material.dart';
// import 'package:flutter/cupertino.dart';
// import 'package:flutter_translate/global.dart';
// import 'package:geolocator/geolocator.dart';
// import 'package:google_maps_flutter/google_maps_flutter.dart';
// import 'package:page_transition/page_transition.dart';
// import 'package:provider/provider.dart';
// import 'package:sliding_up_panel/sliding_up_panel.dart';
// import 'package:http/http.dart' as http;
// import 'package:un_ios_app/Widget/search_map_picker.dart';
// import 'package:un_ios_app/app_color.dart';
//
// class NearbyPlace {
//   String name;
//   String icon;
//   String vicinity;
//   List<dynamic> type;
//   LatLng latLng;
//   double proximity;
// }
//
// class ChangeState with ChangeNotifier {
//   LatLng _lastMapPosition;
//   ScrollPhysics _statusScroll = NeverScrollableScrollPhysics();
//   Placemark _pointLocation;
//   List<NearbyPlace> _nearbyPlaces = List();
//   bool _loadingNearby = true;
//   double _animatedAppBar, _animatedSearchBox;
//
//   LatLng get lastMapPosition => _lastMapPosition;
//
//   ScrollPhysics get statusScroll => _statusScroll;
//
//   Placemark get pointLocation => _pointLocation;
//
//   List<NearbyPlace> get nearbyPlaces => _nearbyPlaces;
//
//   bool get loadingNearby => _loadingNearby;
//
//   double get animatedAppBar => _animatedAppBar;
//
//   double get animatedSearchBox => _animatedSearchBox;
//
//   set lastMapPosition(LatLng value) {
//     _lastMapPosition = value;
//     notifyListeners();
//   }
//
//   set statusScroll(ScrollPhysics value) {
//     _statusScroll = value;
//     notifyListeners();
//   }
//
//   set pointLocation(Placemark value) {
//     _pointLocation = value;
//     notifyListeners();
//   }
//
//   set nearbyPlaces(List<NearbyPlace> value) {
//     _nearbyPlaces.addAll(value);
//     notifyListeners();
//   }
//
//   set clearNearbyPlaces(bool value) {
//     _nearbyPlaces.clear();
//     notifyListeners();
//   }
//
//   set loadingNearby(bool value) {
//     _loadingNearby = value;
//     notifyListeners();
//   }
//
//   set animatedAppBar(double value) {
//     _animatedAppBar = value;
//     notifyListeners();
//   }
//
//   set animatedSearchBox(double value) {
//     _animatedSearchBox = value;
//     notifyListeners();
//   }
// }
//
// class MapPicker extends StatelessWidget {
//   final String apiKey;
//   final LatLng initialLocation;
//
//   MapPicker(this.apiKey, this.initialLocation);
//
//   @override
//   Widget build(BuildContext context) {
//     return ChangeNotifierProvider(
//       create: (_) => ChangeState(),
//       child: Consumer<ChangeState>(
//         builder: (context, changeState, _) =>
//             MapPickers(apiKey, initialLocation, changeState),
//       ),
//     );
//   }
// }
//
// class MapPickers extends StatefulWidget {
//   final String apiKey;
//   final LatLng initialLocation;
//   final ChangeState changeState;
//
//   MapPickers(this.apiKey, this.initialLocation, this.changeState);
//
//   @override
//   _MapPickersState createState() => _MapPickersState();
// }
//
// class _MapPickersState extends State<MapPickers> {
//   Timer _timer;
//   Completer<GoogleMapController> _controller = Completer();
//   PanelController controllerPanel = new PanelController();
//
//   @override
//   void initState() {
//     WidgetsBinding.instance.addPostFrameCallback((_) {
//       final changeState = Provider.of<ChangeState>(context, listen: false);
//       getMyPointPlace(widget.initialLocation, changeState);
//     });
//     super.initState();
//   }
//
//   void currentLocation(ChangeState changeState) async {
//     final GoogleMapController controller = await _controller.future;
//     controller.animateCamera(CameraUpdate.newCameraPosition(
//         CameraPosition(target: widget.initialLocation, zoom: 16)));
//   }
//
//   void getMyPointPlace(
//       LatLng position, covariant ChangeState changeState) async {
//     try {
//       List<Placemark> location = await Geolocator()
//           .placemarkFromCoordinates(position.latitude, position.longitude);
//       if (location != null) {
//         changeState.pointLocation = location[0];
//       }
//     } catch (e) {}
//   }
//
//   distance(double startLat, double startLong, double endLat, double endLong) {
//     var p = 0.017453292519943295;
//     var c = cos;
//     var a = 0.5 -
//         c((endLat - startLat) * p) / 2 +
//         c(startLat * p) *
//             c(endLat * p) *
//             (1 - c((endLong - startLong) * p)) /
//             2;
//     return 12742 * asin(sqrt(a));
//   }
//
//   void getNearbyPlaces(LatLng position, ChangeState changeState) {
//     http
//         .get("https://maps.googleapis.com/maps/api/place/nearbysearch/json?" +
//             "key=${widget.apiKey}&" +
//             "location=${position.latitude},${position.longitude}&radius=150")
//         .then((response) {
//       if (response.statusCode == 200) {
//         changeState.clearNearbyPlaces = true;
//         List<NearbyPlace> temporary = [];
//         for (Map<String, dynamic> item
//             in jsonDecode(response.body)['results']) {
//           List<dynamic> typePlace = item["types"];
//           if (typePlace.contains("point_of_interest")) {
//             NearbyPlace nearbyPlace = NearbyPlace();
//             nearbyPlace.name = item['name'];
//             nearbyPlace.icon = item['icon'];
//             nearbyPlace.vicinity = item['vicinity'];
//             nearbyPlace.type = typePlace;
//             double latitude = item['geometry']['location']['lat'];
//             double longitude = item['geometry']['location']['lng'];
//             nearbyPlace.proximity = distance(
//                 position.latitude, position.longitude, latitude, longitude);
//             LatLng _latLng = LatLng(latitude, longitude);
//
//             nearbyPlace.latLng = _latLng;
//
//             temporary.add(nearbyPlace);
//           }
//         }
//         temporary.sort((a, b) => (a.proximity).compareTo(b.proximity));
//         changeState.nearbyPlaces = temporary;
//       }
//       changeState.loadingNearby = false;
//     }).catchError((error) {
//       changeState.loadingNearby = false;
//     });
//   }
//
//   void showLocation(BuildContext context, String text, bool fromNearby,
//       {int index}) {
//     String latitude;
//     String longitude;
//     if (fromNearby) {
//       latitude =
//           widget.changeState.nearbyPlaces[index].latLng.latitude.toString();
//       longitude =
//           widget.changeState.nearbyPlaces[index].latLng.longitude.toString();
//     } else {
//       latitude = widget.changeState.pointLocation.position.latitude.toString();
//       longitude =
//           widget.changeState.pointLocation.position.longitude.toString();
//     }
//     showDialog(
//         context: context,
//         builder: (_) {
//           String imageLocation =
//               "https://maps.googleapis.com/maps/api/staticmap?center=" +
//                   latitude +
//                   "," +
//                   longitude +
//                   "&zoom=15&size=" +
//                   300.toString() +
//                   "x" +
//                   150.toString() +
//                   "&maptype=normal&markers=color:red|" +
//                   latitude +
//                   "," +
//                   longitude +
//                   "&key=AIzaSyC79oNmadezP9O_4Q_Ud2bbuJ_L7M--y1s";
//           return CupertinoAlertDialog(
//             title: Text("Pilih lokasi ini?"),
//             content: Column(
//               crossAxisAlignment: CrossAxisAlignment.center,
//               children: <Widget>[
//                 Text(text),
//                 SizedBox(height: 10),
//                 CachedNetworkImage(
//                   imageUrl: imageLocation,
//                   placeholder: (context, url) => CupertinoActivityIndicator(),
//                   errorWidget: (context, url, error) => new Icon(Icons.error),
//                 )
//               ],
//             ),
//             actions: <Widget>[
//               FlatButton(
//                 child: Text(
//                   "Ganti Lokasi",
//                   style: TextStyle(color: AppColor.primaryColor),
//                 ),
//                 onPressed: () {
//                   Navigator.of(context).pop();
//                 },
//               ),
//               FlatButton(
//                 child: Text(
//                   "Pilih Lokasi",
//                   style: TextStyle(color: AppColor.primaryColor),
//                 ),
//                 onPressed: () {
//                   Navigator.pop(context);
//                   if (fromNearby) {
//                     Navigator.pop(context, {
//                       "namePlace": text,
//                       "latlng": widget.changeState.nearbyPlaces[index].latLng
//                     });
//                   } else {
//                     Navigator.pop(context, {
//                       "namePlace": text,
//                       "latlng": widget.changeState.pointLocation.position
//                     });
//                   }
//                 },
//               )
//             ],
//           );
//         });
//   }
//
//   @override
//   Widget build(BuildContext context) {
//     return Scaffold(
//       extendBodyBehindAppBar: true,
//       body: Stack(
//         children: <Widget>[
//           Column(
//             children: <Widget>[
//               Container(
//                 height: MediaQuery.of(context).size.height * 0.7,
//                 child: Stack(
//                   children: <Widget>[
//                     GoogleMap(
//                       initialCameraPosition: CameraPosition(
//                           target: widget.initialLocation, zoom: 16),
//                       rotateGesturesEnabled: true,
//                       onCameraIdle: () {
//                         _timer = new Timer(Duration(milliseconds: 500), () {
//                           if (widget.changeState.lastMapPosition != null) {
//                             widget.changeState.loadingNearby = true;
//                             getMyPointPlace(widget.changeState.lastMapPosition,
//                                 widget.changeState);
//                             getNearbyPlaces(widget.changeState.lastMapPosition,
//                                 widget.changeState);
//                           }
//                         });
//                       },
//                       mapToolbarEnabled: false,
//                       myLocationButtonEnabled: false,
//                       myLocationEnabled: true,
//                       onCameraMove: (position) {
//                         if (_timer != null) {
//                           _timer.cancel();
//                         }
//                         widget.changeState.lastMapPosition = position.target;
//                       },
//                       onMapCreated: (controller) {
//                         _controller.complete(controller);
//                         if (widget.changeState.lastMapPosition != null) {
//                           getNearbyPlaces(widget.changeState.lastMapPosition,
//                               widget.changeState);
//                         } else {
//                           getNearbyPlaces(
//                               widget.initialLocation, widget.changeState);
//                         }
//                       },
//                     ),
//                     Align(
//                       alignment: Alignment.center,
//                       child: Container(
//                         margin: EdgeInsets.only(bottom: 40.0),
//                         width: 40,
//                         height: 40,
//                         child: Image.asset("assets/images/pin_picker.png"),
//                       ),
//                     ),
//                     Align(
//                       alignment: Alignment.bottomRight,
//                       child: Container(
//                         margin: EdgeInsets.only(bottom: 20, right: 20),
//                         height: 60,
//                         width: 60,
//                         decoration: BoxDecoration(
//                             color: Colors.white,
//                             shape: BoxShape.circle,
//                             boxShadow: [
//                               BoxShadow(
//                                 color: Colors.grey[400],
//                                 blurRadius: 5.0,
//                               )
//                             ]),
//                         child: Material(
//                           color: Colors.transparent,
//                           child: InkWell(
//                             onTap: () {
//                               currentLocation(widget.changeState);
//                             },
//                             child: Icon(
//                               Icons.gps_fixed,
//                               color: Colors.grey,
//                             ),
//                           ),
//                         ),
//                       ),
//                     )
//                   ],
//                 ),
//               ),
//               Container(
//                 alignment: Alignment.center,
//                 height: MediaQuery.of(context).size.height * 0.1,
//                 color: Colors.white,
//                 child: ListTile(
//                   onTap: () {
//                     String address = "${widget.changeState.pointLocation.name}" +
//                         ", " +
//                         "${widget.changeState.pointLocation.subLocality}" +
//                         ", " +
//                         "${widget.changeState.pointLocation.locality} " +
//                         "${widget.changeState.pointLocation.administrativeArea} " +
//                         "${widget.changeState.pointLocation.postalCode}" +
//                         ", " +
//                         "${widget.changeState.pointLocation.country}";
//                     showLocation(context, address, false);
//                   },
//                   leading: Icon(
//                     Icons.location_on,
//                     color: Colors.blueGrey,
//                   ),
//                   title: Text(translate("selectLocation")),
//                 ),
//               ),
//             ],
//           ),
//           SlidingUpPanel(
//             minHeight: MediaQuery.of(context).size.height * 0.2,
//             maxHeight: MediaQuery.of(context).size.height * 0.96,
//             boxShadow: null,
//             isDraggable: true,
//             onPanelOpened: () {
//               widget.changeState.statusScroll = AlwaysScrollableScrollPhysics();
//             },
//             onPanelClosed: () {
//               if (widget.changeState.statusScroll !=
//                   NeverScrollableScrollPhysics()) {
//                 widget.changeState.statusScroll =
//                     NeverScrollableScrollPhysics();
//               }
//             },
//             onPanelSlide: (slide) {
//               if (slide == 0.0) {
//                 widget.changeState.animatedSearchBox = 40.0;
//               }
//               if (slide > 0.0) {
//                 widget.changeState.animatedSearchBox = -100.0;
//               }
//               if (slide > 0.8) {
//                 widget.changeState.animatedAppBar = 0.0;
//               }
//               if (slide < 0.8) {
//                 widget.changeState.animatedAppBar =
//                     -(MediaQuery.of(context).size.height * 0.1);
//               }
//             },
//             controller: controllerPanel,
//             color: Colors.grey[100],
//             panel: SingleChildScrollView(
//               physics: widget.changeState.statusScroll,
//               child: Column(
//                 crossAxisAlignment: CrossAxisAlignment.start,
//                 children: <Widget>[
//                   Padding(
//                     padding: const EdgeInsets.only(
//                         left: 20.0, top: 20.0, right: 20.0),
//                     child: Row(
//                       mainAxisAlignment: MainAxisAlignment.spaceBetween,
//                       children: <Widget>[
//                         Text("${translate("or")} ${translate("chooseNearby")}",
//                             style: TextStyle(color: Colors.grey)),
//                         widget.changeState.loadingNearby
//                             ? SizedBox(
//                                 height: 20,
//                                 width: 20,
//                                 child:
//                                     CircularProgressIndicator(strokeWidth: 3.0))
//                             : Container()
//                       ],
//                     ),
//                   ),
//                   ListView.builder(
//                       shrinkWrap: true,
//                       physics: NeverScrollableScrollPhysics(),
//                       itemCount: widget.changeState.nearbyPlaces.length,
//                       itemBuilder: (_, i) {
//                         return ListTile(
//                           contentPadding:
//                               EdgeInsets.only(left: 20.0, right: 20.0),
//                           leading: Container(
//                             padding: EdgeInsets.all(8.0),
//                             width: 30,
//                             height: 30,
//                             decoration: BoxDecoration(
//                                 color: Colors.white,
//                                 shape: BoxShape.circle,
//                                 border:
//                                     Border.all(width: 1.0, color: Colors.grey)),
//                             child: Image.network(
//                                 widget.changeState.nearbyPlaces[i].icon,
//                                 color: widget.changeState.nearbyPlaces[i].type
//                                             .contains("food") ||
//                                         widget.changeState.nearbyPlaces[i].type
//                                             .contains("cafe")
//                                     ? Colors.orange
//                                     : widget.changeState.nearbyPlaces[i].type
//                                             .contains("store")
//                                         ? Colors.blue
//                                         : widget.changeState.nearbyPlaces[i]
//                                                 .type
//                                                 .contains("finance")
//                                             ? Colors.green
//                                             : Colors.blueGrey),
//                           ),
//                           title: Text(
//                             widget.changeState.nearbyPlaces[i].name,
//                             overflow: TextOverflow.ellipsis,
//                           ),
//                           subtitle: Text(
//                             widget.changeState.nearbyPlaces[i].vicinity,
//                             overflow: TextOverflow.ellipsis,
//                           ),
//                           onTap: () {
//                             showLocation(context,
//                                 widget.changeState.nearbyPlaces[i].name, true,
//                                 index: i);
//                           },
//                         );
//                       })
//                 ],
//               ),
//             ),
//           ),
//           AnimatedPositioned(
//             duration: Duration(milliseconds: 300),
//             top: widget.changeState.animatedAppBar != null
//                 ? widget.changeState.animatedAppBar
//                 : -(MediaQuery.of(context).size.height * 0.1),
//             height: MediaQuery.of(context).size.height * 0.1,
//             width: MediaQuery.of(context).size.width,
//             child: Container(
//               color: Colors.white,
//               child: Padding(
//                 padding:
//                     EdgeInsets.only(top: 20, bottom: 10, right: 10, left: 10),
//                 child: Row(
//                   mainAxisAlignment: MainAxisAlignment.spaceBetween,
//                   children: <Widget>[
//                     Row(
//                       mainAxisAlignment: MainAxisAlignment.start,
//                       children: <Widget>[
//                         InkWell(
//                             child: Icon(Icons.arrow_back_ios),
//                             onTap: () {
//                               controllerPanel.close();
//                             }),
//                         SizedBox(width: 20),
//                         Text(translate("chooseNearby"),
//                             style: TextStyle(fontSize: 17)),
//                       ],
//                     ),
//                     Material(
//                         color: Colors.transparent,
//                         child: InkWell(
//                             onTap: () {
//                               controllerPanel.close();
//                               Future.delayed(Duration(milliseconds: 300), () {
//                                 Navigator.push(
//                                     context,
//                                     PageTransition(
//                                         type: PageTransitionType.rightToLeft,
//                                         child: SearchMapPicker(widget.apiKey,
//                                             widget.initialLocation)));
//                               });
//                             },
//                             child: Icon(Icons.search)))
//                   ],
//                 ),
//               ),
//             ),
//           ),
//           AnimatedPositioned(
//             duration: Duration(milliseconds: 300),
//             top: widget.changeState.animatedSearchBox != null
//                 ? widget.changeState.animatedSearchBox
//                 : 40.0,
//             child: Row(
//               mainAxisAlignment: MainAxisAlignment.start,
//               children: <Widget>[
//                 SizedBox(width: 10),
//                 GestureDetector(
//                   child: Icon(Icons.arrow_back_ios),
//                   onTap: () => Navigator.of(context).pop(),
//                 ),
//                 GestureDetector(
//                   onTap: () => Navigator.push(
//                       context,
//                       PageTransition(
//                           type: PageTransitionType.rightToLeft,
//                           child: SearchMapPicker(
//                               widget.apiKey, widget.initialLocation))),
//                   child: Container(
//                     margin: EdgeInsets.only(left: 10, right: 10),
//                     height: 50,
//                     width: MediaQuery.of(context).size.width * 0.85,
//                     decoration: BoxDecoration(
//                         color: Colors.white,
//                         borderRadius: BorderRadius.circular(20.0)),
//                     child: Row(
//                       mainAxisAlignment: MainAxisAlignment.start,
//                       children: <Widget>[
//                         SizedBox(width: 20),
//                         Icon(Icons.search),
//                         SizedBox(width: 20),
//                         Text(translate("search"),
//                             style: TextStyle(fontSize: 18)),
//                       ],
//                     ),
//                   ),
//                 ),
//               ],
//             ),
//           ),
//         ],
//       ),
//     );
//   }
// }
