import 'dart:async';

import 'package:flutter/gestures.dart';
import 'package:flutter/material.dart';
import 'package:url_launcher/url_launcher.dart';

class RTFText extends StatelessWidget {
  final Map<String, String>? mentions;
  final Map<String, String>? currentMembers;
  final Color mentionColor;
  final Color textColor;
  final Color linkColor;
  final bool bLink;
  final String? highLightText;
  final bool isSearch;
  final String? textSearch;
  final int? maxLines;
  final String data;
  final TextOverflow overflow;
  final double? fontSize;
  final Widget? fromBubble;
  final bool isPreviewMessage;
  final isGroupBubble;

  RTFText(this.data,
      {Key? key,
      this.textColor = Colors.black,
      this.mentions,
      this.mentionColor = Colors.blueAccent,
      this.highLightText,
      this.bLink = false,
      this.isSearch = false,
      this.textSearch,
      this.linkColor = Colors.blueAccent,
      this.maxLines,
      this.overflow = TextOverflow.visible,
      this.fromBubble,
      this.currentMembers,
      this.isGroupBubble = false,
      this.fontSize,
      this.isPreviewMessage = false})
      : super(key: key);

  @override
  Widget build(BuildContext context) {
    try {
      return Text.rich(
        TextSpan(
            children: toRTF(
                data.isNotEmpty
                    ? data[data.length - 1] == "\n"
                        ? data.replaceAll("\t", " ").trim()
                        : data.contains("@")
                            ? data.replaceAll("\t", " ").trim()
                            : data.replaceAll("\t", " ").trim()
                    : "",
                isPreview: true,
                mentions: mentions!,
                textSearch: textSearch,
                textColor: textColor,
                isSearch: isSearch,
                mentionColor: mentionColor,
                hilghLihtText: highLightText,
                bLink: bLink,
                currentMember: currentMembers,
                fromBubble: fromBubble,
                isGroupBubble: isGroupBubble,
                linkColor: linkColor,
                isPreviewMessage: isPreviewMessage,
                fontSizeText: fontSize)),
        maxLines: this.maxLines,
        overflow: this.overflow,
      );
    } catch (e) {}
    return Text(
        data.isNotEmpty
            ? data[data.length - 1] == "\n"
                ? data.replaceAll("\t", " ").trim()
                : data.contains("@")
                    ? data.replaceAll("\t", " ")
                    : data.replaceAll("\t", " ").trim()
            : "",
        overflow: this.overflow,
        style: TextStyle(color: textColor));
  }

  static List<TextSpan> toRTF(String p_text,
      {bool isPreview = false,
      bool isPreviewMessage = false,
      Color textColor = Colors.black,
      Map<String, String>? mentions,
      Map<String, String>? currentMember,
      Color mentionColor = Colors.red,
      String? hilghLihtText,
      bool isSearch = false,
      String? textSearch,
      bool bLink = false,
      bool isGroupBubble = false,
      Widget? fromBubble,
      Color linkColor = Colors.blueAccent,
      double? fontSizeText}) {
    Map<int, int> bold_map = new Map();
    Map<int, int> italic_map = new Map();
    Map<int, int> underline_map = new Map();
    Map<int, int> strike_map = new Map();
    Timer? _timer;
    List<TextSpan> spans = [];

    bool has_url_0x01 = false;

    String _uch = "_";
    String _sch = "*";
    String _wch = "~";
    String _pch = "^";

    String s_uch = String.fromCharCode(0x01);
    String s_sch = String.fromCharCode(0x02);
    String s_wch = String.fromCharCode(0x03);
    String s_pch = String.fromCharCode(0x04);

    /**
     * Link
     **/
    Map<int, int> link_map = new Map();
    if (p_text.toLowerCase().contains("http://")) {
      var _pHttp = p_text.split(" ");
      var startHttp = 0;

      for (int i = 0; i < _pHttp.length; i++) {
        if (_pHttp[i].toLowerCase().contains("http://")) {
          if (_pHttp[i].contains("\n")) {
            var _phttp2 = _pHttp[i].split("\n");
            for (var j = 0; j < _phttp2.length; j++) {
              if (_phttp2[j].toLowerCase().startsWith("http://")) {
                link_map[startHttp] = startHttp + _phttp2[j].length + 1;
              }
              startHttp = startHttp + _phttp2[j].length + 1;
            }
          } else {
            link_map[startHttp] = startHttp + _pHttp[i].length + 1;
            startHttp = startHttp + _pHttp[i].length + 1;
          }
        } else {
          startHttp = startHttp + _pHttp[i].length + 1;
        }
      }
    }

    if (p_text.toLowerCase().contains("https://")) {
      var _pHttps = p_text.split(" ");
      var startHttps = 0;

      for (int i = 0; i < _pHttps.length; i++) {
        if (_pHttps[i].toLowerCase().contains("https://")) {
          if (_pHttps[i].contains("\n")) {
            var _phttps2 = _pHttps[i].split("\n");
            for (var j = 0; j < _phttps2.length; j++) {
              if (_phttps2[j].toLowerCase().startsWith("https://")) {
                link_map[startHttps] = startHttps + _phttps2[j].length + 1;
              }
              startHttps = startHttps + _phttps2[j].length + 1;
            }
          } else {
            link_map[startHttps] = startHttps + _pHttps[i].length + 1;
            startHttps = startHttps + _pHttps[i].length + 1;
          }
        } else {
          startHttps = startHttps + _pHttps[i].length + 1;
        }
      }
    }

    /**
     * MENTIONS
     **/
    Map<int, int> mention_map = new Map();
    var listMention = [];
    if (p_text.contains('@')) {
      var _m = [];
      var _c = '@'.allMatches(p_text);
      _c.forEach((f) {
        String _p = p_text.substring(
            f.start,
            p_text.indexOf(' ', f.start) == -1
                ? p_text.length
                : p_text.indexOf(' ', f.start));
        _m.add(_p);
      });
      _m.forEach((f) {
        if (mentions != null && mentions.isNotEmpty && mentions[f] != null) {
          String mentionF = "@${mentions[f]}";
          listMention.add(mentionF);
          p_text = p_text.replaceAll(f, mentionF);

          var _pText = p_text.split(mentionF);
          var start = 0;
          var end = 0;

          for (int i = 0; i < _pText.length; i++) {
            start = p_text.indexOf(mentionF, start);
            if (start == -1) {
              break;
            }
            end = start + mentionF.length;

            if (end != -1) {
              if (isGroupBubble) {
                bool inGroup = currentMember!.containsKey(f);
                if (inGroup) {
                  mention_map[start] = end;
                }
              }
              start = end;
            }
          }
        }
      });

//      if (mentions != null && mentions.isNotEmpty) {
//        String m_word;
//        int m_sc = 0, m_ec = 0;
//
//      for (int i = 0; i < p_text.length; i++) {
//        m_sc = p_text.indexOf("@", m_sc);
//        if (m_sc == -1) {
//          break;
//        }
//        m_ec = p_text.indexOf(" ", m_sc + 1);
//        if (m_ec != -1) {
//          m_word = p_text.substring(m_sc, m_ec);
//
//          if (mentions.containsKey(m_word)) {
//            mention_map[m_sc] = m_ec;
//          }
//          m_sc = m_ec;
//        }
//      }
//      }

    }

    if (p_text.contains("*") ||
        p_text.contains("_") ||
        p_text.contains("~") ||
        p_text.contains("^")) {
      int n_uch = 0;
      int n_sch = 0;
      int n_wch = 0;
      int n_pch = 0;

      String tx;
      String _rp = p_text;
      for (int i = 0; i < _rp.length; i++) {
        tx = _rp.substring(i, i + 1);
        if (tx == _uch) {
          if (isAlfaNumeric(_rp, i - 1) && isAlfaNumeric(_rp, i + 1)) {
            _rp = _rp.replaceRange(i, i + 1, s_uch);
            has_url_0x01 = true;
          } else if (isSameChar(_rp, i - 1, _uch) ||
              isSameChar(_rp, i + 1, _uch)) {
            _rp = _rp.replaceRange(i, i + 1, s_uch);
            has_url_0x01 = true;
          } else {
            if (n_uch % 2 == 0 && !any_break_whitespace(_rp, i, _uch)) {
              _rp = _rp.replaceRange(i, i + 1, s_uch);
              has_url_0x01 = true;
            } else {
              n_uch++;
            }
          }
        } else if (tx == _sch) {
          if (isAlfaNumeric(_rp, i - 1) && isAlfaNumeric(_rp, i + 1)) {
            _rp = _rp.replaceRange(i, i + 1, s_sch);
            has_url_0x01 = true;
          } else if (isSameChar(_rp, i - 1, _sch) ||
              isSameChar(_rp, i + 1, _sch)) {
            _rp = _rp.replaceRange(i, i + 1, s_sch);
            has_url_0x01 = true;
          } else {
            if (n_sch % 2 == 0 && !any_break_whitespace(_rp, i, _sch)) {
              _rp = _rp.replaceRange(i, i + 1, s_sch);
              has_url_0x01 = true;
            } else {
              n_sch++;
            }
          }
        } else if (tx == _wch) {
          if (isAlfaNumeric(_rp, i - 1) && isAlfaNumeric(_rp, i + 1)) {
            _rp = _rp.replaceRange(i, i + 1, s_wch);
            has_url_0x01 = true;
          } else if (isSameChar(_rp, i - 1, _wch) ||
              isSameChar(_rp, i + 1, _wch)) {
            _rp = _rp.replaceRange(i, i + 1, s_wch);
            has_url_0x01 = true;
          } else {
            if (n_wch % 2 == 0 && !any_break_whitespace(_rp, i, _wch)) {
              _rp = _rp.replaceRange(i, i + 1, s_wch);
              has_url_0x01 = true;
            } else {
              n_wch++;
            }
          }
        } else if (tx == _pch) {
          if (isAlfaNumeric(_rp, i - 1) && isAlfaNumeric(_rp, i + 1)) {
            _rp = _rp.replaceRange(i, i + 1, s_pch);
            has_url_0x01 = true;
          } else if (isSameChar(_rp, i - 1, _pch) &&
              isSameChar(_rp, i + 1, _pch)) {
            _rp = _rp.replaceRange(i, i + 1, s_pch);
            has_url_0x01 = true;
          } else {
            if (n_pch % 2 == 0 && !any_break_whitespace(_rp, i, _pch)) {
              _rp = _rp.replaceRange(i, i + 1, s_pch);
              has_url_0x01 = true;
            } else {
              n_pch++;
            }
          }
        } else if (tx == '\n') {
          n_uch = 0;
          n_sch = 0;
          n_wch = 0;
          n_pch = 0;
        }
      }

      if (has_url_0x01) {
        p_text = _rp.toString();
      }

      bool boolen;
      // bold text
      if (p_text.contains("*")) {
        int star = 0;
        boolen = true;
        for (int i = 0; i < p_text.length; i++) {
          if (p_text.substring(i, i + 1) == "*") {
            star++;
          }
        }
        if (star >= 2) {
          if (star % 2 != 0) {
            star--;
          }
          int idx = -1;
          for (int i = 0; i <= star; i++) {
            int ix = p_text.indexOf("*", idx + 1);
            if (ix != -1) {
              if (!boolen) {
                bold_map[startIndex(p_text, idx)] = endIndex(p_text, ix);
              }
              idx = ix;
            }
            boolen = !boolen;
          }
        }
      }

      // italic text
      if (p_text.contains("_")) {
        int underscore = 0;
        boolen = true;
        for (int i = 0; i < p_text.length; i++) {
          if (p_text.substring(i, i + 1) == "_") {
            underscore++;
          }
        }
        if (underscore >= 2) {
          if (underscore % 2 != 0) {
            underscore--;
          }
          int idx = -1;
          for (int i = 0; i < underscore; i++) {
            int ix = p_text.indexOf("_", idx + 1);
            if (ix != -1) {
              if (!boolen) {
                italic_map[startIndex(p_text, idx)] = endIndex(p_text, ix);
              }
              idx = ix;
            }
            boolen = !boolen;
          }
        }
      }

      //underline text
      if (p_text.contains("^")) {
        int petik = 0;
        boolen = true;
        for (int i = 0; i < p_text.length; i++) {
          if (p_text.substring(i, i + 1) == "^") {
            petik++;
          }
        }
        if (petik >= 2) {
          if (petik % 2 != 0) {
            petik--;
          }
          int idx = -1;
          for (int i = 0; i < petik; i++) {
            int ix = p_text.indexOf("^", idx + 1);
            if (ix != -1) {
              if (!boolen) {
                underline_map[startIndex(p_text, idx)] = endIndex(p_text, ix);
              }
              idx = ix;
            }
            boolen = !boolen;
          }
        }
      }

      // striketrough text
      if (p_text.contains("~")) {
        int cacing = 0;
        boolen = true;
        for (int i = 0; i < p_text.length; i++) {
          if (p_text.substring(i, i + 1) == "~") {
            cacing++;
          }
        }
        if (cacing >= 2) {
          if (cacing % 2 != 0) {
            cacing--;
          }
          int idx = -1;
          for (int i = 0; i < cacing; i++) {
            int ix = p_text.indexOf("~", idx + 1);
            if (ix != -1) {
              if (!boolen) {
                strike_map[startIndex(p_text, idx)] = endIndex(p_text, ix);
              }
              idx = ix;
            }
            boolen = !boolen;
          }
        }
      }
    }

    /**
     * HIGHLIGHT
     **/
    Map<int, int> highlight_map = link_map;
//    if (hilghLihtText != null && hilghLihtText.trim().isNotEmpty) {
//      try {
//        String buffer =
//            p_text.toLowerCase().replaceAll(new String.fromCharCode(160), " ");
//        int m_sc = 0, m_ec = 0;
//        for (int i = 0; i < buffer.length; i++) {
//          m_sc = buffer.indexOf(hilghLihtText, m_sc);
//          if (m_sc == -1) {
//            break;
//          }
//          m_ec = m_sc + hilghLihtText.length;
//          highlight_map[m_sc] = m_ec;
//          m_sc = m_ec + 1;
//        }
//      } catch (e) {}
//    }

    List<List<int>> rtf_index = [];
    var merge = (a, b) {
      for (List<int> ix in rtf_index) {
        if (ix[0] == a && b == ix[1]) {
          return;
        }
        if (ix[0] == a && b < ix[1]) {
          rtf_index.add([a, b]);
          ix[0] = b;
          return;
        }
        if (ix[0] < a && b == ix[1]) {
          rtf_index.add([a, b]);
          ix[1] = a;
          return;
          ;
        }
        if (ix[0] < a && b < ix[1]) {
          rtf_index.add([ix[0], a]);
          rtf_index.add([b, ix[1]]);
          ix[0] = a;
          ix[1] = b;
          return;
          ;
        }
      }
      rtf_index.add([a, b]);
    };

    bold_map.forEach(merge);
    italic_map.forEach(merge);
    underline_map.forEach(merge);
    strike_map.forEach(merge);
    mention_map.forEach(merge);
    highlight_map.forEach(merge);
    link_map.forEach(merge);

    rtf_index.sort((x, y) {
      return x[0] - y[0];
    });

    List<List<int>> all_index = [];
    int xsc = 0, xec = p_text.length;
    int endidxtemp = 0;
    for (List<int> xy in rtf_index) {
      if (xsc > xy[1]) {
        all_index.removeAt(all_index.length - 1);
        all_index.add([endidxtemp, xy[0]]);
      }
      if (xsc == xy[0] || xsc > xy[1]) {
        all_index.add(xy);
        xsc = xy[1];
      } else {
        if (xsc < xy[0]) {
          all_index.add([xsc, xy[0]]);
          xsc = xy[0];
        }
        all_index.add([xsc, xy[1]]);
        endidxtemp = xsc;
        xsc = xy[1];
      }
    }

    if (xsc < xec) {
      all_index.add([xsc, xec]);
    }

    List<bool> last_style_b_i_u_s = [false, false, false, false, false, false];
    int sc = 0, ec = 0, nline = 0, nchar = 0;
    for (List<int> ix in all_index) {
      sc = ix[0];
      ec = ix[1];

      if (ec > p_text.length) {
        ec = p_text.length;
      }

      int sc_word = sc;
      int ec_word = ec - 1;

      bool bold = false;
      bold_map.forEach((a, b) {
        if (a <= sc_word && ec_word <= b) {
          bold = true;
        }
      });

      bool italic = false;
      italic_map.forEach((a, b) {
        if (a <= sc_word && ec_word <= b) {
          italic = true;
        }
      });

      bool underline = false;
      underline_map.forEach((a, b) {
        if (a <= sc_word && ec_word <= b) {
          underline = true;
        }
      });

      bool strike = false;
      strike_map.forEach((a, b) {
        if (a <= sc_word && ec_word <= b) {
          strike = true;
        }
      });

      bool highlight = false;
      highlight_map.forEach((a, b) {
        if (a <= sc_word && ec_word <= b) {
          highlight = true;
        }
      });

      bool mention_color = false;
      mention_map.forEach((a, b) {
        if (a <= sc_word && ec_word <= b) {
          mention_color = true;
        }
      });

      bool link_color = false;
      link_map.forEach((a, b) {
        if (a <= sc_word && ec_word <= b) {
          link_color = true;
        }
      });

      String word = p_text.substring(sc, ec);
      if (isPreview) {
        word = word
            .replaceAll("_", "")
            .replaceAll("*", "")
            .replaceAll("~", "")
            .replaceAll("^", "");
      }

      if (has_url_0x01) {
        word = word
            .replaceAll(s_uch, "_")
            .replaceAll(s_sch, "*")
            .replaceAll(s_wch, "~")
            .replaceAll(s_pch, "^");
      }

      //link
//      underline = bLink ? true : underline;
//      highlight = bLink ? true : highlight;

      Color? fontColor = null;
      if (highlight) {
        fontColor = bLink ? linkColor : Colors.black;
      } else if (mention_color) {
        fontColor = mentionColor;
      } else if (link_color) {
        fontColor = linkColor;
      } else {
        fontColor = textColor;
      }

      Paint? paint = null;
      if (highlight && bLink) {
        paint = new Paint()
          ..color = Colors.transparent
          ..strokeCap = StrokeCap.square
          ..style = PaintingStyle.fill
          ..strokeWidth = 1.0;
      } else if (highlight) {
        paint = new Paint()
          ..color = Colors.transparent
          ..strokeCap = StrokeCap.square
          ..style = PaintingStyle.fill
          ..strokeWidth = 1.0;
      } else {
        paint = null;
      }

      if (bold || italic || underline || strike) {
        if ((underline || strike) &&
            last_style_b_i_u_s[0] == bold &&
            last_style_b_i_u_s[1] == italic &&
            last_style_b_i_u_s[2] == underline &&
            last_style_b_i_u_s[3] == strike &&
            last_style_b_i_u_s[4] == mention_color &&
            last_style_b_i_u_s[5] == highlight) {
          String merge_word = spans.removeAt(spans.length - 1).text as String;
          merge_word += word;

          word = merge_word;
        }

        if (isSearch) {
          TextStyle posRes = new TextStyle(
                  fontWeight: bold ? FontWeight.bold : FontWeight.normal,
                  fontStyle: italic ? FontStyle.italic : FontStyle.normal,
                  background: null,
                  backgroundColor: Colors.yellow,
                  decoration: underline && strike
                      ? TextDecoration.combine([
                          TextDecoration.underline,
                          TextDecoration.lineThrough
                        ])
                      : underline
                          ? TextDecoration.underline
                          : strike
                              ? TextDecoration.lineThrough
                              : TextDecoration.none,
                  fontSize: fontSizeText,
                  color: fontColor),
              negRes = new TextStyle(
                  fontWeight: bold ? FontWeight.bold : FontWeight.normal,
                  fontStyle: italic ? FontStyle.italic : FontStyle.normal,
                  background: null,
                  backgroundColor: Colors.transparent,
                  decoration: underline && strike
                      ? TextDecoration.combine([
                          TextDecoration.underline,
                          TextDecoration.lineThrough
                        ])
                      : underline
                          ? TextDecoration.underline
                          : strike
                              ? TextDecoration.lineThrough
                              : TextDecoration.none,
                  fontSize: fontSizeText,
                  color: fontColor);
          TextSpan searchMatch(String match) {
            if (textSearch == null || textSearch == "")
              return TextSpan(text: match, style: negRes);
            var refinedMatch = match.toLowerCase();
            var refinedSearch = textSearch.toLowerCase();
            if (refinedMatch.contains(refinedSearch)) {
              if (refinedMatch.substring(0, refinedSearch.length) ==
                  refinedSearch) {
                return TextSpan(
                  style: posRes,
                  text: match.substring(0, refinedSearch.length),
                  children: [
                    searchMatch(
                      match.substring(
                        refinedSearch.length,
                      ),
                    ),
                  ],
                );
              } else if (refinedMatch.length == refinedSearch.length) {
                return TextSpan(text: match, style: posRes);
              } else {
                return TextSpan(
                  style: negRes,
                  text: match.substring(
                    0,
                    refinedMatch.indexOf(refinedSearch),
                  ),
                  children: [
                    searchMatch(
                      match.substring(
                        refinedMatch.indexOf(refinedSearch),
                      ),
                    ),
                  ],
                );
              }
            } else if (!refinedMatch.contains(refinedSearch)) {
              return TextSpan(text: match, style: negRes);
            }
            return TextSpan(
              text: match.substring(0, refinedMatch.indexOf(refinedSearch)),
              style: negRes,
              children: [
                searchMatch(
                    match.substring(refinedMatch.indexOf(refinedSearch)))
              ],
            );
          }

          spans.add(searchMatch(word));
        } else {
          spans.add(new TextSpan(
              text: word,
              style: new TextStyle(
                  fontWeight: bold ? FontWeight.bold : FontWeight.normal,
                  fontStyle: italic ? FontStyle.italic : FontStyle.normal,
                  background: paint,
                  decoration: underline && strike
                      ? TextDecoration.combine([
                          TextDecoration.underline,
                          TextDecoration.lineThrough
                        ])
                      : underline
                          ? TextDecoration.underline
                          : strike
                              ? TextDecoration.lineThrough
                              : TextDecoration.none,
                  fontSize: fontSizeText,
                  color: fontColor)));
        }
      } else {
        if (bLink) {
          if (isSearch) {
            TextStyle posRes = TextStyle(
                    background: null,
                    backgroundColor: Colors.yellow,
                    decoration: highlight && bLink
                        ? TextDecoration.underline
                        : TextDecoration.none,
                    fontSize: fontSizeText,
                    color: fontColor),
                negRes = TextStyle(
                    background: null,
                    backgroundColor: Colors.transparent,
                    decoration: highlight && bLink
                        ? TextDecoration.underline
                        : TextDecoration.none,
                    fontSize: fontSizeText,
                    color: fontColor);
            TextSpan searchMatch(String match) {
              if (textSearch == null || textSearch == "")
                return TextSpan(text: match, style: negRes);
              var refinedMatch = match.toLowerCase();
              var refinedSearch = textSearch.toLowerCase();
              if (refinedMatch.contains(refinedSearch)) {
                if (refinedMatch.substring(0, refinedSearch.length) ==
                    refinedSearch) {
                  return TextSpan(
                    style: posRes,
                    text: match.substring(0, refinedSearch.length),
                    children: [
                      searchMatch(
                        match.substring(
                          refinedSearch.length,
                        ),
                      ),
                    ],
                  );
                } else if (refinedMatch.length == refinedSearch.length) {
                  return TextSpan(text: match, style: posRes);
                } else {
                  return TextSpan(
                    style: negRes,
                    text: match.substring(
                      0,
                      refinedMatch.indexOf(refinedSearch),
                    ),
                    children: [
                      searchMatch(
                        match.substring(
                          refinedMatch.indexOf(refinedSearch),
                        ),
                      ),
                    ],
                  );
                }
              } else if (!refinedMatch.contains(refinedSearch)) {
                return TextSpan(text: match, style: negRes);
              }
              return TextSpan(
                text: match.substring(0, refinedMatch.indexOf(refinedSearch)),
                style: negRes,
                children: [
                  searchMatch(
                      match.substring(refinedMatch.indexOf(refinedSearch)))
                ],
              );
            }

            spans.add(searchMatch(word));
          } else {
            spans.add(new TextSpan(
                text: word,
                style: TextStyle(
                    background: paint,
                    decoration: highlight && bLink
                        ? TextDecoration.underline
                        : TextDecoration.none,
                    fontSize: fontSizeText,
                    color: fontColor),
                recognizer: new TapGestureRecognizer()
                  ..onTapUp = (tap) {
                    if (_timer != null && _timer.isActive) {
                      _timer.cancel();
                    }
                  }
                  ..onTapDown = (tap) {
//                  _timer = Timer(Duration(seconds: 1), () {
//                    Clipboard.setData(new ClipboardData(text: word));
//                    Fluttertoast.showToast(
//                        msg: "Copied to clipboard",
//                        toastLength: Toast.LENGTH_SHORT,
//                        gravity: ToastGravity.CENTER);
//                  });
                  }
                  ..onTapCancel = () {
                    if (_timer != null && _timer.isActive) {
                      _timer.cancel();
                    }
                  }
                  ..onTap = () {
                    if (highlight && bLink && !isPreviewMessage) {
                      if (word.toLowerCase().contains("www.")) {
                        launch(word.substring(0, 3).toLowerCase() +
                            word.substring(3, word.length));
                      } else if (word.contains("://")) {
                        List<String> url = word.split("://");
                        launch(url[0].toLowerCase() + "://" + url[1]);
                      } else {
                        launch(word);
                      }
                    }
                  }));
          }
        } else {
          if (isSearch) {
            TextStyle posRes = TextStyle(
                    background: null,
                    backgroundColor: Colors.yellow,
                    decoration: TextDecoration.none,
                    fontSize: fontSizeText,
                    color: fontColor),
                negRes = TextStyle(
                    background: null,
                    backgroundColor: Colors.transparent,
                    decoration: TextDecoration.none,
                    fontSize: fontSizeText,
                    color: fontColor);
            TextSpan searchMatch(String match) {
              if (textSearch == null || textSearch == "")
                return TextSpan(text: match, style: negRes);
              var refinedMatch = match.toLowerCase();
              var refinedSearch = textSearch.toLowerCase();
              if (refinedMatch.contains(refinedSearch)) {
                if (refinedMatch.substring(0, refinedSearch.length) ==
                    refinedSearch) {
                  return TextSpan(
                    style: posRes,
                    text: match.substring(0, refinedSearch.length),
                    children: [
                      searchMatch(
                        match.substring(
                          refinedSearch.length,
                        ),
                      ),
                    ],
                  );
                } else if (refinedMatch.length == refinedSearch.length) {
                  return TextSpan(text: match, style: posRes);
                } else {
                  return TextSpan(
                    style: negRes,
                    text: match.substring(
                      0,
                      refinedMatch.indexOf(refinedSearch),
                    ),
                    children: [
                      searchMatch(
                        match.substring(
                          refinedMatch.indexOf(refinedSearch),
                        ),
                      ),
                    ],
                  );
                }
              } else if (!refinedMatch.contains(refinedSearch)) {
                return TextSpan(text: match, style: negRes);
              }
              return TextSpan(
                text: match.substring(0, refinedMatch.indexOf(refinedSearch)),
                style: negRes,
                children: [
                  searchMatch(
                      match.substring(refinedMatch.indexOf(refinedSearch)))
                ],
              );
            }

            spans.add(searchMatch(word));
          } else {
            spans.add(new TextSpan(
                text: word,
                style: TextStyle(
                    background: paint,
                    decoration: TextDecoration.none,
                    fontSize: fontSizeText,
                    color: fontColor)));
          }
        }
      }

      last_style_b_i_u_s = [
        bold,
        italic,
        underline,
        strike,
        mention_color,
        highlight
      ];
    }
    if (fromBubble != null) {
      spans.add(TextSpan(children: [WidgetSpan(child: fromBubble)]));
    }
    return spans;
  }

  static bool isAlfaNumeric(String sb, int index) {
    try {
      RegExp regExp = new RegExp(
        "[a-zA-Z0-9]",
        caseSensitive: false,
        multiLine: false,
      );
      return regExp.hasMatch(sb.substring(index, index + 1));
    } catch (e) {}
    return false;
  }

  static bool isNumeric(String sb) {
    try {
      RegExp regExp = new RegExp(
        "[0-9]",
        caseSensitive: false,
        multiLine: false,
      );
      return regExp.hasMatch(sb);
    } catch (e) {}
    return false;
  }

  static bool isSameChar(String sb, int index, String p_char) {
    try {
      return sb.substring(index, index + 1) == p_char;
    } catch (e) {}
    return false;
  }

  static bool any_break_whitespace(String _rp, int _i, String _chr) {
    bool any = false;
    for (int i = _i + 1; i < _rp.length; i++) {
      String tx = _rp.substring(i, i + 1);
      if (tx == _chr) {
        any = true;
        break;
      } else if (tx == "\n") {
        break;
      }
    }
    return any;
  }

  static bool isAlfaNumericChar(String c) {
    try {
      RegExp regExp = new RegExp(
        "[a-zA-Z0-9]",
        caseSensitive: false,
        multiLine: false,
      );
      return regExp.hasMatch(c);
    } catch (e) {}
    return false;
  }

  static int endIndexOfWord(String p_string, int index) {
    while ((index + 1) < p_string.length &&
        isAlfaNumericChar(p_string.substring(index + 1, index + 2))) {
      index++;
    }
    return index;
  }

  static int startIndex(String p_string, int index) {
    while (index > 0 && isKey(p_string.substring(index - 1, index))) {
      index--;
    }
    return index;
  }

  static int endIndex(String p_string, int index) {
    while ((index + 1) < p_string.length &&
        isKey(p_string.substring(index + 1, index + 2))) {
      index++;
    }
    return index;
  }

  static bool isSpaceOrKey(String c) {
    return c == " " ||
        c == "\n" ||
        c == "*" ||
        c == "_" ||
        c == "^" ||
        c == "~";
  }

  static bool isKey(String c) {
    return c == "*" || c == "_" || c == "^" || c == "~";
  }

  static int endIndexTrim(String p_string, int index) {
    while (index > 0 && isSpaceOrKey(p_string.substring(index - 1, index))) {
      index--;
    }
    return index;
  }

  static int startIndexTrim(String p_string, int index) {
    while ((index + 1) < p_string.length &&
        isSpaceOrKey(p_string.substring(index + 1, index + 2))) {
      index++;
    }
    return index;
  }
}
