import 'package:flutter/material.dart';
import 'package:flutter/cupertino.dart';
import 'package:palio_lite/app_color.dart';

class TapToBottom extends StatelessWidget {
  final bool show;
  final VoidCallback tap;
  final int countNewMessages;

  TapToBottom(this.show, this.tap, this.countNewMessages);

  @override
  Widget build(BuildContext context) {
    return show
        ? Align(
            alignment: Alignment.bottomRight,
            child: GestureDetector(
              onTap: () {
                tap();
              },
              child: Stack(
                children: [
                  Container(
                    alignment: Alignment.bottomRight,
                    height: 60,
                    child: Container(
                      margin: EdgeInsets.only(right: 8.0),
                      decoration: BoxDecoration(
                          shape: BoxShape.circle,
                          border:
                              Border.all(width: 3.0, color: AppColor.primaryColor)),
                      child: Icon(
                        Icons.keyboard_arrow_down,
                        color: AppColor.primaryColor,
                        size: 30,
                      ),
                    ),
                  ),
                  countNewMessages == 0
                      ? Positioned(
                          right: 30,
                          bottom: 15.0,
                          child: Container(),
                        )
                      : Positioned(
                          right: 30,
                          bottom: 15.0,
                          child: Container(
                            padding: EdgeInsets.all(5.0),
                            decoration: BoxDecoration(
                                color: Colors.red, shape: BoxShape.circle),
                            child: Text("$countNewMessages",
                                style: TextStyle(color: Colors.white)),
                          ),
                        )
                ],
              ),
            ),
          )
        : Container();
  }
}
