import 'package:flutter/material.dart';
import 'package:flutter/cupertino.dart';
import 'package:fluttertoast/fluttertoast.dart';

class TimeForm extends StatefulWidget {
  final Function(String) time;
  final int timeValue;
  final int? dateEnd;
  final int? timeStart;

  TimeForm(
      {required this.time,
      required this.timeValue,
      this.dateEnd,
      this.timeStart});

  @override
  _TimeFormState createState() => _TimeFormState();
}

class _TimeFormState extends State<TimeForm> {
  String time = TimeOfDay.now().toString().substring(10, 15);
  Color color = Colors.white;
  int timeVal = 0;

  @override
  void initState() {
    super.initState();
    timeVal = widget.timeValue;
    if (timeVal > 0) {
      time =
          TimeOfDay.fromDateTime(DateTime.fromMillisecondsSinceEpoch(timeVal))
              .toString()
              .substring(10, 15);
    }
  }

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      onTap: () {
        showTimePicker(
                context: context,
                initialTime: timeVal != 0
                    ? TimeOfDay.fromDateTime(
                        DateTime.fromMillisecondsSinceEpoch(timeVal))
                    : TimeOfDay.now())
            .then((value) {
          if (value != null) {
            if (DateTime.now().millisecondsSinceEpoch <=
                DateTime(DateTime.now().year, DateTime.now().month,
                        DateTime.now().day, value.hour, value.minute)
                    .millisecondsSinceEpoch) {
              if (widget.timeStart != null) {
                int year =
                    DateTime.fromMillisecondsSinceEpoch(widget.dateEnd!).year;
                int month =
                    DateTime.fromMillisecondsSinceEpoch(widget.dateEnd!).month;
                int day =
                    DateTime.fromMillisecondsSinceEpoch(widget.dateEnd!).day;
                int hours = value.hour;
                int minute = value.minute;
                int epochChoosen = DateTime(year, month, day, hours, minute)
                    .millisecondsSinceEpoch;
                if (epochChoosen >= widget.timeStart!) {
                  widget.time(value.toString().substring(10, 15));
                  setState(() {
                    time = value.toString().substring(10, 15);
                  });
                } else {
                  widget.time(TimeOfDay.fromDateTime(
                          DateTime.fromMillisecondsSinceEpoch(
                              widget.timeStart!))
                      .toString()
                      .substring(10, 15));
                  setState(() {
                    time = TimeOfDay.fromDateTime(
                            DateTime.fromMillisecondsSinceEpoch(
                                widget.timeStart!))
                        .toString()
                        .substring(10, 15);
                  });
                }
              } else {
                widget.time(value.toString().substring(10, 15));
                setState(() {
                  time = value.toString().substring(10, 15);
                });
              }
            } else {
              Fluttertoast.showToast(msg: "The time you selected has expired");
            }
          }
        });
      },
      onTapDown: (tap) {
        setState(() {
          color = Colors.grey;
        });
      },
      onTapUp: (tap) {
        setState(() {
          color = Colors.white;
        });
      },
      onTapCancel: () {
        setState(() {
          color = Colors.white;
        });
      },
      child: Container(
        padding: EdgeInsets.only(left: 10.0, right: 10.0),
        height: 40,
        decoration: BoxDecoration(
            color: color,
            border: Border.all(color: Colors.black),
            borderRadius: BorderRadius.circular(3.0)),
        child: Row(
          mainAxisAlignment: MainAxisAlignment.start,
          children: <Widget>[
            Icon(
              Icons.access_time,
              color: Colors.grey[600],
              size: 14,
            ),
            SizedBox(width: 10.0),
            Text(time)
          ],
        ),
      ),
    );
  }
}
