import 'dart:convert';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:intl/intl.dart';
import 'package:palio_lite/api.dart';
import 'package:palio_lite/app_color.dart';
import 'package:palio_lite/db_helper.dart';
import 'package:palio_lite/ip_list.dart';
import 'package:shared_preferences/shared_preferences.dart';

class VerticalPersonalTimeLine extends StatefulWidget {
  final data;
  final f_pin;
  final List<Map<dynamic, dynamic>> timeline;
  final List<String> post_id;
  final String post_id_chosen;
  final String openFrom;

  VerticalPersonalTimeLine(
      {this.f_pin = "",
      this.data,
      required this.timeline,
      required this.post_id,
      this.post_id_chosen = "",
      required this.openFrom});

  @override
  State<StatefulWidget> createState() {
    return _VerticalPersonalTimeLine();
  }
}

class _VerticalPersonalTimeLine extends State<VerticalPersonalTimeLine> {
  // List<TimeLine> timelineList = List();

  Future<dynamic> getData() async {
    List<Map<dynamic, dynamic>> timeline = [];
    if (widget.post_id.isNotEmpty) {
      String query = "";
      for (int i = 0; i < widget.post_id.length; i++) {
        if (i == 0) {
          query = query + "'" + widget.post_id[i] + "'";
        } else {
          query = query + ",'" + widget.post_id[i] + "'";
        }
      }
      List<dynamic> dataTimelineDB = await DBHelper()
          .queryCustom("SELECT * FROM POST where post_id in (" + query + ")");
      // timelineList.clear();
      // if (dataTimelineDB.length > 0){
      //   for (var x = 0;x<dataTimelineDB.length;x++) {
      //     // TimeLine timeLine = TimeLine.fromMap(dataTimelineDB[x]);
      //     // timelineList.add(timeLine);
      //   }
      // }
      // if (timelineList != null) {
      //   // jsonTimeline.sort((a, b) => a["A11"].compareTo(b["A11"]));
      //   for (var i = 0; i < timelineList.length; i++) {
      //     DateTime date = new DateTime.fromMillisecondsSinceEpoch(
      //         int.parse(timelineList[i].created_date));
      //     var format = new DateFormat('dd MMMM yyyy');
      //     String time = format.format(date);
      //     String httpImage = IPList.imagePost;
      //     String httpVideo = IPList.videoImage;
      //     int mediaType = timelineList[i].file_type;
      //     List<String> listFile = List();
      //     List<String> listImage = List();
      //     List<String> listVideo = List();
      //     if (timelineList[i].file_id.contains("|")) {
      //       listFile = timelineList[i].file_id.split("|");
      //     } else {
      //       listFile.add(timelineList[i].file_id);
      //     }
      //     for (var j = 0; j < listFile.length; j++) {
      //       if (mediaType == 2) {
      //         listVideo.add(httpVideo + listFile[j]);
      //       } else {
      //         listImage.add(httpImage + listFile[j]);
      //       }
      //     }
      //     timeline.add({
      //       "timeline_id": "${timelineList[i].post_id}",
      //       "username": timelineList[i].author_name,
      //       "imagePerson": timelineList[i].author_thumbnail,
      //       "user_id": timelineList[i].author_f_pin,
      //       "date": time,
      //       "image": listImage,
      //       "last_update": timelineList[i].last_update,
      //       "thumbnail": !timelineList[i].thumb_id.contains("|")
      //           ? httpImage + timelineList[i].thumb_id
      //           : timelineList[i].thumb_id.isNotEmpty? httpImage + timelineList[i].thumb_id.split("|")[0] : "",
      //       "media": listVideo,
      //       "title": timelineList[i].title,
      //       "content": timelineList[i].description,
      //       "like_count": timelineList[i].total_like,
      //       "comment_count": timelineList[i].total_comment,
      //       "follower_count": timelineList[i].total_followers,
      //       "type_account": 0,
      //       "official_flag": 2,
      //       "media_type": timelineList[i].file_type,
      //       "liked": timelineList[i].like_flag,
      //       "following": timelineList[i].participate_size,
      //       "isOfficial": timelineList[i].official_account,
      //       "dislike": timelineList[i].total_dislike,
      //       "link": timelineList[i].link,
      //       "is_me": timelineList[i].author_f_pin == widget.f_pin ? true : false,
      //       "document":listFile,
      //       "privacy":timelineList[i].privacy
      //     });
      //   }
      // }
    } else {
      List<dynamic> jsonArray = [];
      String data = "";
      await API.retrievePostProfile(widget.f_pin, "0").then((value) {
        if (value != null) {
          data = value;
          jsonArray = jsonDecode(data);
        }
      });
      if (jsonArray.length > 0) {
        for (int i = 0; i < jsonArray.length; i++) {
          var json = jsonArray[i];
          var format = DateFormat('dd MMMM yyyy');
          DateTime date =
              new DateTime.fromMillisecondsSinceEpoch(int.parse(json["A29"]));
          String time = format.format(date);
          String httpImage = IPList.imagePost;
          String httpVideo = IPList.videoImage;
          var mediaType = json["BN2"];
          List<String> listFile = [];
          List<String> listImage = [];
          List<String> listVideo = [];
          if (json["BN"].contains("|")) {
            listFile = json["BN"].split("|");
          } else {
            listFile.add(json["BN"]);
          }
          for (var j = 0; j < listFile.length; j++) {
            if (mediaType == "2") {
              listVideo.add(httpVideo + listFile[j]);
            } else {
              listImage.add(httpImage + listFile[j]);
            }
          }
          List<dynamic> follow = await DBHelper().queryCustom(
              "select f_pin from FOLLOW where f_pin = '${json["A00"]}'");
          var pref = await SharedPreferences.getInstance();
          var me = pref.getString("hasLogin");
          if (widget.post_id_chosen != null &&
              widget.post_id_chosen.isNotEmpty) {
            if ("${json["PO1"]}" == widget.post_id_chosen) {
              timeline.insert(0, {
                "timeline_id": "${json["PO1"]}",
                "username": json["A92"],
                "imagePerson": "",
                "user_id": json["A00"],
                "date": time,
                "image": listImage,
                "last_update": json["A11"],
                "thumbnail": !json["BN3"].contains("|")
                    ? httpImage + json["BN3"]
                    : json[i]["BN3"].isNotEmpty()
                        ? httpImage + json[i]["BN3"].split("|")[0]
                        : "",
                "media": listVideo,
                "title": json["A37"],
                "content": json["A40"],
                "like_count": int.parse(json["like"]),
                "comment_count": int.parse(json["BL"]),
                "follower_count": int.parse(json['A77']),
                "type_account": 0,
                "official_flag": 2,
                "media_type": int.parse(mediaType),
                "liked": int.parse(json['FL1']),
                "following": follow.length,
                "isOfficial": json["oacc"],
                "dislike": int.parse(json["dislike"]),
                "link": json["Bk"],
                "is_me": me == json["A00"],
                "document": listFile,
                "privacy": int.parse(json["A27"])
              });
            } else {
              timeline.add({
                "timeline_id": "${json["PO1"]}",
                "username": json["A92"],
                "imagePerson": "",
                "user_id": json["A00"],
                "date": time,
                "image": listImage,
                "last_update": json["A11"],
                "thumbnail": !json["BN3"].contains("|")
                    ? httpImage + json["BN3"]
                    : json[i]["BN3"].isNotEmpty()
                        ? httpImage + json[i]["BN3"].split("|")[0]
                        : "",
                "media": listVideo,
                "title": json["A37"],
                "content": json["A40"],
                "like_count": int.parse(json["like"]),
                "comment_count": int.parse(json["BL"]),
                "follower_count": int.parse(json['A77']),
                "type_account": 0,
                "official_flag": 2,
                "media_type": int.parse(mediaType),
                "liked": int.parse(json['FL1']),
                "following": follow.length,
                "isOfficial": json["oacc"],
                "dislike": int.parse(json["dislike"]),
                "link": json["Bk"],
                "is_me": me == json["A00"],
                "document": listFile,
                "privacy": int.parse(json["A27"])
              });
            }
          } else {
            timeline.add({
              "timeline_id": "${json["PO1"]}",
              "username": json["A92"],
              "imagePerson": "",
              "user_id": json["A00"],
              "date": time,
              "image": listImage,
              "last_update": json["A11"],
              "thumbnail": !json["BN3"].contains("|")
                  ? httpImage + json["BN3"]
                  : json[i]["BN3"].isNotEmpty()
                      ? httpImage + json[i]["BN3"].split("|")[0]
                      : "",
              "media": listVideo,
              "title": json["A37"],
              "content": json["A40"],
              "like_count": int.parse(json["like"]),
              "comment_count": int.parse(json["BL"]),
              "follower_count": int.parse(json['A77']),
              "type_account": 0,
              "official_flag": 2,
              "media_type": int.parse(mediaType),
              "liked": int.parse(json['FL1']),
              "following": follow.length,
              "isOfficial": json["oacc"],
              "dislike": int.parse(json["dislike"]),
              "link": json["Bk"],
              "is_me": me == json["A00"],
              "document": listFile,
              "privacy": int.parse(json["A27"])
            });
          }
        }
      }
    }

    print("timeline :" + timeline.toString() + " fpin " + widget.f_pin);
    return timeline;
  }

  Future<dynamic> getFromData(List<Map<dynamic, dynamic>> value) async {
    return value;
  }

  void onUpdatePost() {
    API.onPostUpdate = (String status, String message) {
      if (status == "Delete") {
        setState(() {
          getData();
        });
      }
    };
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        backgroundColor: AppColor.primaryColor,
        title: Text("${widget.data}"),
        centerTitle: false,
      ),
      body: SingleChildScrollView(
        child:
            // widget.timeline != null ? VerticalTimeLine(
            //   listData: widget.timeline,
            //   scrollController: ScrollController(),
            // ) :
            FutureBuilder(
                future: getData(),
                builder: (context, snapshot) {
                  if (snapshot.hasData) {
                    if (widget.openFrom == "PERSONAL") {
                      return Container();
                    } else {
                      return Container();
                    }
                  }
                  return Container();
                }),
      ),
    );
  }
}
