import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:palio_lite/chat/widgets/video_player.dart' as video;
import 'package:video_player/video_player.dart';

class VideoFullScreen extends StatefulWidget {
  final VideoPlayerController controller;

  const VideoFullScreen({Key? key, required this.controller}) : super(key: key);

  @override
  State<StatefulWidget> createState() => _VideoFullScreenState();
}

class _VideoFullScreenState extends State<VideoFullScreen> {
  bool fullScreen = true;

  @override
  Widget build(BuildContext context) {
    return SafeArea(
        child: Scaffold(
            body: RotatedBox(
      quarterTurns: 3,
      child: Container(
        child: Stack(
          alignment: Alignment.bottomCenter,
          children: <Widget>[
            VideoPlayer(widget.controller),
            ClosedCaption(text: widget.controller.value.caption.text),
            video.PlayPauseOverlay(controller: widget.controller),
            _Minimize(controller: widget.controller),
            VideoProgressIndicator(widget.controller, allowScrubbing: true),
          ],
        ),
      ),
    )));
  }
}

class _Minimize extends StatelessWidget {
  final VideoPlayerController controller;

  _Minimize({Key? key, required this.controller}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Container(
        alignment: Alignment.bottomRight,
        margin: EdgeInsets.only(bottom: 10, right: 10),
        child: IconButton(
            onPressed: () {
              Navigator.of(context).pop();
            },
            icon: Icon(
              CupertinoIcons.fullscreen_exit,
              color: Colors.white,
            )));
  }
}
