import 'dart:convert';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:fluttertoast/fluttertoast.dart';
import 'package:page_transition/page_transition.dart';
import 'package:palio_lite/chat/chat_screen.dart';
import 'package:palio_lite/chat/widgets/add_member.dart';
import 'package:palio_lite/Widget/button_add.dart';
import 'package:palio_lite/api.dart';
import 'package:palio_lite/app_color.dart';
import 'package:palio_lite/chat/widgets/calendar_form.dart';
import 'package:palio_lite/chat/widgets/notifications.dart';
import 'package:palio_lite/chat/widgets/time_form.dart';
import 'package:palio_lite/conference/inisiator_ls_screen.dart';
import 'package:palio_lite/db_helper.dart';
import 'package:shared_preferences/shared_preferences.dart';

class AddLiveStreaming extends StatefulWidget {
  @override
  _AddLiveStreamingState createState() => _AddLiveStreamingState();
}

class _AddLiveStreamingState extends State<AddLiveStreaming> {
  String f_pin = "";
  String name = "";
  String device_id = "";
  int time = 0;
  int timeVal = DateTime.now().millisecondsSinceEpoch;
  int timeValDate = DateTime.now().millisecondsSinceEpoch;
  String type = "";
  DateTime timeDate = DateTime(DateTime.now().year);
  String language = "en_US";
  int tanggal = DateTime.now().day;
  int bulan = DateTime.now().month;
  int tahun = DateTime.now().year;
  int jam = DateTime.now().hour;
  int menit = DateTime.now().minute;
  static const menuIndo = <String>["Undangan", "Teman", "Publik"];
  static const menuEng = <String>["Invitation", "Friends", "Public"];
  TextEditingController judul = TextEditingController(),
      desc = TextEditingController();
  List<String> nameChosen = [];
  List<String> fpinChosen = [];
  List<String> dataChosen = [];
  List<DropdownMenuItem<String>> _dropDownMMenuItems = menuEng
      .map((String value) =>
          DropdownMenuItem<String>(value: value, child: Text(value)))
      .toList();
  String _btnSelected = "Invitation";

  Future<void> getData() async {
    final SharedPreferences prefs = await SharedPreferences.getInstance();
    f_pin = prefs.getString("hasLogin") ?? "";
    var resultQueryBuddy = await DBHelper().queryCustom(
        "SELECT f_pin, first_name, last_name, device_id FROM BUDDY WHERE f_pin='$f_pin'");
    print("Live Video Promotion resultQueryBuddy: $resultQueryBuddy");
    if (resultQueryBuddy.length != 0) {
      device_id = resultQueryBuddy[0]['device_id'];
      if (resultQueryBuddy[0]['last_name'].toString().isEmpty) {
        name = resultQueryBuddy[0]['first_name'];
      } else {
        name = resultQueryBuddy[0]['first_name'] +
            " " +
            resultQueryBuddy[0]['last_name'];
      }
    }
    setState(() {});
  }

  String getLSDataPublic(String title, String desc, String f_pin, String type) {
    var jsonData = {
      "title": title,
      "description": desc,
      "by": f_pin,
      "type": type,
      "time": 0,
      "members": jsonEncode([]),
      "groups": jsonEncode([])
    };
    return jsonEncode(jsonData);
  }

  String getLSDataTargeted(
      String title, String desc, String f_pin, String type, int time) {
    var jsonData = {
      "title": title,
      "description": desc,
      "by": f_pin,
      "type": type,
      "time": time.toString(),
      "members": jsonEncode(fpinChosen),
      "groups": jsonEncode([])
    };
    // jsondata.putIfAbsent("title", () => title);
    // jsondata.putIfAbsent("description", () => desc);
    // jsondata.putIfAbsent("by", () => f_pin);
    // jsondata.putIfAbsent("type", () => type);
    // jsondata.putIfAbsent("time", () => time);
    // jsondata.putIfAbsent("members", () => json.decode(fpinChosen.toString()));
    // jsondata.putIfAbsent("groups", () => json.decode([].toString()));
    return jsonEncode(jsonData);
  }

  @override
  void initState() {
    super.initState();
    getData();
  }

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      onTap: () {
        FocusScopeNode currentFocus = FocusScope.of(context);
        if (!currentFocus.hasPrimaryFocus) {
          currentFocus.unfocus();
        }
      },
      child: Scaffold(
        appBar: AppBar(
          iconTheme: IconThemeData(color: Colors.white),
          title: Text("Live Video Promotion",
              style: TextStyle(color: Colors.white)),
          backgroundColor: AppColor.primaryColor,
        ),
        backgroundColor: Colors.white,
        body: Stack(
          children: <Widget>[
            SingleChildScrollView(
              child: Column(
                crossAxisAlignment: CrossAxisAlignment.start,
                children: <Widget>[
                  Container(
                    child: Text("Broadcast To",
                        style: TextStyle(color: Colors.grey)),
                    padding: EdgeInsets.only(left: 10.0, top: 5.0),
                  ),
                  Container(
                    padding: EdgeInsets.only(left: 10.0, right: 10.0),
                    child: DropdownButtonHideUnderline(
                      child: DropdownButton(
                        onChanged: (newValue) {
                          setState(() {
                            _btnSelected = newValue as String;
                            if (_btnSelected == "Invitation" ||
                                _btnSelected == "Group") {
                              type = "5";
                            } else if (_btnSelected == "Public") {
                              type = "3";
                            } else if (_btnSelected == "Friends") {
                              type = "0";
                            }
                          });
                        },
                        value: _btnSelected,
                        items: this._dropDownMMenuItems,
                      ),
                    ),
                  ),
                  Divider(height: 0.0, color: Colors.grey),
                  SizedBox(height: 10.0),
                  Container(
                    child: Text("Live Video Promotion Title *",
                        style: TextStyle(color: Colors.grey)),
                    padding: EdgeInsets.only(left: 10.0, top: 5.0),
                  ),
                  Container(
                    padding: EdgeInsets.only(left: 10.0, right: 10.0),
                    child: TextField(
                      cursorColor: Colors.black,
                      controller: judul,
                      decoration: InputDecoration(
                          border: InputBorder.none,
                          contentPadding: EdgeInsets.only(top: -20.0)),
                    ),
                  ),
                  Divider(height: 0.0, color: Colors.grey),
                  SizedBox(height: 10.0),
                  Container(
                    child: Text("Live Video Promotion Description *",
                        style: TextStyle(color: Colors.grey)),
                    padding: EdgeInsets.only(left: 10.0, top: 5.0),
                  ),
                  Container(
                    padding: EdgeInsets.only(left: 10.0, right: 10.0),
                    child: TextField(
                      cursorColor: Colors.black,
                      controller: desc,
                      decoration: InputDecoration(
                          border: InputBorder.none,
                          contentPadding: EdgeInsets.only(top: -20.0)),
                    ),
                  ),
                  Divider(height: 0.0, color: Colors.grey),
                  SizedBox(height: 10.0),
                  Visibility(
                    visible: _btnSelected == "Invitation",
                    child: Container(
                      child: Text("Start Live Video Promotion *",
                          style: TextStyle(color: Colors.grey)),
                      padding: EdgeInsets.only(left: 10.0, top: 5.0),
                    ),
                  ),
                  Visibility(
                    visible: _btnSelected == "Invitation",
                    child: Container(
                      padding: EdgeInsets.only(left: 10.0, right: 10.0),
                      margin: EdgeInsets.only(top: 5.0, bottom: 10.0),
                      child: Row(
                        mainAxisAlignment: MainAxisAlignment.start,
                        children: <Widget>[
                          CalendarForm(
                              times: timeValDate,
                              date: (date) {
                                List<String> dataTanggal = date.split("-");
                                tahun = int.parse(dataTanggal[2]);
                                bulan = int.parse(dataTanggal[1]);
                                tanggal = int.parse(dataTanggal[0]);
                                setState(() {
                                  timeValDate = DateTime(
                                          tahun, bulan, tanggal, jam, menit)
                                      .millisecondsSinceEpoch;
                                });
                              }),
                          SizedBox(width: 10.0),
                          TimeForm(
                              timeValue: timeVal,
                              time: (time) {
                                List<String> dataWaktu = time.split(":");
                                menit = int.parse(dataWaktu[1]);
                                jam = int.parse(dataWaktu[0]);
                                setState(() {
                                  timeVal = DateTime(
                                          tahun, bulan, tanggal, jam, menit)
                                      .millisecondsSinceEpoch;
                                });
                              })
                        ],
                      ),
                    ),
                  ),
                  Visibility(
                    visible: _btnSelected == "Invitation",
                    child: Divider(height: 0.0, color: Colors.grey),
                  ),
                  Visibility(
                    visible: _btnSelected == "Invitation",
                    child: SizedBox(height: 10.0),
                  ),
                  Visibility(
                    visible: _btnSelected == "Invitation",
                    child: Container(
                      child: Text(
                          _btnSelected == "Invitation"
                              ? "Live Video Promotion Participants *"
                              : "Live Video Promotion Groups Participants *",
                          style: TextStyle(color: Colors.grey)),
                      padding: EdgeInsets.only(left: 10.0, top: 5.0),
                      margin: EdgeInsets.only(bottom: 5.0),
                    ),
                  ),
                  Visibility(
                    visible: _btnSelected == "Invitation",
                    child: Container(
                      margin: EdgeInsets.only(bottom: 10.0),
                      padding: EdgeInsets.only(left: 10.0, right: 10.0),
                      child: Wrap(
                        children: List.generate(
                            nameChosen.length,
                            (index) => Container(
                                  padding: EdgeInsets.all(10.0),
                                  width:
                                      MediaQuery.of(context).size.width * 0.45,
                                  height: 50,
                                  decoration: BoxDecoration(
                                      border: Border.all(color: Colors.black),
                                      borderRadius: BorderRadius.circular(3.0)),
                                  child: Row(
                                    mainAxisAlignment:
                                        MainAxisAlignment.spaceBetween,
                                    children: <Widget>[
                                      Expanded(
                                        child: Row(
                                          mainAxisAlignment:
                                              MainAxisAlignment.start,
                                          children: <Widget>[
                                            Icon(Icons.person,
                                                color: Colors.grey[600]),
                                            SizedBox(width: 10.0),
                                            Text(
                                              nameChosen[index],
                                              overflow: TextOverflow.ellipsis,
                                            ),
                                          ],
                                        ),
                                      ),
                                      GestureDetector(
                                          onTap: () {
                                            setState(() {
                                              nameChosen.removeAt(index);
                                              fpinChosen.removeAt(index);
                                              dataChosen.removeAt(index);
                                              print(dataChosen.toString());
                                              print(nameChosen.toString());
                                              print(fpinChosen.toString());
                                            });
                                          },
                                          child: Icon(Icons.cancel,
                                              color: Colors.red))
                                    ],
                                  ),
                                )),
                        spacing: 15.0,
                        runSpacing: 10.0,
                      ),
                    ),
                  ),
                  Visibility(
                    visible: _btnSelected == "Invitation",
                    child: AddMember(
                        listUpdate: dataChosen,
                        listMembers: (name) {
                          setState(() {
                            if (!fpinChosen.contains(name.split("~")[1])) {
                              nameChosen.add(name.split("~")[0]);
                              fpinChosen.add(name.split("~")[1]);
                              dataChosen.add(name);
                            }
                            print(dataChosen.toString());
                            print(nameChosen.toString());
                            print(fpinChosen.toString());
                          });
                        }),
                  ),
                  SizedBox(height: 20.0),
                  Visibility(
                    visible: _btnSelected == "Invitation",
                    child: Divider(height: 0.0, color: Colors.grey),
                  ),
                ],
              ),
            ),
            Align(
              alignment: Alignment.bottomCenter,
              child: Container(
                alignment: Alignment.centerRight,
                width: double.infinity,
                height: 60,
                child: ButtonAdd(() {
                  if (judul.text.isEmpty) {
                    Fluttertoast.showToast(
                        msg: "Live Video Promotion title must not empty",
                        toastLength: Toast.LENGTH_LONG);
                  } else if (desc.text.isEmpty) {
                    Fluttertoast.showToast(
                        msg: "Live Video Promotion description must not empty",
                        toastLength: Toast.LENGTH_LONG);
                  } else if ((_btnSelected == "Invitation" ||
                          _btnSelected == "Group") &&
                      nameChosen.isEmpty) {
                    Fluttertoast.showToast(
                        msg: "Live Video Promotion participants must not empty",
                        toastLength: Toast.LENGTH_LONG);
                  } else {
                    DateTime dateTime = new DateTime.now();
                    int timeNow = dateTime.millisecondsSinceEpoch;
                    timeNow++;
                    String mID = "LST" + f_pin + timeNow.toString();
                    timeDate = DateTime(tahun, bulan, tanggal, jam, menit);
                    print("Time Date " + timeDate.toString());
                    time = timeDate.millisecondsSinceEpoch - 240000;
                    print("Waktu $time");
                    if (_btnSelected == "Invitation" ||
                        _btnSelected == "Group") {
                      API.sendCreateLS(
                          "1~" + judul.text,
                          "5",
                          "",
                          "3",
                          mID,
                          getLSDataTargeted(
                              "1~" + judul.text, desc.text, f_pin, "5", time));
                      API.sendToBot(
                          getLSDataTargeted(
                              "1~" + judul.text, desc.text, f_pin, "3", time),
                          "27",
                          mID);
                    } else {
                      API.sendCreateLS(
                          "1~" + judul.text,
                          _btnSelected == "Public" ? "3" : "0",
                          "",
                          "3",
                          mID,
                          getLSDataPublic("1~" + judul.text, desc.text, f_pin,
                              _btnSelected == "Public" ? "3" : "0"));
                    }
                    if (timeDate.millisecondsSinceEpoch <=
                        DateTime.now().millisecondsSinceEpoch) {
                      // Navigator.pushReplacement(context,
                      //     PageTransition(type: PageTransitionType.fade, child: InisiateLs(
                      //       title: "1~" + judul.text,
                      //       name: name,
                      //       f_pin: f_pin,
                      //       privacy: type,
                      //       desc: desc.text,
                      //     )));
                      Navigator.pushReplacement(
                          context,
                          PageTransition(
                              type: PageTransitionType.fade,
                              child: InisiateLs(
                                  title: "1~" + judul.text,
                                  name: name,
                                  f_pin: f_pin,
                                  privacy: type,
                                  desc: desc.text,
                                  blog_id: mID)));
                    } else {
                      // Future.delayed(Duration(seconds: 2), () async {
                      //   var result = {
                      //     "A00" : '-999',
                      //     "A149": '27',
                      //     "A06" : '3'
                      //   };
                      //   Notifications.showNotifications(result, 0, context);
                      // });
                      // Navigator.of(context).pop();
                      Navigator.pushReplacement(
                          context,
                          PageTransition(
                              type: PageTransitionType.fade,
                              child: ChatPage(
                                fullName: "Bot",
                                image: "",
                                identifier: '-999',
                                refresh: true,
                              )));
                    }
                  }
                }, "CREATE"),
              ),
            )
          ],
        ),
      ),
    );
  }
}
