import 'package:flutter/material.dart';
import 'package:flutter/cupertino.dart';
import 'package:fluttertoast/fluttertoast.dart';
import 'package:page_transition/page_transition.dart';
import 'package:palio_lite/conference/seminar_screen.dart';
import 'package:palio_lite/chat/widgets/add_member.dart';
import 'package:palio_lite/Widget/button_add.dart';
import 'package:palio_lite/app_color.dart';
import 'package:shared_preferences/shared_preferences.dart';
import 'package:palio_lite/db_helper.dart';

class AddSeminar extends StatefulWidget {
  @override
  _AddSeminarState createState() => _AddSeminarState();
}

class _AddSeminarState extends State<AddSeminar> {
  static const menuItems = <String>[
    "Customer",
    "Team Member",
    "All User",
    "Groups",
    "Specific Users"
  ];
  TextEditingController judul = TextEditingController(),
      desc = TextEditingController();
  final List<DropdownMenuItem<String>> _dropDownMMenuItems = menuItems
      .map((String value) =>
          DropdownMenuItem<String>(value: value, child: Text(value)))
      .toList();
  String _btnSelected = "Customer";

  DateTime timeDate = DateTime(DateTime.now().year);
  int tanggal = DateTime.now().day;
  int bulan = DateTime.now().month;
  int tahun = DateTime.now().year;
  int jam = DateTime.now().hour;
  int menit = DateTime.now().minute;
  int time = 0;
  int timeVal = DateTime.now().millisecondsSinceEpoch;
  int timeValDate = DateTime.now().millisecondsSinceEpoch;

  String f_pin = "";
  String name = "";
  String device_id = "";

  List<String> nameChosen = [];
  List<String> fpinChosen = [];
  List<String> dataChosen = [];

  Future<void> getData() async {
    final SharedPreferences prefs = await SharedPreferences.getInstance();
    f_pin = prefs.getString("hasLogin") ?? "";
    var resultQueryBuddy = await DBHelper().queryCustom(
        "SELECT f_pin, first_name, last_name, device_id FROM BUDDY WHERE f_pin='$f_pin'");
    print("Live Video Promotion resultQueryBuddy: $resultQueryBuddy");
    if (resultQueryBuddy.length != 0) {
      device_id = resultQueryBuddy[0]['device_id'];
      if (resultQueryBuddy[0]['last_name'].toString().isEmpty) {
        name = resultQueryBuddy[0]['first_name'];
      } else {
        name = resultQueryBuddy[0]['first_name'] +
            " " +
            resultQueryBuddy[0]['last_name'];
      }
    }
    setState(() {});
  }

  @override
  void initState() {
    super.initState();
    getData();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        iconTheme: IconThemeData(color: Colors.white),
        title: Text("Seminar", style: TextStyle(color: Colors.white)),
        backgroundColor: AppColor.primaryColor,
      ),
      backgroundColor: Colors.white,
      body: Stack(
        children: <Widget>[
          SingleChildScrollView(
            child: Column(
              crossAxisAlignment: CrossAxisAlignment.start,
              children: <Widget>[
                Container(
                  child: Text("Mode", style: TextStyle(color: Colors.grey)),
                  padding: EdgeInsets.only(left: 10.0, top: 5.0),
                ),
                Container(
                  padding: EdgeInsets.only(left: 10.0, right: 10.0),
                  child: DropdownButtonHideUnderline(
                    child: DropdownButton(
                      onChanged: (newValue) {
                        setState(() {
                          _btnSelected = newValue as String;
                        });
                      },
                      value: _btnSelected,
                      items: this._dropDownMMenuItems,
                    ),
                  ),
                ),
                Divider(height: 0.0, color: Colors.grey),
                SizedBox(height: 10.0),
                Container(
                  child: Text("Title *", style: TextStyle(color: Colors.grey)),
                  padding: EdgeInsets.only(left: 10.0, top: 5.0),
                ),
                Container(
                  padding: EdgeInsets.only(left: 10.0, right: 10.0),
                  child: TextField(
                    cursorColor: Colors.black,
                    controller: judul,
                    decoration: InputDecoration(
                        border: InputBorder.none,
                        contentPadding: EdgeInsets.only(top: -20.0)),
                  ),
                ),
                Divider(height: 0.0, color: Colors.grey),
                SizedBox(height: 10.0),
                Container(
                  child: Text("Description *",
                      style: TextStyle(color: Colors.grey)),
                  padding: EdgeInsets.only(left: 10.0, top: 5.0),
                ),
                Container(
                  padding: EdgeInsets.only(left: 10.0, right: 10.0),
                  child: TextField(
                    cursorColor: Colors.black,
                    controller: desc,
                    decoration: InputDecoration(
                        border: InputBorder.none,
                        contentPadding: EdgeInsets.only(top: -20.0)),
                  ),
                ),
                Divider(height: 0.0, color: Colors.grey),
                SizedBox(height: 10.0),
                Visibility(
                  visible: _btnSelected == "Specific Users" ||
                      _btnSelected == "Groups",
                  child: Container(
                    child: Text(
                        _btnSelected == "Specific Users"
                            ? "Participants *"
                            : "Group *",
                        style: TextStyle(color: Colors.grey)),
                    padding: EdgeInsets.only(left: 10.0, top: 5.0),
                    margin: EdgeInsets.only(bottom: 5.0),
                  ),
                ),
                Visibility(
                  visible: _btnSelected == "Specific Users" ||
                      _btnSelected == "Groups",
                  child: Container(
                    margin: EdgeInsets.only(bottom: 10.0),
                    padding: EdgeInsets.only(left: 10.0, right: 10.0),
                    child: Wrap(
                      children: List.generate(
                          nameChosen.length,
                          (index) => Container(
                                padding: EdgeInsets.all(10.0),
                                width: MediaQuery.of(context).size.width * 0.45,
                                height: 50,
                                decoration: BoxDecoration(
                                    border: Border.all(color: Colors.black),
                                    borderRadius: BorderRadius.circular(3.0)),
                                child: Row(
                                  mainAxisAlignment:
                                      MainAxisAlignment.spaceBetween,
                                  children: <Widget>[
                                    Expanded(
                                      child: Row(
                                        mainAxisAlignment:
                                            MainAxisAlignment.start,
                                        children: <Widget>[
                                          Icon(Icons.person,
                                              color: Colors.grey[600]),
                                          SizedBox(width: 10.0),
                                          Text(
                                            nameChosen[index],
                                            overflow: TextOverflow.ellipsis,
                                          ),
                                        ],
                                      ),
                                    ),
                                    GestureDetector(
                                        onTap: () {
                                          setState(() {
                                            nameChosen.removeAt(index);
                                            fpinChosen.removeAt(index);
                                            dataChosen.removeAt(index);
                                            print(dataChosen.toString());
                                            print(nameChosen.toString());
                                            print(fpinChosen.toString());
                                          });
                                        },
                                        child: Icon(Icons.cancel,
                                            color: Colors.red))
                                  ],
                                ),
                              )),
                      spacing: 15.0,
                      runSpacing: 10.0,
                    ),
                  ),
                ),
                Visibility(
                  visible: _btnSelected == "Specific Users" ||
                      _btnSelected == "Groups",
                  child: AddMember(
                      listUpdate: dataChosen,
                      listMembers: (name) {
                        setState(() {
                          if (!fpinChosen.contains(name.split("~")[1])) {
                            nameChosen.add(name.split("~")[0]);
                            fpinChosen.add(name.split("~")[1]);
                            dataChosen.add(name);
                          }
                          print(dataChosen.toString());
                          print(nameChosen.toString());
                          print(fpinChosen.toString());
                        });
                      }),
                ),
                SizedBox(height: 20.0),
                Visibility(
                  visible: _btnSelected == "Specific Users" ||
                      _btnSelected == "Groups",
                  child: Divider(height: 0.0, color: Colors.grey),
                ),
              ],
            ),
          ),
          Align(
            alignment: Alignment.bottomCenter,
            child: Container(
              alignment: Alignment.centerRight,
              width: double.infinity,
              height: 60,
              child: ButtonAdd(() {
                if (judul.text.isEmpty) {
                  Fluttertoast.showToast(
                      msg: "Seminar title must not empty",
                      toastLength: Toast.LENGTH_LONG);
                } else if (desc.text.isEmpty) {
                  Fluttertoast.showToast(
                      msg: "Seminar description must not empty",
                      toastLength: Toast.LENGTH_LONG);
                } else if ((_btnSelected == "Invitation" ||
                        _btnSelected == "Group") &&
                    nameChosen.isEmpty) {
                  Fluttertoast.showToast(
                      msg: "Live Video Promotion participants must not empty",
                      toastLength: Toast.LENGTH_LONG);
                } else {
                  Navigator.push(
                      context,
                      PageTransition(
                          type: PageTransitionType.fade,
                          child: SeminarScreen(
                            name: "",
                            f_pin: "",
                            privacy: "",
                          )));
                }
              }, "Create"),
            ),
          )
        ],
      ),
    );
  }
}
