import 'dart:convert';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:fluttertoast/fluttertoast.dart';
import 'package:page_transition/page_transition.dart';
import 'package:palio_lite/api.dart';
import 'package:palio_lite/app_color.dart';
import 'package:palio_lite/chat/chat_screen.dart';
import 'package:palio_lite/chat/widgets/add_member.dart';
import 'package:palio_lite/chat/widgets/calendar_form.dart';
import 'package:palio_lite/chat/widgets/time_form.dart';
import 'package:palio_lite/conference/video_conference.dart';
import 'package:palio_lite/conference/widgets/button_add.dart';
import 'package:palio_lite/db_helper.dart';
import 'package:shared_preferences/shared_preferences.dart';

class AddConferenceRoom extends StatefulWidget {
  @override
  _AddConferenceRoomState createState() => _AddConferenceRoomState();
}

class _AddConferenceRoomState extends State<AddConferenceRoom> {
  TextEditingController judul = TextEditingController();
  List<String> nameChosen = [];
  List<String> fpinChosen = [];
  List<String> dataChosen = [];
  String name = "";
  String f_pin = "";
  String device_id = "";
  DateTime timeDate = DateTime(DateTime.now().year);
  int tanggal = DateTime.now().day;
  int bulan = DateTime.now().month;
  int tahun = DateTime.now().year;
  int jam = DateTime.now().hour;
  int menit = DateTime.now().minute;
  int time = 0;
  int timeVal = DateTime.now().millisecondsSinceEpoch;
  int timeValDate = DateTime.now().millisecondsSinceEpoch;

  Future<void> getData() async {
    final SharedPreferences prefs = await SharedPreferences.getInstance();
    f_pin = prefs.getString("hasLogin") ?? "";
    var resultQueryBuddy = await DBHelper().queryCustom(
        "SELECT f_pin, first_name, last_name, device_id FROM BUDDY WHERE f_pin='$f_pin'");
    print("Conf call resultQueryBuddy: $resultQueryBuddy");
    if (resultQueryBuddy.length != 0) {
      device_id = resultQueryBuddy[0]['device_id'];
      if (resultQueryBuddy[0]['last_name'].toString().isEmpty) {
        name = resultQueryBuddy[0]['first_name'];
      } else {
        name = resultQueryBuddy[0]['first_name'] +
            " " +
            resultQueryBuddy[0]['last_name'];
      }
    }
    setState(() {});
  }

  @override
  void initState() {
    // TODO: implement initState
    super.initState();
    getData();
  }

  String getVCRoomData(String title, int time, String f_pin) {
    // Map<String,dynamic> jsondata = Map();
    var jsonData = {
      "title": title,
      "by": f_pin,
      "time": time,
      "members": jsonEncode(fpinChosen)
    };
    // jsondata.putIfAbsent("title", () => title);
    // jsondata.putIfAbsent("by", () => f_pin);
    // jsondata.putIfAbsent("time", () => time);
    // jsondata.putIfAbsent("members", () => json.decode(fpinChosen.toString()));
    return jsonEncode(jsonData);
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        iconTheme: IconThemeData(color: Colors.white),
        title: Text("Video Conference Room",
            style: TextStyle(color: Colors.white)),
        backgroundColor: AppColor.primaryColor,
      ),
      backgroundColor: Colors.white,
      body: Stack(
        children: <Widget>[
          SingleChildScrollView(
            child: Column(
              crossAxisAlignment: CrossAxisAlignment.start,
              children: <Widget>[
                Container(
                  child: Text("Title" + " *",
                      style: TextStyle(color: Colors.grey)),
                  padding: EdgeInsets.only(left: 10.0, top: 5.0),
                ),
                Container(
                  padding: EdgeInsets.only(left: 10.0, right: 10.0),
                  child: TextField(
                    cursorColor: Colors.black,
                    controller: judul,
                    decoration: InputDecoration(
                        border: InputBorder.none,
                        contentPadding: EdgeInsets.only(top: -20.0)),
                  ),
                ),
                Divider(height: 0.0, color: Colors.grey),
                SizedBox(height: 10.0),
                Container(
                  child: Text("Start*", style: TextStyle(color: Colors.grey)),
                  padding: EdgeInsets.only(left: 10.0, top: 5.0),
                ),
                Container(
                  padding: EdgeInsets.only(left: 10.0, right: 10.0),
                  margin: EdgeInsets.only(top: 5.0, bottom: 10.0),
                  child: Row(
                    mainAxisAlignment: MainAxisAlignment.start,
                    children: <Widget>[
                      CalendarForm(
                          times: timeValDate,
                          date: (date) {
                            List<String> dataTanggal = date.split("-");
                            tahun = int.parse(dataTanggal[2]);
                            bulan = int.parse(dataTanggal[1]);
                            tanggal = int.parse(dataTanggal[0]);
                            setState(() {
                              timeValDate =
                                  DateTime(tahun, bulan, tanggal, jam, menit)
                                      .millisecondsSinceEpoch;
                            });
                          }),
                      SizedBox(width: 10.0),
                      TimeForm(
                          timeValue: timeVal,
                          time: (time) {
                            List<String> dataWaktu = time.split(":");
                            menit = int.parse(dataWaktu[1]);
                            jam = int.parse(dataWaktu[0]);
                            setState(() {
                              timeVal =
                                  DateTime(tahun, bulan, tanggal, jam, menit)
                                      .millisecondsSinceEpoch;
                            });
                          })
                    ],
                  ),
                ),
                Divider(height: 0.0, color: Colors.grey),
                SizedBox(height: 10.0),
                Container(
                  child: Text("Participants" + " *",
                      style: TextStyle(color: Colors.grey)),
                  padding: EdgeInsets.only(left: 10.0, top: 5.0),
                  margin: EdgeInsets.only(bottom: 5.0),
                ),
                Container(
                  margin: EdgeInsets.only(bottom: 10.0),
                  padding: EdgeInsets.only(left: 10.0, right: 10.0),
                  child: Wrap(
                    children: List.generate(
                        nameChosen.length,
                        (index) => Container(
                              padding: EdgeInsets.all(10.0),
                              width: MediaQuery.of(context).size.width * 0.45,
                              height: 50,
                              decoration: BoxDecoration(
                                  border: Border.all(color: Colors.black),
                                  borderRadius: BorderRadius.circular(3.0)),
                              child: Row(
                                mainAxisAlignment:
                                    MainAxisAlignment.spaceBetween,
                                children: <Widget>[
                                  Expanded(
                                    child: Row(
                                      mainAxisAlignment:
                                          MainAxisAlignment.start,
                                      children: <Widget>[
                                        Icon(Icons.person,
                                            color: Colors.grey[600]),
                                        SizedBox(width: 10.0),
                                        Text(
                                          nameChosen[index],
                                          overflow: TextOverflow.ellipsis,
                                        ),
                                      ],
                                    ),
                                  ),
                                  GestureDetector(
                                      onTap: () {
                                        setState(() {
                                          nameChosen.removeAt(index);
                                          fpinChosen.removeAt(index);
                                          dataChosen.removeAt(index);
                                          print(dataChosen.toString());
                                          print(nameChosen.toString());
                                          print(fpinChosen.toString());
                                        });
                                      },
                                      child:
                                          Icon(Icons.cancel, color: Colors.red))
                                ],
                              ),
                            )),
                    spacing: 15.0,
                    runSpacing: 10.0,
                  ),
                ),
                AddMember(
                    listUpdate: dataChosen,
                    listMembers: (name) {
                      setState(() {
                        if (!fpinChosen.contains(name.split("~")[1])) {
                          nameChosen.add(name.split("~")[0]);
                          fpinChosen.add(name.split("~")[1]);
                          dataChosen.add(name);
                        }
                        print(dataChosen.toString());
                        print(nameChosen.toString());
                        print(fpinChosen.toString());
                      });
                    }),
                SizedBox(height: 20.0),
                Divider(height: 0.0, color: Colors.grey),
              ],
            ),
          ),
          Align(
            alignment: Alignment.bottomCenter,
            child: Container(
              alignment: Alignment.centerRight,
              width: double.infinity,
              height: 60,
              child: ButtonAdd(() {
                if (judul.text.isEmpty) {
                  Fluttertoast.showToast(
                      msg: "Video Conference Room title can't be empty",
                      toastLength: Toast.LENGTH_LONG);
                } else if (nameChosen.isEmpty) {
                  Fluttertoast.showToast(
                      msg: "Video Conference Room participants can't be empty",
                      toastLength: Toast.LENGTH_LONG);
                } else if (nameChosen.length > 16) {
                  Fluttertoast.showToast(
                      msg: "vcroomexceedPart", toastLength: Toast.LENGTH_LONG);
                } else {
                  DateTime dateTime = new DateTime.now();
                  int timeNow = dateTime.millisecondsSinceEpoch;
                  timeNow++;
                  String mID = f_pin + timeNow.toString();
                  timeDate = DateTime(tahun, bulan, tanggal, jam, menit);
                  time = timeDate.millisecondsSinceEpoch;
                  API.createCRoom(mID, getVCRoomData(judul.text, time, f_pin));
                  API.sendToBot(
                      getVCRoomData(judul.text, time, f_pin), "25", mID);
                  print("FPINNNN $f_pin");
                  if (DateTime.now().millisecondsSinceEpoch >=
                      timeDate.millisecondsSinceEpoch) {
                    // Navigator.pushReplacement(context,
                    //     PageTransition(type: PageTransitionType.fade, child: VCRoom(
                    //       name: name,
                    //       cameraId: 1,
                    //       isInitiatior: 1,
                    //       mId: mID,
                    //       f_pin: f_pin,
                    //     )));
                    Navigator.pushReplacement(
                        context,
                        PageTransition(
                            type: PageTransitionType.fade,
                            child: VCRoom(
                              name: name,
                              cameraId: 1,
                              isInitiatior: 1,
                              mId: mID,
                              f_pin: f_pin,
                            )));
                  } else {
                    // Navigator.of(context).pop();
                    Navigator.pushReplacement(
                        context,
                        PageTransition(
                            type: PageTransitionType.fade,
                            child: ChatPage(
                              fullName: "Bot",
                              image: "",
                              identifier: '-999',
                              refresh: true,
                            )));
                  }
                }
              }, "CREATE"),
            ),
          )
        ],
      ),
    );
  }
}
