import 'dart:async';
import 'dart:convert';

import 'package:fading_edge_scrollview/fading_edge_scrollview.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter/painting.dart';
import 'package:marquee/marquee.dart';
import 'package:page_transition/page_transition.dart';
import 'package:palio_lite/api.dart';
import 'package:palio_lite/app_color.dart';
import 'package:palio_lite/call/widgets/bubble_vc.dart';
import 'package:palio_lite/call/widgets/camera.dart';
import 'package:palio_lite/call/widgets/change_camera.dart';
import 'package:palio_lite/call/widgets/editor_vc.dart';
import 'package:palio_lite/conference/widgets/like_live.dart';
import 'package:palio_lite/conference/widgets/list_person_ls.dart';
import 'package:palio_lite/conference/widgets/view_live.dart';
import 'package:palio_lite/db_helper.dart';
import 'package:shared_preferences/shared_preferences.dart';

class InisiateLs extends StatefulWidget {
  final String name;
  final String f_pin;
  final String desc;
  final String privacy;
  final String title;
  final String blog_id;

  InisiateLs(
      {required this.name,
      required this.f_pin,
      required this.privacy,
      this.desc = "",
      this.title = "",
      this.blog_id = ""});

  _InisiateLsState createState() => _InisiateLsState();
}

class _InisiateLsState extends State<InisiateLs> {
  String language = "";
  String f_pin = "";
  String blog_id = "";
  String name = "";
  String privacy = "";
  String defTag = "";
  String title = "";
  int sizeFlag = 3;
  int like = 0;
  int view = 0;
  String idMe = "";
  List<String> userLS = [];
  List<String> imageUserLs = [];
  List<Map<String, String>> personData = [];
  bool muted = false, backCam = false;
  TextEditingController? _titleController;
  TextEditingController? _tagLineController;
  ScrollController? _controller;
  List<String> dataSelf = [];
  List<Map<dynamic, dynamic>> samplemessages = [];

  Timer? _timer;

  void getDataLS() {
    _timer = new Timer.periodic(Duration(seconds: 2), (Timer timer) async {
      API.getLSData(f_pin);
    });
  }

  void updateLS() {
    API.onJoinLS = (int state, String message) {
      print("Message onJoin $state $message");
      if (state == 999) {
        print("Message Title $message");
        String datas = message.split("~")[1];
        var datax = datas.split(String.fromCharCode(9632));
        print("data string " + datax[0] + " " + datax[1]);
        //Update LS
        _titleController?.text = datax[0];
        _tagLineController?.text = datax[1];
        setState(() {});
      } else if (state == 95) {
        print("pesan dari " +
            message.split(",")[4] +
            " berupa " +
            message.split(",")[3]);
        samplemessages.insert(0, {
          "originator": message.split(",")[3],
          "content": message.split(",")[4],
          "thumbnail": message.split(",")[1]
        });
        _controller?.jumpTo(_controller!.position.minScrollExtent);
        setState(() {});
      } else if (state == 96) {
        print("jumlah like " + message.split(",")[1]);
        like = int.parse(message.split(",")[2]);
        setState(() {});
      } else if (state == 97) {
        print("view " +
            message.split(",")[4] +
            " user " +
            message.split(",")[3] +
            " ");
        view = int.parse(message.split(",")[4]);

        String message_leave = "";
        message_leave = message.split(",")[3] + " Leaving";
        print("message leave $message_leave");
        samplemessages.insert(0, {
          "originator": message.split(",")[3],
          "content": message_leave,
          "thumbnail": message.split(",")[1]
        });
        _controller?.jumpTo(_controller!.position.minScrollExtent);
        // personData.removeAt(view);
        userLS.remove(message.split(",")[3]);
        imageUserLs.remove(message.split(",")[1]);
        setState(() {});
      } else if (state == 98) {
        print("view " +
            message.split(",")[4] +
            " user " +
            message.split(",")[3] +
            " ");
        view = int.parse(message.split(",")[4]);
        String message_join = "";
        message_join = message.split(",")[3] + "Joined";
        print("message join $message_join");
        samplemessages.insert(0, {
          "originator": message.split(",")[3],
          "content": message_join,
          "thumbnail": message.split(",")[1]
        });
        _controller?.jumpTo(_controller!.position.minScrollExtent);
        // personData.add({"name":message.split(",")[3],"picture":message.split(",")[1]});
        userLS.add(message.split(",")[3]);
        imageUserLs.add(message.split(",")[1]);
        setState(() {});
      } else if (state == 94) {
        like = int.parse(message.split(",")[2]);
        view = int.parse(message.split(",")[5]);
        setState(() {});
      }
    };
    API.onStartLS = (int state, String message) {
      print("Message onStart $state $message");
    };
  }

  void _changeTitle() {
    showDialog(
        context: context,
        builder: (context) {
          return CupertinoAlertDialog(
              insetAnimationCurve: Curves.easeInBack,
              title: Text("Title"),
              content: Container(
                margin: EdgeInsets.only(top: 10),
                child: CupertinoTextField(
                  controller: _titleController,
                  cursorColor: AppColor.primaryColor,
                ),
              ),
              actions: <Widget>[
                CupertinoDialogAction(
                  onPressed: () => Navigator.pop(context),
                  child: Text("Cancel",
                      style: TextStyle(
                          color: AppColor.primaryColor, fontSize: 14)),
                ),
                CupertinoDialogAction(
                  onPressed: () {
                    setState(() {
                      API.updateLSTitle("1~" +
                          _titleController!.text +
                          String.fromCharCode(9632) +
                          _tagLineController!.text);
                      title = _titleController!.text;
                    });
                    Navigator.pop(context);
                  },
                  child: Text("OK",
                      style: TextStyle(
                          color: AppColor.primaryColor, fontSize: 14)),
                )
              ]);
        });
  }

  void _changeTagLine() {
    showDialog(
        context: context,
        builder: (context) {
          return CupertinoAlertDialog(
              insetAnimationCurve: Curves.easeInBack,
              title: Text("Tag Line"),
              content: Container(
                margin: EdgeInsets.only(top: 10),
                child: CupertinoTextField(
                  controller: _tagLineController,
                  cursorColor: AppColor.primaryColor,
                ),
              ),
              actions: <Widget>[
                CupertinoDialogAction(
                  onPressed: () => Navigator.pop(context),
                  child: Text("Cancel",
                      style: TextStyle(
                          color: AppColor.primaryColor, fontSize: 14)),
                ),
                CupertinoDialogAction(
                  onPressed: () {
                    setState(() {
                      API.updateLSTitle("1~" +
                          _titleController!.text +
                          String.fromCharCode(9632) +
                          _tagLineController!.text);
                    });
                    defTag = _tagLineController!.text;
                    Navigator.pop(context);
                  },
                  child: Text("OK",
                      style: TextStyle(
                          color: AppColor.primaryColor, fontSize: 14)),
                )
              ]);
        });
  }

  @override
  void initState() {
    super.initState();
    f_pin = widget.f_pin;
    name = widget.name;
    privacy = widget.privacy;
    defTag = widget.desc;
    blog_id = widget.blog_id;
    title = widget.title.split("~").sublist(1).join("~");
    print("ls init $f_pin $name $privacy $blog_id $title");

    _titleController = TextEditingController(text: title);
    _tagLineController = TextEditingController(text: defTag);
    _controller = new ScrollController();
    Future.delayed(Duration(seconds: 2), () {
      if (mounted) {
        if (title.isNotEmpty) {
          API.startLPInvited(widget.title, privacy, "", "3", blog_id);
          API.startLS(title, 1);
        }
      }
    });
    getData();
    updateLS();
    // getDataLS();
  }

  String getLSData(String title, String desc, String f_pin, String type) {
    Map<String, dynamic> jsondata = Map();
    jsondata.putIfAbsent("title", () => title);
    jsondata.putIfAbsent("description", () => desc);
    jsondata.putIfAbsent("by", () => f_pin);
    jsondata.putIfAbsent("type", () => type);
    jsondata.putIfAbsent("time", () => 0);
    jsondata.putIfAbsent("members", () => json.decode([].toString()));
    jsondata.putIfAbsent("groups", () => json.decode([].toString()));
    return json.encode(jsondata).toString();
  }

  @override
  void dispose() {
    if (_timer != null) {
      _timer?.cancel();
    }
    super.dispose();
  }

  Future<List<String>> getData() async {
    SharedPreferences prefs = await SharedPreferences.getInstance();
    idMe = prefs.getString("hasLogin") ?? "";
    language = prefs.getString("language") ?? "";
    var resultQueryBuddy = await DBHelper().queryCustom(
        "SELECT f_pin,first_name, last_name FROM BUDDY WHERE f_pin='" +
            idMe +
            "'");
    dataSelf.add(resultQueryBuddy[0]['f_pin']);
    dataSelf.add(resultQueryBuddy[0]['first_name'] +
        " " +
        resultQueryBuddy[0]['last_name']);
    print("Data Self Done");
    setState(() {});
    return dataSelf;
  }

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      onTap: () {
        FocusScopeNode currentFocus = FocusScope.of(context);
        if (!currentFocus.hasPrimaryFocus) {
          currentFocus.unfocus();
        }
      },
      child: SafeArea(
        child: Scaffold(
          body: Container(
            color: Colors.black,
            child: Stack(
              children: <Widget>[
                _cameraView(),
                Column(
                  mainAxisAlignment: MainAxisAlignment.spaceBetween,
                ),
                Column(
                  children: <Widget>[
                    Container(
                      margin: EdgeInsets.only(left: 10, right: 10, top: 10),
                      child: Row(
                        mainAxisAlignment: MainAxisAlignment.spaceBetween,
                        children: <Widget>[
                          Row(
                            children: <Widget>[
                              ViewLive(
                                (() async {
                                  if (mounted) {
                                    final dest = await Navigator.push(
                                        context,
                                        PageTransition(
                                            type: PageTransitionType.fade,
                                            child: ShowLSUsers(
                                              user: userLS,
                                              image: imageUserLs,
                                            )));
                                  }
                                }),
                                view: view.toString(),
                              ),
                              SizedBox(width: 10.0),
                              LikeLive(
                                (() {
                                  if (mounted) {}
                                }),
                                like: like.toString(),
                              ),
                            ],
                          ),
                          Material(
                            color: Colors.transparent,
                            child: InkWell(
                              onTap: () {
                                showDialog(
                                    context: context,
                                    builder: (context) {
                                      return CupertinoAlertDialog(
                                          insetAnimationCurve:
                                              Curves.easeInBack,
                                          title:
                                              Text("End Live Video Promotion?"),
                                          content: Container(
                                            margin: EdgeInsets.only(top: 10),
                                            child: Text(
                                              "Live Video Promotion session still running. End?",
                                              textAlign: TextAlign.start,
                                            ),
                                          ),
                                          actions: <Widget>[
                                            CupertinoDialogAction(
                                              onPressed: () =>
                                                  Navigator.pop(context),
                                              child: Text("CONTINUE",
                                                  style: TextStyle(
                                                      color:
                                                          AppColor.primaryColor,
                                                      fontSize: 14)),
                                            ),
                                            CupertinoDialogAction(
                                              onPressed: () {
                                                if (_timer != null) {
                                                  _timer?.cancel();
                                                }
                                                API.endLS();
                                                DateTime dateTime =
                                                    new DateTime.now();
                                                int timeNow = dateTime
                                                    .millisecondsSinceEpoch;
                                                String request_id =
                                                    timeNow.toRadixString(16);
                                                // API.leftLiveVideo(f_pin, request_id);
                                                // Navigator.pushReplacement(context,
                                                //     PageTransition(type: PageTransitionType.fade, child: Home(index: 1,)));
                                                Navigator.pop(context);
                                                Navigator.pop(context);
                                              },
                                              child: Text("FINISH",
                                                  style: TextStyle(
                                                      color:
                                                          AppColor.primaryColor,
                                                      fontSize: 14)),
                                            )
                                          ]);
                                    });
                              },
                              child: Container(
                                padding: EdgeInsets.all(10.0),
                                child: Text("END",
                                    style: TextStyle(
                                        color: Colors.white,
                                        fontWeight: FontWeight.bold)),
                              ),
                            ),
                          )
                        ],
                      ),
                    ),
                    Row(
                      mainAxisAlignment: MainAxisAlignment.spaceBetween,
                      children: <Widget>[
                        Container(
                          margin: EdgeInsets.only(left: 10),
                          child: Row(
                            children: <Widget>[
                              Text(
                                title,
                                style: TextStyle(color: Colors.white),
                              ),
                              SizedBox(
                                width: 8,
                              ),
                              InkWell(
                                onTap: () {
                                  _changeTitle();
                                },
                                child: Icon(
                                  CupertinoIcons.pencil,
                                  color: Colors.white,
                                  size: 18,
                                ),
                              ),
                            ],
                          ),
                        ),
                        Visibility(
                          visible: false,
                          child: ChangeCameraLive(() {}),
                        ),
                      ],
                    ),
                  ],
                ),
                _chat()
              ],
            ),
          ),
        ),
      ),
    );
  }

  Widget _cameraView() {
    return Container(
        width: MediaQuery.of(context).size.width,
        height: MediaQuery.of(context).size.height,
        child: Camera()
//          Container(),
        );
  }

  Widget _chat() {
    return Container(
      padding: EdgeInsets.only(top: MediaQuery.of(context).size.height * 0.3),
      child: Column(
        children: <Widget>[
          Expanded(
            child: FadingEdgeScrollView.fromScrollView(
              child: CustomScrollView(
                shrinkWrap: true,
                reverse: true,
                controller: _controller,
                slivers: <Widget>[
                  SliverList(
                      delegate: SliverChildBuilderDelegate((context, index) {
                    var data = samplemessages[index];
                    return Padding(
                      padding: EdgeInsets.only(top: 8.0),
                      child: GestureDetector(
                        child: BubbleVc(
                          originator: data['originator'],
                          content: data['content'],
                          thumbnail: data['thumbnail'],
                        ),
                        onTap: () {},
                      ),
                    );
                  }, childCount: samplemessages.length))
                ],
              ),
            ),
          ),
          EditorVc(
            onPressed: (val) async {
              getData().then((value) {
                print("data " + value.toString());
                var obj = {"originator": value[1], "content": val['content']};
                setState(() {
                  samplemessages.insert(0, obj);
                  _controller?.jumpTo(_controller!.position.minScrollExtent);
                  API.sendLSChat(f_pin, val['content'].toString());
                });
              });
            },
          ),
          Container(
            padding: EdgeInsets.only(left: 5, right: 5),
            child: Row(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: <Widget>[
                Container(
                  height: 15,
                  width: MediaQuery.of(context).size.width * 0.9,
                  color: Colors.transparent,
                  child: Marquee(
                    crossAxisAlignment: CrossAxisAlignment.start,
                    blankSpace: 20.0,
                    text: _tagLineController!.text,
                    style: TextStyle(color: Colors.white, fontSize: 12),
                  ),
                ),
                SizedBox(
                  width: 8,
                ),
                InkWell(
                  onTap: () {
                    _changeTagLine();
                  },
                  child: Icon(
                    CupertinoIcons.pencil,
                    color: Colors.white,
                    size: 18,
                  ),
                ),
              ],
            ),
          )
        ],
      ),
    );
  }
}
