import 'dart:async';
import 'dart:core';

import 'package:fading_edge_scrollview/fading_edge_scrollview.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter/painting.dart';
import 'package:marquee/marquee.dart';
import 'package:page_transition/page_transition.dart';
import 'package:palio_lite/api.dart';
import 'package:palio_lite/app_color.dart';
import 'package:palio_lite/call/widgets/bubble_vc.dart';
import 'package:palio_lite/call/widgets/editor_vc.dart';
import 'package:palio_lite/call/widgets/remote.dart';
import 'package:palio_lite/chat/widgets/widget_Image_Download.dart';
import 'package:palio_lite/conference/widgets/join_like_live.dart';
import 'package:palio_lite/conference/widgets/join_view_live.dart';
import 'package:palio_lite/conference/widgets/list_person_ls.dart';
import 'package:palio_lite/db_helper.dart';
import 'package:shared_preferences/shared_preferences.dart';

class JoinLs extends StatefulWidget {
  final String name;
  final String title;
  final String f_pin;
  final String privacy;
  final String device_id;
  final String desc;

  JoinLs(
      {required this.name,
      required this.f_pin,
      required this.privacy,
      this.device_id = "",
      required this.desc,
      required this.title});

  _JoinLsState createState() => _JoinLsState();
}

class _JoinLsState extends State<JoinLs> {
  String language = "";
  bool isLiked = false;
  String f_pin = "";
  String name = "";
  String title = "";
  String privacy = "";
  String device_id = "";
  String defTag = "Test";
  int sizeFlag = 3;
  String thumb_id = "";
  String idMe = "";
  bool muted = false, backCam = false;
  int like = 0;
  int view = 0;
  String bdName = "";
  List<String> userLS = [];
  List<String> imageUserLs = [];
  List<Map<String, String>> personData = [];
  TextEditingController? _titleController;
  TextEditingController? _tagLineController;
  ScrollController? _controller;
  List<String> dataSelf = [];
  List<Map<dynamic, dynamic>> samplemessages = [
//    {"originator": "Dea Rahman", "content": "TEST123"},
//    {
//      "originator": "Yayan",
//      "content":
//          "ashdudghsdghjsdfhjsdfjhsdjgsfdghjsfdgsgdfsgdfsdfsjgdfsgdfgsdfgsdfgsdgsdsd"
//    },
//    {"originator": "Qindi", "content": "sdhsugdsdjsfguyscjkscschscuacsduyasdgiabfahfvdahkcahjsdgjhsabdjhasvdgshjdasghjdgshadghjsagdhjsgdusagud"}
  ];

  Timer? _timer;

  void getDataLS() {
    _timer = new Timer.periodic(Duration(seconds: 2), (Timer timer) async {
      API.getLSData(f_pin);
    });
  }

  void _changeTitle() {
    showDialog(
        context: context,
        builder: (context) {
          return CupertinoAlertDialog(
              insetAnimationCurve: Curves.easeInBack,
              title: Text("Title"),
              content: Container(
                margin: EdgeInsets.only(top: 10),
                child: CupertinoTextField(
                  controller: _titleController,
                  cursorColor: AppColor.primaryColor,
                ),
              ),
              actions: <Widget>[
                CupertinoDialogAction(
                  onPressed: () => Navigator.pop(context),
                  child: Text("Cancel",
                      style: TextStyle(
                          color: AppColor.primaryColor, fontSize: 14)),
                ),
                CupertinoDialogAction(
                  onPressed: () {
                    Navigator.pop(context);
                    setState(() {
//                      API.updateLSTitle("1~"+_titleController.text+String.fromCharCode(9632)+_tagLineController.text);
                    });
                  },
                  child: Text("OK",
                      style: TextStyle(
                          color: AppColor.primaryColor, fontSize: 14)),
                )
              ]);
        });
  }

  Future<List<String>> getData() async {
    SharedPreferences prefs = await SharedPreferences.getInstance();
    idMe = prefs.getString("hasLogin") ?? "";
    language = prefs.getString("language") ?? "";
    var resultQueryBuddy = await DBHelper().queryCustom(
        "SELECT f_pin,first_name, last_name FROM BUDDY WHERE f_pin='" +
            idMe +
            "'");
    dataSelf.add(resultQueryBuddy[0]['f_pin']);
    dataSelf.add(resultQueryBuddy[0]['first_name'] +
        " " +
        resultQueryBuddy[0]['last_name']);
    print("Data Self Done");
    setState(() {});
    return dataSelf;
  }

  Future<void> getBCData(String f_pin) async {
    var resultQueryBuddy = await DBHelper().queryCustom(
        "SELECT first_name, last_name, image_id FROM BUDDY WHERE f_pin='$f_pin'");
    bdName = resultQueryBuddy[0]['first_name'] +
        " " +
        resultQueryBuddy[0]['last_name'];
    thumb_id = resultQueryBuddy[0]['image_id'];
    print("Data BC Done");
    setState(() {});
  }

  void updateLS() {
    API.onJoinLS = (int state, String message) {
      print("Message onJoin $state $message");
      if (state == 999) {
        print("Message Title $message");
        String datas = message.split("~")[1];
        var datax = datas.split(String.fromCharCode(9632));
        print("data string " + datax[0] + " " + datax[1]);
        //Update LS
        title = datax[0];
        _tagLineController?.text = datax[1];
        setState(() {});
      } else if (state == 88) {
        //Exit LS
        Navigator.pop(context);
        // Navigator.pushReplacement(context,
        //     PageTransition(type: PageTransitionType.fade, child: Home(index: 1,)));
      } else if (state == 95) {
        print("pesan dari " +
            message.split(",")[4] +
            " berupa " +
            message.split(",")[3]);
        //LS Chat
        samplemessages.insert(0, {
          "originator": message.split(",")[3],
          "content": message.split(",")[4],
          "thumbnail": message.split(",")[1]
        });
        _controller?.jumpTo(_controller!.position.minScrollExtent);
        setState(() {});
      } else if (state == 96) {
        print("jumlah like " + message.split(",")[1]);
        //LS Like
        like = int.parse(message.split(",")[1]);
        setState(() {});
      } else if (state == 97) {
        print("view " +
            message.split(",")[4] +
            " user " +
            message.split(",")[3] +
            " ");
        //LS Leave
        view = int.parse(message.split(",")[4]);

        String message_leave = "";
        message_leave = message.split(",")[3] + " Leaving";
        print("message leave $message_leave");
        samplemessages.insert(0, {
          "originator": message.split(",")[3],
          "content": message.split(",")[3] + "Leaving",
          "thumbnail": message.split(",")[1]
        });
        _controller?.jumpTo(_controller!.position.minScrollExtent);
        // personData.removeAt(view);
        userLS.remove(message.split(",")[3]);
        imageUserLs.remove(message.split(",")[1]);
        setState(() {});
      } else if (state == 98) {
        print("view " +
            message.split(",")[4] +
            " user " +
            message.split(",")[3] +
            " ");
        //LS Join
        view = int.parse(message.split(",")[4]);

        String message_join = "";
        message_join = message.split(",")[3] + " Joined";
        print("message join $message_join");
        // view = view + 1;
        samplemessages.insert(0, {
          "originator": message.split(",")[3],
          "content": message_join,
          "thumbnail": message.split(",")[1]
        });
        _controller?.jumpTo(_controller!.position.minScrollExtent);
        // personData.add({"name":message.split(",")[3],"picture":message.split(",")[1]});
        userLS.add(message.split(",")[3]);
        imageUserLs.add(message.split(",")[1]);
        setState(() {});
      } else if (state == 94) {
        //LS Join
        like = int.parse(message.split(",")[2]);
        view = int.parse(message.split(",")[5]);
        setState(() {});
      }
    };
    API.onStartLS = (int state, String message) {
      print("Message onStart $state $message");
    };
  }

  void _changeTagLine() {
    showDialog(
        context: context,
        builder: (context) {
          return CupertinoAlertDialog(
              insetAnimationCurve: Curves.easeInBack,
              title: Text("Tag Line"),
              content: Container(
                margin: EdgeInsets.only(top: 10),
                child: CupertinoTextField(
                  controller: _tagLineController,
                  cursorColor: AppColor.primaryColor,
                ),
              ),
              actions: <Widget>[
                CupertinoDialogAction(
                  onPressed: () => Navigator.pop(context),
                  child: Text("Cancel",
                      style: TextStyle(
                          color: AppColor.primaryColor, fontSize: 14)),
                ),
                CupertinoDialogAction(
                  onPressed: () {
                    setState(() {
//                      API.updateLSTitle("1~"+_titleController.text+String.fromCharCode(9632)+_tagLineController.text);
                    });
                    Navigator.pop(context);
                  },
                  child: Text("OK",
                      style: TextStyle(
                          color: AppColor.primaryColor, fontSize: 14)),
                )
              ]);
        });
  }

  @override
  void initState() {
    super.initState();
    f_pin = widget.f_pin;
    name = widget.name;
    title = widget.title;
    privacy = widget.privacy;
    device_id = widget.device_id;
    defTag = widget.desc;
    if (defTag.isEmpty) {
      defTag = "Live Video Promotion";
    }
    _titleController = TextEditingController(text: title);
    _tagLineController = TextEditingController(text: defTag);
    _controller = new ScrollController();
    Future.delayed(Duration(seconds: 2)).then((value) {
      API.joinLS(f_pin);
      DateTime dateTime = new DateTime.now();
      int timeNow = dateTime.millisecondsSinceEpoch;
      String request_id = timeNow.toRadixString(16);
      API.joinLiveVideo(f_pin, request_id);
    });
    updateLS();
    getData();
    getBCData(f_pin);
    // getDataLS();
//    joinLS(f_pin);
  }

  @override
  void dispose() {
    if (_timer != null) {
      _timer?.cancel();
    }
    _titleController?.dispose();
    _tagLineController?.dispose();
    _controller?.dispose();
    super.dispose();
  }

//  Future<void> joinLS(String device_id) async {
//    if (mounted) {
//      setState(() {
//        Future.delayed(Duration(seconds: 2)).then((value) {
//          API.joinLS(device_id);
//        });
////        API.startLS("Live Video Promotion", 1);
////        API.sendLSBroadcast("1~Live Video Promotion", privacy, "", "3");
//      });
//    }
//  }

  @override
  Widget build(BuildContext context) {
    return SafeArea(
      child: Scaffold(
        body: Container(
          color: Colors.black,
          child: Stack(
            children: <Widget>[
              _cameraView(),
              Column(
                mainAxisAlignment: MainAxisAlignment.spaceBetween,
              ),
              Column(
                children: <Widget>[
                  Container(
                    margin: EdgeInsets.only(left: 10, right: 10, top: 10),
                    child: Row(
                      mainAxisAlignment: MainAxisAlignment.spaceBetween,
                      children: <Widget>[
                        Row(
                          mainAxisAlignment: MainAxisAlignment.start,
                          children: <Widget>[
                            Container(
                                width: 40.0,
                                height: 40.0,
                                decoration: new BoxDecoration(
                                    shape: BoxShape.circle,
                                    image: new DecorationImage(
                                        fit: BoxFit.fill,
                                        image: thumb_id.isEmpty
                                            ? NetworkImage(
                                                "https://cdn.pixabay.com/photo/2012/04/26/19/47/man-42934_1280.png")
                                            : LocalImage(thumb_id)
                                                as ImageProvider))),
                            Column(
                              mainAxisAlignment: MainAxisAlignment.spaceBetween,
                              children: <Widget>[
                                Row(
                                  children: <Widget>[
                                    Text(
                                      bdName,
                                      style: TextStyle(color: Colors.white),
                                    )
                                  ],
                                ),
                                Row(
                                  children: <Widget>[
                                    JoinViewLive(
                                      (() async {
                                        final dest = await Navigator.push(
                                            context,
                                            PageTransition(
                                                type: PageTransitionType.fade,
                                                child: ShowLSUsers(
                                                  user: userLS,
                                                  image: imageUserLs,
                                                )));
                                      }),
                                      view: view.toString(),
                                    ),
                                    SizedBox(width: 10.0),
                                    JoinLikeLive(
                                      (() async {
                                        if (mounted) {
                                          if (!isLiked) {
                                            API.sendLSEmotion(f_pin, "2");
                                            isLiked = true;
                                          }
                                        }
                                      }),
                                      like: like.toString(),
                                    )
                                  ],
                                ),
                              ],
                            ),
                          ],
                        ),
                        Material(
                          color: Colors.transparent,
                          child: InkWell(
                            onTap: () {
                              showDialog(
                                  context: context,
                                  builder: (context) {
                                    return CupertinoAlertDialog(
                                        insetAnimationCurve: Curves.easeInBack,
                                        title:
                                            Text("End Live Video Promotion?"),
                                        content: Container(
                                          margin: EdgeInsets.only(top: 10),
                                          child: Text(
                                            "Live Video Promotion session still running. End?",
                                            textAlign: TextAlign.start,
                                          ),
                                        ),
                                        actions: <Widget>[
                                          CupertinoDialogAction(
                                            onPressed: () =>
                                                Navigator.pop(context),
                                            child: Text("CONTINUE",
                                                style: TextStyle(
                                                    color:
                                                        AppColor.primaryColor,
                                                    fontSize: 14)),
                                          ),
                                          CupertinoDialogAction(
                                            onPressed: () {
                                              if (_timer != null) {
                                                _timer?.cancel();
                                              }
                                              DateTime dateTime =
                                                  new DateTime.now();
                                              int timeNow = dateTime
                                                  .millisecondsSinceEpoch;
                                              String request_id =
                                                  timeNow.toRadixString(16);
                                              API.leftLiveVideo(
                                                  f_pin, request_id);
                                              API.leftLS(f_pin);
                                              Navigator.pop(context);
                                              Navigator.pop(context);
                                              // Navigator.pushReplacement(context,
                                              //     PageTransition(type: PageTransitionType.fade, child: Home(index: 1,)));
                                            },
                                            child: Text("FINISH",
                                                style: TextStyle(
                                                    color:
                                                        AppColor.primaryColor,
                                                    fontSize: 14)),
                                          )
                                        ]);
                                  });
                            },
                            child: Container(
                              padding: EdgeInsets.all(10.0),
                              child: Text("X",
                                  style: TextStyle(
                                      color: Colors.white,
                                      fontWeight: FontWeight.bold,
                                      fontSize: 20.0)),
                            ),
                          ),
                        )
                      ],
                    ),
                  ),
                  Row(
                    mainAxisAlignment: MainAxisAlignment.spaceBetween,
                    children: <Widget>[
                      Container(
                        margin: EdgeInsets.only(left: 10),
                        child: Row(
                          children: <Widget>[
                            Text(
                              title,
                              style: TextStyle(color: Colors.white),
                            ),
                            SizedBox(
                              width: 8,
                            ),
                            InkWell(
                              onTap: () {},
                              child: Container(),
                            ),
                          ],
                        ),
                      ),
//                      ChangeCameraLive(() {})
                    ],
                  ),
                ],
              ),
              _chat()
            ],
          ),
        ),
      ),
    );
  }

  Widget _cameraView() {
    return Container(
        width: MediaQuery.of(context).size.width,
        height: MediaQuery.of(context).size.height * 0.7,
        child: Remote()
//      Container(),
        );
  }

  Widget _chat() {
    return Container(
      padding: EdgeInsets.only(top: MediaQuery.of(context).size.height * 0.3),
      child: Column(
        children: <Widget>[
          Expanded(
            child: FadingEdgeScrollView.fromScrollView(
              child: CustomScrollView(
                shrinkWrap: true,
                reverse: true,
                controller: _controller,
                slivers: <Widget>[
                  SliverList(
                      delegate: SliverChildBuilderDelegate((context, index) {
                    var data = samplemessages[index];
                    return Padding(
                      padding: EdgeInsets.only(top: 8.0),
                      child: GestureDetector(
                        child: BubbleVc(
                          originator: data['originator'],
                          content: data['content'],
                          thumbnail: data['thumbnail'],
                        ),
                        onTap: () {},
                      ),
                    );
                  }, childCount: samplemessages.length))
                ],
              ),
            ),
          ),
          EditorVc(
            onPressed: (val) async {
              getData().then((value) {
                print("data " + value.toString());
                var obj = {"originator": value[1], "content": val['content']};
                setState(() {
                  samplemessages.insert(0, obj);
                  _controller?.jumpTo(_controller!.position.minScrollExtent);
                  API.sendLSChat(f_pin, val['content'].toString());
                });
              });
            },
          ),
          Container(
            padding: EdgeInsets.only(left: 5, right: 5),
            child: Row(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: <Widget>[
                Container(
                  height: 15,
                  width: MediaQuery.of(context).size.width * 0.9,
                  color: Colors.transparent,
                  child: Marquee(
                    crossAxisAlignment: CrossAxisAlignment.start,
                    blankSpace: 20.0,
                    text: _tagLineController!.text,
                    style: TextStyle(color: Colors.white, fontSize: 12),
                  ),
                ),
              ],
            ),
          )
        ],
      ),
    );
  }
}
