import 'dart:convert';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:page_transition/page_transition.dart';
import 'package:palio_lite/api.dart';
import 'package:palio_lite/app_color.dart';
import 'package:palio_lite/conference/video_conference.dart';
import 'package:palio_lite/conference/widgets/button_join.dart';
import 'package:palio_lite/conference/widgets/calendar_form.dart';
import 'package:palio_lite/conference/widgets/time_form.dart';
import 'package:palio_lite/db_helper.dart';
import 'package:shared_preferences/shared_preferences.dart';

class JoinConferenceRoom extends StatefulWidget {
  List<String> members;
  String title;
  String f_pin;
  String blog_id;
  int time;

  JoinConferenceRoom(
      {required this.members,
      required this.title,
      required this.f_pin,
      required this.blog_id,
      required this.time});

  @override
  _JoinConferenceRoomState createState() => _JoinConferenceRoomState();
}

class _JoinConferenceRoomState extends State<JoinConferenceRoom> {
  TextEditingController judul = TextEditingController();
  List<String> nameChosen = [];
  List<String> fpinChosen = [];
  String name = "";
  String f_pin = "";
  String title = "";
  String blog_id = "";
  int tanggal = 0;
  int bulan = 0;
  int tahun = 0;
  int jam = 0;
  int menit = 0;
  int timeVal = DateTime.now().millisecondsSinceEpoch;
  int timeValDate = DateTime.now().millisecondsSinceEpoch;
  String myselfFpin = "";

  Future<void> getData(List<String> fpin_person) async {
    print("fpin person " + fpin_person.toString());
    String listfpin = "";
    for (int x = 0; x < fpin_person.length; x++) {
      if (x == 0) {
        listfpin = listfpin + "'" + fpin_person[x] + "'";
      } else {
        listfpin = listfpin + "," + "'" + fpin_person[x] + "'";
      }
    }
    print("list fpin $listfpin");
    String query =
        "SELECT first_name, last_name FROM BUDDY WHERE f_pin in ($listfpin)";
    List<dynamic> resultQueryBuddy = await DBHelper().queryCustom(query);
    for (int y = 0; y < resultQueryBuddy.length; y++) {
      if (resultQueryBuddy[y]['last_name'].toString().isEmpty) {
        nameChosen.add(resultQueryBuddy[y]['first_name']);
      } else {
        nameChosen.add(resultQueryBuddy[y]['first_name'] +
            " " +
            resultQueryBuddy[y]['last_name']);
      }
    }
    print("Data : " + nameChosen.toString());
    print("Data Person Done");
    setState(() {});
  }

  Future<void> getSelfData() async {
    var resultQueryBuddy = await DBHelper().queryCustom(
        "SELECT f_pin,first_name, last_name FROM BUDDY WHERE f_pin='${widget.f_pin}'");
    if (resultQueryBuddy[0]['last_name'].toString().isEmpty) {
      name = resultQueryBuddy[0]['first_name'];
    } else {
      name = resultQueryBuddy[0]['first_name'] +
          " " +
          resultQueryBuddy[0]['last_name'];
    }

    final SharedPreferences prefs = await SharedPreferences.getInstance();
    myselfFpin = prefs.getString("hasLogin") ?? "";
    print("Data Self Done");
  }

  @override
  void initState() {
    super.initState();
    fpinChosen = widget.members;
    getData(fpinChosen);
    getSelfData();
    f_pin = widget.f_pin;
    title = widget.title;
    blog_id = widget.blog_id;
    timeVal = widget.time;
    timeValDate = widget.time;
    print("fpin " +
        f_pin +
        " title " +
        title +
        " time " +
        timeVal.toString() +
        " blog_id" +
        blog_id +
        " member " +
        fpinChosen.toString());
    judul.text = title;
  }

  String getVCRoomData(String title, int time, String f_pin) {
    Map<String, dynamic> jsondata = Map();
    jsondata.putIfAbsent("title", () => title);
    jsondata.putIfAbsent("by", () => f_pin);
    jsondata.putIfAbsent("time", () => time);
    jsondata.putIfAbsent("members", () => json.decode(fpinChosen.toString()));
    return json.encode(jsondata).toString();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        iconTheme: IconThemeData(color: Colors.white),
        title: Text("Video Conference Room",
            style: TextStyle(color: Colors.white)),
        backgroundColor: AppColor.primaryColor,
      ),
      backgroundColor: Colors.white,
      body: Stack(
        children: <Widget>[
          SingleChildScrollView(
            child: Column(
              crossAxisAlignment: CrossAxisAlignment.start,
              children: <Widget>[
                Container(
                  child: Text("Title" + " *",
                      style: TextStyle(color: Colors.grey)),
                  padding: EdgeInsets.only(left: 10.0, top: 5.0),
                ),
                Container(
                  padding: EdgeInsets.only(left: 10.0, right: 10.0),
                  child: TextField(
                    enabled: false,
                    cursorColor: Colors.black,
                    controller: judul,
                    decoration: InputDecoration(
                        border: InputBorder.none,
                        contentPadding: EdgeInsets.only(top: -20.0)),
                  ),
                ),
                Divider(height: 0.0, color: Colors.grey),
                SizedBox(height: 10.0),
                Container(
                  child: Text("Video Conference Room Time*",
                      style: TextStyle(color: Colors.grey)),
                  padding: EdgeInsets.only(left: 10.0, top: 5.0),
                ),
                AbsorbPointer(
                  absorbing: true,
                  child: Container(
                    padding: EdgeInsets.only(left: 10.0, right: 10.0),
                    margin: EdgeInsets.only(top: 5.0, bottom: 10.0),
                    child: Row(
                      mainAxisAlignment: MainAxisAlignment.start,
                      children: <Widget>[
                        CalendarForm(
                            times: timeValDate,
                            date: (date) {
                              List<String> dataTanggal = date.split("-");
                              tahun = int.parse(dataTanggal[2]);
                              bulan = int.parse(dataTanggal[1]);
                              tanggal = int.parse(dataTanggal[0]);
                              setState(() {
                                timeValDate =
                                    DateTime(tahun, bulan, tanggal, jam, menit)
                                        .millisecondsSinceEpoch;
                              });
                            }),
                        SizedBox(width: 10.0),
                        TimeForm(
                            timeValue: timeVal,
                            time: (time) {
                              List<String> dataWaktu = time.split(":");
                              menit = int.parse(dataWaktu[1]);
                              jam = int.parse(dataWaktu[0]);
                              setState(() {
                                timeVal =
                                    DateTime(tahun, bulan, tanggal, jam, menit)
                                        .millisecondsSinceEpoch;
                              });
                            })
                      ],
                    ),
                  ),
                ),

                Divider(height: 0.0, color: Colors.grey),
                SizedBox(height: 10.0),
                Container(
                  child: Text("Participants" + " *",
                      style: TextStyle(color: Colors.grey)),
                  padding: EdgeInsets.only(left: 10.0, top: 5.0),
                  margin: EdgeInsets.only(bottom: 5.0),
                ),
                Container(
                  margin: EdgeInsets.only(bottom: 10.0),
                  padding: EdgeInsets.only(left: 10.0, right: 10.0),
                  child: Wrap(
                    children: List.generate(
                        nameChosen.length,
                        (index) => Container(
                              padding: EdgeInsets.all(10.0),
                              width: MediaQuery.of(context).size.width * 0.45,
                              height: 50,
                              decoration: BoxDecoration(
                                  border: Border.all(color: Colors.black),
                                  borderRadius: BorderRadius.circular(3.0)),
                              child: Row(
                                mainAxisAlignment:
                                    MainAxisAlignment.spaceBetween,
                                children: <Widget>[
                                  Expanded(
                                    child: Row(
                                      mainAxisAlignment:
                                          MainAxisAlignment.start,
                                      children: <Widget>[
                                        Icon(Icons.person,
                                            color: Colors.grey[600]),
                                        SizedBox(width: 10.0),
                                        Text(
                                          nameChosen[index],
                                          overflow: TextOverflow.ellipsis,
                                        ),
                                      ],
                                    ),
                                  ),
                                ],
                              ),
                            )),
                    spacing: 15.0,
                    runSpacing: 10.0,
                  ),
                ),
                // AddMember(listMembers: (name) {
                //   setState(() {
                //     nameChosen.add(name.split("~")[0]);
                //     fpinChosen.add(name.split("~")[1]);
                //     print(nameChosen.toString());
                //     print(fpinChosen.toString());
                //   });
                // }),
                SizedBox(height: 20.0),
                Divider(height: 0.0, color: Colors.grey),
              ],
            ),
          ),
          Align(
            alignment: Alignment.bottomCenter,
            child: Container(
              alignment: Alignment.centerRight,
              width: double.infinity,
              height: 60,
              child: ButtonJoin(() {
                if (myselfFpin == f_pin) {
                  Navigator.push(
                      context,
                      PageTransition(
                          type: PageTransitionType.fade,
                          child: VCRoom(
                            title: title,
                            name: name,
                            cameraId: 1,
                            isInitiatior: 1,
                            mId: blog_id,
                            f_pin: f_pin,
                          )));
                } else {
                  API.joinCRoom(blog_id);
                  Navigator.push(
                      context,
                      PageTransition(
                          type: PageTransitionType.fade,
                          child: VCRoom(
                            title: title,
                            name: name,
                            cameraId: 1,
                            isInitiatior: 0,
                            mId: blog_id,
                            f_pin: f_pin,
                          )));
                }
              }, myselfFpin == f_pin ? true : false),
            ),
          )
        ],
      ),
    );
  }
}
