import 'dart:math';

import 'package:fading_edge_scrollview/fading_edge_scrollview.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter/painting.dart';
import 'package:flutter/services.dart';
import 'package:fluttertoast/fluttertoast.dart';
import 'package:marquee/marquee.dart';

// import 'package:un_ios_app/Screen/add_call.dart';
// import 'package:un_ios_app/Widget/bubble_vc.dart';
// import 'package:un_ios_app/Widget/change_camera.dart';
// import 'package:un_ios_app/Widget/change_remote.dart';
// import 'package:un_ios_app/Widget/editor_vc.dart';
// import 'package:un_ios_app/Widget/camera.dart';
// import 'package:un_ios_app/Widget/show_user_list.dart';
// import 'package:un_ios_app/Widget/view_live.dart';
// import 'package:un_ios_app/api.dart';
import 'package:page_transition/page_transition.dart';
import 'package:palio_lite/app_color.dart';

class SeminarScreen extends StatefulWidget {
  final String name;
  final String f_pin;
  final String privacy;

  SeminarScreen(
      {required this.name, required this.f_pin, required this.privacy});

  @override
  _SeminarScreenState createState() => _SeminarScreenState();
}

class _SeminarScreenState extends State<SeminarScreen> {
  String f_pin = "";
  String name = "";
  String privacy = "";
  int sizeFlag = 3;
  bool muted = false, backCam = false;
  bool handsUp = false;
  TextEditingController? _titleController;
  TextEditingController? _tagLineController;
  ScrollController? _controller;
  List<Map<dynamic, dynamic>> samplemessages = [
//    {"originator": "Dea Rahman", "content": "TEST123"},
//    {
//      "originator": "Yayan",
//      "content":
//          "ashdudghsdghjsdfhjsdfjhsdjgsfdghjsfdgsgdfsgdfsdfsjgdfsgdfgsdfgsdfgsdgsdsd"
//    },
//    {
//      "originator": "Qindi",
//      "content":
//          "sdhsugdsdjsfguyscjkscschscuacsduyasdgiabfahfvdahkcahjsdgjhsabdjhasvdgshjdasghjdgshadghjsagdhjsgdusagud"
//    }
  ];

  void _changeTitle() {
    showDialog(
        context: context,
        builder: (context) {
          return CupertinoAlertDialog(
              insetAnimationCurve: Curves.easeInBack,
              title: Text("Title"),
              content: Container(
                margin: EdgeInsets.only(top: 10),
                child: CupertinoTextField(
                  controller: _titleController,
                  cursorColor: AppColor.primaryColor,
                ),
              ),
              actions: <Widget>[
                CupertinoDialogAction(
                  onPressed: () => Navigator.pop(context),
                  child: Text("Cancel",
                      style: TextStyle(
                          color: AppColor.primaryColor, fontSize: 14)),
                ),
                CupertinoDialogAction(
                  onPressed: () {
                    Navigator.pop(context);
                    setState(() {
//                      API.updateLSTitle("1~"+_titleController.text+String.fromCharCode(9632)+_tagLineController.text);
                    });
                  },
                  child: Text("OK",
                      style: TextStyle(
                          color: AppColor.primaryColor, fontSize: 14)),
                )
              ]);
        });
  }

  void _changeTagLine() {
    showDialog(
        context: context,
        builder: (context) {
          return CupertinoAlertDialog(
              insetAnimationCurve: Curves.easeInBack,
              title: Text("Tag Line"),
              content: Container(
                margin: EdgeInsets.only(top: 10),
                child: CupertinoTextField(
                  controller: _tagLineController,
                  cursorColor: AppColor.primaryColor,
                ),
              ),
              actions: <Widget>[
                CupertinoDialogAction(
                  onPressed: () => Navigator.pop(context),
                  child: Text("Cancel",
                      style: TextStyle(
                          color: AppColor.primaryColor, fontSize: 14)),
                ),
                CupertinoDialogAction(
                  onPressed: () {
                    setState(() {
//                      API.updateLSTitle("1~"+_titleController.text+String.fromCharCode(9632)+_tagLineController.text);
                    });
                    Navigator.pop(context);
                  },
                  child: Text("OK",
                      style: TextStyle(
                          color: AppColor.primaryColor, fontSize: 14)),
                )
              ]);
        });
  }

  @override
  void initState() {
    super.initState();
    f_pin = widget.f_pin;
    name = widget.name;
    privacy = widget.privacy;
    _titleController = TextEditingController(text: "Live Streaming");
    _tagLineController = TextEditingController(
        text:
            "UM provides Live Streaming, various Content, Chat and Video Call services in one application");
    _controller = new ScrollController();
  }

  @override
  void dispose() {
    super.dispose();
  }

  Future<void> startLS(String privacy) async {
    if (mounted) {
      setState(() {
//        API.startLS("Live Streaming", 1);
//        API.sendLSBroadcast("1~Live Streaming", privacy, "", "3");
      });
    }
  }

  @override
  Widget build(BuildContext context) {
//    startLS(privacy);
    return SafeArea(
      child: Scaffold(
        body: Container(
          color: Colors.brown,
          child: Stack(
            children: <Widget>[
              _cameraView(),
              Column(
                mainAxisAlignment: MainAxisAlignment.spaceBetween,
              ),
              Column(
                mainAxisAlignment: MainAxisAlignment.spaceBetween,
                children: <Widget>[
                  Column(
                    children: [
                      Container(
                        margin: EdgeInsets.only(left: 10, right: 10, top: 10),
                        child: Row(
                          mainAxisAlignment: MainAxisAlignment.spaceBetween,
                          children: <Widget>[
                            // ViewLive(() {}),
                            Container(
                              margin: EdgeInsets.only(left: 10),
                              child: Row(
                                children: <Widget>[
                                  InkWell(
                                    onTap: () {
                                      _changeTitle();
                                    },
                                    child: Text(
                                      "Seminar",
                                      style: TextStyle(color: Colors.white),
                                    ),
                                  ),
                                ],
                              ),
                            ),
                            Material(
                              color: Colors.transparent,
                              child: InkWell(
                                onTap: () {
                                  showDialog(
                                      context: context,
                                      builder: (context) {
                                        return CupertinoAlertDialog(
                                            insetAnimationCurve:
                                                Curves.easeInBack,
                                            title: Text("End Live Streaming?"),
                                            content: Container(
                                              margin: EdgeInsets.only(top: 10),
                                              child: Text(
                                                "Live Streaming session still running. End?",
                                                textAlign: TextAlign.start,
                                              ),
                                            ),
                                            actions: <Widget>[
                                              CupertinoDialogAction(
                                                onPressed: () =>
                                                    Navigator.pop(context),
                                                child: Text("CONTINUE",
                                                    style: TextStyle(
                                                        color: AppColor
                                                            .primaryColor,
                                                        fontSize: 14)),
                                              ),
                                              CupertinoDialogAction(
                                                onPressed: () {
//                                                leftLS(f_pin);
//                                                API.endLS();
                                                  Navigator.pop(context);
                                                  Navigator.pop(context);
                                                  Navigator.pop(context);
                                                },
                                                child: Text("FINISH",
                                                    style: TextStyle(
                                                        color: AppColor
                                                            .primaryColor,
                                                        fontSize: 14)),
                                              )
                                            ]);
                                      });
                                },
                                child: Container(
                                  padding: EdgeInsets.all(10.0),
                                  child: Text("End",
                                      style: TextStyle(
                                          color: Colors.white,
                                          fontWeight: FontWeight.bold)),
                                ),
                              ),
                            )
                          ],
                        ),
                      ),
                      Row(
                        mainAxisAlignment: MainAxisAlignment.end,
                        children: <Widget>[
                          //   ChangeRemoteLive(() async {
                          //   if(mounted){
                          //     final dest = await Navigator.push(context, PageTransition(
                          //         type: PageTransitionType.fade,
                          //         child: ShowUser()
                          //     ));
                          //     print("output text : "+dest.toString() );
                          //     if(dest.toString().length > 0){
                          //       setState(() {
                          //         handsUp = !handsUp;
                          //       });
                          //     }
                          //   }
                          // })
                        ],
                      ),
                      SizedBox(
                        height: 5.0,
                      ),
                      Row(
                        mainAxisAlignment: MainAxisAlignment.end,
                        children: <Widget>[
                          //   ChangeCameraLive(()  {
                          //
                          // })
                        ],
                      ),
                      SizedBox(height: 5.0),
                    ],
                  ),
                  Visibility(
                    visible: handsUp,
                    child: Row(
                      mainAxisAlignment: MainAxisAlignment.end,
                      crossAxisAlignment: CrossAxisAlignment.end,
                      children: <Widget>[
                        InkWell(
                          onTap: () {},
                          child: Container(
                              margin: EdgeInsets.only(right: 10.0),
                              padding: EdgeInsets.fromLTRB(0, 0, 10, 80),
                              child: _remoteView()),
                        ),
//                        GestureDetector(
//                          onPanUpdate: (detail){
//                            if(detail.delta.dx > 0){
//                              print("NTAB");
//                            }
//                          },
//                          onTap: (){
//                            if(mounted){
//                              setState(() {
//                                print("handsup status : "+handsUp.toString());
//                                handsUp = !handsUp;
//                              });
//                            }
//                          },
//                          child: Container(
//                              margin: EdgeInsets.only(rig ht: 10.0),
//                              padding: EdgeInsets.fromLTRB(0, 0, 10, 80),
//                              child: _remoteView()),
//                        )
                      ],
                    ),
                  ),
                ],
              ),
              _chat()
            ],
          ),
        ),
      ),
    );
  }

  Widget _cameraView() {
    return Container(
      child:
//          Camera()
          Container(),
    );
  }

  Widget _remoteView() {
    return Container(
      height: MediaQuery.of(context).size.height * 0.25,
      width: MediaQuery.of(context).size.width * 0.3,
      color: Colors.grey,
      child:
//          Camera()
          Container(),
    );
  }

  Widget _chat() {
    return Container(
      padding: EdgeInsets.only(top: MediaQuery.of(context).size.height * 0.3),
      child: Column(
        children: <Widget>[
          Expanded(
            child: FadingEdgeScrollView.fromScrollView(
              child: CustomScrollView(
                shrinkWrap: true,
                reverse: true,
                controller: _controller,
                slivers: <Widget>[
                  // SliverList(
                  //     delegate: SliverChildBuilderDelegate((context, index) {
                  //   var data = samplemessages[index];
                  //   return Padding(
                  //     padding: EdgeInsets.only(top: 8.0),
                  //     child: GestureDetector(
                  //       child: BubbleVc(
                  //         originator: data['originator'],
                  //         content: data['content'],
                  //         thumbnail: data['thumbnail'],
                  //       ),
                  //       onTap: () {},
                  //     ),
                  //   );
                  // }, childCount: samplemessages.length))
                ],
              ),
            ),
          ),
//           EditorVc(
//             onPressed: (val) async {
//               var obj = {"originator": f_pin, "content": val['content']};
//               setState(() {
//                 samplemessages.insert(0, obj);
//                 _controller.jumpTo(_controller.position.minScrollExtent);
// //                API.sendLSChat(f_pin, val['content'].toString());
//               });
//             },
//           ),
//          Container(
//            padding: EdgeInsets.only(left: 5, right: 5),
//            child: Row(
//              mainAxisAlignment: MainAxisAlignment.spaceBetween,
//              children: <Widget>[
//                Container(
//                  height: 15,
//                  width: MediaQuery.of(context).size.width * 0.9,
//                  color: Colors.transparent,
//                  child: Marquee(
//                    crossAxisAlignment: CrossAxisAlignment.start,
//                    blankSpace: 20.0,
//                    text: _tagLineController.text,
//                    style: TextStyle(color: Colors.white, fontSize: 12),
//                  ),
//                ),
//                SizedBox(
//                  width: 8,
//                ),
//                InkWell(
//                  onTap: () {
//                    _changeTagLine();
//                  },
//                  child: Icon(
//                    CupertinoIcons.pencil,
//                    color: Colors.white,
//                    size: 18,
//                  ),
//                ),
//              ],
//            ),
//          )
        ],
      ),
    );
  }
}
