import 'dart:async';
import 'dart:collection';
import 'dart:ui';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter/painting.dart';
import 'package:flutter_translate/flutter_translate.dart';
import 'package:fluttertoast/fluttertoast.dart';
import 'package:page_transition/page_transition.dart';
import 'package:palio_lite/api.dart';
import 'package:palio_lite/app_color.dart';
import 'package:palio_lite/call/widgets/camera.dart';
import 'package:palio_lite/call/widgets/remote.dart';
import 'package:palio_lite/call/widgets/zoom.dart';
import 'package:palio_lite/db_helper.dart';
import 'package:palio_lite/palio_button.dart';
import 'package:shared_preferences/shared_preferences.dart';

class VCRoom extends StatefulWidget {
  String title;
  String name;
  final String mId;
  final int cameraId;
  final int isInitiatior;
  final int startTime;
  final String f_pin;

  VCRoom(
      {this.title = "",
      required this.name,
      required this.mId,
      required this.cameraId,
      required this.isInitiatior,
      this.startTime = 0,
      required this.f_pin});

  _VCRoom createState() => _VCRoom();
}

class _VCRoom extends State<VCRoom> {
  bool speaker = true;
  int sizeFlag = 3;
  bool muted = false, backCam = false, accept = false;
  int isInitiator = 0;
  var _videoCallIndex = <int>[];

  bool first = true;
  bool zoomOut = false;
  final _infoStrings = <String>[];
  LinkedHashSet<String> destinationList = LinkedHashSet();
  LinkedHashSet<String> deviceList = LinkedHashSet();
  Map<String, bool> speakerList = Map();
  int participants = 1;
  int speakerCount = 0;

  String subTitle = 'Video Call';
  String duration = "";
  double animatedWidth = 120.0;
  double opac = 1.0;
  ScrollController? _controller;

  String title = "";

  Future<void> setVideoCallFlag(int flag) async {
    final SharedPreferences prefs = await SharedPreferences.getInstance();
    prefs.setInt("isVideoCall", flag);
  }

  Future<String> getFPIN() async {
    final SharedPreferences prefs = await SharedPreferences.getInstance();
    return prefs.getString('hasLogin') ?? "";
  }

  Future<bool> setCRFlag(String isConfRoom) async {
    final SharedPreferences prefs = await SharedPreferences.getInstance();
    return prefs.setString("isConfRoom", isConfRoom);
  }

  Future<String> getCRFlag() async {
    final SharedPreferences prefs = await SharedPreferences.getInstance();
    return prefs.getString("isConfRoom") ?? "";
  }

  Future<String> getNameData(String f_pin) async {
    String name = "";
    var resultQueryBuddy = await DBHelper().queryCustom(
        "SELECT first_name, last_name FROM BUDDY WHERE f_pin='$f_pin'");
    if (resultQueryBuddy.length == 0) {
      await API.addFriend(f_pin);
      resultQueryBuddy = await DBHelper().queryCustom(
          "SELECT first_name, last_name FROM BUDDY WHERE f_pin='$f_pin'");
    }
    if (resultQueryBuddy[0]['last_name'].toString().isEmpty) {
      name = resultQueryBuddy[0]['first_name'];
    } else {
      name = resultQueryBuddy[0]['first_name'] +
          " " +
          resultQueryBuddy[0]['last_name'];
    }
    return name;
  }

  @override
  void initState() {
    _controller = new ScrollController();
    isInitiator = widget.isInitiatior;
    if (isInitiator == 1) {
      WidgetsBinding.instance?.addPostFrameCallback((_) {
        if (mounted) {
          API.initiateVCRoom(widget.mId, widget.cameraId);
          API.startCRoom(widget.mId, widget.startTime.toString());
          // API.setSpeaker(speaker);
        }
      });
    } else {
      WidgetsBinding.instance?.addPostFrameCallback((_) {
        if (mounted) {
          API.joinVCRoom(widget.mId, widget.cameraId);
          API.joinCRoom(widget.mId);
          // API.setSpeaker(speaker);
        }
      });
    }

    updateCR();
    super.initState();
  }

  @override
  void dispose() {
    destinationList.clear();
    // deviceList.clear();
    super.dispose();
  }

  void updateCR() {
    API.statusCall = (int state, String message) async {
      print("State vcr $state Message $message");
      if (state == 32) {
        if (destinationList.length < 16) {
          List<String> datax = message.split(",");
          for (int i = 0; i < datax.length; i++) {
            print("state vcr data " + datax[i] + " " + i.toString());
            if (i > 0 && i < datax.length - 4) {
              String userName = await getNameData(datax[i]);
              if (!destinationList.contains(userName)) {
                print("state vcr deviceid " + datax[i] + " username $userName");
                destinationList.add(userName);
                // deviceList.add(datax[i]);
                speakerList[datax[i]] = false;
                print("state vcr destination list " +
                    destinationList.length.toString() +
                    " destmap " +
                    destinationList.toString());
              }
            }
          }
          setState(() {});
        } else {
          Fluttertoast.showToast(
              msg: "Conference Room Members Already Full",
              toastLength: Toast.LENGTH_LONG);
        }
      } else if (state == 38) {
        String deviceId = message.split(",")[0];
        String userName = await getNameData(deviceId);
        print("state vcr deviceid $deviceId username $userName");
        destinationList.remove(userName);
        // deviceList.remove(deviceId);
        print("state vcr destination list " +
            destinationList.length.toString() +
            " destmap " +
            destinationList.toString());
        String myFpin = await getFPIN();
        print("SAME? $deviceId $myFpin");
        if (deviceId != myFpin && mounted) {
          if (deviceId == widget.f_pin) {
            Fluttertoast.showToast(
                msg: "Initiator Conference Room has lefted",
                toastLength: Toast.LENGTH_LONG);
            Navigator.pop(context);
            Future.delayed(Duration(seconds: 1), () async {
              API.terminateCall(widget.mId);
              API.endCRoom(widget.mId);
            });
          } else if (destinationList.length == 0) {
            Fluttertoast.showToast(
                msg: "All participants have lefted",
                toastLength: Toast.LENGTH_LONG);
            Navigator.pop(context);
            Future.delayed(Duration(seconds: 1), () async {
              API.terminateCall(widget.mId);
              API.endCRoom(widget.mId);
            });
          }
          setState(() {});
        }
      } else if (state == -3) {
        Fluttertoast.showToast(
            msg: "Room not found", toastLength: Toast.LENGTH_LONG);
        Navigator.pop(context);
      }
    };
    API.incomingCall = (int state, String message) {
      print("State vcr $state Message $message");
    };
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
          automaticallyImplyLeading: false,
          backgroundColor: AppColor.primaryColor,
          title: Text("Video Conference Room")),
      body: Center(
        child: Stack(
          children: <Widget>[_Views(), _remoteView(), _toolBar()],
        ),
      ),
    );
  }

  Widget _Views() {
    return SingleChildScrollView(
      child: GridView.count(
          physics: NeverScrollableScrollPhysics(),
          shrinkWrap: true,
          crossAxisCount: 3,
          children: List.generate(16, (index) {
            if (index == 0) {
              return _cameraView();
            }
            return Stack(
              children: [
                _remoteOtherView(""),
                (index - 1) >= destinationList.length ||
                        destinationList.elementAt(index - 1).isEmpty ||
                        destinationList.elementAt(index - 1) == null ||
                        destinationList.length == 1
                    ? Container()
                    : Align(
                        alignment: Alignment.bottomCenter,
                        child: Container(
                          decoration: BoxDecoration(
                              borderRadius: BorderRadius.circular(5.0),
                              color: Colors.black.withOpacity(0.5)),
                          padding: EdgeInsets.all(5.0),
                          child: Text(destinationList.elementAt(index - 1),
                              style: TextStyle(color: Colors.white)),
                        ),
                      )
              ],
            );
          })),
    );
  }

  Widget _remoteView() {
    return GestureDetector(
      child: Align(
        alignment: Alignment.center,
        child: Container(
          // color: Colors.transparent,
          width: MediaQuery.of(context).size.width,
          height: MediaQuery.of(context).size.height,
          child: Container(
            child: Zoom(),
            width: zoomOut ? 300 : MediaQuery.of(context).size.width,
            height: zoomOut ? 300 : MediaQuery.of(context).size.height,
          ),
        ),
      ),
      onTap: () {},
    );
  }

  Widget _topSection() {
    return Container(
      padding: EdgeInsets.all(10),
      height: MediaQuery.of(context).size.height * 0.3,
      color: Colors.transparent,
      child: Row(
        mainAxisAlignment: MainAxisAlignment.spaceBetween,
        children: <Widget>[
          _cameraView(),
        ],
      ),
    );
  }

  Widget _toolBar() {
    return Align(
      alignment: Alignment.bottomCenter,
      child: Padding(
        padding: EdgeInsets.only(bottom: 10.0),
        child: Wrap(
          direction: Axis.horizontal,
          spacing: 15,
          children: <Widget>[
            Container(
              width: 40,
              height: 40,
              decoration: BoxDecoration(
                  color: Colors.blueAccent, shape: BoxShape.circle),
              child: IconButton(
                icon: Icon(
                  speaker ? Icons.volume_up : Icons.volume_mute,
                  color: Colors.white,
                  size: 20.0,
                ),
                onPressed: () {
                  setState(() {
                    speaker = !speaker;
                  });
                  API.setSpeaker(speaker);
                },
              ),
            ),
//             Container(
//               width: 40,
//               height: 40,
//               decoration:
//               BoxDecoration(color: Colors.black26, shape: BoxShape.circle),
//               child: IconButton(
//                 icon: Icon(
//                   Icons.person_add,
//                   color: Colors.red,
//                   size: 20.0,
//                 ),
//                 onPressed: () async {
//                   if (participants < 16) {
//                     final dest = await Navigator.push(context, PageTransition(
//                         type: PageTransitionType.fade,
//                         child: AddCall()
//                     ));
//                     destinationList.add(dest);
//                     destMap.update("$participants",
//                             (value) => dest);
//                     dummyParticipant[participants] = dest;
//                     participants++;
//
//                     setState(() {});
//                     Fluttertoast.showToast(
//                       msg: "Participants: $participants",
//                       gravity: ToastGravity.BOTTOM,
//                       toastLength: Toast.LENGTH_SHORT,
//                     );
//                   }
//
// //                Fluttertoast.showToast(
// //                  msg: "Coming Soon",
// //                  gravity: ToastGravity.BOTTOM,
// //                  toastLength: Toast.LENGTH_SHORT,
// //                );
//                 },
//               ),
//             ),
//             Container(
//               width: 40,
//               height: 40,
//               decoration:
//               BoxDecoration(color: Colors.black, shape: BoxShape.circle),
//               child: IconButton(
//                 icon: Icon(
//                   Icons.person_outline,
//                   color: Colors.white,
//                   size: 20.0,
//                 ),
//                 onPressed: () {
//                   if (participants > 1) {
//                     participants--;
//                     destinationList.remove(dummyParticipant[participants]);
//                     destMap.update("$participants", (value) => "");
//                     if (!destinationList.contains(widget.name))
//                       widget.name = destinationList.first;
//                     // remote view change to first
//                     setState(() {});
//                     Fluttertoast.showToast(
//                       msg: "Participants: $participants",
//                       gravity: ToastGravity.BOTTOM,
//                       toastLength: Toast.LENGTH_SHORT,
//                     );
//                   }
//                 },
//               ),
//             ),

            Container(
              width: 40,
              height: 40,
              decoration: BoxDecoration(
                  color: isInitiator == 1 || accept ? Colors.red : Colors.red,
                  shape: BoxShape.circle),
              child: IconButton(
                icon: Icon(
                  isInitiator == 1 || accept ? Icons.call_end : Icons.call_end,
                  color: Colors.white,
                  size: 20.0,
                ),
                onPressed: () {
                  Navigator.pop(context);
                  Future.delayed(Duration(seconds: 1), () async {
                    API.terminateCall(widget.mId);
                    API.endCRoom(widget.mId);
                  });
                },
              ),
            ),
            // Container(
            //   width: 40,
            //   height: 40,
            //   decoration: BoxDecoration(
            //       color: Colors.blueAccent, shape: BoxShape.circle),
            //   child: IconButton(
            //     icon: Icon(
            //       Icons.videocam,
            //       color: Colors.white,
            //       size: 20.0,
            //     ),
            //     onPressed: () {
            //       Fluttertoast.showToast(
            //         msg: "Switch Camera",
            //         gravity: ToastGravity.BOTTOM,
            //         toastLength: Toast.LENGTH_SHORT,
            //       );
            //     },
            //   ),
            // ),
            // Container(
            //   width: 40,
            //   height: 40,
            //   decoration: BoxDecoration(
            //       color: Colors.blueAccent, shape: BoxShape.circle),
            //   child: IconButton(
            //     icon: Icon(
            //       Icons.zoom_in,
            //       color: Colors.white,
            //       size: 20.0,
            //     ),
            //     onPressed: () {
            //       if (mounted) {
            //         setState(() {
            //           zoomOut = !zoomOut;
            //         });
            //       }
            //     },
            //   ),
            // ),
            // Container(
            //   width: 40,
            //   height: 40,
            //   decoration: BoxDecoration(
            //       color: Colors.blueAccent, shape: BoxShape.circle),
            //   child: IconButton(
            //     icon: Icon(
            //       Icons.pan_tool,
            //       color: Colors.white,
            //       size: 20.0,
            //     ),
            //     onPressed: () {},
            //   ),
            // ),
          ],
        ),
      ),
    );
  }

  Widget _destinationName() {
    return Align(
      alignment: Alignment.topCenter,
      child: Container(
        padding: EdgeInsets.all(5),
        color: Colors.black26,
        child: Text(
          widget.name,
          style: TextStyle(color: Colors.white, fontSize: 13),
        ),
      ),
    );
  }

  Widget _cameraView() {
    return Container(child: Camera());
  }

  Widget _remoteOtherView(String name) {
    return GestureDetector(
      onTap: () {
        // bool speakerCCall = speakerList[device_id];
        // if (isInitiator == 1){
        //   setState(() {
        //     speakerCCall = !speakerCCall;
        //     speakerList[device_id] = speakerCCall;
        //     // API.setCCallAudio(device_id, speakerCCall);
        //     speakerCount = 1;
        //   });
        // }
      },
      child: Container(child: Remote()),
    );
  }

  Widget _remoteOthersView(String name, double hgt, double wdt) {
    return GestureDetector(
      child: Container(
        alignment: Alignment.topCenter,
        padding: EdgeInsets.fromLTRB(5, 5, 0, 0),
        height: hgt,
        width: wdt,
        color: Colors.black12,
        child: Stack(
          children: <Widget>[
            Container(
              padding: EdgeInsets.only(top: 5),
              alignment: Alignment.topCenter,
              child: Visibility(
                visible: animatedWidth == 120.0 ? true : false,
                child: Text(
                  "$name",
                  style: TextStyle(
                      color: Colors.blue,
                      backgroundColor: Colors.white,
                      fontSize: 10),
                ),
              ),
            ),
            Remote()
          ],
        ),
      ),
      onTap: () {
        widget.name = name;
        setState(() {});
      },
    );
  }
}
