import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:page_transition/page_transition.dart';
import 'package:palio_lite/app_color.dart';
import 'package:palio_lite/conference/inisiator_ls_screen.dart';
import 'package:palio_lite/conference/join_ls_screen.dart';
import 'package:palio_lite/conference/widgets/button_join.dart';
import 'package:palio_lite/conference/widgets/calendar_form.dart';
import 'package:palio_lite/conference/widgets/time_form.dart';
import 'package:palio_lite/db_helper.dart';
import 'package:shared_preferences/shared_preferences.dart';

class ViewInfoLiveStreaming extends StatefulWidget {
  final String title;
  final String desc;
  final String fpin;
  final List<String> members;
  final int time;
  final String type;
  final String blog_id;

  ViewInfoLiveStreaming(
      {required this.title,
        required this.desc,
        required this.fpin,
        required this.members,
        required this.time,
        required this.type,
        this.blog_id = ""});

  @override
  _ViewInfoLiveStreamingState createState() => _ViewInfoLiveStreamingState();
}

class _ViewInfoLiveStreamingState extends State<ViewInfoLiveStreaming> {
  static const menuItems = <String>["Undangan", "Teman", "Publik"];
  TextEditingController judul = TextEditingController(),
      desc = TextEditingController(),
      target = TextEditingController();
  List<String> nameChosen = [];
  final List<DropdownMenuItem<String>> _dropDownMMenuItems = menuItems
      .map((String value) =>
          DropdownMenuItem<String>(value: value, child: Text(value)))
      .toList();
  String name = "";
  String bsName = "";
  String f_pin = "";
  String myFpin = "";
  String title = "";
  String type = "";
  String blog_id = "";
  int timeVal = 0;
  int timeValDate = 0;
  String deskripsi = "";

  List<String> fpinChosen = [];

  Future<void> getData(List<String> fpin_person) async {
    print("fpin person " + fpin_person.toString());
    String listfpin = "";
    for (int x = 0; x < fpin_person.length; x++) {
      if (x == 0) {
        listfpin = listfpin + "'" + fpin_person[x] + "'";
      } else {
        listfpin = listfpin + "," + "'" + fpin_person[x] + "'";
      }
    }
    print("list fpin $listfpin");
    String query =
        "SELECT first_name, last_name FROM BUDDY WHERE f_pin in ($listfpin)";
    List<dynamic> resultQueryBuddy = await DBHelper().queryCustom(query);
    for (int y = 0; y < resultQueryBuddy.length; y++) {
      if (resultQueryBuddy[y]['last_name'].toString().isEmpty) {
        nameChosen.add(resultQueryBuddy[y]['first_name']);
      } else {
        nameChosen.add(resultQueryBuddy[y]['first_name'] +
            " " +
            resultQueryBuddy[y]['last_name']);
      }
    }
    print("Data : " + nameChosen.toString());
    print("Data Person Done");
    setState(() {});
  }

  Future<void> getSelfData() async {
    final SharedPreferences prefs = await SharedPreferences.getInstance();
    myFpin = prefs.getString("hasLogin") ?? "";
    var resultQueryBuddy = await DBHelper().queryCustom(
        "SELECT f_pin,first_name, last_name FROM BUDDY WHERE f_pin='" +
            myFpin +
            "'");
    if (resultQueryBuddy[0]['last_name'].toString().isEmpty) {
      name = resultQueryBuddy[0]['first_name'];
    } else {
      name = resultQueryBuddy[0]['first_name'] +
          " " +
          resultQueryBuddy[0]['last_name'];
    }
    print("Data Self Done");
  }

  @override
  void initState() {
    super.initState();
    fpinChosen = widget.members;
    f_pin = widget.fpin;
    title = widget.title;
    type = widget.type;
    timeVal = widget.time;
    timeValDate = widget.time;
    deskripsi = widget.desc;
    desc.text = deskripsi;
    judul.text = title.split("~").sublist(1).join("~");
    blog_id = widget.blog_id;
    print("data masuk $f_pin $title $type $timeVal $deskripsi $blog_id" +
        desc.text +
        " " +
        judul.text);
    getData(fpinChosen);
    getSelfData();
    if (type == "5") {
      target.text = "Invitation";
    } else if (type == "3") {
      target.text = "Public";
    } else if (type == "0") {
      target.text = "Friends";
    }
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        iconTheme: IconThemeData(color: Colors.white),
        title: Text("Live Video Promotion", style: TextStyle(color: Colors.white)),
        backgroundColor: AppColor.primaryColor,
      ),
      backgroundColor: Colors.white,
      body: Stack(
        children: <Widget>[
          SingleChildScrollView(
            child: Column(
              crossAxisAlignment: CrossAxisAlignment.start,
              children: <Widget>[
                Container(
                  child: Text("Broadcast To",
                      style: TextStyle(color: Colors.grey)),
                  padding: EdgeInsets.only(left: 10.0, top: 5.0),
                ),
                Container(
                  padding: EdgeInsets.only(left: 10.0, right: 10.0),
                  child: TextFormField(
                    enabled: false,
                    cursorColor: Colors.black,
                    controller: target,
                    decoration: InputDecoration(
                        border: InputBorder.none,
                        contentPadding: EdgeInsets.only(top: -20.0)),
                  ),
                ),
                Divider(height: 0.0, color: Colors.grey),
                SizedBox(height: 10.0),
                Container(
                  child: Text("Live Video Promotion Title *",
                      style: TextStyle(color: Colors.grey)),
                  padding: EdgeInsets.only(left: 10.0, top: 5.0),
                ),
                Container(
                  padding: EdgeInsets.only(left: 10.0, right: 10.0),
                  child: TextFormField(
                    enabled: false,
                    cursorColor: Colors.black,
                    controller: judul,
                    decoration: InputDecoration(
                        border: InputBorder.none,
                        contentPadding: EdgeInsets.only(top: -20.0)),
                  ),
                ),
                Divider(height: 0.0, color: Colors.grey),
                SizedBox(height: 10.0),
                Container(
                  child: Text("Live Video Promotion Description *",
                      style: TextStyle(color: Colors.grey)),
                  padding: EdgeInsets.only(left: 10.0, top: 5.0),
                ),
                Container(
                  padding: EdgeInsets.only(left: 10.0, right: 10.0),
                  child: TextFormField(
                    enabled: false,
                    cursorColor: Colors.black,
                    controller: desc,
                    decoration: InputDecoration(
                        border: InputBorder.none,
                        contentPadding: EdgeInsets.only(top: -20.0)),
                  ),
                ),
                Divider(height: 0.0, color: Colors.grey),
                SizedBox(height: 10.0),
                Container(
                  child: Text("Start Live Video Promotion *",
                      style: TextStyle(color: Colors.grey)),
                  padding: EdgeInsets.only(left: 10.0, top: 5.0),
                ),
                AbsorbPointer(
                  absorbing: true,
                  child: Container(
                    padding: EdgeInsets.only(left: 10.0, right: 10.0),
                    margin: EdgeInsets.only(top: 5.0, bottom: 10.0),
                    child: Row(
                      mainAxisAlignment: MainAxisAlignment.start,
                      children: <Widget>[
                        CalendarForm(
                          times: timeVal,
                          date: (date) {},
                        ),
                        SizedBox(width: 10.0),
                        TimeForm(
                          timeValue: timeValDate,
                          time: (time) {},
                        )
                      ],
                    ),
                  ),
                ),
                Divider(height: 0.0, color: Colors.grey),
                SizedBox(height: 10.0),
                Container(
                  child: Text("Live Video Promotion Participants *",
                      style: TextStyle(color: Colors.grey)),
                  padding: EdgeInsets.only(left: 10.0, top: 5.0),
                  margin: EdgeInsets.only(bottom: 5.0),
                ),
                Container(
                  margin: EdgeInsets.only(bottom: 10.0),
                  padding: EdgeInsets.only(left: 10.0, right: 10.0),
                  child: Wrap(
                    children: List.generate(
                        nameChosen.length,
                        (index) => Container(
                              padding: EdgeInsets.all(10.0),
                              width: MediaQuery.of(context).size.width * 0.45,
                              height: 50,
                              decoration: BoxDecoration(
                                  border: Border.all(color: Colors.black),
                                  borderRadius: BorderRadius.circular(3.0)),
                              child: Row(
                                mainAxisAlignment:
                                    MainAxisAlignment.spaceBetween,
                                children: <Widget>[
                                  Expanded(
                                    child: Row(
                                      mainAxisAlignment:
                                          MainAxisAlignment.start,
                                      children: <Widget>[
                                        Icon(Icons.person,
                                            color: Colors.grey[600]),
                                        SizedBox(width: 10.0),
                                        Text(
                                          nameChosen[index],
                                          overflow: TextOverflow.ellipsis,
                                        ),
                                      ],
                                    ),
                                  ),
                                ],
                              ),
                            )),
                    spacing: 15.0,
                    runSpacing: 10.0,
                  ),
                ),
                // AddMember(listMembers: (name) {
                //   setState(() {
                //     nameChosen.add(name);
                //   });
                // }),
                SizedBox(height: 20.0),
                Divider(height: 0.0, color: Colors.grey),
              ],
            ),
          ),
          Align(
            alignment: Alignment.bottomCenter,
            child: Container(
              alignment: Alignment.centerRight,
              width: double.infinity,
              height: 60,
              child: ButtonJoin(() {
                print("ls info $type $name $f_pin $myFpin $deskripsi " +
                    judul.text);
                if (myFpin == f_pin) {
                  Navigator.push(
                      context,
                      PageTransition(
                          type: PageTransitionType.fade,
                          child: InisiateLs(
                            title: "1~" + judul.text,
                            name: name,
                            f_pin: f_pin,
                            privacy: type,
                            desc: deskripsi,
                            blog_id: blog_id,
                          )));
                } else {
                  Navigator.push(
                      context,
                      PageTransition(
                          type: PageTransitionType.fade,
                          child: JoinLs(
                            name: name,
                            f_pin: f_pin,
                            privacy: type,
                            title: judul.text,
                            desc: deskripsi,
                          )));
                }
              }, myFpin == f_pin ? true : false),
            ),
          )
        ],
      ),
    );
  }
}
