import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:palio_lite/app_color.dart';

class ButtonJoin extends StatefulWidget {
  final VoidCallback click;
  final bool isInitiator;

  ButtonJoin(this.click, this.isInitiator);

  @override
  _ButtonJoinState createState() => _ButtonJoinState();
}

class _ButtonJoinState extends State<ButtonJoin> {
  Color color = AppColor.primaryColor;

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      onTap: () {
        widget.click();
      },
      onTapDown: (tap) {
        setState(() {
          color = Colors.yellow;
        });
      },
      onTapCancel: () {
        setState(() {
          color = AppColor.primaryColor;
        });
      },
      onTapUp: (tap) {
        setState(() {
          color = AppColor.primaryColor;
        });
      },
      child: Container(
        height: 50,
        padding: EdgeInsets.all(10.0),
        margin: EdgeInsets.only(right: 5.0),
        width: MediaQuery.of(context).size.width * 0.5,
        decoration: BoxDecoration(
          color: color,
          borderRadius: BorderRadius.circular(3.0),
        ),
        child: Row(
          mainAxisAlignment: MainAxisAlignment.start,
          children: <Widget>[
            Flexible(
                flex: 1,
                child: Container(
                    alignment: Alignment.center,
                    child: Icon(
                      Icons.done,
                      color: Colors.white,
                    ))),
            Flexible(
              flex: 4,
              child: Container(
                  alignment: Alignment.center,
                  child: Text(
                    widget.isInitiator ? "Start" : "Join",
                    style: TextStyle(color: Colors.white),
                  )),
            )
          ],
        ),
      ),
    );
  }
}
