import 'package:flutter/material.dart';
import 'package:flutter/cupertino.dart';
import 'package:intl/intl.dart';

class CalendarForm extends StatefulWidget {
  final Function(String) date;
  final int times;

  CalendarForm({required this.date, required this.times});

  @override
  _CalendarFormState createState() => _CalendarFormState();
}

class _CalendarFormState extends State<CalendarForm> {
  int time = 0;
  String date = DateFormat('dd MMM yyyy').format(DateTime.now());
  Color color = Colors.white;

  @override
  void initState() {
    super.initState();
    time = widget.times;
    if (time > 0) {
      date = DateFormat('dd MMM yyyy')
          .format(DateTime.fromMillisecondsSinceEpoch(time));
    }
  }

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      onTap: () {
        if (time == 0) {
          showDatePicker(
                  context: context,
                  initialDate: DateTime.now(),
                  firstDate: DateTime.now(),
                  lastDate: DateTime(9999))
              .then((value) {
            if (value != null) {
              widget.date(DateFormat('dd-MM-yyyy').format(value));
              setState(() {
                date = DateFormat('dd-MM-yyyy').format(value);
              });
            }
          });
        } else {
          showDatePicker(
                  context: context,
                  initialDate: DateTime.fromMillisecondsSinceEpoch(time),
                  firstDate: DateTime.fromMillisecondsSinceEpoch(time),
                  lastDate: DateTime(9999))
              .then((value) {
            if (value != null) {
              widget.date(DateFormat('dd-MM-yyyy').format(value));
              setState(() {
                date = DateFormat('dd-MM-yyyy').format(value);
              });
            }
          });
        }
      },
      onTapDown: (tap) {
        setState(() {
          color = Colors.grey;
        });
      },
      onTapUp: (tap) {
        setState(() {
          color = Colors.white;
        });
      },
      onTapCancel: () {
        setState(() {
          color = Colors.white;
        });
      },
      child: Container(
        padding: EdgeInsets.only(left: 10.0, right: 10.0),
        height: 40,
        decoration: BoxDecoration(
            color: color,
            border: Border.all(color: Colors.black),
            borderRadius: BorderRadius.circular(3.0)),
        child: Row(
          mainAxisAlignment: MainAxisAlignment.start,
          children: <Widget>[
            Icon(
              Icons.calendar_today,
              color: Colors.grey[600],
              size: 14,
            ),
            SizedBox(width: 10.0),
            Text(date)
          ],
        ),
      ),
    );
  }
}
