import 'package:flutter/material.dart';
import 'package:flutter/cupertino.dart';

class JoinViewLive extends StatefulWidget {
  final VoidCallback tap;
  final String view;

  JoinViewLive(this.tap, {this.view = "0"});

  @override
  _JoinViewLiveState createState() => _JoinViewLiveState();
}

class _JoinViewLiveState extends State<JoinViewLive> {
  Color color = Colors.transparent;

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      onTap: () {
        widget.tap();
      },
      onTapDown: (tap) {
        setState(() {
          color = Colors.transparent;
        });
      },
      onTapUp: (tap) {
        setState(() {
          color = Colors.transparent;
        });
      },
      onTapCancel: () {
        setState(() {
          color = Colors.transparent;
        });
      },
      child: Container(
          padding: EdgeInsets.only(right: 10, top: 3, bottom: 3, left: 3),
          child: Row(
            children: <Widget>[
              Icon(
                CupertinoIcons.person,
                color: Colors.white,
                size: 20,
              ),
              SizedBox(
                width: 8,
              ),
              Text(
                widget.view,
                style: TextStyle(color: Colors.white),
              )
            ],
          ),
          decoration: BoxDecoration(
              color: color, borderRadius: BorderRadius.circular(10))),
    );
  }
}
