import 'package:flutter/material.dart';
import 'package:flutter/cupertino.dart';

class LikeLive extends StatefulWidget {
  final VoidCallback tap;
  final String like;

  LikeLive(this.tap, {this.like = "0"});

  @override
  _LikeLiveState createState() => _LikeLiveState();
}

class _LikeLiveState extends State<LikeLive> {
  Color color = Colors.black.withOpacity(0.5);

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      onTap: () {
        widget.tap();
      },
      onTapDown: (tap) {
        setState(() {
          color = Colors.grey[300]!;
        });
      },
      onTapUp: (tap) {
        setState(() {
          color = Colors.black.withOpacity(0.5);
        });
      },
      onTapCancel: () {
        setState(() {
          color = Colors.black.withOpacity(0.5);
        });
      },
      child: Container(
        padding: EdgeInsets.all(5.0),
        decoration: BoxDecoration(
            color: color, borderRadius: BorderRadius.circular(5.0)),
        child: Row(
          children: <Widget>[
            InkWell(
              onTap: () {
                print("Like");
              },
              child: Icon(
                CupertinoIcons.heart_solid,
                color: Colors.white,
                size: 20,
              ),
            ),
            SizedBox(
              width: 8,
            ),
            Text(
              widget.like,
              style: TextStyle(color: Colors.white),
            )
          ],
        ),
      ),
    );
  }
}
