import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:palio_lite/app_color.dart';
import 'package:palio_lite/db_helper.dart';
import 'package:shared_preferences/shared_preferences.dart';

class ChangeState with ChangeNotifier {
  List<Map<dynamic, dynamic>> _dataContact = [], _srcContact = [];

  List<Map<dynamic, dynamic>> get getDataContact => _dataContact;

  List<Map<dynamic, dynamic>> get getSrcContact => _srcContact;

  set dataContact(Map<dynamic, dynamic> value) {
    _dataContact.add(value);
    notifyListeners();
  }

  set srcContact(List<Map<dynamic, dynamic>> value) {
    _srcContact.addAll(value);
    notifyListeners();
  }

  set addSrcContact(Map<dynamic, dynamic> value) {
    _srcContact.add(value);
    notifyListeners();
  }

  set clearSrcContact(bool value) {
    _srcContact.clear();
    notifyListeners();
  }
}

class ShowLSUsers extends StatefulWidget {
  bool isCall = false;
  List<String> user;
  List<String> image;

  ShowLSUsers({required this.user, required this.image});

  _ShowLSUsers createState() => _ShowLSUsers();
}

class _ShowLSUsers extends State<ShowLSUsers> {
  TextEditingController _editingController = new TextEditingController();

  List<Map<dynamic, dynamic>> _dataContact = [], _srcContact = [];

  List<Map<dynamic, dynamic>> get getDataContact => _dataContact;

  List<Map<dynamic, dynamic>> get getSrcContact => _srcContact;

  @override
  void initState() {
    getData();
    super.initState();
  }

  List<dynamic> dummyAccounts = [
    {
      "f_pin": "1",
      "first_name": "Phil",
      "image_id": "000001",
      "official_account": "0",
      "device_id": "000001"
    },
    {
      "f_pin": "2",
      "first_name": "Yan",
      "image_id": "000002",
      "official_account": "0",
      "device_id": "000002"
    },
    {
      "f_pin": "3",
      "first_name": "Crumbs",
      "image_id": "000003",
      "official_account": "0",
      "device_id": "000003"
    },
    {
      "f_pin": "4",
      "first_name": "Yums",
      "image_id": "000004",
      "official_account": "0",
      "device_id": "000004"
    },
    {
      "f_pin": "5",
      "first_name": "Dimitri",
      "image_id": "000005",
      "official_account": "0",
      "device_id": "000005"
    },
    {
      "f_pin": "6",
      "first_name": "Claude",
      "image_id": "000006",
      "official_account": "0",
      "device_id": "000006"
    }
  ];

  void getData() async {
    if (widget.user.isEmpty && widget.image.isEmpty) {
      final SharedPreferences prefs = await SharedPreferences.getInstance();
      String idMe = prefs.getString("hasLogin") ?? "";
      List<dynamic> resultQuery = await DBHelper().queryCustom(
          "SELECT f_pin, first_name,official_account, image_id, device_id FROM BUDDY where official_account<>'1' and f_pin <> '$idMe' and f_pin <> '02121368af'");
      // List<dynamic> resultQuery = dummyAccounts;
      for (var i = 0; i < resultQuery.length; i++) {
        _dataContact.add({
          "f_pin": resultQuery[i]["f_pin"],
          "name": resultQuery[i]["first_name"],
          "picture": resultQuery[i]["image_id"],
          "isVerified": resultQuery[i]["official_account"] == "2" ? "1" : "0",
          "isOfficial": resultQuery[i]["official_account"] == "1" ? "1" : "0",
          "deviceId": resultQuery[i]["device_id"]
        });
      }
    } else {
      for (var i = 0; i < widget.user.length; i++) {
        _dataContact.add({"name": widget.user[i], "picture": widget.image[i]});
      }
    }
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
          automaticallyImplyLeading: true,
          backgroundColor: AppColor.primaryColor,
          title: Text("Live Video Promotion")),
      body: Container(
        child: Column(
          children: <Widget>[
            Container(
              decoration: BoxDecoration(
                  color: Colors.grey[100],
                  border: Border(
                      bottom:
                          BorderSide(color: Colors.grey[200]!, width: 2.0))),
              padding: EdgeInsets.all(2.0),
              child: Row(
                mainAxisAlignment: MainAxisAlignment.spaceAround,
                children: <Widget>[
                  Container(
                    width: MediaQuery.of(context).size.width * 0.98,
                    child: Theme(
                      child: Container(
                        color: Colors.blueGrey,
                        height: 25.0,
                        child: Text(
                          "Daftar Peserta",
                          style: TextStyle(
                              color: Colors.white, fontWeight: FontWeight.bold),
                          textAlign: TextAlign.center,
                        ),
                      ),
                      data:
                          Theme.of(context).copyWith(primaryColor: Colors.grey),
                    ),
                  )
                ],
              ),
            ),
            Flexible(
              child: ListView.builder(
                  itemCount: _dataContact.length,
                  itemBuilder: (builder, index) {
                    return ListTile(
                      leading: Container(
                        width: 45,
                        height: 45,
                        decoration: BoxDecoration(
                            shape: BoxShape.circle,
                            image: DecorationImage(
                                fit: BoxFit.cover,
                                image: Image.asset(
                                  "assets/images/ic_person_boy.png",
                                ).image
//                                image: LocalImage(widget.changeState
//                                    .getSrcContact[index]["picture"])
                                )),
                      ),
                      title: Row(
                        children: <Widget>[
                          Padding(
                            padding: EdgeInsets.only(
                              left: 8.0,
                            ),
                            child: Text(
                              _dataContact[index]["name"],
                            ),
                          )
                        ],
                      ),
                    );
                  }),
            )
          ],
        ),
      ),
    );
  }
}
