import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:palio_lite/app_color.dart';

class ViewLive extends StatefulWidget {
  final VoidCallback tap;
  final String view;

  ViewLive(this.tap, {this.view = "0"});

  @override
  _ViewLiveState createState() => _ViewLiveState();
}

class _ViewLiveState extends State<ViewLive> {
  Color color = AppColor.primaryColor;

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      onTap: () {
        widget.tap();
      },
      onTapDown: (tap) {
        setState(() {
          color = Colors.grey[300]!;
        });
      },
      onTapUp: (tap) {
        setState(() {
          color = AppColor.primaryColor;
        });
      },
      onTapCancel: () {
        setState(() {
          color = AppColor.primaryColor;
        });
      },
      child: Container(
          padding: EdgeInsets.only(right: 10, top: 3, bottom: 3, left: 3),
          child: Row(
            children: <Widget>[
              Icon(
                CupertinoIcons.eye_solid,
                color: Colors.white,
                size: 20,
              ),
              SizedBox(
                width: 8,
              ),
              Text(
                widget.view,
                style: TextStyle(color: Colors.white),
              )
            ],
          ),
          decoration: BoxDecoration(
              color: color, borderRadius: BorderRadius.circular(10))),
    );
  }
}
