import 'package:sqflite/sqflite.dart';

class DBHelper {
  static Database? _db;

  Future<Database> get checkDatabase async {
    if (_db == null) {
      var databasesPath = await getDatabasesPath();
      Future<Database> getDB =
          openDatabase(databasesPath + "/PalioLite.sqlite");
      _db = await getDB;
    }
    return _db!;
  }

  Future<dynamic> getMessages(
      String fpin, String lpin, int limit, int end) async {
    var dbClient = await checkDatabase;
    var result = await dbClient.rawQuery(
        "SELECT * FROM MESSAGE where (f_pin='$fpin' or l_pin='$lpin') AND message_scope_id='3' order by server_date desc limit $limit,$end");
    return result;
  }

  Future<dynamic> queryCustom(String query) async {
    var dbClient = await checkDatabase;
    var result = await dbClient.rawQuery(query);
    return result;
  }

  Future<dynamic> minStatusGroup(String messageId) async {
    var dbClient = await checkDatabase;
    var result = await dbClient.rawQuery(
        "SELECT MIN(status) FROM MESSAGE_STATUS WHERE message_id='$messageId'");
    return result;
  }

  Future<String> getLiveCenterSession(String f_pin) async {
    var dbClient = await checkDatabase;
    var result = await dbClient
        .rawQuery("SELECT value FROM PREFS WHERE key = 'CC:$f_pin'");
    if (result.isNotEmpty) {
      return result[0]["value"] as String;
    }
    return "";
  }
}
