import 'dart:async';
import 'dart:convert';
import 'dart:io';

import 'package:file_picker/file_picker.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:fluttertoast/fluttertoast.dart';
import 'package:html/parser.dart';
import 'package:image/image.dart' as image;

// import 'package:geolocator/geolocator.dart';
// import 'package:google_maps_flutter/google_maps_flutter.dart';
import 'package:image_picker/image_picker.dart';
import 'package:intl/intl.dart';
import 'package:open_file/open_file.dart';
import 'package:page_transition/page_transition.dart';
import 'package:palio_lite/api.dart';
import 'package:palio_lite/app_color.dart';

// import 'package:un_ios_app/Screen/approval_student.dart';
import 'package:palio_lite/call/audio_call.dart';
import 'package:palio_lite/call/video_call.dart';
import 'package:palio_lite/chat/pa_profile.dart';
import 'package:palio_lite/chat/widgets/buble_chat_personal.dart';
import 'package:palio_lite/chat/widgets/custom_scroll_to_index.dart';
import 'package:palio_lite/chat/widgets/forward_chat.dart';
import 'package:palio_lite/chat/widgets/link_previewer.dart';
import 'package:palio_lite/chat/widgets/my_text_selection.dart';
import 'package:palio_lite/chat/widgets/notifications.dart';
import 'package:palio_lite/chat/widgets/rich_text_field.dart';
import 'package:palio_lite/chat/widgets/show_date.dart';
import 'package:palio_lite/chat/widgets/tap_to_bottom.dart';
import 'package:palio_lite/chat/widgets/widget_Image_Download.dart';
import 'package:palio_lite/chat/widgets/widget_sticker.dart';
import 'package:palio_lite/conference/join_vidconf_room.dart';
import 'package:palio_lite/conference/view_ls_info.dart';
import 'package:palio_lite/db_helper.dart';
import 'package:palio_lite/palio_button.dart';
import 'package:path/path.dart' as path;
import 'package:path_provider/path_provider.dart';
import 'package:photo_view/photo_view.dart';
import 'package:provider/provider.dart';
import 'package:shared_preferences/shared_preferences.dart';
import 'package:url_launcher/url_launcher.dart';
import 'package:video_compress/video_compress.dart';
import 'package:video_thumbnail/video_thumbnail.dart';

import '../shared_obj.dart';

// import 'approval_teacher.dart';

class ChangeState with ChangeNotifier {
  bool _isGoingCallCenter = false;
  String _isGoingCallCenterFPIN = "";
  String _isGoingCallCenterDATA = "";
  bool _isGoingCallCenterTemp = false;
  String _isGoingCallCenterComplaintID = "";
  bool _isClickEnd = false;
  bool _isClickBusy = false;
  bool _isRequestingCallCenter = false;
  bool _isCallCenterEnded = false;
  bool _mChecking = false;
  String _identifier = "";
  bool _isContactCenter = false;
  bool _isContactCenterHistory = false;
  String _data = "";
  String _channel = "0";
  bool _isChannelSelected = false;
  bool _isBusySelected = false;

  bool get isChannelSelected => _isChannelSelected;

  set isChannelSelected(bool value) {
    _isChannelSelected = value;
  }

  String get channel => _channel;

  set channel(String value) {
    _channel = value;
  }

  bool get isContactCenter => _isContactCenter;

  set isContactCenter(bool value) {
    _isContactCenter = value;
  }

  bool get isGoingCallCenter => _isGoingCallCenter;

  set isGoingCallCenter(bool value) {
    _isGoingCallCenter = value;
  }

  String get isGoingCallCenterFPIN => _isGoingCallCenterFPIN;

  set isGoingCallCenterFPIN(String value) {
    _isGoingCallCenterFPIN = value;
  }

  String get isGoingCallCenterDATA => _isGoingCallCenterDATA;

  set isGoingCallCenterDATA(String value) {
    _isGoingCallCenterDATA = value;
  }

  bool get isGoingCallCenterTemp => _isGoingCallCenterTemp;

  set isGoingCallCenterTemp(bool value) {
    _isGoingCallCenterTemp = value;
  }

  String get isGoingCallCenterComplaintID => _isGoingCallCenterComplaintID;

  set isGoingCallCenterComplaintID(String value) {
    _isGoingCallCenterComplaintID = value;
  }

  bool get isClickEnd => _isClickEnd;

  set isClickEnd(bool value) {
    _isClickEnd = value;
  }

  bool get isClickBusy => _isClickBusy;

  set isClickBusy(bool value) {
    _isClickBusy = value;
  }

  bool get isRequestingCallCenter => _isRequestingCallCenter;

  set isRequestingCallCenter(bool value) {
    _isRequestingCallCenter = value;
  }

  bool get isCallCenterEnded => _isCallCenterEnded;

  set isCallCenterEnded(bool value) {
    _isCallCenterEnded = value;
  }

  bool get mChecking => _mChecking;

  set mChecking(bool value) {
    _mChecking = value;
  }

  String get identifier => _identifier;

  set identifier(String value) {
    _identifier = value;
  }

  bool get isContactCenterHistory => _isContactCenterHistory;

  set isContactCenterHistory(bool value) {
    _isContactCenterHistory = value;
  }

  String get data => _data;

  set data(String value) {
    _data = value;
  }

  bool get isBusySelected => _isBusySelected;

  set isBusySelected(bool value) {
    _isBusySelected = value;
  }
}

class ChatPage extends StatelessWidget {
  final String fullName;
  final String image;
  final String identifier;
  final bool refresh;
  final bool isContactCenter;
  final bool isContactCenterHistory;
  final String contactCenterHistoryId;
  final String data;
  final String channel;

  ChatPage(
      {required this.fullName,
      required this.image,
      required this.identifier,
      this.refresh = false,
      this.isContactCenter = false,
      this.isContactCenterHistory = false,
      this.data = "",
      this.channel = "0",
      this.contactCenterHistoryId = ""});

  @override
  Widget build(BuildContext context) {
    return MultiProvider(
      providers: [
        ChangeNotifierProvider(create: (_) => ChangeState()),
        ChangeNotifierProvider(create: (_) => ListMessage()),
        ChangeNotifierProvider(create: (_) => SelectedChat()),
        ChangeNotifierProvider(create: (_) => Attachment()),
      ],
      child: Consumer<ChangeState>(
        builder: (context, changeState, _) => Consumer<SelectedChat>(
          builder: (context, selectChat, _) => Consumer<Attachment>(
            builder: (context, attachment, _) => Consumer<ListMessage>(
                builder: (context, select, _) => ChatPages(
                      fullName,
                      image,
                      changeState,
                      attachment,
                      selectChat,
                      select,
                      identifier: identifier,
                      refresh: refresh,
                      isContactCenter: isContactCenter,
                      isContactCenterHistory: isContactCenterHistory,
                      contactCenterHistoryId: contactCenterHistoryId,
                      data: data,
                      channel: channel,
                    )),
          ),
        ),
      ),
    );
  }
}

class ChatPages extends StatefulWidget {
  final String fullName;
  final String image;
  final SelectedChat selectChat;
  final Attachment attachment;
  final ListMessage select;
  final ChangeState changeState;
  final String identifier;
  final bool refresh;
  final bool isContactCenter;
  final bool isContactCenterHistory;
  final String contactCenterHistoryId;
  final String data;
  final String channel;

  ChatPages(this.fullName, this.image, this.changeState, this.attachment,
      this.selectChat, this.select,
      {required this.identifier,
      required this.refresh,
      this.isContactCenter = false,
      this.isContactCenterHistory = false,
      this.data = "",
      this.channel = "0",
      this.contactCenterHistoryId = ""});

  @override
  _ChatPagesState createState() => _ChatPagesState();
}

class _ChatPagesState extends State<ChatPages> {
  // with WidgetsBindingObserver
  AutoScrollController _scrollController =
      AutoScrollController(initialScrollOffset: 0.0);
  TextEditingController _controllerEditor = TextEditingController();
  TextEditingController _controllerSearch = TextEditingController();
  Timer? _timer,
      _timer2,
      _timerSendTyping,
      _timerReceiveTyping,
      _timerLink,
      _timerRefreshBuddy;
  String? language;
  final MyTextSelectionControls _myExtendedMaterialTextSelectionControls =
      MyTextSelectionControls();
  String? idMe;
  Map<String, dynamic> queryMe = {};

  Future<bool> getAutoDownload() async {
    SharedPreferences prefs = await SharedPreferences.getInstance();
    if (prefs.containsKey("autoDownload")) {
      return prefs.getBool("autoDownload") ?? false;
    }
    return false;
  }

  Widget _textComposerWidget(Attachment attachment) {
    return Row(
      mainAxisAlignment: MainAxisAlignment.start,
      crossAxisAlignment: CrossAxisAlignment.start,
      children: <Widget>[
        Container(
          width: MediaQuery.of(context).size.width > 400
              ? MediaQuery.of(context).size.width * 0.85
              : MediaQuery.of(context).size.width * 0.83,
          decoration: BoxDecoration(
              color: Colors.white, borderRadius: BorderRadius.circular(8.0)),
          margin: EdgeInsets.only(left: 5.0, top: 5.0, bottom: 5.0),
          child: Column(
            crossAxisAlignment: CrossAxisAlignment.start,
            children: <Widget>[
              attachment.getReplyContent != null
                  ? Stack(
                      children: <Widget>[
                        Container(
                          color: Color(0xFFECF0F1),
                          constraints:
                              BoxConstraints(minHeight: 30, maxHeight: 80),
                          margin: EdgeInsets.all(5.0),
                          padding: EdgeInsets.all(8.0),
                          child: Row(
                            mainAxisAlignment: MainAxisAlignment.spaceBetween,
                            children: <Widget>[
                              Expanded(
                                child: Column(
                                  crossAxisAlignment: CrossAxisAlignment.start,
                                  mainAxisSize: MainAxisSize.min,
                                  children: <Widget>[
                                    Text(attachment.getReplyContent["fromName"],
                                        style: TextStyle(
                                            color: Colors.black54,
                                            fontWeight: FontWeight.bold)),
                                    Wrap(
                                      children: <Widget>[
                                        Text(
                                          attachment.getReplyContent[
                                                      "attachment_type"] ==
                                                  "11"
                                              ? "Attachment sticker"
                                              : attachment.getReplyContent[
                                                              "attachment_type"] ==
                                                          "1" &&
                                                      attachment
                                                          .getReplyContent[
                                                              "text"]
                                                          .isEmpty
                                                  ? "Attachment picture"
                                                  : attachment.getReplyContent[
                                                                  "attachment_type"] ==
                                                              "2" &&
                                                          attachment
                                                              .getReplyContent[
                                                                  "text"]
                                                              .isEmpty
                                                      ? "Attachment video"
                                                      : attachment.getReplyContent[
                                                                      "attachment_type"] ==
                                                                  "6" &&
                                                              attachment
                                                                  .getReplyContent[
                                                                      "text"]
                                                                  .isEmpty
                                                          ? "Attachment document"
                                                          : attachment.getReplyContent["attachment_type"] ==
                                                                      "-1" &&
                                                                  attachment
                                                                      .getReplyContent[
                                                                          "text"]
                                                                      .isEmpty
                                                              ? "Attachment audio"
                                                              : attachment.getReplyContent["attachment_type"] == "3" &&
                                                                      attachment
                                                                          .getReplyContent["text"]
                                                                          .isEmpty
                                                                  ? "Attachment location"
                                                                  : attachment.getReplyContent["text"],
                                          maxLines: 2,
                                          overflow: TextOverflow.ellipsis,
                                          style:
                                              TextStyle(color: Colors.black54),
                                        )
                                      ],
                                    )
                                  ],
                                ),
                              ),
                              attachment.getReplyContent["attachment_type"] != "0" &&
                                      attachment.getReplyContent["attachment_type"] !=
                                          "11"
                                  ? Container(
                                      margin: EdgeInsets.only(left: 10.0),
                                      width: 64,
                                      height: 64,
                                      decoration: BoxDecoration(
                                          image: attachment.getReplyContent["attachment_type"] == "-1" ||
                                                  attachment.getReplyContent[
                                                          "attachment_type"] ==
                                                      "6"
                                              ? null
                                              : DecorationImage(
                                                  fit: BoxFit.cover,
                                                  image: attachment.getReplyContent["attachment_type"] == "3"
                                                      ? NetworkImage(
                                                          attachment.getReplyContent[
                                                              "thumb_location"])
                                                      : FileImage(File(attachment.getReplyContent["thumb_id"]))
                                                          as ImageProvider)),
                                      child: attachment.getReplyContent["attachment_type"] == "-1"
                                          ? Icon(
                                              Icons.volume_up,
                                              color: Colors.grey,
                                              size: 60,
                                            )
                                          : attachment.getReplyContent["attachment_type"] == "6"
                                              ? Icon(Icons.insert_drive_file, color: Colors.green, size: 60)
                                              : Container())
                                  : attachment.getReplyContent["attachment_type"] == "11"
                                      ? Container(
                                          margin: EdgeInsets.only(left: 10.0),
                                          width: 64,
                                          height: 64,
                                          child: Image.asset(
                                              "assets/stickers/${attachment.getReplyContent["text"]}",
                                              package: "palio_lite"),
                                        )
                                      : Container(height: 0.0, width: 0.0)
                            ],
                          ),
                        ),
                        Align(
                          alignment: Alignment.topRight,
                          child: Container(
                            margin: EdgeInsets.only(top: 8, right: 8),
                            child: Material(
                              color: Colors.transparent,
                              child: InkWell(
                                onTap: () {
                                  widget.attachment.replyContent = null;
                                },
                                child: Icon(Icons.cancel, color: Colors.white),
                              ),
                            ),
                          ),
                        )
                      ],
                    )
                  : Container(),
              RichExtendedTextField(
                isRTF: true,
                minLines: 1,
                maxLines: 6,
                cursorColor: AppColor.primaryColor,
                controller: _controllerEditor,
                selectionControls: _myExtendedMaterialTextSelectionControls,
                onTap: () {
                  if (widget.attachment.clickedSticker) {
                    widget.attachment.clickedSticker = false;
                  }
                },
                onChanged: (text) {
                  textListener();
                },
                decoration: InputDecoration(
                    filled: true,
                    fillColor: Colors.white,
                    contentPadding: EdgeInsets.all(20),
                    hintText: "Type Message",
                    border: InputBorder.none),
              )
            ],
          ),
        ),
        Container(
          margin: EdgeInsets.only(left: 5.0, right: 5.0, top: 10.0),
          decoration: BoxDecoration(
              color: AppColor.primaryColor, shape: BoxShape.circle),
          width: 45,
          height: 45,
          child: Material(
            color: Colors.transparent,
            child: InkWell(
              onTap: () async {
                if (widget.changeState.isContactCenterHistory) {
                  return;
                }
                stopTimeoutFirstResponse();
                print("queryMe: $queryMe");
                SharedPreferences prefs = await SharedPreferences.getInstance();
                String idMe = prefs.getString("hasLogin")!;
                var resultQueryMe = await DBHelper()
                    .queryCustom("SELECT * FROM BUDDY WHERE f_pin='$idMe'");
                if (widget.changeState.isContactCenter) {
                  bool sog = SharedObj.isOnGoingCallCenter;
                  if (resultQueryMe[0]["user_type"] != "24" &&
                      (!sog && !widget.changeState.isGoingCallCenter)) {
                    Fluttertoast.showToast(
                        msg:
                            "Unable to send message, waiting for Contact Center to accept your request",
                        toastLength: Toast.LENGTH_SHORT);
                    return;
                  }
                }
                if (attachment.getListImage.length > 0) {
                  for (var j = 0; j < attachment.getListImage.length; j++) {
                    attachment.getListImage[j].copy(
                        "${attachment.path.path}/${path.basename(attachment.getListImage[j].path)}");
                    final realImage = image.decodeImage(
                        attachment.getListImage[j].readAsBytesSync());
                    final thumbImage =
                        image.copyResize(realImage!, width: 480, height: 640);
                    File newThumb =
                        new File('${attachment.path.path}/thumbnail.png')
                          ..writeAsBytesSync(image.encodePng(thumbImage));
                    newThumb.copy(
                        "${attachment.path.path}/THUMB_${path.basename(attachment.getListImage[j].path)}");
                    var resultSend = await API.sendMessage(
                        lPin: widget.changeState.identifier,
                        messageScopeId: "3",
                        status: "2",
                        messageText: j == 0 ? _controllerEditor.text : "",
                        imageId: path.basename(attachment.getListImage[j].path),
                        reffId: attachment.getReplyContent != null
                            ? attachment.getReplyContent["message_id"]
                            : "",
                        credential:
                            widget.attachment.getConfidentialActive ? "1" : "0",
                        thumbId: "THUMB_" +
                            path.basename(attachment.getListImage[j].path),
                        readReceipts: attachment.getAckActive ? "8" : "",
                        attachmentFlag: "1",
                        isCallCenter:
                            widget.changeState.isContactCenter ? "1" : "0",
                        callCenterId:
                            widget.changeState.isGoingCallCenterComplaintID);
                    var formatTime = new DateFormat('Hm');
                    String? refId,
                        refName,
                        refText,
                        refType,
                        refThumbId,
                        refThumbLoc;
                    if (attachment.getReplyContent != null) {
                      refId = attachment.getReplyContent["message_id"];
                      refName = attachment.getReplyContent["fromName"];
                      refText = attachment.getReplyContent["attachment_type"] ==
                                  "3" ||
                              attachment.getReplyContent["attachment_type"] ==
                                  "-1"
                          ? ""
                          : attachment.getReplyContent["text"];
                      refType = attachment.getReplyContent["attachment_type"];
                      refThumbId = attachment.getReplyContent["thumb_id"];
                      refThumbLoc =
                          attachment.getReplyContent["thumb_location"];
                    }
                    int countCredential = 0;
                    String? credential;
                    if (widget.attachment.getConfidentialActive) {
                      credential = "1";
                      countCredential = 60;
                      SharedPreferences prefs =
                          await SharedPreferences.getInstance();
                      prefs.setInt(resultSend,
                          DateTime.now().toUtc().millisecondsSinceEpoch);
                    }
                    widget.select.addChat = Chat(
                        messageId: resultSend,
                        isOriginator: true,
                        text: _controllerEditor.text,
                        statusRead: "2",
                        fileName:
                            path.basename(attachment.getListImage[j].path),
                        thumbName: attachment.getListImage[j].path,
                        refFrom: refName!,
                        lPin: widget.changeState.identifier,
                        credential: credential,
                        countCredential: countCredential,
                        runCount: false,
                        ack: attachment.getAckActive ? "8" : "",
                        refType: refType,
                        refText: refText,
                        refThumbLoc: refThumbLoc,
                        refId: refId,
                        refThumbId: refThumbId,
                        attachmentType: "1",
                        time: formatTime.format(DateTime.now()),
                        date: DateTime.now());
                  }
                  _controllerEditor.clear();
                  attachment.clearListImage = true;
                  attachment.refresh = true;
                  attachment.replyContent = null;
                  Future.delayed(Duration(milliseconds: 50), () {
                    _scrollController.animateTo(0.0,
                        duration: Duration(milliseconds: 1),
                        curve: Curves.easeOut);
                  });
                } else if (attachment.getVideo != null) {
                  attachment.getVideo!.copy(
                      "${attachment.path.path}/${path.basename(attachment.getVideo!.path)}");
                  var resultSend = await API.sendMessage(
                      lPin: widget.changeState.identifier,
                      messageScopeId: "3",
                      status: "2",
                      reffId: attachment.getReplyContent != null
                          ? attachment.getReplyContent["message_id"]
                          : "",
                      credential:
                          widget.attachment.getConfidentialActive ? "1" : "0",
                      messageText: _controllerEditor.text,
                      videoId: path.basename(attachment.getVideo!.path),
                      thumbId:
                          path.basename(attachment.getThumbnailVideo!.path),
                      readReceipts: attachment.getAckActive ? "8" : "",
                      attachmentFlag: "2",
                      isCallCenter:
                          widget.changeState.isContactCenter ? "1" : "0",
                      callCenterId:
                          widget.changeState.isGoingCallCenterComplaintID);
                  var formatTime = new DateFormat('Hm');
                  String? refId,
                      refName,
                      refText,
                      refType,
                      refThumbId,
                      refThumbLoc;
                  if (attachment.getReplyContent != null) {
                    refId = attachment.getReplyContent["message_id"];
                    refName = attachment.getReplyContent["fromName"];
                    refText =
                        attachment.getReplyContent["attachment_type"] == "3" ||
                                attachment.getReplyContent["attachment_type"] ==
                                    "-1"
                            ? ""
                            : attachment.getReplyContent["text"];
                    refType = attachment.getReplyContent["attachment_type"];
                    refThumbId = attachment.getReplyContent["thumb_id"];
                    refThumbLoc = attachment.getReplyContent["thumb_location"];
                  }
                  int countCredential = 0;
                  String? credential;
                  if (widget.attachment.getConfidentialActive) {
                    credential = "1";
                    countCredential = 60;
                    SharedPreferences prefs =
                        await SharedPreferences.getInstance();
                    prefs.setInt(resultSend,
                        DateTime.now().toUtc().millisecondsSinceEpoch);
                  }
                  widget.select.addChat = Chat(
                      messageId: resultSend,
                      lPin: widget.changeState.identifier,
                      isOriginator: true,
                      text: _controllerEditor.text,
                      statusRead: "1",
                      fileName: path.basename(attachment.getVideo!.path),
                      thumbName: attachment.getThumbnailVideo!.path,
                      attachmentType: "2",
                      refFrom: refName,
                      refType: refType,
                      countCredential: countCredential,
                      credential: credential,
                      runCount: false,
                      refText: refText,
                      refThumbLoc: refThumbLoc,
                      ack: attachment.getAckActive ? "8" : "",
                      refId: refId,
                      refThumbId: refThumbId,
                      time: formatTime.format(DateTime.now()),
                      date: DateTime.now());

                  _controllerEditor.clear();
                  attachment.video = null;
                  attachment.refresh = true;
                  attachment.replyContent = null;
                  Future.delayed(Duration(milliseconds: 50), () {
                    _scrollController.animateTo(0.0,
                        duration: Duration(milliseconds: 1),
                        curve: Curves.easeOut);
                  });
                } else if (attachment.getFile != null) {
                  attachment.getFile!.copy(
                      "${attachment.path.path}/${path.basename(attachment.getFile!.path)}");
                  var resultSend = await API.sendMessage(
                      lPin: widget.changeState.identifier,
                      messageScopeId: "3",
                      status: "2",
                      reffId: attachment.getReplyContent != null
                          ? attachment.getReplyContent["message_id"]
                          : "",
                      credential:
                          widget.attachment.getConfidentialActive ? "1" : "0",
                      messageText: _controllerEditor.text,
                      fileId: path.basename(attachment.getFile!.path),
                      readReceipts: attachment.getAckActive ? "8" : "",
                      attachmentFlag: "6",
                      isCallCenter:
                          widget.changeState.isContactCenter ? "1" : "0",
                      callCenterId:
                          widget.changeState.isGoingCallCenterComplaintID);
                  var formatTime = new DateFormat('Hm');
                  String? refId,
                      refName,
                      refText,
                      refType,
                      refThumbId,
                      refThumbLoc;
                  if (attachment.getReplyContent != null) {
                    refId = attachment.getReplyContent["message_id"];
                    refName = attachment.getReplyContent["fromName"];
                    refText =
                        attachment.getReplyContent["attachment_type"] == "3" ||
                                attachment.getReplyContent["attachment_type"] ==
                                    "-1"
                            ? ""
                            : attachment.getReplyContent["text"];
                    refType = attachment.getReplyContent["attachment_type"];
                    refThumbId = attachment.getReplyContent["thumb_id"];
                    refThumbLoc = attachment.getReplyContent["thumb_location"];
                  }
                  int countCredential = 0;
                  String? credential;
                  if (widget.attachment.getConfidentialActive) {
                    credential = "1";
                    countCredential = 60;
                    SharedPreferences prefs =
                        await SharedPreferences.getInstance();
                    prefs.setInt(resultSend,
                        DateTime.now().toUtc().millisecondsSinceEpoch);
                  }
                  widget.select.addChat = Chat(
                      messageId: resultSend,
                      lPin: widget.changeState.identifier,
                      isOriginator: true,
                      text: _controllerEditor.text,
                      statusRead: "2",
                      fileName: path.basename(attachment.getFile!.path),
                      attachmentType: "6",
                      refFrom: refName,
                      refType: refType,
                      credential: credential,
                      countCredential: countCredential,
                      runCount: false,
                      refText: refText,
                      refThumbLoc: refThumbLoc,
                      ack: attachment.getAckActive ? "8" : "",
                      refId: refId,
                      refThumbId: refThumbId,
                      time: formatTime.format(DateTime.now()),
                      date: DateTime.now());
                  _controllerEditor.clear();
                  attachment.file = null;
                  attachment.refresh = true;
                  attachment.replyContent = null;
                  Future.delayed(Duration(milliseconds: 50), () {
                    _scrollController.animateTo(0.0,
                        duration: Duration(milliseconds: 1),
                        curve: Curves.easeOut);
                  });
                } else if (_controllerEditor.text.trim().isNotEmpty) {
                  var resultSend = await API.sendMessage(
                      lPin: widget.changeState.identifier,
                      messageScopeId: "3",
                      status: "2",
                      reffId: attachment.getReplyContent != null
                          ? attachment.getReplyContent["message_id"]
                          : "",
                      credential:
                          widget.attachment.getConfidentialActive ? "1" : "0",
                      readReceipts: attachment.getAckActive ? "8" : "",
                      messageText: _controllerEditor.text,
                      isCallCenter:
                          widget.changeState.isContactCenter ? "1" : "0",
                      callCenterId:
                          widget.changeState.isGoingCallCenterComplaintID);
                  var formatTime = new DateFormat('Hm');
                  String? refId,
                      refName,
                      refText,
                      refType,
                      refThumbId,
                      refThumbLoc;
                  if (attachment.getReplyContent != null) {
                    refId = attachment.getReplyContent["message_id"];
                    refName = attachment.getReplyContent["fromName"];
                    refText =
                        attachment.getReplyContent["attachment_type"] == "3" ||
                                attachment.getReplyContent["attachment_type"] ==
                                    "-1"
                            ? ""
                            : attachment.getReplyContent["text"];
                    refType = attachment.getReplyContent["attachment_type"];
                    refThumbId = attachment.getReplyContent["thumb_id"];
                    refThumbLoc = attachment.getReplyContent["thumb_location"];
                  }
                  int countCredential = 0;
                  String? credential;
                  if (widget.attachment.getConfidentialActive) {
                    credential = "1";
                    countCredential = 60;
                    SharedPreferences prefs =
                        await SharedPreferences.getInstance();
                    prefs.setInt(resultSend,
                        DateTime.now().toUtc().millisecondsSinceEpoch);
                  }
                  var text = _controllerEditor.text;
                  widget.select.addChat = Chat(
                      messageId: resultSend,
                      lPin: widget.changeState.identifier,
                      isOriginator: true,
                      text: text,
                      statusRead: "1",
                      attachmentType: "0",
                      refFrom: refName,
                      refType: refType,
                      credential: credential,
                      countCredential: countCredential,
                      runCount: false,
                      refText: refText,
                      refThumbLoc: refThumbLoc,
                      ack: attachment.getAckActive ? "8" : "",
                      refId: refId,
                      refThumbId: refThumbId,
                      time: formatTime.format(DateTime.now()),
                      date: DateTime.now());
                  attachment.refresh = true;
                  attachment.replyContent = null;
                  _controllerEditor.clear();
                  Future.delayed(Duration(milliseconds: 50), () {
                    _scrollController.animateTo(0.0,
                        duration: Duration(milliseconds: 1),
                        curve: Curves.easeOut);
                  });
                } else {
                  Fluttertoast.showToast(
                      msg: "Type Message", toastLength: Toast.LENGTH_SHORT);
                }
                if (widget.attachment.textLink != null) {
                  attachment.textLink = null;
                }
                if (widget.selectChat.getSelectedChat.length > 0) {
                  widget.selectChat.getSelectedChat.forEach((k, v) {
                    int idx = widget.select.getChat.indexWhere(
                        (element) => element.messageId == v.messageId);
                    widget.select.falseSelected = idx;
                  });
                  widget.attachment.justDelete = 0;
                  widget.attachment.cantForward = 0;
                  if (widget.attachment.disableFavoriteMessage) {
                    widget.attachment.disableFavoriteMessage = false;
                  }
                  widget.selectChat.clearList = true;
                }
              },
              splashColor: Colors.yellow,
              child: Icon(
                Icons.send,
                size: 25,
                color: Colors.white,
              ),
            ),
          ),
        )
      ],
    );
  }

  Widget clip(Attachment attachment) {
    return Row(
      mainAxisAlignment: MainAxisAlignment.spaceBetween,
      children: <Widget>[
        Row(
          mainAxisAlignment: MainAxisAlignment.start,
          children: <Widget>[
            widget.changeState.isContactCenter
                ? Container()
                : Container(
                    margin: EdgeInsets.only(left: 10.0, top: 5.0),
                    width: 40,
                    height: 40,
                    child: Material(
                      color: Colors.transparent,
                      child: InkWell(
                        onTap: () async {
                          if (FocusScope.of(context).hasFocus) {
                            FocusScope.of(context).unfocus();
                            await Future.delayed(Duration(milliseconds: 100));
                          }
                          dialogAckConfidential(attachment);
                        },
                        splashColor: Colors.blueGrey,
                        child: attachment.getConfidentialActive
                            ? Image.asset("assets/images/od_guard_color.png",
                                package: "palio_lite")
                            : Image.asset("assets/images/od_guard_grey.png",
                                package: "palio_lite"),
                      ),
                    ),
                  ),
            widget.changeState.isContactCenter
                ? Container()
                : Container(
                    margin: EdgeInsets.only(top: 5.0),
                    width: 40,
                    height: 40,
                    child: Material(
                      color: Colors.transparent,
                      child: InkWell(
                        onTap: () async {
                          if (FocusScope.of(context).hasFocus) {
                            FocusScope.of(context).unfocus();
                            await Future.delayed(Duration(milliseconds: 100));
                          }
                          dialogAckConfidential(attachment);
                        },
                        splashColor: Colors.blueGrey,
                        child: Stack(
                          alignment: Alignment.center,
                          children: <Widget>[
                            attachment.getAckActive
                                ? Image.asset(
                                    "assets/images/twsn_menulist_ack_12.png",
                                    package: "palio_lite")
                                : Image.asset(
                                    "assets/images/twsn_menulist_ack_11.png",
                                    package: "palio_lite"),
                          ],
                        ),
                      ),
                    ),
                  ),
            (widget.changeState.isContactCenter &&
                        widget.changeState.isGoingCallCenter) ||
                    !widget.changeState.isContactCenter
                ? Container(
                    margin: EdgeInsets.only(top: 5.0),
                    width: 40,
                    height: 40,
                    child: Material(
                      color: Colors.transparent,
                      child: InkWell(
                        onTap: () async {
                          print("clickedSticker");
                          if (FocusScope.of(context).hasFocus) {
                            FocusScope.of(context).unfocus();
                            await Future.delayed(Duration(milliseconds: 100));
                          }
                          if (attachment.clickedSticker) {
                            attachment.clickedSticker = false;
                          } else {
                            attachment.clickedSticker = true;
                          }
                        },
                        splashColor: Colors.blueGrey,
                        child: Stack(
                          alignment: Alignment.center,
                          children: <Widget>[
                            Image.asset("assets/images/od_hex_base.png",
                                package: "palio_lite"),
                            Icon(
                              Icons.mood,
                              size: 20,
                              color: Colors.grey[300],
                            )
                          ],
                        ),
                      ),
                    ),
                  )
                : Container()
          ],
        ),
        Row(
          mainAxisAlignment: MainAxisAlignment.start,
          children: <Widget>[
            attachment.getFile != null
                ? Row(
                    mainAxisAlignment: MainAxisAlignment.start,
                    children: <Widget>[
                      Container(
                        constraints:
                            BoxConstraints(maxWidth: 120, minWidth: 60),
                        child: Text(
                          path
                              .basename(attachment.getFile!.absolute.path)
                              .split(".")[0],
                          style: TextStyle(fontWeight: FontWeight.bold),
                          overflow: TextOverflow.ellipsis,
                        ),
                      ),
                      Text(
                        ".${path.basename(attachment.getFile!.absolute.path).split(".")[1]}",
                        style: TextStyle(fontWeight: FontWeight.bold),
                      )
                    ],
                  )
                : Container(),
            SizedBox(width: 5),
            Container(
              margin: EdgeInsets.only(top: 5.0, right: 5.0),
              width: 40,
              height: 40,
              child: Material(
                color: Colors.transparent,
                child: InkWell(
                  onTap: () async {
                    if (FocusScope.of(context).hasFocus) {
                      FocusScope.of(context).unfocus();
                      await Future.delayed(Duration(milliseconds: 100));
                    }
                    dialogAttachment(attachment);
                  },
                  splashColor: Colors.blueGrey,
                  child: attachment.getVideo != null
                      ? Image.asset("assets/images/od_video.png",
                          package: "palio_lite")
                      : attachment.getListImage.length > 0
                          ? Image.asset("assets/images/od_images.png",
                              package: "palio_lite")
                          : attachment.getFile != null
                              ? Image.asset("assets/images/od_file.png",
                                  package: "palio_lite")
                              : Stack(
                                  alignment: Alignment.center,
                                  children: <Widget>[
                                    Image.asset("assets/images/od_hex_base.png",
                                        package: "palio_lite"),
                                    Image.asset(
                                        "assets/images/od_icon_attach.png",
                                        package: "palio_lite")
                                  ],
                                ),
                ),
              ),
            ),
          ],
        )
      ],
    );
  }

  Widget screenImageList(Attachment attachment) {
    return Container(
      margin: EdgeInsets.only(bottom: 20, right: 10),
      child: SizedBox(
        height: 70,
        child: ListView.builder(
            shrinkWrap: true,
            reverse: true,
            physics: ClampingScrollPhysics(),
            scrollDirection: Axis.horizontal,
            itemCount: attachment.getListImage.length,
            itemBuilder: (_, i) {
              return Container(
                margin: EdgeInsets.only(right: 20),
                width: 100,
                color: Colors.transparent,
                child: Container(
                  padding: EdgeInsets.all(2.0),
                  decoration: BoxDecoration(
                      color: Colors.white,
                      border: Border.all(color: Colors.black),
                      borderRadius: BorderRadius.circular(5.0)),
                  child: Stack(
                    alignment: Alignment.topRight,
                    children: <Widget>[
                      Material(
                        color: Colors.transparent,
                        child: InkWell(
                          splashColor: Colors.grey,
                          onTap: () {
                            Navigator.push(
                                context,
                                PageTransition(
                                    type: PageTransitionType.fade,
                                    child: Stack(
                                      children: <Widget>[
                                        Center(
                                          child: PhotoView(
                                              imageProvider: FileImage(
                                                  attachment.getListImage[i]),
                                              backgroundDecoration:
                                                  BoxDecoration(
                                                      color: Colors.blueGrey)),
                                        ),
                                        Align(
                                          alignment: Alignment.topLeft,
                                          child: Container(
                                            child: Material(
                                              color: Colors.transparent,
                                              child: GestureDetector(
                                                child: Row(
                                                  mainAxisAlignment:
                                                      MainAxisAlignment.start,
                                                  children: <Widget>[
                                                    Icon(Icons.arrow_back_ios,
                                                        color: Colors.white),
                                                    Text("Back",
                                                        style: TextStyle(
                                                            color: Colors.white,
                                                            fontSize: 18))
                                                  ],
                                                ),
                                                onTap: () =>
                                                    Navigator.pop(context),
                                              ),
                                            ),
                                            margin: EdgeInsets.only(
                                                top: 40.0, left: 5.0),
                                          ),
                                        )
                                      ],
                                    )));
                          },
                          child: Container(
                            decoration: BoxDecoration(
                                image: DecorationImage(
                                    fit: BoxFit.cover,
                                    image:
                                        FileImage(attachment.getListImage[i]))),
                          ),
                        ),
                      ),
                      ClipOval(
                        child: Material(
                          color: Colors.white,
                          child: InkWell(
                            splashColor: Colors.grey,
                            onTap: () {
                              attachment.removeListImage = i;
                            },
                            child: Container(
                              width: 25,
                              height: 25,
                              child: Icon(
                                Icons.close,
                                color: Colors.grey,
                              ),
                            ),
                          ),
                        ),
                      )
                    ],
                  ),
                ),
              );
            }),
      ),
    );
  }

  Widget screenVideo(Attachment attachment) {
    return Align(
      alignment: Alignment.centerRight,
      child: Stack(
        alignment: Alignment.topRight,
        children: <Widget>[
          Material(
            color: Colors.transparent,
            child: InkWell(
              onTap: () {
                OpenFile.open(attachment.getVideo!.absolute.path);
              },
              child: Container(
                margin: EdgeInsets.only(right: 5.0),
                height: 90,
                width: 80,
                decoration: BoxDecoration(
                    image: DecorationImage(
                        fit: BoxFit.cover,
                        image: FileImage(attachment.getThumbnailVideo!))),
              ),
            ),
          ),
          Padding(
            padding: const EdgeInsets.only(right: 5.0),
            child: ClipOval(
              child: Material(
                color: Colors.white,
                child: InkWell(
                  splashColor: Colors.grey,
                  onTap: () {
                    attachment.video = null;
                    attachment.thumbnailVideo = null;
                  },
                  child: Container(
                    width: 25,
                    height: 25,
                    child: Icon(
                      Icons.close,
                      color: Colors.grey,
                    ),
                  ),
                ),
              ),
            ),
          )
        ],
      ),
    );
  }

  void dialogAckConfidential(Attachment attachment) {
    showGeneralDialog(
        context: context,
        barrierDismissible: true,
        barrierLabel:
            MaterialLocalizations.of(context).modalBarrierDismissLabel,
        barrierColor: Colors.black45,
        transitionDuration: const Duration(milliseconds: 200),
        pageBuilder: (BuildContext buildContext, Animation animation,
            Animation secondaryAnimation) {
          return Center(
            child: Container(
              width: MediaQuery.of(context).size.width * 0.9,
              height: 180,
              padding: EdgeInsets.all(10.0),
              decoration: BoxDecoration(
                  border: Border.all(color: Colors.white, width: 1.0),
                  color: Colors.black54),
              child: Column(
                crossAxisAlignment: CrossAxisAlignment.start,
                children: <Widget>[
                  Material(
                    color: Colors.transparent,
                    child: Text("Message Mode",
                        style: TextStyle(color: Colors.white, fontSize: 16)),
                  ),
                  Material(
                    color: Colors.transparent,
                    child: Text("Choose Message Mode",
                        style: TextStyle(color: Colors.white, fontSize: 14)),
                  ),
                  SizedBox(
                    height: 5.0,
                  ),
                  Container(
                    margin: EdgeInsets.only(left: 30),
                    child: Material(
                      color: Colors.transparent,
                      child: InkWell(
                        onTap: () {
                          if (attachment.getAckActive) {
                            attachment.ackActive = !attachment.getAckActive;
                          }
                          attachment.confidentialActive =
                              !attachment.getConfidentialActive;
                          Navigator.pop(context);
                        },
                        splashColor: Colors.blueAccent,
                        child: Row(
                          mainAxisAlignment: MainAxisAlignment.start,
                          children: <Widget>[
                            Container(
                              width: 50,
                              height: 50,
                              child: Image.asset(
                                  "assets/images/od_guard_color.png",
                                  package: "palio_lite"),
                            ),
                            Column(
                              crossAxisAlignment: CrossAxisAlignment.start,
                              children: <Widget>[
                                Text("Confidential Message",
                                    style: TextStyle(
                                        color: Colors.white, fontSize: 14)),
                                Container(
                                  constraints: BoxConstraints(
                                      maxWidth: MediaQuery.of(context)
                                                  .size
                                                  .width >
                                              400
                                          ? MediaQuery.of(context).size.width *
                                              0.65
                                          : MediaQuery.of(context).size.width *
                                              0.6),
                                  child: Wrap(
                                    children: <Widget>[
                                      Text(
                                          "Your message will be automatically deleted within 60 seconds after it's been read",
                                          style: TextStyle(
                                              color: Colors.white,
                                              fontSize: 9)),
                                    ],
                                  ),
                                )
                              ],
                            )
                          ],
                        ),
                      ),
                    ),
                  ),
                  SizedBox(
                    height: 5.0,
                  ),
                  Container(
                    margin: EdgeInsets.only(left: 30),
                    child: Material(
                      color: Colors.transparent,
                      child: InkWell(
                        onTap: () {
                          if (attachment.getConfidentialActive) {
                            attachment.confidentialActive =
                                !attachment.getConfidentialActive;
                          }
                          attachment.ackActive = !attachment.getAckActive;
                          Navigator.pop(context);
                        },
                        splashColor: Colors.blueAccent,
                        child: Row(
                          mainAxisAlignment: MainAxisAlignment.start,
                          children: <Widget>[
                            Container(
                              width: 50,
                              height: 50,
                              child: Image.asset(
                                  "assets/images/twsn_menulist_ack_12.png",
                                  package: "palio_lite"),
                            ),
                            Column(
                              crossAxisAlignment: CrossAxisAlignment.start,
                              children: <Widget>[
                                Text("Confirmation Message",
                                    style: TextStyle(
                                        color: Colors.white, fontSize: 14)),
                                Container(
                                  constraints: BoxConstraints(
                                      maxWidth: MediaQuery.of(context)
                                                  .size
                                                  .width >
                                              400
                                          ? MediaQuery.of(context).size.width *
                                              0.65
                                          : MediaQuery.of(context).size.width *
                                              0.6),
                                  child: Wrap(
                                    children: <Widget>[
                                      Text(
                                          "Request to get confirmation from the recipient including the user's location information",
                                          style: TextStyle(
                                              color: Colors.white,
                                              fontSize: 9)),
                                    ],
                                  ),
                                )
                              ],
                            )
                          ],
                        ),
                      ),
                    ),
                  )
                ],
              ),
            ),
          );
        });
  }

  void dialogAttachment(Attachment attachment) {
    showGeneralDialog(
        context: context,
        barrierDismissible: true,
        barrierLabel:
            MaterialLocalizations.of(context).modalBarrierDismissLabel,
        barrierColor: Colors.black45,
        transitionDuration: const Duration(milliseconds: 200),
        pageBuilder: (BuildContext buildContext, Animation animation,
            Animation secondaryAnimation) {
          return Center(
            child: Container(
              width: MediaQuery.of(context).size.width * 0.9,
              height: 220,
              padding: EdgeInsets.all(10.0),
              decoration: BoxDecoration(
                  border: Border.all(color: Colors.white, width: 1.0),
                  color: Colors.black54),
              child: Column(
                crossAxisAlignment: CrossAxisAlignment.start,
                children: <Widget>[
                  Material(
                    color: Colors.transparent,
                    child: Text("Attachment",
                        style: TextStyle(color: Colors.white, fontSize: 16)),
                  ),
                  SizedBox(height: 5.0),
                  Container(
                    margin: EdgeInsets.only(left: 25),
                    child: Material(
                      color: Colors.transparent,
                      child: InkWell(
                        onTap: () {
                          if (attachment.getListImage.length < 5) {
                            Navigator.pop(context);
                            showDialog(
                                barrierDismissible: true,
                                context: context,
                                builder: (BuildContext context) {
                                  return GestureDetector(
                                    child: CupertinoAlertDialog(
                                      content: Material(
                                        color: Colors.transparent,
                                        child: Column(
                                          crossAxisAlignment:
                                              CrossAxisAlignment.start,
                                          children: <Widget>[
                                            ListTile(
                                              title: Text("Take Photo"),
                                              onTap: () {
                                                Navigator.pop(context);
                                                takePhoto(attachment);
                                              },
                                            ),
                                            ListTile(
                                              title:
                                                  Text("Select from Gallery"),
                                              onTap: () {
                                                Navigator.pop(context);
                                                pickImages(attachment);
                                              },
                                            )
                                          ],
                                        ),
                                      ),
                                    ),
                                  );
                                });
                          } else {
                            Fluttertoast.showToast(
                                msg: "Maximum 5 images",
                                toastLength: Toast.LENGTH_SHORT);
                          }
                        },
                        splashColor: Colors.blueAccent,
                        child: Row(
                          mainAxisAlignment: MainAxisAlignment.start,
                          children: <Widget>[
                            Container(
                              width: 50,
                              height: 50,
                              child: Image.asset("assets/images/od_images.png",
                                  package: "palio_lite"),
                            ),
                            Column(
                              crossAxisAlignment: CrossAxisAlignment.start,
                              children: <Widget>[
                                Text("Image",
                                    style: TextStyle(
                                        color: Colors.white, fontSize: 14)),
                                Text("Send image attachment",
                                    style: TextStyle(
                                        color: Colors.white, fontSize: 9))
                              ],
                            )
                          ],
                        ),
                      ),
                    ),
                  ),
                  SizedBox(height: 5.0),
                  Container(
                    margin: EdgeInsets.only(left: 25),
                    child: Material(
                      color: Colors.transparent,
                      child: InkWell(
                        onTap: () {
                          Navigator.pop(context);
                          showDialog(
                              barrierDismissible: true,
                              context: context,
                              builder: (BuildContext context) {
                                return GestureDetector(
                                  child: CupertinoAlertDialog(
                                    content: Material(
                                      color: Colors.transparent,
                                      child: Column(
                                        crossAxisAlignment:
                                            CrossAxisAlignment.start,
                                        children: <Widget>[
                                          ListTile(
                                            title: Text("Take Video"),
                                            onTap: () {
                                              Navigator.pop(context);
                                              takePickVideo(
                                                  "camera", attachment);
                                            },
                                          ),
                                          ListTile(
                                            title: Text("Select from Gallery"),
                                            onTap: () {
                                              Navigator.pop(context);
                                              takePickVideo(
                                                  "gallery", attachment);
                                            },
                                          )
                                        ],
                                      ),
                                    ),
                                  ),
                                );
                              });
                        },
                        splashColor: Colors.blueAccent,
                        child: Row(
                          mainAxisAlignment: MainAxisAlignment.start,
                          children: <Widget>[
                            Container(
                              width: 50,
                              height: 50,
                              child: Image.asset("assets/images/od_video.png",
                                  package: "palio_lite"),
                            ),
                            Column(
                              crossAxisAlignment: CrossAxisAlignment.start,
                              children: <Widget>[
                                Text("Video",
                                    style: TextStyle(
                                        color: Colors.white, fontSize: 14)),
                                Text("Send video attachment",
                                    style: TextStyle(
                                        color: Colors.white, fontSize: 9))
                              ],
                            )
                          ],
                        ),
                      ),
                    ),
                  ),
                  SizedBox(height: 5.0),
                  // Container(
                  //   margin: EdgeInsets.only(left: 25),
                  //   child: Material(
                  //     color: Colors.transparent,
                  //     child: InkWell(
                  //       onTap: () async {
                  //         Navigator.pop(context);
                  //         pickLocation();
                  //       },
                  //       splashColor: Colors.blueAccent,
                  //       child: Row(
                  //         mainAxisAlignment: MainAxisAlignment.start,
                  //         children: <Widget>[
                  //           Container(
                  //             width: 50,
                  //             height: 50,
                  //             child:
                  //                 Image.asset("assets/images/od_location.png"),
                  //           ),
                  //           Column(
                  //             crossAxisAlignment: CrossAxisAlignment.start,
                  //             children: <Widget>[
                  //               Text(translate("location"),
                  //                   style: TextStyle(
                  //                       color: Colors.white, fontSize: 14)),
                  //               Text(translate("descLocation"),
                  //                   style: TextStyle(
                  //                       color: Colors.white, fontSize: 9))
                  //             ],
                  //           )
                  //         ],
                  //       ),
                  //     ),
                  //   ),
                  // ),
                  // SizedBox(height: 5.0),
                  Container(
                    margin: EdgeInsets.only(left: 25),
                    child: Material(
                      color: Colors.transparent,
                      child: InkWell(
                        onTap: () {
                          Navigator.pop(context);
                          pickFile(attachment);
                        },
                        splashColor: Colors.blueAccent,
                        child: Row(
                          mainAxisAlignment: MainAxisAlignment.start,
                          children: <Widget>[
                            Container(
                              width: 50,
                              height: 50,
                              child: Image.asset("assets/images/od_file.png",
                                  package: "palio_lite"),
                            ),
                            Column(
                              crossAxisAlignment: CrossAxisAlignment.start,
                              children: <Widget>[
                                Text("File",
                                    style: TextStyle(
                                        color: Colors.white, fontSize: 14)),
                                Text("Send file attachment",
                                    style: TextStyle(
                                        color: Colors.white, fontSize: 9))
                              ],
                            )
                          ],
                        ),
                      ),
                    ),
                  ),
                ],
              ),
            ),
          );
        });
  }

  void takePhoto(Attachment attachment) async {
    PickedFile? image = await ImagePicker.platform.pickImage(
      source: ImageSource.camera,
      imageQuality: 100,
      maxHeight: 720,
      maxWidth: 1280,
    );
    if (image == null) {
      return;
    } else {
      if (attachment.getVideo != null) {
        attachment.video = null;
        attachment.thumbnailVideo = null;
      }
      attachment.addListImage = File(image.path);
    }
  }

  void pickImages(Attachment attachment) async {
    List<PickedFile>? image = await ImagePicker.platform
        .pickMultiImage(imageQuality: 100, maxHeight: 720, maxWidth: 1280);
    if (image == null) {
      return;
    } else {
      if (attachment.getVideo != null) {
        attachment.video = null;
        attachment.thumbnailVideo = null;
      } else if (attachment.getFile != null) {
        attachment.file = null;
      }
      List<File> listImage = [];
      for (var i = 0; i < 5; i++) {
        if (File(image[i].path).lengthSync() * 0.001 >= 250.0) {
          Fluttertoast.showToast(
              msg: "You can only attach file that are less than 250 KB");
          return null;
        }
        listImage.add(File(image[i].path));
      }
      attachment.listImage = listImage;
    }
  }

  void takePickVideo(String from, Attachment attachment) async {
    PickedFile? pickedFile = await ImagePicker().getVideo(
        source: from == "camera" ? ImageSource.camera : ImageSource.gallery);
    File? pickVideo;
    if (pickedFile != null) {
      pickVideo = File(pickedFile.path);
    }
    if (pickVideo == null) {
      return;
    } else {
      await VideoCompress.setLogLevel(0);
      final info = await VideoCompress.compressVideo(
        pickVideo.path,
        quality: VideoQuality.MediumQuality,
        deleteOrigin: false,
        includeAudio: true,
      );
      if (info != null) {
        pickVideo = info.file;
      }
      if (attachment.getListImage.length > 0) {
        attachment.clearListImage = true;
      } else if (attachment.getFile != null) {
        attachment.file = null;
      }
      if (pickVideo!.lengthSync() * 0.001 >= 2500.0) {
        Fluttertoast.showToast(
            msg: "You can only attach file that are less than 2.5 MB");
        return null;
      }
      var myPath = await getApplicationDocumentsDirectory();
      String thumbPath = myPath.path;
      var videoThumb = await VideoThumbnail.thumbnailFile(
        video: pickVideo.path,
        thumbnailPath: thumbPath,
        imageFormat: ImageFormat.JPEG,
        maxHeight: 720,
        maxWidth: 1280,
        quality: 80,
      );
      attachment.thumbnailVideo = File(videoThumb!);
      attachment.video = pickVideo;
    }
  }

  // void pickLocation() async {
  //   Position position = await Geolocator()
  //       .getCurrentPosition(desiredAccuracy: LocationAccuracy.high);
  //   if (position == null) {
  //     Fluttertoast.showToast(
  //         msg: translate("checkGPS"), toastLength: Toast.LENGTH_SHORT);
  //   } else {
  //     var result = await Navigator.push(
  //         context,
  //         PageTransition(
  //             type: PageTransitionType.fade,
  //             child: MapPicker(
  //               "AIzaSyB3RM2rmLCsLzuymu6IU_0kx-GNmoAaY6g",
  //               LatLng(position.latitude, position.longitude),
  //             )));
  //     if (result != null) {
  //       Position position = result["latlng"];
  //       var resultMessage = await API.sendMessage(
  //           lPin: widget.identifier,
  //           messageScopeId: "3",
  //           status: "2",
  //           attachmentFlag: "3",
  //           readReceipts: widget.attachment.getAckActive ? "8" : "",
  //           messageText:
  //               "Share location ${result["namePlace"]} lat/lng: (${position.latitude},${position.longitude})");
  //       var formatTime = new DateFormat('Hm');
  //       String refId, refName, refText, refType, refThumbId, refThumbLoc;
  //       if (widget.attachment.getReplyContent != null) {
  //         refId = widget.attachment.getReplyContent["message_id"];
  //         refName = widget.attachment.getReplyContent["fromName"];
  //         refText = widget.attachment.getReplyContent["attachment_type"] ==
  //                     "3" ||
  //                 widget.attachment.getReplyContent["attachment_type"] == "-1"
  //             ? ""
  //             : widget.attachment.getReplyContent["text"];
  //         refType = widget.attachment.getReplyContent["attachment_type"];
  //         refThumbId = widget.attachment.getReplyContent["thumb_id"];
  //         refThumbLoc = widget.attachment.getReplyContent["thumb_location"];
  //       }
  //       int countCredential;
  //       String credential;
  //       if (widget.attachment.getConfidentialActive) {
  //         credential = "1";
  //         countCredential = 60;
  //         SharedPreferences prefs = await SharedPreferences.getInstance();
  //         prefs.setInt(
  //             resultMessage, DateTime.now().toUtc().millisecondsSinceEpoch);
  //       }
  //       widget.select.addChat = Chat(
  //           isOriginator: true,
  //           text: Uri.encodeQueryComponent(Uri.encodeFull(
  //               "Share location ${result["namePlace"]} lat/lng: (${position.latitude},${position.longitude})")),
  //           statusRead: "1",
  //           attachmentType: "3",
  //           countCredential: countCredential,
  //           credential: credential,
  //           messageId: resultMessage,
  //           runCount: false,
  //           refId: refId,
  //           refFrom: refName,
  //           refType: refType,
  //           refText: refText,
  //           refThumbId: refThumbId,
  //           refThumbLoc: refThumbLoc,
  //           ack: widget.attachment.getAckActive ? "8" : "",
  //           lPin: widget.identifier,
  //           time: formatTime.format(DateTime.now()),
  //           date: DateTime.now());
  //     }
  //   }
  // }

  void pickFile(Attachment attachment) async {
    FilePickerResult? result = await FilePicker.platform
        .pickFiles(type: FileType.any, allowMultiple: false);
    File? pickFile;
    if (result != null && result.files.single != null) {
      pickFile = File(result.files.single.path!);
    }
    if (pickFile == null) {
      return;
    } else {
      if (pickFile.lengthSync() * 0.001 >= 250.0) {
        Fluttertoast.showToast(
            msg: "You can only attach file that are less than 250 KB");
        return null;
      }
      if (attachment.getVideo != null) {
        attachment.video = null;
        attachment.thumbnailVideo = null;
      } else if (attachment.getListImage.length > 0) {
        attachment.clearListImage = true;
      }
      attachment.file = pickFile;
    }
  }

  void onMessageReceiver(ListMessage listMessage, Attachment attachment) {
    API.onReceiveMessage = (dynamic result) async {
      print("result receive message chat screen: $result");
      if (mounted) {
        SharedPreferences prefs = await SharedPreferences.getInstance();
        String idMe = prefs.getString("hasLogin")!;
        if (result.containsKey('flag')) {
          if (result["flag"] == "PUSH_CALL_CENTER") {
          } else if (result["flag"] == "ACCEPT_CALL_CENTER") {
            var resultQueryMe = await DBHelper()
                .queryCustom("SELECT * FROM BUDDY WHERE f_pin='$idMe'");
            if (resultQueryMe[0]["user_type"] == "24") {
              return;
            }
            String f_pin = result["f_pin"];
            String real_name = result["real_name"];
            String complaint_id = result.containsKey("complaint_id")
                ? result["complaint_id"]
                : "";
            String first_timeout = result["first_timeout"];
            String channel =
                result.containsKey("channel") ? result["channel"] : "-1";
            SharedObj.setCacheCallCenter(f_pin, complaint_id);
            if (await DBHelper().getLiveCenterSession(f_pin) == "2") {
              widget.changeState.identifier = f_pin;
              widget.changeState.isGoingCallCenter = true;
              widget.changeState.isGoingCallCenterFPIN = f_pin;
              widget.changeState.isGoingCallCenterComplaintID = complaint_id;
              print("Real Name accept: ${real_name}");
              print(
                  "ComplaintID accept: ${widget.changeState.isGoingCallCenterComplaintID}");
              // var resultQuery = await DBHelper().queryCustom(
              //     "SELECT * FROM BUDDY WHERE f_pin='$f_pin'");
              DateFormat dateformat = DateFormat("HH:mm");
              String dateNow = dateformat.format(DateTime.now());
              if (resultQueryMe[0]["user_type"] != "24" &&
                  widget.changeState.isRequestingCallCenter) {
                // if (resultQueryMe[0]["user_type"] == '0') {
                //   Notifications.showNotifications(result, 2, context);
                // }
                String text =
                    "_You are connected to $real_name at $dateNow. To improve our service, all conversation will be recorded in accordance with state regulation..._";
                widget.changeState.isRequestingCallCenter = false;
                var msg = createMessageContactCenter(text, "0");
                addMessage(msg);
                if (first_timeout == "1" && channel == "0") {
                  createTimeoutFirstResponse();
                }
              }
              Notifications.showNotifications(result, 2, context);
              setState(() {});
            }
          } else if (result["flag"] == "END_CALL_CENTER") {
            SharedObj.deleteCacheCallCenter();
            // var status =
            // await DBHelper().getLiveCenterSession(widget.changeState.identifier);
            if (widget.changeState.isContactCenter) {
              var resultQuery = await DBHelper().queryCustom(
                  "SELECT * FROM BUDDY WHERE f_pin='${widget.changeState.identifier}'");
              if (resultQuery[0]["f_pin"] == result["f_pin"]) {
                widget.changeState.isClickEnd = true;
                widget.changeState.isCallCenterEnded = true;
                widget.changeState.isRequestingCallCenter = false;
                var resultQueryMe = await DBHelper()
                    .queryCustom("SELECT * FROM BUDDY WHERE f_pin='$idMe'");
                if (resultQueryMe[0]["user_type"] == "24") {
                  // String text = "_Call Center Session has ended..._";
                  // var msg = createMessageContactCenter(text, "0");
                  // addMessage(msg);
                } else {
                  stopTimeoutFirstResponse();
                  String text = "_Call Center Session has ended..._";
                  var msg = createMessageContactCenter(text, "0");
                  addMessage(msg);
                }
                widget.attachment.isBlock = 1;
                widget.attachment.textBlock = "Call Center Session has ended";
                setState(() {});
                Future.delayed(Duration(milliseconds: 500), () {
                  API.setCCSessionWelcome("");
                  widget.changeState.isGoingCallCenter = false;
                  widget.changeState.isGoingCallCenterTemp = false;
                  widget.changeState.isGoingCallCenterFPIN = "";
                  widget.changeState.isGoingCallCenterComplaintID = "";
                  widget.changeState.isGoingCallCenterDATA = "";
                  widget.changeState.isRequestingCallCenter = false;
                  PalioButtonState statePalio = PalioButtonState();
                  statePalio.receiveMessage(context);
                  statePalio.incomingCall(context);
                  Navigator.pop(context);
                });
              }
            }
          }
          return;
        }
        if (widget.changeState.isContactCenter) {
          if (result["icc"] != "1" || result["B4"] == "1") {
            return;
          }
        } else {
          if (result["icc"] == "1") {
            return;
          }
        }
        if (widget.changeState.isContactCenterHistory) {
          if (result["ccid"] !=
                  widget.changeState.isGoingCallCenterComplaintID ||
              result["B4"] == "1") {
            return;
          }
        }
        var idOp = widget.changeState.identifier;
        var res01 = result["A01"];
        var res00 = result["A00"];
        if ((res00 == idOp && res01 == idMe) ||
            (result["ccid"].isNotEmpty &&
                (result["ccid"] ==
                    widget.changeState.isGoingCallCenterComplaintID))) {
          API.sendReadMessageStatus(
              result["A00"], "", result["A06"], result["A18"]);
          String? fileName, thumbName, attachmentFlag, room_id, unDownloadThumb;
          double progress = 0.0;
          room_id!;
          bool auto = await getAutoDownload();
          if (result["A57"] != null) {
            fileName = result["A57"];
            thumbName = "${attachment.path.path}/${result["A74"]}";
            attachmentFlag = "1";
            progress = 100.0;
            if (auto) {
              Fluttertoast.showToast(
                  msg: "Downloading...", toastLength: Toast.LENGTH_SHORT);
              API.download(result["A57"]);
            }
          } else if (result["A149"].toString() == "11") {
            attachmentFlag = "11";
          } else if (result["A47"] != null) {
            fileName = result["A47"];
            thumbName = "${attachment.path.path}/${result["A74"]}";
            unDownloadThumb = result["A74"];
            if (!File("${attachment.path.path}/${result["A74"]}")
                .existsSync()) {
              API.download(result["A74"]);
            }
            attachmentFlag = "2";
            if (auto) {
              Fluttertoast.showToast(
                  msg: "Downloading...", toastLength: Toast.LENGTH_SHORT);
              API.download(result["A47"]);
            }
          } else if (result["BN"] != null) {
            fileName = result["BN"];
            attachmentFlag = "6";
            if (auto) {
              Fluttertoast.showToast(
                  msg: "Downloading...", toastLength: Toast.LENGTH_SHORT);
              API.download(result["BN"]);
            }
          } else if (result["A63"] != null) {
            fileName = result["A63"];
            attachmentFlag = "-1";
            if (auto) {
              Fluttertoast.showToast(
                  msg: "Downloading...", toastLength: Toast.LENGTH_SHORT);
              API.download(result["A63"]);
            }
          } else if (result["A07"].contains("Share%20location%20")) {
            attachmentFlag = "3";
          } else if (result["A149"].toString() == "12" ||
              result["A149"].toString() == "19") {
            attachmentFlag = result["A149"].toString();
          } else {
            attachmentFlag = "0";
          }
          String? refId, refName, refText, refType, refThumbId, refThumbLoc;
          if (result["A121"] != null) {
            var resultReplyMessage = await DBHelper().queryCustom(
                "SELECT * FROM MESSAGE WHERE message_id='${result["A121"]}'${widget.changeState.isContactCenter ? " AND is_call_center = 1" : ''}");
            if (resultReplyMessage.length != 0) {
              String? imageLocation;
              if (resultReplyMessage[0]["message_text"]
                  .contains("lat/lng: (")) {
                String textDecode = Uri.decodeQueryComponent(
                    Uri.decodeFull(resultReplyMessage[0]["message_text"]));
                int idx = textDecode.indexOf("(");
                var textLatLng = textDecode
                    .substring(idx + 1, textDecode.trim().length - 1)
                    .split(",");
                imageLocation =
                    "https://maps.googleapis.com/maps/api/staticmap?center=" +
                        textLatLng[0] +
                        "," +
                        textLatLng[1].trimLeft() +
                        "&zoom=15&size=" +
                        300.toString() +
                        "x" +
                        150.toString() +
                        "&maptype=normal&markers=color:red|" +
                        textLatLng[0] +
                        "," +
                        textLatLng[1].trimLeft() +
                        "&key=AIzaSyC79oNmadezP9O_4Q_Ud2bbuJ_L7M--y1s";
              }
              refId = result["A121"];
              var resultQueryBuddyreff;
              SharedPreferences prefs = await SharedPreferences.getInstance();
              String idMe = prefs.getString("hasLogin")!;
              if (resultReplyMessage[0]["f_pin"] != idMe) {
                resultQueryBuddyreff = await DBHelper().queryCustom(
                    "SELECT first_name, last_name, image_id FROM BUDDY WHERE f_pin='${resultReplyMessage[0]["f_pin"]}'");
              }
              refName = resultReplyMessage[0]["f_pin"] == idMe
                  ? "You"
                  : resultQueryBuddyreff[0]["first_name"] +
                      " " +
                      resultQueryBuddyreff[0]["last_name"];
              refText = resultReplyMessage[0]["message_text"]
                          .contains("lat/lng: (") ||
                      resultReplyMessage[0]["audio_id"] != ""
                  ? ""
                  : resultReplyMessage[0]["message_text"];
              if (resultReplyMessage[0]["image_id"] != "") {
                refThumbId =
                    "${attachment.path.path}/${resultReplyMessage[0]["thumb_id"]}";
                refType = "1";
              } else if (resultReplyMessage[0]["video_id"] != "") {
                refThumbId =
                    "${attachment.path.path}/${resultReplyMessage[0]["thumb_id"]}";
                refType = "2";
              } else if (resultReplyMessage[0]["file_id"] != "") {
                refType = "6";
              } else if (resultReplyMessage[0]["audio_id"] != "") {
                refType = "-1";
              } else if (resultReplyMessage[0]["message_text"]
                  .contains("lat/lng: (")) {
                refType = "3";
              } else if (resultReplyMessage[0]["attachment_flag"].toString() ==
                  "11") {
                refType = "11";
              } else {
                refType = "0";
              }
              refThumbId = resultReplyMessage[0]["thumb_id"];
              refThumbLoc = imageLocation!;
            }
          }
          int countCredential = 0;
          if (result["A118"] == "1") {
            SharedPreferences prefs = await SharedPreferences.getInstance();
            prefs.setInt(
                result["A18"], DateTime.now().toUtc().millisecondsSinceEpoch);
            countCredential = 60;
          }
          DateTime dateTime =
              DateTime.fromMillisecondsSinceEpoch(int.parse(result["A19"]));
          var formatTime = new DateFormat('Hm');
          var text = result["A07"];

          //Chatbot LS Invitation
          if (result["A149"] == "27") {
            var parseLSMessage = jsonDecode(text);
            var title = parseLSMessage['title'];
            String titleLS = title.split("~")[1];
            var desc = parseLSMessage['description'];
            var by = parseLSMessage['by'];
            var times = parseLSMessage['time'];
            List<dynamic> members = jsonDecode(parseLSMessage['members']);
            DateTime dateTimes = DateTime.fromMillisecondsSinceEpoch(
                int.parse(times.toString()) + 240000);
            String name = await getUserName(by);
            room_id = result["A52"] + "~" + text;
            if (dateTimes.minute < 10) {
              String timeString = dateTimes.day.toString() +
                  "-" +
                  dateTimes.month.toString() +
                  "-" +
                  dateTimes.year.toString() +
                  " " +
                  dateTimes.hour.toString() +
                  ":" +
                  "0" +
                  dateTimes.minute.toString();
              if (language == "en_US") {
                text =
                    "Live Video Promotion\nTitle : $titleLS \nDescription : $desc \nStart : $timeString \nBroadcaster : $name";
              } else {
                text =
                    "Live Video Promotion\nJudul : $titleLS \nDeskripsi : $desc \nMulai : $timeString \nPenyiar : $name";
              }
            } else {
              String timeString = dateTimes.day.toString() +
                  "-" +
                  dateTimes.month.toString() +
                  "-" +
                  dateTimes.year.toString() +
                  " " +
                  dateTimes.hour.toString() +
                  ":" +
                  dateTimes.minute.toString();
              if (language == "en_US") {
                text =
                    "Live Video Promotion\nTitle : $titleLS \nDescription : $desc \nStart : $timeString \nBroadcaster : $name";
              } else {
                text =
                    "Live Video Promotion\nJudul : $titleLS \nDeskripsi : $desc \nMulai : $timeString \nPenyiar : $name";
              }
            }

            fileName;
            thumbName = "assets/images/live_tv.png";
            attachmentFlag = "27";
          } else if (result["A149"] == "25") {
            var parseVCRMessage = json.decode(text);
            var by = parseVCRMessage['by'];
            var times = parseVCRMessage['time'];
            List<dynamic> members = jsonDecode(parseVCRMessage['members']);
            DateTime dateTimes = DateTime.fromMillisecondsSinceEpoch(times);
            String name = await getUserName(by);
            room_id = result["A52"] + "~" + text;
            if (dateTimes.minute < 10) {
              String timeString = dateTimes.day.toString() +
                  "-" +
                  dateTimes.month.toString() +
                  "-" +
                  dateTimes.year.toString() +
                  " " +
                  dateTimes.hour.toString() +
                  ":" +
                  "0" +
                  dateTimes.minute.toString();
              if (language == "en_US") {
                text =
                    "Video Conference Room\nStart : $timeString \nInitiator : $name \nRoom ID :  " +
                        room_id!.split("~")[0];
              } else {
                text =
                    "Video Conference Room\nMulai : $timeString \nInisiator : $name \nRoom ID :  " +
                        room_id!.split("~")[0];
              }
            } else {
              String timeString = dateTimes.day.toString() +
                  "-" +
                  dateTimes.month.toString() +
                  "-" +
                  dateTimes.year.toString() +
                  " " +
                  dateTimes.hour.toString() +
                  ":" +
                  dateTimes.minute.toString();
              if (language == "en_US") {
                text =
                    "Video Conference Room\nStart : $timeString \nInitiator : $name \nRoom ID :  " +
                        room_id!.split("~")[0];
              } else {
                text =
                    "Video Conference Room\nMulai : $timeString \nInisiator : $name \nRoom ID :  " +
                        room_id!.split("~")[0];
              }
            }

            fileName;
            thumbName = "assets/images/ic_action_live_conference.png";
            attachmentFlag = "25";
          } else if (result["A149"] == "24") {
            var parseVCRMessage = json.decode(text);
            print(parseVCRMessage);
            var by = parseVCRMessage['by'];
            String name = await getUserName(by);
            String student = await getUserName(idMe);
            String titleQuiz =
                toNormalString(parseVCRMessage['title'].toString());
            String descQuiz =
                toNormalString(parseVCRMessage['description'].toString());
            if (language == "en_US") {
              String pricing = parseVCRMessage['pricing'].toString() == "0"
                  ? "Free"
                  : "Paid";
              text =
                  "Quiz\nTitle : ${titleQuiz} \nDescription : ${descQuiz} \nEducator: $name \nStudent: $student";
            } else {
              String pricing = parseVCRMessage['pricing'].toString() == "0"
                  ? "Gratis"
                  : "Berbayar";
              text =
                  "Kuis\nJudul : ${titleQuiz} \nDeskripsi : ${descQuiz} \nPendidik: $name \nPelajar: $student";
            }

            fileName!;
            thumbName = "assets/images/seminar_wpr.png";
            attachmentFlag = "24";
          }
          // if(widget.fullName == "Bot"){
          text = removeBreak(text);
          // }
          Chat message = Chat(
              text: text,
              messageId: result["A18"],
              time: formatTime.format(dateTime),
              attachmentType: attachmentFlag,
              statusRead: result["A15"],
              refThumbId: refThumbId,
              lPin: result["A01"],
              refId: refId,
              refThumbLoc: refThumbLoc,
              refText: refText,
              refType: refType,
              refFrom: refName,
              fileName: fileName,
              thumbName: thumbName,
              date: dateTime,
              progress: progress,
              countCredential: countCredential,
              unDownloadThumb: unDownloadThumb,
              runCount: false,
              credential: result["A118"],
              ack: result["Bf"],
              blog_id: room_id,
              isOriginator: false);
          if (!attachment.isNotBottom) {
            listMessage.addChat = message;
          } else {
            listMessage.addNewMessages = message;
          }
          await API.updateCounter(widget.changeState.identifier);
          if (widget.selectChat.getSelectedChat.length > 0) {
            widget.selectChat.getSelectedChat.forEach((k, v) {
              int idx = widget.select.getChat
                  .indexWhere((element) => element.messageId == v.messageId);
              widget.select.falseSelected = idx;
            });
            widget.attachment.justDelete = 0;
            widget.attachment.cantForward = 0;
            if (widget.attachment.disableFavoriteMessage) {
              widget.attachment.disableFavoriteMessage = false;
            }
            widget.selectChat.clearList = true;
          }
        } else {
          if (!widget.changeState.isContactCenter) {
            Notifications.showNotifications(result, 0, context, level: 2);
          }
        }
      }
      if (!widget.attachment.refresh) {
        widget.attachment.refresh = true;
      }
    };
  }

  Timer? _timeoutFirstResponse;

  void createTimeoutFirstResponse() {
    if (_timeoutFirstResponse == null) {
      _timeoutFirstResponse = Timer(Duration(seconds: 30), () {
        Fluttertoast.showToast(
            msg:
                "The Call Center Automatically ended because you did not respond for 30 seconds",
            toastLength: Toast.LENGTH_LONG);
        setEndCallCenter();
        _timeoutFirstResponse?.cancel();
        _timeoutFirstResponse = null;
        PalioButtonState statePalio = PalioButtonState();
        statePalio.receiveMessage(context);
        statePalio.incomingCall(context);
        Navigator.pop(context);
      });
    }
  }

  void stopTimeoutFirstResponse() {
    if (_timeoutFirstResponse != null) {
      _timeoutFirstResponse?.cancel();
      _timeoutFirstResponse = null;
    }
  }

  void onMessage(ListMessage listMessage, Attachment attachment) {
    API.onMessage = (dynamic result) async {
      print("RESULT $result");
      if (mounted) {
        SharedPreferences prefs = await SharedPreferences.getInstance();
        String idMe = prefs.getString("hasLogin")!;
        if ((result["A00"] == idMe &&
                result["A01"] == widget.changeState.identifier) ||
            (result["A00"] == widget.changeState.identifier &&
                result["A01"] == idMe)) {
          if (!result["A18"].contains("-2,")) {
            int idx =
                listMessage.getChat.indexOf(Chat(messageId: result["A18"]));
            if (idx != -1) {
              if (result["D01"] == "1") {
                listMessage.updateStatusDelete = {
                  "index": idx,
                  "value": "🚫 _This message was deleted_",
                  "flag": "0"
                };
              } else {
                listMessage.updateStatus = {
                  "index": idx,
                  "value": result["A15"]
                };
              }
            }
          } else {
            int idx = listMessage.getChat
                .indexOf(Chat(messageId: result["A18"].split(",")[1]));
            if (idx != -1) {
              listMessage.updateStatus = {"index": idx, "value": result["A15"]};
            }
          }
        }
        if (!attachment.refresh) {
          attachment.refresh = true;
        }
      }
    };
  }

  void incomingCall(BuildContext context) {
    // CallNotifications.init(context);
    API.incomingCall = (int state, String message) {
      String? idMe;
      var queryMe;
      print("message : " + message);
      String deviceId = message.substring(0, message.indexOf(","));
      print("DEVICE ID : " + deviceId);
      SharedPreferences.getInstance().then((prefs) {
        idMe = prefs.getString("hasLogin")!;
      });
      DBHelper()
          .queryCustom(
              "SELECT first_name, last_name,f_pin, offline_mode, image_id FROM BUDDY")
          .then((value) {
        for (var i = 0; i < value.length; i++) {
          if (value[i]["f_pin"] == idMe!) {
            queryMe = value[i];
            break;
          }
        }
      });
      DBHelper()
          .queryCustom(
              "SELECT first_name, last_name,f_pin, offline_mode, image_id FROM BUDDY WHERE f_pin = '$deviceId'")
          .then((result) {
        print("Result : " + result.toString());
        if (queryMe["offline_mode"].toString() != "1" ||
            widget.changeState.isContactCenter) {
          if (widget.changeState.isGoingCallCenter &&
              result[0]['f_pin'] != widget.changeState.identifier) {
            API.terminateCall(deviceId);
            SharedObj.stopRingtone();
            return;
          }
          if (state == 21) {
            print("fpin : " + result[0]["f_pin"]);
            SharedObj.startRingtone();
            Notifications.showNotifications(result[0], 1, context,
                state: state);
            Navigator.push(
                context,
                PageTransition(
                    type: PageTransitionType.fade,
                    child: AudioCall(
                      name:
                          "${result[0]["first_name"]} ${result[0]["last_name"]}",
                      image: result[0]["image_id"],
                      isInitiatior: 0,
                      deviceId: deviceId,
                      isContactCenter: widget.changeState.isContactCenter,
                    )));
          } else if (state == 31) {
            print("fpin : " + result[0]["f_pin"]);
            SharedObj.startRingtone();
            Notifications.showNotifications(result[0], 1, context,
                state: state);
            Navigator.push(
                context,
                PageTransition(
                    type: PageTransitionType.fade,
                    child: VideoCall(
                      name:
                          "${result[0]["first_name"]} ${result[0]["last_name"]}",
                      isInitiatior: 0,
                      deviceId: deviceId,
                      cameraId: "1",
                      image: result[0]["image_id"],
                      isContactCenter: widget.changeState.isContactCenter,
                    )));
          }
        } else {
          API.terminateCall(deviceId);
          SharedObj.stopRingtone();
        }
      });
    };
  }

  Future<bool> onWillPop() async {
    if (widget.attachment.isSearch) {
      _controllerSearch.clear();
      widget.attachment.isSuffix = false;
      widget.attachment.isSearch = false;
      widget.attachment.textSearch = null;
      widget.attachment.indexLastSearch = 0;
    } else if (widget.selectChat.getSelectedChat.length > 0) {
      widget.selectChat.getSelectedChat.forEach((k, v) {
        int idx = widget.select.getChat
            .indexWhere((element) => element.messageId == v.messageId);
        widget.select.falseSelected = idx;
      });
      widget.attachment.justDelete = 0;
      widget.attachment.cantForward = 0;
      if (widget.attachment.disableFavoriteMessage) {
        widget.attachment.disableFavoriteMessage = false;
      }
      widget.selectChat.clearList = true;
    } else if (widget.changeState.isGoingCallCenter) {
      var status =
          await DBHelper().getLiveCenterSession(widget.changeState.identifier);
      if (status == "2") {
        showDialog(
            context: context,
            builder: (context) {
              return CupertinoAlertDialog(
                  insetAnimationCurve: Curves.easeInBack,
                  title: Text("Interaction with Call Center In Progress"),
                  content: Container(
                    margin: EdgeInsets.only(top: 10),
                    child: Text(
                      "Have you finished your call?",
                      textAlign: TextAlign.start,
                    ),
                  ),
                  actions: <Widget>[
                    CupertinoDialogAction(
                      onPressed: () => Navigator.pop(context),
                      child: Text("NOT YET",
                          style: TextStyle(
                              color: AppColor.primaryColor, fontSize: 14)),
                    ),
                    CupertinoDialogAction(
                      onPressed: () async {
                        stopTimeoutFirstResponse();
                        await setEndCallCenter();
                        Navigator.pop(context);
                        PalioButtonState statePalio = PalioButtonState();
                        statePalio.receiveMessage(context);
                        statePalio.incomingCall(context);
                        Notifications.clearNotification(
                            Notifications.NOTIFICATION_CALL_CENTER_ID);
                        Navigator.pop(context);
                        // Navigator.pushReplacement(context,
                        //     PageTransition(type: PageTransitionType.fade, child: Home(index: 1,)));
                      },
                      child: Text("FINISH",
                          style: TextStyle(
                              color: AppColor.primaryColor, fontSize: 14)),
                    )
                  ]);
            });
      } else {
        API.setCCSessionWelcome("");
        widget.changeState.isGoingCallCenter = false;
        widget.changeState.isGoingCallCenterTemp = false;
        widget.changeState.isGoingCallCenterFPIN = "";
        widget.changeState.isGoingCallCenterComplaintID = "";
        widget.changeState.isGoingCallCenterDATA = "";
        widget.changeState.isRequestingCallCenter = false;
        PalioButtonState statePalio = PalioButtonState();
        statePalio.receiveMessage(context);
        statePalio.incomingCall(context);
        Notifications.clearNotification(
            Notifications.NOTIFICATION_CALL_CENTER_ID);
        Navigator.pop(context);
      }
    } else {
      PalioButtonState statePalio = PalioButtonState();
      statePalio.receiveMessage(context);
      statePalio.incomingCall(context);
      Navigator.pop(context);
    }
    return Future.value(false);
  }

  Future<void> setEndCallCenter() async {
    await API.setLiveCenterSession(widget.changeState.identifier, "0",
        complaintId: widget.changeState.isGoingCallCenterComplaintID);
    SharedObj.deleteCacheCallCenter();
    await API.endRequestCallCenter(widget.changeState.identifier,
        widget.changeState.isGoingCallCenterComplaintID);
    // Future.delayed(const Duration(seconds: 3), () async {
    //   SharedPreferences prefs = await SharedPreferences.getInstance();
    //   String idMe = prefs.getString("hasLogin");
    //   var queryMe = await DBHelper()
    //       .queryCustom(
    //       "SELECT * FROM BUDDY WHERE f_pin = '$idMe'");
    //   if(queryMe[0]["user_type"] == "24"){
    //     API.timeOutRequestCallCenter(SharedObj.CALL_CENTER_SESSION_F_PIN, widget.channel);
    //   }
    // });
    widget.changeState.isGoingCallCenter = false;
    widget.changeState.isGoingCallCenterTemp = false;
    widget.changeState.isGoingCallCenterFPIN = "";
    widget.changeState.isGoingCallCenterComplaintID = "";
    widget.changeState.isGoingCallCenterDATA = "";
    widget.changeState.isRequestingCallCenter = false;
  }

  String removeBreak(String htmlText) {
    String result = htmlText.replaceAll("<br/>", "\n");
    result = result.replaceAll("<br>", "\n");
    return result;
  }

  String fromHTML(String htmlText) {
    var document = parse(htmlText);
    String result = parse(document.body!.text).documentElement!.text;
    return result;
  }

  Future<String> getUserName(String f_pin) async {
    String name;
    var resultQueryBuddy = await DBHelper().queryCustom(
        "SELECT first_name, last_name FROM BUDDY WHERE f_pin = '$f_pin'");
    print("name " + resultQueryBuddy[0]['first_name']);
    print("last name " + resultQueryBuddy[0]['last_name']);
    name = resultQueryBuddy[0]['first_name'] +
        " " +
        resultQueryBuddy[0]['last_name'];
    return name;
  }

  Future<void> getChat(
      ListMessage listMessage, Attachment attachment, int limit,
      {int end = 40}) async {
    SharedPreferences prefs = await SharedPreferences.getInstance();
    attachment.path = await getApplicationDocumentsDirectory();
    String idMe = prefs.getString("hasLogin")!;
    List<dynamic> resultQuery = await DBHelper().getMessages(
        widget.changeState.identifier,
        widget.changeState.identifier,
        limit,
        end);
    List<Chat> temporaryChat = [];
    for (var i = 0; i < resultQuery.length; i++) {
      if (widget.changeState.isContactCenter &&
          (resultQuery[i]["broadcast_flag"] == 1 ||
              resultQuery[i]["is_call_center"] == 0 ||
              resultQuery[i]["call_center_id"] !=
                  widget.changeState.isGoingCallCenterComplaintID)) {
        continue;
      }
      if (!widget.changeState.isContactCenter &&
          resultQuery[i]["is_call_center"] == 1) {
        continue;
      }
      if (widget.changeState.isContactCenterHistory &&
          (resultQuery[i]["broadcast_flag"] == 1 ||
              resultQuery[i]["call_center_id"] !=
                  widget.changeState.isGoingCallCenterComplaintID)) {
        continue;
      }
      var resultQueryMessageStatus = await DBHelper().queryCustom(
          "SELECT status FROM MESSAGE_STATUS WHERE message_id='${resultQuery[i]["message_id"]}' AND f_pin='${widget.changeState.identifier}'");
      DateTime dateTime =
          DateTime.fromMillisecondsSinceEpoch(resultQuery[i]["server_date"]);
      var formatTime = new DateFormat('Hm');
      if (resultQuery[i]["f_pin"] != idMe &&
          !resultQuery[i]["message_text"].contains("🚫")) {
        if (resultQuery[i]["status"] != "4" &&
            resultQuery[i]["status"] != "8") {
          API.sendReadMessageStatus(resultQuery[i]["f_pin"], "",
              resultQuery[i]["message_scope_id"], resultQuery[i]["message_id"]);
        }
      }
      String? fileName, thumbName, attachmentFlag, room_id, unDownloadThumb;
      room_id;
      double progress = 0.0;
      bool auto = await getAutoDownload();
      if (resultQuery[i]["image_id"].trim().isNotEmpty) {
        fileName = resultQuery[i]["image_id"];
        thumbName = "${attachment.path.path}/${resultQuery[i]["thumb_id"]}";
        if (File("${attachment.path.path}/${resultQuery[i]["image_id"]}")
            .existsSync()) {
          progress = 100.0;
        } else {
          if (auto) {
            API.download(resultQuery[i]["image_id"]);
          }
        }
        attachmentFlag = "1";
      } else if (resultQuery[i]["video_id"].trim().isNotEmpty) {
        fileName = resultQuery[i]["video_id"];
        thumbName = "${attachment.path.path}/${resultQuery[i]["thumb_id"]}";
        attachmentFlag = "2";
        if (File("${attachment.path.path}/${resultQuery[i]["video_id"]}")
            .existsSync()) {
          progress = 100.0;
        } else {
          if (auto) {
            API.download(resultQuery[i]["video_id"]);
          }
        }
        if (!File("${attachment.path.path}/${resultQuery[i]["thumb_id"]}")
            .existsSync()) {
          thumbName = "assets/images/cuc_scope_image.png";
          unDownloadThumb = resultQuery[i]["thumb_id"];
          API.download(resultQuery[i]["thumb_id"]);
        }
      } else if (resultQuery[i]["file_id"].trim().isNotEmpty) {
        fileName = resultQuery[i]["file_id"];
        attachmentFlag = "6";
        if (File("${attachment.path.path}/${resultQuery[i]["file_id"]}")
            .existsSync()) {
          progress = 100.0;
        } else {
          if (auto) {
            API.download(resultQuery[i]["file_id"]);
          }
        }
      } else if (resultQuery[i]["audio_id"].trim().isNotEmpty) {
        fileName = resultQuery[i]["audio_id"];
        attachmentFlag = "-1";
        if (File("${attachment.path.path}/${resultQuery[i]["audio_id"]}")
            .existsSync()) {
          progress = 100.0;
        } else {
          if (auto) {
            API.download(resultQuery[i]["audio_id"]);
          }
        }
      } else if (resultQuery[i]["attachment_flag"].toString() == "11") {
        attachmentFlag = "11";
      } else if (resultQuery[i]["message_text"].contains("lat/lng: (")) {
        attachmentFlag = "3";
      } else if (resultQuery[i]["attachment_flag"].toString() == "12" ||
          resultQuery[i]["attachment_flag"].toString() == "19") {
        attachmentFlag = resultQuery[i]["attachment_flag"].toString();
      } else {
        attachmentFlag = "0";
      }
      String? refId, refName, refText, refType, refThumbId, refThumbLoc;
      if (resultQuery[i]["reff_id"].isNotEmpty) {
        int idx =
            temporaryChat.indexOf(Chat(messageId: resultQuery[i]["reff_id"]));
        String? imageLocation;
        String textDecode;
        if (idx != -1) {
          if (temporaryChat[idx].attachmentType == "3") {
            textDecode = Uri.decodeQueryComponent(
                Uri.decodeFull(temporaryChat[idx].text!));
            int idx2 = textDecode.indexOf("(");
            var textLatLng = textDecode
                .substring(idx2 + 1, textDecode.trim().length - 1)
                .split(",");
            imageLocation =
                "https://maps.googleapis.com/maps/api/staticmap?center=" +
                    textLatLng[0] +
                    "," +
                    textLatLng[1].trimLeft() +
                    "&zoom=15&size=" +
                    300.toString() +
                    "x" +
                    150.toString() +
                    "&maptype=normal&markers=color:red|" +
                    textLatLng[0] +
                    "," +
                    textLatLng[1].trimLeft() +
                    "&key=AIzaSyC79oNmadezP9O_4Q_Ud2bbuJ_L7M--y1s";
          }
          refId = resultQuery[i]["reff_id"];
          refName = temporaryChat[idx].isOriginator ? "You" : widget.fullName;
          refText = temporaryChat[idx].attachmentType == "3" ||
                  temporaryChat[idx].attachmentType == "-1"
              ? ""
              : temporaryChat[idx].text!;
          refType = temporaryChat[idx].attachmentType!;
          refThumbId = temporaryChat[idx].thumbName!;
        } else {
          List<dynamic> resultQueryReff = await DBHelper().queryCustom(
              "SELECT * FROM MESSAGE where message_id='${resultQuery[i]["reff_id"]}'${widget.changeState.isContactCenter ? " and is_call_center = 1" : ''}");
          if (resultQueryReff[0]["message_text"].contains("lat/lng: (")) {
            textDecode = Uri.decodeQueryComponent(
                Uri.decodeFull(resultQueryReff[0]["message_text"]));
            int idx = textDecode.indexOf("(");
            var textLatLng = textDecode
                .substring(idx + 1, textDecode.trim().length - 1)
                .split(",");
            imageLocation =
                "https://maps.googleapis.com/maps/api/staticmap?center=" +
                    textLatLng[0] +
                    "," +
                    textLatLng[1].trimLeft() +
                    "&zoom=15&size=" +
                    300.toString() +
                    "x" +
                    150.toString() +
                    "&maptype=normal&markers=color:red|" +
                    textLatLng[0] +
                    "," +
                    textLatLng[1].trimLeft() +
                    "&key=AIzaSyC79oNmadezP9O_4Q_Ud2bbuJ_L7M--y1s";
          }
          refId = resultQuery[i]["reff_id"];
          refName =
              resultQueryReff[0]["f_pin"] == idMe ? "You" : widget.fullName;
          refText = resultQueryReff[0]["message_text"].contains("lat/lng: (") ||
                  resultQueryReff[0]["audio_id"].trim().isNotEmpty
              ? ""
              : resultQueryReff[0]["message_text"];
          if (resultQueryReff[0]["image_id"].trim().isNotEmpty) {
            refThumbId =
                "${attachment.path.path}/${resultQueryReff[0]["thumb_id"]}";
            if (File(
                    "${attachment.path.path}/${resultQueryReff[0]["image_id"]}")
                .existsSync()) {
              progress = 100.0;
            }
            refType = "1";
          } else if (resultQueryReff[0]["video_id"].trim().isNotEmpty) {
            refThumbId =
                "${attachment.path.path}/${resultQueryReff[0]["thumb_id"]}";
            refType = "2";
            if (File(
                    "${attachment.path.path}/${resultQueryReff[0]["video_id"]}")
                .existsSync()) {
              progress = 100.0;
            }
          } else if (resultQueryReff[0]["file_id"].trim().isNotEmpty) {
            refType = "6";
            if (File("${attachment.path.path}/${resultQueryReff[0]["file_id"]}")
                .existsSync()) {
              progress = 100.0;
            }
          } else if (resultQueryReff[0]["audio_id"].trim().isNotEmpty) {
            refType = "-1";
            if (File(
                    "${attachment.path.path}/${resultQueryReff[0]["audio_id"]}")
                .existsSync()) {
              progress = 100.0;
            }
          } else if (resultQueryReff[0]["message_text"]
              .contains("lat/lng: (")) {
            refType = "3";
          } else if (resultQueryReff[0]["attachment_flag"].toString() == "11") {
            refType = "11";
          } else {
            refType = "0";
          }
        }
        refThumbLoc = imageLocation!;
      }
      int countCredential = 0;
      if (resultQuery[i]["credential"] == "1") {
        SharedPreferences prefs = await SharedPreferences.getInstance();
        if (prefs.getInt(resultQuery[i]["message_id"]) == null) {
          prefs.setInt(resultQuery[i]["message_id"],
              DateTime.now().toUtc().millisecondsSinceEpoch);
          countCredential = 60;
        } else {
          int timeCount = prefs.getInt(resultQuery[i]["message_id"])!;
          int difSecond = DateTime.now()
              .difference(DateTime.fromMillisecondsSinceEpoch(timeCount))
              .inSeconds;
          if (60 - difSecond > 0) {
            countCredential = 60 - difSecond;
          } else {
            countCredential = 0;
          }
        }
      }
      String text = resultQuery[i]["message_text"];
      // print("attachment flag " +
      //     resultQuery[i]["read_receipts"].toString() +
      //     " " +
      //     resultQuery[i]["message_id"]);
      //Chatbot LS Invitation
      if (resultQuery[i]["attachment_flag"].toString() == "27") {
        var parseLSMessage = json.decode(text);
        var title = parseLSMessage['title'];
        String titleLS = title.split("~")[1];
        var desc = parseLSMessage['description'];
        var by = parseLSMessage['by'];
        var times = parseLSMessage['time'];
        // print("time data " + times.runtimeType.toString());
        room_id = resultQuery[i]["blog_id"] + "~" + text;
        List<dynamic> members = jsonDecode(parseLSMessage['members']);
        DateTime dateTimes = DateTime.fromMillisecondsSinceEpoch(
            int.parse(times.toString()) + 240000);
        String name = await getUserName(by);
        if (dateTimes.minute < 10) {
          String timeString = dateTimes.day.toString() +
              "-" +
              dateTimes.month.toString() +
              "-" +
              dateTimes.year.toString() +
              " " +
              dateTimes.hour.toString() +
              ":" +
              "0" +
              dateTimes.minute.toString();
          text =
              "Live Video Promotion\nTitle : $titleLS \nDescription : $desc \nStart : $timeString \nBroadcaster : $name";
          // if (language == "en_US") {
          //   text =
          //       "Live Video Promotion\nTitle : $titleLS \nDescription : $desc \nStart : $timeString \nBroadcaster : $name";
          // } else {
          //   text =
          //       "Live Video Promotion\nJudul : $titleLS \nDeskripsi : $desc \nMulai : $timeString \nPenyiar : $name";
          // }
        } else {
          String timeString = dateTimes.day.toString() +
              "-" +
              dateTimes.month.toString() +
              "-" +
              dateTimes.year.toString() +
              " " +
              dateTimes.hour.toString() +
              ":" +
              dateTimes.minute.toString();
          text =
              "Live Video Promotion\nTitle : $titleLS \nDescription : $desc \nStart : $timeString \nBroadcaster : $name";
          // if (language == "en_US") {
          //   text =
          //       "Live Video Promotion\nTitle : $titleLS \nDescription : $desc \nStart : $timeString \nBroadcaster : $name";
          // } else {
          //   text =
          //       "Live Video Promotion\nJudul : $titleLS \nDeskripsi : $desc \nMulai : $timeString \nPenyiar : $name";
          // }
        }

        fileName;
        thumbName = "assets/images/live_tv.png";
        attachmentFlag = "27";
      } else if (resultQuery[i]["attachment_flag"].toString() == "25") {
        var parseVCRMessage = json.decode(text);
        // print(parseVCRMessage);
        var by = parseVCRMessage['by'];
        var times = parseVCRMessage['time'];
        List<dynamic> members = jsonDecode(parseVCRMessage['members']);
        DateTime dateTimes =
            DateTime.fromMillisecondsSinceEpoch(int.parse(times.toString()));
        String name = await getUserName(by);
        room_id = resultQuery[i]["blog_id"] + "~" + text;
        if (dateTimes.minute < 10) {
          String timeString = dateTimes.day.toString() +
              "-" +
              dateTimes.month.toString() +
              "-" +
              dateTimes.year.toString() +
              " " +
              dateTimes.hour.toString() +
              ":" +
              "0" +
              dateTimes.minute.toString();
          text =
              "Video Conference Room\nStart : $timeString \nInitiator : $name \nRoom ID :  " +
                  room_id!.split("~")[0];
          // if (language == "en_US") {
          //   text =
          //       "Video Conference Room\nStart : $timeString \nInitiator : $name \nRoom ID :  " +
          //           room_id.split("~")[0];
          // } else {
          //   text =
          //       "Video Conference Room\nMulai : $timeString \nInisiator : $name \nRoom ID :  " +
          //           room_id.split("~")[0];
          // }
        } else {
          String timeString = dateTimes.day.toString() +
              "-" +
              dateTimes.month.toString() +
              "-" +
              dateTimes.year.toString() +
              " " +
              dateTimes.hour.toString() +
              ":" +
              dateTimes.minute.toString();
          text =
              "Video Conference Room\nStart : $timeString \nInitiator : $name \nRoom ID :  " +
                  room_id!.split("~")[0];
          // if (language == "en_US") {
          //   text =
          //       "Video Conference Room\nStart : $timeString \nInitiator : $name \nRoom ID :  " +
          //           room_id.split("~")[0];
          // } else {
          //   text =
          //       "Video Conference Room\nMulai : $timeString \nInisiator : $name \nRoom ID :  " +
          //           room_id.split("~")[0];
          // }
        }

        fileName;
        thumbName = "assets/images/ic_action_live_conference.png";
        attachmentFlag = "25";
      } else if (resultQuery[i]["attachment_flag"].toString() == "24") {
        var parseVCRMessage = json.decode(text);
        // print(parseVCRMessage);
        var by = parseVCRMessage['by'];
        String name = await getUserName(by);
        String student = await getUserName(idMe);
        String titleQuiz = toNormalString(parseVCRMessage['title'].toString());
        String descQuiz =
            toNormalString(parseVCRMessage['description'].toString());
        if (language == "en_US") {
          String pricing =
              parseVCRMessage['pricing'].toString() == "0" ? "Free" : "Paid";
          text =
              "Quiz\nTitle : ${titleQuiz} \nDescription : ${descQuiz} \nEducator: $name \nStudent: $student";
        } else {
          String pricing = parseVCRMessage['pricing'].toString() == "0"
              ? "Gratis"
              : "Berbayar";
          text =
              "Kuis\nJudul : ${titleQuiz} \nDeskripsi : ${descQuiz} \nPendidik: $name \nPelajar: $student";
        }
        fileName;
        thumbName = "assets/images/seminar_wpr.png";
        attachmentFlag = "24";
      }
      var resultFavorite = await DBHelper().queryCustom(
          "SELECT message_id FROM MESSAGE_FAVORITE WHERE message_id='${resultQuery[i]["message_id"]}'");
      // if(widget.fullName == "Bot"){
      text = removeBreak(text);
      // }
      Chat message = Chat(
          text: text,
          messageId: resultQuery[i]["message_id"],
          lPin: resultQuery[i]["l_pin"],
          refId: refId,
          refFrom: refName,
          refText: refText,
          refThumbId: refThumbId,
          refType: refType,
          isFavorite: resultFavorite.length > 0 ? true : false,
          refThumbLoc: refThumbLoc,
          time: formatTime.format(dateTime),
          attachmentType: attachmentFlag,
          statusRead: resultQueryMessageStatus.length != 0
              ? resultQueryMessageStatus[0]["status"].toString()
              : resultQuery[i]["status"],
          fileName: fileName,
          thumbName: thumbName,
          countCredential: countCredential,
          date: dateTime,
          runCount: false,
          unDownloadThumb: unDownloadThumb,
          progress: progress,
          ack: resultQuery[i]["read_receipts"].toString(),
          credential: resultQuery[i]["credential"],
          blog_id: room_id,
          isOriginator: resultQuery[i]["f_pin"] == idMe);
      temporaryChat.add(message);
    }
    temporaryChat.sort((b, a) =>
        a.date.millisecondsSinceEpoch.compareTo(b.date.millisecondsSinceEpoch));
    listMessage.addChatAll = temporaryChat;
    if (widget.attachment.loading) {
      attachment.loading = false;
    }
    if (widget.refresh) {
      attachment.refresh = widget.refresh;
    }
  }

  String toNormalString(String stupidString) {
    String result = stupidString.replaceAll("+", " ");
    return result;
  }

  void startTimer(int idx) {
    widget.select.trueRunCount = idx;
    const oneSec = const Duration(seconds: 1);
    _timer = new Timer.periodic(
      oneSec,
      (Timer timer) async {
        // print("INDEX Timer $idx");
        if (widget.select.getChat[idx].countCredential == null) {
          idx = idx + 1;
        }
        if (widget.select.getChat[idx].countCredential! < 1) {
          timer.cancel();
          widget.attachment.refresh = true;
          // SharedPreferences prefs = await SharedPreferences.getInstance();
          // prefs.remove(widget.select.getChat[idx].messageId);
        } else {
          if (mounted) {
            widget.select.countCredential = {
              "index": idx,
              "count": widget.select.getChat[idx].countCredential! - 1
            };
          } else {
            timer.cancel();
          }
        }
      },
    );
  }

  @override
  void dispose() {
    if (_timer != null) {
      _timer?.cancel();
    }
    super.dispose();
  }

  void getFirstIndex() {
    int itemCount = widget.select.getChat.length;
    double scrollOffset = _scrollController.position.pixels;
    double viewportHeight = _scrollController.position.viewportDimension;
    double scrollRange = _scrollController.position.maxScrollExtent -
        _scrollController.position.minScrollExtent;
    int firstVisible =
        (scrollOffset / (scrollRange + viewportHeight) * itemCount).floor();
    if (firstVisible != 0) {
      if (!widget.attachment.isNotBottom &&
          !_scrollController.position.outOfRange) {
        widget.attachment.isNotBottom = true;
      }
    }
    if (firstVisible == 0) {
      if (widget.attachment.isNotBottom) {
        if (widget.select.getNewMessages.length != 0) {
          widget.select.insertAllChat = widget.select.getNewMessages;
          widget.select.clearNewMessages();
        }
        widget.attachment.isNotBottom = false;
      }
    }
  }

  void onDownload(ListMessage listMessage, Attachment attachment) {
    API.onDownloadProgress = (double progress, String fileName) {
      if (mounted) {
        int idx = widget.select.getChat.indexOf(Chat(fileName: fileName));
        if (idx != -1) {
          widget.select.updateProgress = {'index': idx, 'value': progress};
        } else {
          int idx2 =
              widget.select.getChat.indexOf(Chat(unDownloadThumb: fileName));
          if (idx2 != -1) {
            widget.select.updateThumbnail = {
              'index': idx2,
              'value': "${widget.attachment.path.path}/$fileName"
            };
          }
        }
      }
    };
  }

  void onUpload(ListMessage listMessage, Attachment attachment) {
    API.onUploadProgress = (double progress, String fileName) {
      if (mounted) {
        int idx = widget.select.getChat.indexOf(Chat(fileName: fileName));
        if (idx != -1) {
          widget.select.updateProgress = {'index': idx, 'value': progress};
        }
      }
    };
  }

  void onUploadFile(ListMessage listMessage, Attachment attachment) {
    API.onUploadFileProgress = (double progress, String fileName) {
      if (mounted) {
        int idx = widget.select.getChat.indexOf(Chat(fileName: fileName));
        if (idx != -1) {
          widget.select.updateProgress = {'index': idx, 'value': progress};
        }
      }
    };
  }

  void onTyping(ListMessage listMessage, Attachment attachment) {
    API.onTyping = (dynamic result) {
      if (mounted) {
        if (result["A00"] == widget.changeState.identifier &&
            result["A76"] == "3") {
          attachment.isTyping = true;
          if (_timerReceiveTyping != null && _timerReceiveTyping!.isActive) {
            _timerReceiveTyping?.cancel();
          }
          _timerReceiveTyping = Timer(Duration(seconds: 3), () {
            attachment.isTyping = false;
          });
        }
      }
    };
  }

  void onUpdateStatus(Attachment attachment) {
    API.onStatus = (int state, String status) {
      if (mounted) {
        if (state == 55) {
          if (status == "1") {
            if (!attachment.connected) {
              attachment.connected = true;
            }
          } else {
            if (attachment.connected) {
              attachment.connected = false;
            }
          }
        }
        if (state == 01) {
          var data = jsonDecode(status);
          if (data["l_pin"] == widget.changeState.identifier) {
            if (widget.attachment.isBlock == -1) {
              attachment.isBlock = 0;
            } else {
              String text = "You have been blocked by this user";
              attachment.textBlock = text;
              attachment.isBlock = -1;
            }
          }
        }
      }
    };
  }

  void event(ListMessage listMessage, Attachment attachment) async {
    onUpdateStatus(attachment);
    onMessageReceiver(listMessage, attachment);
    onMessage(listMessage, attachment);
    onDownload(listMessage, attachment);
    onTyping(listMessage, attachment);
    onUpload(listMessage, attachment);
    onUploadFile(listMessage, attachment);
  }

  void sendFirst(Attachment attachment) async {
    API.sendTyping(widget.changeState.identifier, "3", "1");
    var resultQueryBuddy = await DBHelper().queryCustom(
        "SELECT connected, ex_block FROM BUDDY WHERE f_pin=='${widget.changeState.identifier}'");
    if (resultQueryBuddy.isNotEmpty) {
      // print("APAAN ${resultQueryBuddy[0]["connected"]}");
      if (resultQueryBuddy[0]["connected"] == "1") {
        attachment.connected = true;
      }
      // print("MANTAB ${resultQueryBuddy[0]["ex_block"]}");
      if (resultQueryBuddy[0]["ex_block"] == "1" ||
          resultQueryBuddy[0]["ex_block"] == "-1") {
        String text = "You have blocked this user";
        if (resultQueryBuddy[0]["ex_block"] == "-1") {
          text = "You have been blocked by this user";
        }
        attachment.textBlock = text;
        attachment.isBlock = int.parse(resultQueryBuddy[0]["ex_block"]);
      }
    }
    API.getBuddyInfo(widget.changeState.identifier);
  }

  scrollListener() {
    getFirstIndex();
    int currentIndex = _scrollController.currentTagIndexInViewport(
        preferPosition: AutoScrollPosition.begin)!;
    if (currentIndex == null) {
      return;
    }
    String dateIndex = DateTime(
                    widget.select.getChat[currentIndex].date.year,
                    widget.select.getChat[currentIndex].date.month,
                    widget.select.getChat[currentIndex].date.day)
                .difference(DateTime(DateTime.now().year, DateTime.now().month,
                    DateTime.now().day))
                .inDays ==
            0
        ? "Today"
        : DateTime(
                        widget.select.getChat[currentIndex].date.year,
                        widget.select.getChat[currentIndex].date.month,
                        widget.select.getChat[currentIndex].date.day)
                    .difference(DateTime(DateTime.now().year,
                        DateTime.now().month, DateTime.now().day))
                    .inDays ==
                -1
            ? "Yesterday"
            : DateTime(
                            widget.select.getChat[currentIndex].date.year,
                            widget.select.getChat[currentIndex].date.month,
                            widget.select.getChat[currentIndex].date.day)
                        .difference(DateTime(DateTime.now().year,
                            DateTime.now().month, DateTime.now().day))
                        .inDays ==
                    -2
                ? "2 days ago"
                : DateFormat('dd MMMM yyyy')
                    .format(widget.select.getChat[currentIndex].date);
    if (_scrollController.position.outOfRange) {
      if (widget.attachment.isShowDate) {
        widget.attachment.isShowDate = false;
      }
    }
    if (widget.attachment.dateIndex == null &&
        _scrollController.offset != 0.0 &&
        !_scrollController.position.outOfRange &&
        dateIndex != "Today") {
      widget.attachment.dateIndex = dateIndex;
      widget.attachment.isShowDate = true;
    } else {
      if (_timer2 != null) {
        _timer2?.cancel();
      }
      if (widget.attachment.dateIndex != dateIndex &&
          _scrollController.offset != 0.0 &&
          !_scrollController.position.outOfRange &&
          dateIndex != "Today") {
        widget.attachment.dateIndex = dateIndex;
        widget.attachment.isShowDate = true;
        _timer2 = Timer(Duration(seconds: 1), () {
          if (mounted) {
            widget.attachment.isShowDate = false;
          }
        });
      } else {
        if (!widget.attachment.isShowDate &&
            _scrollController.offset != 0.0 &&
            !_scrollController.position.outOfRange &&
            dateIndex != "Today") {
          widget.attachment.isShowDate = true;
        }
        _timer2 = Timer(Duration(seconds: 1), () {
          if (mounted) {
            widget.attachment.isShowDate = false;
          }
        });
      }
    }
  }

  textListener() {
    String text = "";
    if (_controllerEditor.text.isNotEmpty) {
      text = _controllerEditor.text
          .substring(0, _controllerEditor.selection.baseOffset);
    }
    String spaceSplit = text.split(" ")[text.split(" ").length - 1];
    String enterSplit = spaceSplit;
    if (spaceSplit.contains("\n")) {
      enterSplit = spaceSplit.split("\n")[spaceSplit.split("\n").length - 1];
    }
    if (_controllerEditor.text.trim().isNotEmpty &&
        (_timerSendTyping == null || !_timerSendTyping!.isActive)) {
      API.sendTyping(widget.changeState.identifier, "3", "4");
      _timerSendTyping = Timer(Duration(seconds: 2), () {});
    }
    if (text.split(" ").length - 2 != -1 || text.split("\n").length - 2 != -1) {
      if (widget.attachment.textLink != null) {
        return;
      }
    }
    if (enterSplit.contains("://")) {
      if (enterSplit.toLowerCase().substring(0, 7) == "http://" ||
          enterSplit.toLowerCase().substring(0, 8) == "https://") {
        widget.attachment.textLink = enterSplit;
        if (_timerLink != null && _timerLink!.isActive) {
          _timerLink?.cancel();
          if (widget.attachment.hitLink) {
            widget.attachment.hitLink = false;
          }
        }
        _timerLink = Timer(Duration(seconds: 1), () {
          widget.attachment.hitLink = true;
        });
      }
    } else {
      if (widget.attachment.textLink != null) {
        widget.attachment.textLink = null;
      }
    }
  }

  void getMembers(Attachment attachment) async {
    Map<String, String> temp2 = Map();
    var resultQueryBuddyMembers = await DBHelper()
        .queryCustom("SELECT f_pin, first_name, last_name FROM BUDDY");
    for (var j = 0; j < resultQueryBuddyMembers.length; j++) {
      temp2["@${resultQueryBuddyMembers[j]["f_pin"]}"] =
          (resultQueryBuddyMembers[j]["first_name"] +
                  " " +
                  resultQueryBuddyMembers[j]["last_name"])
              .trim();
    }
    attachment.addAllContacts = temp2;
  }

  getLink(String text) {
    List<String> data = text.split(" ");
    String? link;
    for (int i = 0; i < data.length; i++) {
      if (data[i].toLowerCase().contains("http://")) {
        if (data[i].contains("\n")) {
          var shttp2 = data[i].split("\n");
          for (var j = 0; j < shttp2.length; j++) {
            if (shttp2[j].startsWith("http://")) {
              link = shttp2[j];
              break;
            }
          }
        } else {
          link = data[i];
          break;
        }
      } else if (data[i].toLowerCase().contains("https://")) {
        if (data[i].contains("\n")) {
          var shttp2 = data[i].split("\n");
          for (var j = 0; j < shttp2.length; j++) {
            if (shttp2[j].startsWith("https://")) {
              link = shttp2[j];
              break;
            }
          }
        } else {
          link = data[i];
          break;
        }
      }
    }
    return link;
  }

  // Future<String> getLanguage() async {
  //   final SharedPreferences prefs = await SharedPreferences.getInstance();
  //   language = prefs.getString("language");
  //   return language;
  // }

  Future<void> contactCenter() async {
    SharedPreferences prefs = await SharedPreferences.getInstance();
    var lcs =
        await DBHelper().getLiveCenterSession(widget.changeState.identifier);
    if (widget.changeState.isContactCenter && lcs.isNotEmpty) {
      widget.changeState.isGoingCallCenter = true;
      widget.changeState.isGoingCallCenterFPIN = widget.changeState.identifier;
      widget.changeState.isGoingCallCenterDATA = widget.changeState.data;
      if (widget.changeState.isGoingCallCenterDATA.isNotEmpty) {
        var jo = jsonDecode(widget.changeState.isGoingCallCenterDATA);
        if (jo.containsKey("complaint_id")) {
          widget.changeState.isGoingCallCenterComplaintID = jo["complaint_id"];
        } else if (jo.containsKey("ccid")) {
          widget.changeState.isGoingCallCenterComplaintID = jo["ccid"];
        }
      }
    } else {
      widget.changeState.isGoingCallCenterTemp =
          widget.changeState.isContactCenter;
      widget.changeState.isGoingCallCenter = false;
    }

    if (widget.changeState.isContactCenter) {
      String idMe = prefs.getString("hasLogin")!;
      var querySelect = await DBHelper().queryCustom(
          "SELECT first_name, last_name,f_pin, offline_mode, image_id, user_type FROM BUDDY WHERE f_pin = '$idMe'");
      var queryCompany = await DBHelper()
          .queryCustom("SELECT * FROM BUDDY WHERE official_account = 1");
      String company = queryCompany[0]["first_name"];
      if (querySelect[0]["user_type"] == "24") {
        if (widget.changeState.isGoingCallCenter) {
          var querySelectOp = await DBHelper().queryCustom(
              "SELECT first_name, last_name,f_pin, offline_mode, image_id, user_type FROM BUDDY WHERE f_pin = '${widget.changeState.identifier}'");
          String time = "Good Day";
          //todo: calendar shit
          var timeOfDay = DateTime.now().hour;
          if (timeOfDay >= 0 && timeOfDay < 12) {
            time = "Good Morning";
          } else if (timeOfDay >= 12 && timeOfDay < 16) {
            time = "Good Afternoon";
          } else if (timeOfDay >= 16 && timeOfDay < 21) {
            time = "Good Evening";
          } else if (timeOfDay >= 21 && timeOfDay < 24) {
            time = "Good Night";
          }
          String name = querySelectOp[0]["first_name"];
          String text =
              "$time $name, thank you for contacting $company Contact Center, how may I help you today?";
          if (!widget.changeState.isContactCenterHistory) {
            API.setCCSessionWelcome(widget.changeState.identifier);
            switch (widget.changeState.channel) {
              case "0":
                break;
              case "1":
                print("Start call");
                Future.delayed(Duration(milliseconds: 2000), () {
                  startCall();
                });
                break;
              case "2":
                print("Start video call");
                Future.delayed(Duration(milliseconds: 2000), () {
                  startVideoCall();
                });
                break;
              case "3":
                break;
            }
            Future.delayed(Duration(milliseconds: 200), () async {
              var formatTime = new DateFormat('Hm');
              var resultSend = await API.sendMessage(
                  lPin: widget.changeState.identifier,
                  messageScopeId: "3",
                  status: "2",
                  messageText: text,
                  isCallCenter: widget.changeState.isContactCenter ? "1" : "0",
                  callCenterId:
                      widget.changeState.isGoingCallCenterComplaintID);
              widget.select.addChat = Chat(
                  messageId: resultSend,
                  lPin: widget.changeState.identifier,
                  isOriginator: true,
                  text: text,
                  statusRead: "1",
                  attachmentType: "0",
                  runCount: false,
                  time: formatTime.format(DateTime.now()),
                  date: DateTime.now());
            });
          }
        }
      } else {
        if (widget.changeState.isGoingCallCenter) {
          print("masuk daerah terlarang");
          var resultQuery = await DBHelper().queryCustom(
              "SELECT first_name, last_name,f_pin, offline_mode, image_id FROM BUDDY WHERE f_pin = '${SharedObj.CALL_CENTER_SESSION_F_PIN}'");
          var realName = resultQuery.isNotEmpty
              ? "${resultQuery[0]["first_name"]} ${resultQuery[0]["last_name"]}"
              : "";
          var jo = {
            'f_pin': SharedObj.CALL_CENTER_SESSION_F_PIN,
            'real_name': realName,
            'complaint_id': SharedObj.CALL_CENTER_SESSION_COMPLAINT_ID,
            'first_timeout': "0"
          };
          API.onReceiveMessage!(jo);
        } else {
          if (widget.changeState.isContactCenterHistory) {
            return;
          }
          String messageCC = "_*Welcome to $company Contact Center *_";
          final String attachmentFlag = "50";
          // todo: send message or whatever
          var msg = createMessageContactCenter(messageCC, attachmentFlag);
          addMessage(msg);
        }
      }
      if (widget.changeState.isGoingCallCenterComplaintID != "") {
        SharedObj.setCacheCallCenter(widget.changeState.identifier,
            widget.changeState.isGoingCallCenterComplaintID);
      }
    }
  }

  Future<void> startCall() async {
    await Navigator.push(
        context,
        PageTransition(
            type: PageTransitionType.fade,
            child: AudioCall(
              isInitiatior: 1,
              name: widget.fullName,
              image: widget.image,
              deviceId: widget.changeState.identifier,
              isContactCenter: true,
            )));
  }

  Future<void> startVideoCall() async {
    await Navigator.push(
        context,
        PageTransition(
            type: PageTransitionType.fade,
            child: VideoCall(
              name: widget.fullName,
              isInitiatior: 1,
              cameraId: "1",
              deviceId: widget.changeState.identifier,
              image: widget.image,
              isContactCenter: true,
            )));
  }

  dynamic createMessageContactCenter(String message, String attachmentFlag) {
    var holder = {};
    int timeNow = DateTime.now().millisecondsSinceEpoch;
    holder["message_id"] = "${timeNow}cc";
    holder["attachment_flag"] = attachmentFlag;
    holder["text"] = message;
    holder["server_date"] = "$timeNow";
    holder["timestamp"] = "$timeNow";
    holder["message_scope"] = "3";
    return holder;
  }

  void addMessage(dynamic message, {String? blogId}) {
    final listMessage = Provider.of<ListMessage>(context, listen: false);
    DateTime dateTime =
        DateTime.fromMillisecondsSinceEpoch(int.parse(message["timestamp"]));
    var formatTime = new DateFormat('Hm');
    Chat msg = Chat(
      text: message["text"],
      messageId: message["message_id"],
      time: formatTime.format(dateTime),
      attachmentType: message["attachment_flag"],
      date: dateTime,
      isOriginator: false,
      blog_id: blogId,
    );
    listMessage.addChat = msg;
  }

  @override
  void initState() {
    widget.changeState.identifier = widget.identifier;
    widget.changeState.isContactCenter = widget.isContactCenter;
    widget.changeState.isContactCenterHistory = widget.isContactCenterHistory;
    widget.changeState.isGoingCallCenterComplaintID =
        widget.contactCenterHistoryId;
    widget.changeState.data = widget.data;
    widget.changeState.channel = widget.channel;
    incomingCall(context);
    // SharedPreferences.getInstance().then((prefs) {
    //   idMe = prefs.getString("hasLogin");
    //   API.pullBatchBuddyList(idMe);
    //   _timerRefreshBuddy = Timer(Duration(seconds: 2), () {
    //     setState(() {});
    //     API.pullBatchBuddyList(idMe);
    //   });
    // });
    initQueryMe();
    if (widget.changeState.isGoingCallCenterComplaintID.isEmpty) {
      sendFirst(widget.attachment);
    }
    if (widget.changeState.isContactCenter) {
      contactCenter();
    }
    final listMessage = Provider.of<ListMessage>(context, listen: false);
    getChat(listMessage, widget.attachment, 0);
    _scrollController.addListener(scrollListener);
    event(listMessage, widget.attachment);
    super.initState();
    // getLanguage();
    if (widget.changeState.isContactCenter) {
      Future.delayed(Duration(milliseconds: 200), () {
        widget.attachment.confidentialActive = false;
        widget.attachment.ackActive = false;
        widget.attachment.disableFavoriteMessage = true;
      });
    }
    if (widget.changeState.isContactCenterHistory) {
      Future.delayed(Duration(milliseconds: 200), () {
        widget.attachment.isBlock = 1;
        widget.attachment.textBlock = "Call Center Session has ended";
      });
    }
  }

  @override
  void didChangeAppLifecycleState(AppLifecycleState state) {}

  @override
  Widget build(BuildContext context) {
    return WillPopScope(
      onWillPop: onWillPop,
      child: Scaffold(
        backgroundColor: Colors.grey[200],
        appBar: AppBar(
          backgroundColor: AppColor.primaryColor,
          titleSpacing: 0.0,
          title: widget.attachment.isSearch
              ? TextField(
                  autofocus: true,
                  controller: _controllerSearch,
                  cursorColor: AppColor.primaryColor,
                  style: TextStyle(color: Colors.grey[300]),
                  onChanged: (text) {
                    if (text.isNotEmpty && !widget.attachment.isSuffix) {
                      widget.attachment.isSuffix = true;
                    } else if (text.isEmpty && widget.attachment.isSuffix) {
                      widget.attachment.isSuffix = false;
                    }
                    widget.attachment.textSearch = text;
                  },
                  onSubmitted: (text) async {
                    if (widget.attachment.isSearch) {
                      if (_controllerSearch.text.isNotEmpty) {
                        if (FocusScope.of(context).hasFocus) {
                          FocusScope.of(context).unfocus();
                        }
                        int currentIndex = widget.attachment.indexLastSearch;
                        if (currentIndex == null) {
                          currentIndex =
                              _scrollController.currentTagIndexInViewport(
                                  preferPosition: AutoScrollPosition.begin)!;
                        } else {
                          if (currentIndex >
                              _scrollController.currentTagIndexInViewport(
                                  preferPosition: AutoScrollPosition.begin)!) {
                            currentIndex =
                                _scrollController.currentTagIndexInViewport(
                                    preferPosition: AutoScrollPosition.begin)!;
                          } else {
                            currentIndex =
                                widget.attachment.indexLastSearch + 1;
                          }
                        }

                        showDialog(
                            barrierDismissible: false,
                            context: context,
                            builder: (_) {
                              return CupertinoAlertDialog(
                                title: Row(
                                  mainAxisAlignment: MainAxisAlignment.start,
                                  children: <Widget>[
                                    Container(
                                        child: CupertinoActivityIndicator(),
                                        width: 20,
                                        height: 20),
                                    SizedBox(width: 20.0),
                                    Text("Searching...",
                                        style: TextStyle(
                                            fontWeight: FontWeight.normal))
                                  ],
                                ),
                              );
                            });
                        if (currentIndex != null) {
                          for (var i = currentIndex;
                              i < widget.select.getChat.length;
                              i++) {
                            if (widget.select.getChat[i].text!
                                .toLowerCase()
                                .contains(_controllerSearch.text)) {
                              _scrollController.scrollToIndex(i,
                                  duration: Duration(milliseconds: 500));
                              widget.select.trueSelected = i;
                              widget.attachment.indexLastSearch = i;
                              Navigator.of(context).pop();
                              Future.delayed(Duration(seconds: 1), () {
                                widget.select.falseSelected = i;
                              });
                              return;
                            }
                          }
                        }
                        Fluttertoast.showToast(
                            msg: "Search not found",
                            gravity: ToastGravity.CENTER,
                            toastLength: Toast.LENGTH_SHORT);
                        Navigator.of(context).pop();
                      }
                    } else if (widget.selectChat.getSelectedChat.length == 0) {
                      var send = await Navigator.push(
                          context,
                          PageTransition(
                              type: PageTransitionType.fade,
                              child: VideoCall(
                                name: widget.fullName,
                                isInitiatior: 1,
                                cameraId: "1",
                                deviceId: widget.changeState.identifier,
                                image: widget.image,
                              )));
                      PalioButtonState statePalio = PalioButtonState();
                      statePalio.incomingCall(context);
                      if (send != null) {
                        var formatTime = new DateFormat('Hm');
                        Chat message = Chat(
                            text: send["textHistory"],
                            messageId: send["messageId"],
                            time: formatTime.format(DateTime.now()),
                            attachmentType: send["attachmentFlag"],
                            statusRead: "2",
                            lPin: widget.changeState.identifier,
                            date: DateTime.now(),
                            runCount: false,
                            isOriginator: true);
                        if (!widget.attachment.isNotBottom) {
                          widget.select.addChat = message;
                        } else {
                          widget.select.addNewMessages = message;
                        }
                      }
                    }
                  },
                  decoration: InputDecoration(
                      border: InputBorder.none,
                      hintText: "Searching for... ",
                      hintStyle: TextStyle(color: Colors.grey[300]),
                      suffixIcon: widget.attachment.isSuffix
                          ? IconButton(
                              onPressed: () {
                                _controllerSearch.clear();
                                widget.attachment.isSuffix = false;
                                widget.attachment.textSearch = null;
                              },
                              icon: Icon(Icons.clear, color: Colors.grey[300]))
                          : null),
                )
              : Material(
                  color: Colors.transparent,
                  child: InkWell(
                    onTap: () async {
                      if (widget.changeState.identifier != "-999" &&
                          !widget.changeState.isContactCenter) {
                        List<dynamic> resultQuery = await DBHelper().queryCustom(
                            "SELECT * FROM BUDDY where f_pin='${widget.changeState.identifier}'");
                        Navigator.pushReplacement(
                            context,
                            PageTransition(
                                type: PageTransitionType.fade,
                                child: PAProfile(
                                  profileDet: {
                                    'f_pin': widget.changeState.identifier,
                                    'myProfile': false,
                                    'name': resultQuery[0]["first_name"],
                                    'follower': 0,
                                    'official_flag': resultQuery[0]
                                                ["official_account"] ==
                                            "1"
                                        ? 1
                                        : resultQuery[0]["official_account"] ==
                                                "2"
                                            ? 0
                                            : 2,
                                    'isFriend': 1,
                                    'post': 0,
                                    'following': 0,
                                    'isOffline': resultQuery[0]["offline_mode"],
                                    'isMuted': resultQuery[0]["muted"],
                                    'industry': resultQuery[0]
                                        ["bidang_industri"],
                                    'email_address': resultQuery[0]["email"],
                                    'phone_number': resultQuery[0]["msisdn"],
                                    'website': resultQuery[0]["web"],
                                    'address': resultQuery[0]["address"],
                                    'status': resultQuery[0]["quote"],
                                    'isOnline':
                                        int.parse(resultQuery[0]["connected"]),
                                    'image': resultQuery[0]["image_id"],
                                    'official_account': resultQuery[0]
                                        ["official_account"],
                                    'user_type': resultQuery[0]["user_type"]
                                  },
                                )));
                      }
                    },
                    child: Row(
                      mainAxisAlignment: MainAxisAlignment.start,
                      mainAxisSize: MainAxisSize.min,
                      children: <Widget>[
                        CircleAvatar(
                          backgroundColor: Colors.transparent,
                          child: Container(
                            decoration: BoxDecoration(
                                shape: BoxShape.circle,
                                color: Colors.grey,
                                image: DecorationImage(
                                    fit: BoxFit.cover,
                                    image: widget.image.isEmpty &&
                                            widget.fullName == "Bot"
                                        ? AssetImage(
                                            "assets/images/palio_ball.png",
                                            package: "palio_lite")
                                        : widget.image.isEmpty
                                            ? AssetImage(
                                                "assets/images/default_pp.png",
                                                package: "palio_lite")
                                            : widget.image ==
                                                    "palio_logo_round.png"
                                                ? AssetImage(
                                                    "assets/images/palio.png",
                                                    package: "palio_lite")
                                                : LocalImage(widget.image)
                                                    as ImageProvider)),
                          ),
                        ),
                        SizedBox(
                          width: 5.0,
                        ),
                        Expanded(
                          child: Column(
                            crossAxisAlignment: CrossAxisAlignment.start,
                            children: <Widget>[
                              Text(widget.fullName,
                                  overflow: TextOverflow.ellipsis,
                                  style: TextStyle(
                                      fontSize: 18, color: Colors.white)),
                              widget.changeState.identifier == "-999"
                                  ? Container()
                                  : Text(
                                      widget.attachment.isTyping
                                          ? "is typing..."
                                          : widget.attachment.connected ||
                                                  widget.changeState
                                                      .isContactCenter
                                              ? "Online"
                                              : "Offline",
                                      style: TextStyle(
                                          fontSize: 14, color: Colors.white))
                            ],
                          ),
                        )
                      ],
                    ),
                  ),
                ),
          actions: <Widget>[
            widget.selectChat.getSelectedChat.length > 0 &&
                    widget.attachment.justDelete == 0 &&
                    !widget.changeState.isContactCenterHistory
                ? widget.selectChat.getSelectedChat.length > 1 &&
                        widget.attachment.cantForward > 0
                    ? Container()
                    : IconButton(
                        icon: Icon(
                            widget.selectChat.getSelectedChat.length == 1 &&
                                    !widget.changeState.isContactCenterHistory
                                ? CupertinoIcons.reply_thick_solid
                                : CupertinoIcons.forward),
                        iconSize: 25,
                        onPressed: () {
                          if (widget.selectChat.getSelectedChat.length == 1) {
                            widget.selectChat.getSelectedChat.forEach((k, v) {
                              String? imageLocation;
                              if (v.attachmentType == "3") {
                                String textDecode = Uri.decodeQueryComponent(
                                    Uri.decodeFull(v.text!));
                                int idx = textDecode.indexOf("(");
                                var textLatLng = textDecode
                                    .substring(
                                        idx + 1, textDecode.trim().length - 1)
                                    .split(",");
                                imageLocation =
                                    "https://maps.googleapis.com/maps/api/staticmap?center=" +
                                        textLatLng[0] +
                                        "," +
                                        textLatLng[1].trimLeft() +
                                        "&zoom=15&size=" +
                                        300.toString() +
                                        "x" +
                                        150.toString() +
                                        "&maptype=normal&markers=color:red|" +
                                        textLatLng[0] +
                                        "," +
                                        textLatLng[1].trimLeft() +
                                        "&key=AIzaSyC79oNmadezP9O_4Q_Ud2bbuJ_L7M--y1s";
                              }
                              widget.attachment.replyContent = {
                                "message_id": v.messageId,
                                "attachment_type": v.attachmentType,
                                "fromName": v.isOriginator
                                    ? "You"
                                    : "${widget.fullName}",
                                "text": v.attachmentType == "3" ||
                                        v.attachmentType == "-1"
                                    ? ""
                                    : v.text,
                                "thumb_id": v.thumbName,
                                "thumb_location": imageLocation!
                              };
                              widget.select.falseSelected = k;
                            });
                            widget.attachment.cantForward = 0;
                            widget.attachment.justDelete = 0;
                            if (widget.attachment.disableFavoriteMessage) {
                              widget.attachment.disableFavoriteMessage = false;
                            }
                            widget.selectChat.clearList = true;
                          } else {
                            List<dynamic> data = [];
                            for (var i = 0;
                                i < widget.selectChat.getSelectedChat.length;
                                i++) {
                              data.add({
                                "index": widget.selectChat.getSelectedChat.keys
                                    .elementAt(i),
                                "data": widget.selectChat.getSelectedChat.values
                                    .elementAt(i)
                              });
                              widget.select.falseSelected = widget
                                  .selectChat.getSelectedChat.keys
                                  .elementAt(i);
                            }
                            widget.attachment.cantForward = 0;
                            widget.attachment.justDelete = 0;
                            if (widget.attachment.disableFavoriteMessage) {
                              widget.attachment.disableFavoriteMessage = false;
                            }
                            widget.selectChat.clearList = true;
                            if (widget.attachment.cantForward > 0) {
                              Fluttertoast.showToast(
                                  msg: "Upload file or document first",
                                  toastLength: Toast.LENGTH_LONG);
                              return null;
                            }
                            data.sort(
                                (b, a) => a["index"].compareTo(b["index"]));
                            showDialog(
                                context: context,
                                builder: (_) {
                                  return Dialog(
                                    child: Container(
                                      height:
                                          MediaQuery.of(context).size.height,
                                      width: MediaQuery.of(context).size.width,
                                      child: ForwardChat(data,
                                          isContactCenter: widget
                                              .changeState.isContactCenter),
                                    ),
                                  );
                                });
                          }
                        },
                      )
                : Container(),
            //iconAck
            widget.selectChat.getSelectedChat.length == 1 &&
                    widget.selectChat.getSelectedChat.values.elementAt(0).ack ==
                        "8" &&
                    widget.selectChat.getSelectedChat.values
                            .elementAt(0)
                            .statusRead !=
                        "8" &&
                    !widget.selectChat.getSelectedChat.values
                        .elementAt(0)
                        .isOriginator
                ? IconButton(
                    icon: Icon(
                      CupertinoIcons.check_mark_circled_solid,
                      color: Colors.white,
                    ),
                    onPressed: () async {
                      SharedPreferences prefs =
                          await SharedPreferences.getInstance();
                      String idMe = prefs.getString("hasLogin")!;
                      API.sendAckmessage(
                          idMe,
                          widget.changeState.identifier,
                          widget.selectChat.getSelectedChat.values
                              .elementAt(0)
                              .date
                              .toString(),
                          "3",
                          widget.selectChat.getSelectedChat.values
                              .elementAt(0)
                              .messageId!,
                          "",
                          "",
                          "");
                      widget.selectChat.getSelectedChat.forEach((k, v) {
                        int idx = widget.select.getChat.indexWhere(
                            (element) => element.messageId == v.messageId);
                        widget.select.falseSelected = idx;
                        widget.select.updateStatus = {
                          "index": idx,
                          "value": "8"
                        };
                      });
                      widget.attachment.justDelete = 0;
                      widget.attachment.cantForward = 0;
                      if (widget.attachment.disableFavoriteMessage) {
                        widget.attachment.disableFavoriteMessage = false;
                      }
                      widget.selectChat.clearList = true;
                    },
                  )
                : Container(),
            (widget.attachment.justDelete != 0 ||
                        (widget.attachment.isBlock == 1 &&
                            !widget.changeState.isContactCenter) ||
                        widget.attachment.isBlock == -1 ||
                        widget.changeState.identifier == "-999" ||
                        (widget.changeState.isContactCenter &&
                            widget.selectChat.getSelectedChat.length == 0)) &&
                    !widget.attachment.isSearch
                ? Container()
                : widget.selectChat.getSelectedChat.length > 1 &&
                        widget.attachment.cantForward > 0
                    ? Container()
                    : IconButton(
                        icon: Icon(
                            widget.attachment.isSearch
                                ? Icons.keyboard_arrow_up
                                : widget.selectChat.getSelectedChat.length >
                                            0 &&
                                        widget.attachment.cantForward > 0
                                    ? CupertinoIcons.delete_solid
                                    : widget.selectChat.getSelectedChat.length >
                                            0
                                        ? Icons.content_copy
                                        : CupertinoIcons.video_camera_solid,
                            color: Colors.white),
                        iconSize: 25,
                        onPressed: () async {
                          if (widget.attachment.isSearch) {
                            if (_controllerSearch.text.isNotEmpty) {
                              if (FocusScope.of(context).hasFocus) {
                                FocusScope.of(context).unfocus();
                              }
                              int currentIndex =
                                  widget.attachment.indexLastSearch;
                              if (currentIndex == null) {
                                currentIndex =
                                    _scrollController.currentTagIndexInViewport(
                                        preferPosition:
                                            AutoScrollPosition.begin)!;
                              } else {
                                if (currentIndex >
                                    _scrollController.currentTagIndexInViewport(
                                        preferPosition:
                                            AutoScrollPosition.begin)!) {
                                  currentIndex = _scrollController
                                      .currentTagIndexInViewport(
                                          preferPosition:
                                              AutoScrollPosition.begin)!;
                                } else {
                                  currentIndex =
                                      widget.attachment.indexLastSearch + 1;
                                }
                              }

                              showDialog(
                                  barrierDismissible: false,
                                  context: context,
                                  builder: (_) {
                                    return CupertinoAlertDialog(
                                      title: Row(
                                        mainAxisAlignment:
                                            MainAxisAlignment.start,
                                        children: <Widget>[
                                          Container(
                                              child:
                                                  CupertinoActivityIndicator(),
                                              width: 20,
                                              height: 20),
                                          SizedBox(width: 20.0),
                                          Text("Searching...",
                                              style: TextStyle(
                                                  fontWeight:
                                                      FontWeight.normal))
                                        ],
                                      ),
                                    );
                                  });
                              if (currentIndex != null) {
                                for (var i = currentIndex;
                                    i < widget.select.getChat.length;
                                    i++) {
                                  if (widget.select.getChat[i].text!
                                      .toLowerCase()
                                      .contains(_controllerSearch.text)) {
                                    _scrollController.scrollToIndex(i,
                                        duration: Duration(milliseconds: 500));
                                    widget.select.trueSelected = i;
                                    widget.attachment.indexLastSearch = i;
                                    Navigator.of(context).pop();
                                    Future.delayed(Duration(seconds: 1), () {
                                      widget.select.falseSelected = i;
                                    });
                                    return;
                                  }
                                }
                              }
                              Fluttertoast.showToast(
                                  msg: "Search not found",
                                  gravity: ToastGravity.CENTER,
                                  toastLength: Toast.LENGTH_SHORT);
                              Navigator.of(context).pop();
                            }
                          } else if (widget.selectChat.getSelectedChat.length ==
                              0) {
                            await Navigator.push(
                                context,
                                PageTransition(
                                    type: PageTransitionType.fade,
                                    child: VideoCall(
                                      name: widget.fullName,
                                      isInitiatior: 1,
                                      cameraId: "1",
                                      deviceId: widget.changeState.identifier,
                                      image: widget.image,
                                    )));
                            PalioButtonState statePalio = PalioButtonState();
                            statePalio.incomingCall(context);
                          } else if (widget.selectChat.getSelectedChat.length >
                                  0 &&
                              widget.attachment.cantForward > 0) {
                            if (FocusScope.of(context).hasFocus) {
                              FocusScope.of(context).unfocus();
                              await Future.delayed(Duration(milliseconds: 100));
                            }
                            showDialog(
                                context: context,
                                builder: (context) {
                                  return CupertinoAlertDialog(
                                      insetAnimationCurve: Curves.easeInBack,
                                      title: Text("Delete Message"),
                                      content: Container(
                                        margin: EdgeInsets.only(top: 10),
                                        child: Text(
                                            "Are you sure to delete this message?"),
                                      ),
                                      actions: <Widget>[
                                        CupertinoDialogAction(
                                          onPressed: () {
                                            Navigator.of(context).pop();
                                            List<Chat> tempChat = [];
                                            tempChat
                                                .addAll(widget.select.getChat);
                                            for (var i = 0;
                                                i <
                                                    widget.selectChat
                                                        .getSelectedChat.length;
                                                i++) {
                                              API.deleteMessage(
                                                  widget.selectChat
                                                      .getSelectedChat.values
                                                      .elementAt(i)
                                                      .lPin!,
                                                  "",
                                                  "1",
                                                  "3",
                                                  widget.selectChat
                                                      .getSelectedChat.values
                                                      .elementAt(i)
                                                      .messageId!);
                                              tempChat[tempChat.indexWhere(
                                                      (item) =>
                                                          item.messageId ==
                                                          widget
                                                              .selectChat
                                                              .getSelectedChat
                                                              .values
                                                              .elementAt(i)
                                                              .messageId)]
                                                  .isSelected = false;
                                              tempChat.removeAt(
                                                  tempChat.indexWhere((item) =>
                                                      item.messageId ==
                                                      widget
                                                          .selectChat
                                                          .getSelectedChat
                                                          .values
                                                          .elementAt(i)
                                                          .messageId));
                                            }
                                            widget.select.replaceChat =
                                                tempChat;
                                            widget.attachment.cantForward = 0;
                                            widget.attachment.justDelete = 0;
                                            if (widget.attachment
                                                .disableFavoriteMessage) {
                                              widget.attachment
                                                      .disableFavoriteMessage =
                                                  false;
                                            }
                                            widget.selectChat.clearList = true;
                                            if (!widget.attachment.refresh) {
                                              widget.attachment.refresh = true;
                                            }
                                          },
                                          child: Text("Delete",
                                              style: TextStyle(
                                                  color: AppColor.primaryColor,
                                                  fontSize: 14)),
                                        ),
                                        CupertinoDialogAction(
                                          onPressed: () =>
                                              Navigator.pop(context),
                                          child: Text("Cancel",
                                              style: TextStyle(
                                                  color: AppColor.primaryColor,
                                                  fontSize: 14)),
                                        ),
                                        widget.attachment
                                                    .cantDeleteForEveryone >
                                                0
                                            ? Container()
                                            : CupertinoDialogAction(
                                                onPressed: () {
                                                  Navigator.of(context).pop();
                                                  for (var i = 0;
                                                      i <
                                                          widget
                                                              .selectChat
                                                              .getSelectedChat
                                                              .length;
                                                      i++) {
                                                    API.deleteMessage(
                                                        widget
                                                            .selectChat
                                                            .getSelectedChat
                                                            .values
                                                            .elementAt(i)
                                                            .lPin!,
                                                        "",
                                                        "2",
                                                        "3",
                                                        widget
                                                            .selectChat
                                                            .getSelectedChat
                                                            .values
                                                            .elementAt(i)
                                                            .messageId!);
                                                    widget.select
                                                            .falseSelected =
                                                        widget
                                                            .selectChat
                                                            .getSelectedChat
                                                            .keys
                                                            .elementAt(i);
                                                  }
                                                  widget.attachment
                                                      .cantForward = 0;
                                                  widget.attachment.justDelete =
                                                      0;
                                                  if (widget.attachment
                                                      .disableFavoriteMessage) {
                                                    widget.attachment
                                                            .disableFavoriteMessage =
                                                        false;
                                                  }
                                                  widget.selectChat.clearList =
                                                      true;
                                                  if (!widget
                                                      .attachment.refresh) {
                                                    widget.attachment.refresh =
                                                        true;
                                                  }
                                                },
                                                child: Text(
                                                    "Delete for everyone",
                                                    style: TextStyle(
                                                        color: AppColor
                                                            .primaryColor,
                                                        fontSize: 14)),
                                              )
                                      ]);
                                });
                          } else {
                            String? text;
                            List<Map<int, Chat>> temp = [];
                            widget.selectChat.getSelectedChat.forEach(
                                (key, value) => temp.add({key: value}));
                            temp.sort((b, a) {
                              int aValue = a.keys.first;
                              int bValue = b.keys.first;
                              return aValue > bValue ? 1 : 0;
                            });
                            Map<int, Chat> sortedMap = Map.fromIterable(temp,
                                key: (e) => e.keys.first,
                                value: (e) => e.values.first);
                            var tempText;
                            for (var i = 0; i < sortedMap.length; i++) {
                              widget.select.falseSelected =
                                  sortedMap.keys.elementAt(i);
                              String? name;
                              if (sortedMap.values.elementAt(i).isOriginator) {
                                final SharedPreferences prefs =
                                    await SharedPreferences.getInstance();
                                String idMe = prefs.getString("hasLogin")!;
                                List<dynamic> resultQuery = await DBHelper()
                                    .queryCustom(
                                        "SELECT first_name,last_name FROM BUDDY where f_pin == '$idMe'");
                                name = resultQuery[0]["last_name"].isEmpty
                                    ? "${resultQuery[0]["first_name"]}"
                                    : "${resultQuery[0]["first_name"]} ${resultQuery[0]["last_name"]}";
                              } else {
                                name = widget.fullName;
                              }
                              tempText =
                                  sortedMap.values.elementAt(i).text!.trim();
                              if (tempText.contains("@")) {
                                for (int j = 0;
                                    j < widget.attachment.getAllContacts.length;
                                    j++) {
                                  if (tempText.contains(
                                      "@${widget.attachment.getAllContacts.values.elementAt(j)}")) {
                                    tempText = tempText.replaceAll(
                                        widget.attachment.getAllContacts.keys
                                            .elementAt(j),
                                        "@${widget.attachment.getAllContacts.values.elementAt(j)}");
                                  }
                                }
                              }
                              text = text! +
                                  "*[" +
                                  DateFormat('dd MMMM yyyy').format(
                                      sortedMap.values.elementAt(i).date) +
                                  " " +
                                  sortedMap.values.elementAt(i).time! +
                                  "]" +
                                  " " +
                                  name +
                                  ":*" +
                                  "\n" +
                                  tempText +
                                  "\n";
                              if (i == sortedMap.length - 1) {
                                text = text +
                                    "\n\n\n" +
                                    "chat powered by Palio Lite\n\n";
                              }
                            }
                            widget.attachment.justDelete = 0;
                            widget.attachment.cantForward = 0;
                            if (widget.attachment.disableFavoriteMessage) {
                              widget.attachment.disableFavoriteMessage = false;
                            }
                            widget.selectChat.clearList = true;
                            if (tempText.isNotEmpty) {
                              Clipboard.setData(new ClipboardData(text: text));
                              Fluttertoast.showToast(
                                  msg: "Copied to clipboard",
                                  toastLength: Toast.LENGTH_SHORT,
                                  gravity: ToastGravity.CENTER);
                            } else {
                              Fluttertoast.showToast(
                                  msg: "Nothing to copy to clipboard",
                                  toastLength: Toast.LENGTH_SHORT,
                                  gravity: ToastGravity.CENTER);
                            }
                          }
                        },
                      ),
            widget.attachment.justDelete != 0 ||
                    (widget.selectChat.getSelectedChat.length == 1 &&
                        widget.attachment.cantForward > 0)
                ? Container()
                : IconButton(
                    icon: Icon(
                        widget.attachment.isSearch
                            ? Icons.keyboard_arrow_down
                            : ((widget.attachment.isBlock == 1 &&
                                        !widget.changeState
                                            .isContactCenterHistory) ||
                                    widget.attachment.isBlock == -1 ||
                                    widget.changeState.identifier == "-999" ||
                                    (widget.changeState.isContactCenter &&
                                        widget.selectChat.getSelectedChat
                                                .length ==
                                            0))
                                ? CupertinoIcons.search
                                : widget.selectChat.getSelectedChat.length == 1
                                    ? CupertinoIcons.forward
                                    : widget.selectChat.getSelectedChat.length >
                                            1
                                        ? CupertinoIcons.delete_solid
                                        : CupertinoIcons.phone_solid,
                        color: Colors.white),
                    iconSize: 25,
                    onPressed: () async {
                      if (widget.attachment.isSearch) {
                        if (_controllerSearch.text.isNotEmpty) {
                          if (FocusScope.of(context).hasFocus) {
                            FocusScope.of(context).unfocus();
                          }
                          int currentIndex = widget.attachment.indexLastSearch;
                          if (currentIndex == null) {
                            currentIndex =
                                _scrollController.currentTagIndexInViewport(
                                    preferPosition: AutoScrollPosition.begin)!;
                          } else {
                            if (currentIndex >
                                _scrollController.currentTagIndexInViewport(
                                    preferPosition:
                                        AutoScrollPosition.begin)!) {
                              currentIndex =
                                  _scrollController.currentTagIndexInViewport(
                                      preferPosition:
                                          AutoScrollPosition.begin)!;
                            } else {
                              currentIndex =
                                  widget.attachment.indexLastSearch - 1;
                            }
                          }

                          showDialog(
                              barrierDismissible: false,
                              context: context,
                              builder: (_) {
                                return CupertinoAlertDialog(
                                  title: Row(
                                    mainAxisAlignment: MainAxisAlignment.start,
                                    children: <Widget>[
                                      Container(
                                          child: CupertinoActivityIndicator(),
                                          width: 20,
                                          height: 20),
                                      SizedBox(width: 20.0),
                                      Text("Searching...",
                                          style: TextStyle(
                                              fontWeight: FontWeight.normal))
                                    ],
                                  ),
                                );
                              });
                          if (currentIndex != null) {
                            for (var i = currentIndex; i >= 0; i--) {
                              if (widget.select.getChat[i].text!
                                  .toLowerCase()
                                  .contains(_controllerSearch.text)) {
                                _scrollController.scrollToIndex(i,
                                    duration: Duration(milliseconds: 500));
                                widget.select.trueSelected = i;
                                widget.attachment.indexLastSearch = i;
                                Navigator.of(context).pop();
                                Future.delayed(Duration(seconds: 1), () {
                                  widget.select.falseSelected = i;
                                });
                                return;
                              }
                            }
                          }
                          Fluttertoast.showToast(
                              msg: "Search not found",
                              gravity: ToastGravity.CENTER,
                              toastLength: Toast.LENGTH_SHORT);
                          Navigator.of(context).pop();
                        }
                      } else {
                        if ((widget.attachment.isBlock == 1 ||
                                widget.attachment.isBlock == -1) &&
                            !widget.changeState.isContactCenterHistory) {
                          widget.attachment.isSearch =
                              !widget.attachment.isSearch;
                          Future.delayed(const Duration(milliseconds: 500),
                              () async {
                            _scrollController.scrollToIndex(0);
                          });
                        } else if (widget.selectChat.getSelectedChat.length ==
                                0 &&
                            (widget.changeState.identifier == "-999" ||
                                widget.changeState.isContactCenter)) {
                          widget.attachment.isSearch = true;
                        } else if (widget.selectChat.getSelectedChat.length ==
                                0 &&
                            !widget.changeState.isContactCenterHistory) {
                          List<dynamic> resultQuery = await DBHelper().queryCustom(
                              "SELECT device_id, offline_mode FROM BUDDY where f_pin='${widget.changeState.identifier}'");
                          if (resultQuery[0]["offline_mode"] == "1" &&
                              !widget.changeState.isContactCenter) {
                            Fluttertoast.showToast(
                                msg:
                                    "Unable to call because user disable calls");
                          } else {
                            var send = await Navigator.push(
                                context,
                                PageTransition(
                                    type: PageTransitionType.fade,
                                    child: AudioCall(
                                      isInitiatior: 1,
                                      name: widget.fullName,
                                      image: widget.image,
                                      deviceId: resultQuery[0]["device_id"],
                                    )));
                            PalioButtonState statePalio = PalioButtonState();
                            statePalio.incomingCall(context);
                            if (send != null) {
                              var formatTime = new DateFormat('Hm');
                              Chat message = Chat(
                                  text: send["textHistory"],
                                  messageId: send["messageId"],
                                  time: formatTime.format(DateTime.now()),
                                  attachmentType: send["attachmentFlag"],
                                  statusRead: "2",
                                  lPin: widget.changeState.identifier,
                                  date: DateTime.now(),
                                  runCount: false,
                                  isOriginator: true);
                              if (!widget.attachment.isNotBottom) {
                                widget.select.addChat = message;
                              } else {
                                widget.select.addNewMessages = message;
                              }
                            }
                          }
                        } else if (widget.selectChat.getSelectedChat.length ==
                            1) {
                          List<dynamic> data = [];
                          for (var i = 0;
                              i < widget.selectChat.getSelectedChat.length;
                              i++) {
                            data.add({
                              "index": widget.selectChat.getSelectedChat.keys
                                  .elementAt(i),
                              "data": widget.selectChat.getSelectedChat.values
                                  .elementAt(i)
                            });
                            widget.select.falseSelected = widget
                                .selectChat.getSelectedChat.keys
                                .elementAt(i);
                          }
                          widget.attachment.cantForward = 0;
                          widget.attachment.justDelete = 0;
                          if (widget.attachment.disableFavoriteMessage) {
                            widget.attachment.disableFavoriteMessage = false;
                          }
                          widget.selectChat.clearList = true;
                          if (widget.attachment.cantForward > 0) {
                            Fluttertoast.showToast(
                                msg: "Upload file or document first",
                                toastLength: Toast.LENGTH_LONG);
                            return null;
                          }
                          data.sort((b, a) => a["index"].compareTo(b["index"]));
                          showDialog(
                              context: context,
                              builder: (_) {
                                return Dialog(
                                  child: Container(
                                    height: MediaQuery.of(context).size.height,
                                    width: MediaQuery.of(context).size.width,
                                    child: ForwardChat(data,
                                        isContactCenter:
                                            widget.changeState.isContactCenter),
                                  ),
                                );
                              });
                        } else if (widget.selectChat.getSelectedChat.length >
                            1) {
                          if (FocusScope.of(context).hasFocus) {
                            FocusScope.of(context).unfocus();
                            await Future.delayed(Duration(milliseconds: 100));
                          }
                          showDialog(
                              context: context,
                              builder: (context) {
                                return CupertinoAlertDialog(
                                    insetAnimationCurve: Curves.easeInBack,
                                    title: Text("Delete Message"),
                                    content: Container(
                                      margin: EdgeInsets.only(top: 10),
                                      child: Text(
                                          "Are you sure to delete this message?"),
                                    ),
                                    actions: <Widget>[
                                      CupertinoDialogAction(
                                        onPressed: () {
                                          Navigator.of(context).pop();
                                          List<Chat> tempChat = [];
                                          tempChat
                                              .addAll(widget.select.getChat);
                                          for (var i = 0;
                                              i <
                                                  widget.selectChat
                                                      .getSelectedChat.length;
                                              i++) {
                                            API.deleteMessage(
                                                widget.selectChat
                                                    .getSelectedChat.values
                                                    .elementAt(i)
                                                    .lPin!,
                                                "",
                                                "1",
                                                "3",
                                                widget.selectChat
                                                    .getSelectedChat.values
                                                    .elementAt(i)
                                                    .messageId!);
                                            tempChat[tempChat.indexWhere(
                                                    (item) =>
                                                        item.messageId ==
                                                        widget
                                                            .selectChat
                                                            .getSelectedChat
                                                            .values
                                                            .elementAt(i)
                                                            .messageId)]
                                                .isSelected = false;
                                            tempChat.removeAt(
                                                tempChat.indexWhere((item) =>
                                                    item.messageId ==
                                                    widget.selectChat
                                                        .getSelectedChat.values
                                                        .elementAt(i)
                                                        .messageId));
                                          }
                                          widget.select.replaceChat = tempChat;
                                          widget.attachment.cantForward = 0;
                                          widget.attachment.justDelete = 0;
                                          if (widget.attachment
                                              .disableFavoriteMessage) {
                                            widget.attachment
                                                .disableFavoriteMessage = false;
                                          }
                                          widget.selectChat.clearList = true;
                                          if (!widget.attachment.refresh) {
                                            widget.attachment.refresh = true;
                                          }
                                        },
                                        child: Text("Delete",
                                            style: TextStyle(
                                                color: AppColor.primaryColor,
                                                fontSize: 14)),
                                      ),
                                      CupertinoDialogAction(
                                        onPressed: () => Navigator.pop(context),
                                        child: Text("Cancel",
                                            style: TextStyle(
                                                color: AppColor.primaryColor,
                                                fontSize: 14)),
                                      ),
                                      widget.attachment.cantDeleteForEveryone >
                                              0
                                          ? Container()
                                          : CupertinoDialogAction(
                                              onPressed: () {
                                                Navigator.of(context).pop();
                                                for (var i = 0;
                                                    i <
                                                        widget
                                                            .selectChat
                                                            .getSelectedChat
                                                            .length;
                                                    i++) {
                                                  API.deleteMessage(
                                                      widget
                                                          .selectChat
                                                          .getSelectedChat
                                                          .values
                                                          .elementAt(i)
                                                          .lPin!,
                                                      "",
                                                      "2",
                                                      "3",
                                                      widget
                                                          .selectChat
                                                          .getSelectedChat
                                                          .values
                                                          .elementAt(i)
                                                          .messageId!);
                                                  widget.select.falseSelected =
                                                      widget.selectChat
                                                          .getSelectedChat.keys
                                                          .elementAt(i);
                                                }
                                                widget.attachment.cantForward =
                                                    0;
                                                widget.attachment.justDelete =
                                                    0;
                                                if (widget.attachment
                                                    .disableFavoriteMessage) {
                                                  widget.attachment
                                                          .disableFavoriteMessage =
                                                      false;
                                                }
                                                widget.selectChat.clearList =
                                                    true;
                                                if (!widget
                                                    .attachment.refresh) {
                                                  widget.attachment.refresh =
                                                      true;
                                                }
                                              },
                                              child: Text("Delete for everyone",
                                                  style: TextStyle(
                                                      color:
                                                          AppColor.primaryColor,
                                                      fontSize: 14)),
                                            )
                                    ]);
                              });
                        }
                      }
                    }),
            widget.attachment.isSearch && !widget.changeState.isContactCenter
                ? PopupMenuButton(
                    itemBuilder: (context) => [
                          widget.attachment.isBlock == -1 ||
                                  widget.changeState.isContactCenter ||
                                  widget.changeState.identifier == "-999"
                              ? PopupMenuItem(child: Container())
                              : PopupMenuItem(
                                  value: 2,
                                  child: Text(widget.attachment.isBlock == 1
                                      ? "Unblock"
                                      : "Block"),
                                ),
                          widget.changeState.isContactCenter
                              ? PopupMenuItem(child: Container())
                              : PopupMenuItem(
                                  value: 3,
                                  child: Text("Delete conversation"),
                                ),
                        ],
                    onSelected: (select) async {
                      if (select == 3) {
                        if (FocusScope.of(context).hasFocus) {
                          FocusScope.of(context).unfocus();
                          await Future.delayed(Duration(milliseconds: 100));
                        }
                        showDialog(
                            context: context,
                            builder: (context) {
                              return CupertinoAlertDialog(
                                  insetAnimationCurve: Curves.easeInBack,
                                  content: Container(
                                    margin: EdgeInsets.only(top: 10),
                                    child: Text(
                                        "Are you sure to delete all message in this conversation?"),
                                  ),
                                  actions: <Widget>[
                                    CupertinoDialogAction(
                                      onPressed: () => Navigator.pop(context),
                                      child: Text("Cancel",
                                          style: TextStyle(
                                              color: AppColor.primaryColor,
                                              fontSize: 14)),
                                    ),
                                    CupertinoDialogAction(
                                      onPressed: () async {
                                        SharedPreferences prefs =
                                            await SharedPreferences
                                                .getInstance();
                                        String idMe =
                                            prefs.getString("hasLogin")!;
                                        await API.clearChat(
                                            widget.changeState.identifier,
                                            "",
                                            idMe,
                                            widget.changeState.identifier,
                                            "3");
                                        Navigator.pop(context);
                                        Navigator.pop(context);
                                      },
                                      child: Text("Delete",
                                          style: TextStyle(
                                              color: AppColor.primaryColor,
                                              fontSize: 14)),
                                    )
                                  ]);
                            });
                      } else {
                        if (widget.attachment.isBlock == 1) {
                          var resultBlock = await API.unblockUser(
                              widget.changeState.identifier, "0");
                          if (resultBlock == "00") {
                            widget.attachment.isBlock = 0;
                          }
                        } else {
                          var resultBlock = await API.blockUser(
                              widget.changeState.identifier, "1");
                          if (resultBlock == "00") {
                            String text = "You have blocked this user";
                            widget.attachment.textBlock = text;
                            widget.attachment.isBlock = 1;
                          }
                        }
                      }
                    })
                : widget.attachment.justDelete != 0 &&
                        !widget.changeState.isContactCenter
                    ? IconButton(
                        icon: Icon(CupertinoIcons.delete_solid),
                        onPressed: () async {
                          if (FocusScope.of(context).hasFocus) {
                            FocusScope.of(context).unfocus();
                            await Future.delayed(Duration(milliseconds: 100));
                          }
                          showDialog(
                              context: context,
                              builder: (context) {
                                return CupertinoAlertDialog(
                                    insetAnimationCurve: Curves.easeInBack,
                                    title: Text("Delete Message"),
                                    content: Container(
                                      margin: EdgeInsets.only(top: 10),
                                      child: Text(
                                          "Are you sure to delete this message?"),
                                    ),
                                    actions: <Widget>[
                                      CupertinoDialogAction(
                                        onPressed: () {
                                          Navigator.of(context).pop();
                                          List<Chat> tempChat = [];
                                          tempChat
                                              .addAll(widget.select.getChat);
                                          for (var i = 0;
                                              i <
                                                  widget.selectChat
                                                      .getSelectedChat.length;
                                              i++) {
                                            API.deleteMessage(
                                                widget.selectChat
                                                    .getSelectedChat.values
                                                    .elementAt(i)
                                                    .lPin!,
                                                "",
                                                "1",
                                                "3",
                                                widget.selectChat
                                                    .getSelectedChat.values
                                                    .elementAt(i)
                                                    .messageId!);
                                            tempChat[tempChat.indexWhere(
                                                    (item) =>
                                                        item.messageId ==
                                                        widget
                                                            .selectChat
                                                            .getSelectedChat
                                                            .values
                                                            .elementAt(i)
                                                            .messageId)]
                                                .isSelected = false;
                                            tempChat.removeAt(
                                                tempChat.indexWhere((item) =>
                                                    item.messageId ==
                                                    widget.selectChat
                                                        .getSelectedChat.values
                                                        .elementAt(i)
                                                        .messageId));
                                          }
                                          widget.select.replaceChat = tempChat;
                                          widget.attachment.cantForward = 0;
                                          widget.attachment.justDelete = 0;
                                          if (widget.attachment
                                              .disableFavoriteMessage) {
                                            widget.attachment
                                                .disableFavoriteMessage = false;
                                          }
                                          widget.selectChat.clearList = true;
                                          if (!widget.attachment.refresh) {
                                            widget.attachment.refresh = true;
                                          }
                                        },
                                        child: Text("Delete",
                                            style: TextStyle(
                                                color: AppColor.primaryColor,
                                                fontSize: 14)),
                                      ),
                                      CupertinoDialogAction(
                                        onPressed: () => Navigator.pop(context),
                                        child: Text("Cancel",
                                            style: TextStyle(
                                                color: AppColor.primaryColor,
                                                fontSize: 14)),
                                      ),
                                    ]);
                              });
                        },
                      )
                    : widget.selectChat.getSelectedChat.length == 1 &&
                            !widget.changeState.isContactCenter
                        ? PopupMenuButton(
                            itemBuilder: (context) => [
                              widget.attachment.disableFavoriteMessage
                                  ? PopupMenuItem(child: Container())
                                  : PopupMenuItem(
                                      value: 4,
                                      child: Text(widget
                                              .selectChat.getSelectedChat.values
                                              .elementAt(0)
                                              .isFavorite
                                          ? "Delete from favourite message"
                                          : "Add to favourite message"),
                                    ),
                              widget.selectChat.getSelectedChat.length == 1 &&
                                      widget.attachment.cantForward > 0
                                  ? PopupMenuItem(child: Container())
                                  : PopupMenuItem(
                                      value: 5,
                                      child: Text("Delete Messages"),
                                    ),
                            ],
                            onSelected: (value) async {
                              if (value == 5) {
                                if (FocusScope.of(context).hasFocus) {
                                  FocusScope.of(context).unfocus();
                                  await Future.delayed(
                                      Duration(milliseconds: 100));
                                }
                                showDialog(
                                    context: context,
                                    builder: (context) {
                                      return CupertinoAlertDialog(
                                          insetAnimationCurve:
                                              Curves.easeInBack,
                                          title: Text("Delete Message"),
                                          content: Container(
                                            margin: EdgeInsets.only(top: 10),
                                            child: Text(
                                                "Are you sure to delete this message?"),
                                          ),
                                          actions: <Widget>[
                                            CupertinoDialogAction(
                                              onPressed: () {
                                                Navigator.of(context).pop();
                                                List<Chat> tempChat = [];
                                                tempChat.addAll(
                                                    widget.select.getChat);
                                                for (var i = 0;
                                                    i <
                                                        widget
                                                            .selectChat
                                                            .getSelectedChat
                                                            .length;
                                                    i++) {
                                                  API.deleteMessage(
                                                      widget
                                                          .selectChat
                                                          .getSelectedChat
                                                          .values
                                                          .elementAt(i)
                                                          .lPin!,
                                                      "",
                                                      "1",
                                                      "3",
                                                      widget
                                                          .selectChat
                                                          .getSelectedChat
                                                          .values
                                                          .elementAt(i)
                                                          .messageId!);
                                                  tempChat[tempChat.indexWhere(
                                                          (item) =>
                                                              item.messageId ==
                                                              widget
                                                                  .selectChat
                                                                  .getSelectedChat
                                                                  .values
                                                                  .elementAt(i)
                                                                  .messageId)]
                                                      .isSelected = false;
                                                  tempChat.removeAt(tempChat
                                                      .indexWhere((item) =>
                                                          item.messageId ==
                                                          widget
                                                              .selectChat
                                                              .getSelectedChat
                                                              .values
                                                              .elementAt(i)
                                                              .messageId));
                                                }
                                                widget.select.replaceChat =
                                                    tempChat;
                                                widget.selectChat.clearList =
                                                    true;
                                                if (!widget
                                                    .attachment.refresh) {
                                                  widget.attachment.refresh =
                                                      true;
                                                }
                                              },
                                              child: Text("Delete",
                                                  style: TextStyle(
                                                      color:
                                                          AppColor.primaryColor,
                                                      fontSize: 14)),
                                            ),
                                            CupertinoDialogAction(
                                              onPressed: () =>
                                                  Navigator.pop(context),
                                              child: Text("Cancel",
                                                  style: TextStyle(
                                                      color:
                                                          AppColor.primaryColor,
                                                      fontSize: 14)),
                                            ),
                                            widget.attachment
                                                        .cantDeleteForEveryone >
                                                    0
                                                ? Container()
                                                : CupertinoDialogAction(
                                                    onPressed: () {
                                                      Navigator.of(context)
                                                          .pop();
                                                      for (var i = 0;
                                                          i <
                                                              widget
                                                                  .selectChat
                                                                  .getSelectedChat
                                                                  .length;
                                                          i++) {
                                                        API.deleteMessage(
                                                            widget
                                                                .selectChat
                                                                .getSelectedChat
                                                                .values
                                                                .elementAt(i)
                                                                .lPin!,
                                                            "",
                                                            "2",
                                                            "3",
                                                            widget
                                                                .selectChat
                                                                .getSelectedChat
                                                                .values
                                                                .elementAt(i)
                                                                .messageId!);
                                                        widget.select
                                                                .falseSelected =
                                                            widget
                                                                .selectChat
                                                                .getSelectedChat
                                                                .keys
                                                                .elementAt(i);
                                                      }
                                                      widget.selectChat
                                                          .clearList = true;
                                                    },
                                                    child: Text(
                                                        "Delete for everyone",
                                                        style: TextStyle(
                                                            color: AppColor
                                                                .primaryColor,
                                                            fontSize: 14)),
                                                  )
                                          ]);
                                    });
                              } else {
                                widget.selectChat.getSelectedChat
                                    .forEach((k, v) {
                                  int idx = widget.select.getChat.indexWhere(
                                      (element) =>
                                          element.messageId == v.messageId);
                                  if (widget.select.getChat[idx].isFavorite) {
                                    API.deleteMessageFavorite(v.messageId!);
                                    widget.select.updateFavoriteMessage = {
                                      "index": idx,
                                      "value": false
                                    };
                                  } else {
                                    API.addFavoriteMessage(v.messageId!);
                                    widget.select.updateFavoriteMessage = {
                                      "index": idx,
                                      "value": true
                                    };
                                  }
                                  widget.select.falseSelected = idx;
                                });
                                widget.attachment.justDelete = 0;
                                widget.attachment.cantForward = 0;
                                if (widget.attachment.disableFavoriteMessage) {
                                  widget.attachment.disableFavoriteMessage =
                                      false;
                                }
                                widget.selectChat.clearList = true;
                                widget.attachment.refresh = true;
                              }
                            },
                          )
                        : (widget.selectChat.getSelectedChat.length > 1 &&
                                    widget.attachment.disableFavoriteMessage) ||
                                widget.changeState.isContactCenter
                            ? Container()
                            : widget.selectChat.getSelectedChat.length > 1 &&
                                    !widget.changeState.isContactCenter
                                ? PopupMenuButton(
                                    itemBuilder: (context) => [
                                      PopupMenuItem(
                                        value: 4,
                                        child: Text(widget.selectChat
                                                .getSelectedChat.values
                                                .elementAt(0)
                                                .isFavorite
                                            ? "Delete from favourite message"
                                            : "Add to favourite message"),
                                      )
                                    ],
                                    onSelected: (value) async {
                                      widget.selectChat.getSelectedChat
                                          .forEach((k, v) {
                                        int idx = widget.select.getChat
                                            .indexWhere((element) =>
                                                element.messageId ==
                                                v.messageId);
                                        if (widget
                                            .select.getChat[idx].isFavorite) {
                                          API.deleteMessageFavorite(
                                              v.messageId!);
                                          widget.select.updateFavoriteMessage =
                                              {"index": idx, "value": false};
                                        } else {
                                          API.addFavoriteMessage(v.messageId!);
                                          widget.select.updateFavoriteMessage =
                                              {"index": idx, "value": true};
                                        }
                                        widget.select.falseSelected = idx;
                                      });
                                      widget.attachment.justDelete = 0;
                                      widget.attachment.cantForward = 0;
                                      if (widget
                                          .attachment.disableFavoriteMessage) {
                                        widget.attachment
                                            .disableFavoriteMessage = false;
                                      }
                                      widget.selectChat.clearList = true;
                                      widget.attachment.refresh = true;
                                    },
                                  )
                                : widget.changeState.isContactCenter
                                    ? Container()
                                    : PopupMenuButton(
                                        itemBuilder: (context) => [
                                          widget.attachment.isBlock == 1 ||
                                                  widget.attachment.isBlock ==
                                                      -1 ||
                                                  widget.changeState
                                                          .identifier ==
                                                      "-999" ||
                                                  widget.changeState
                                                      .isContactCenter
                                              ? PopupMenuItem(
                                                  child: Container())
                                              : PopupMenuItem(
                                                  value: 1,
                                                  child: Text("Search"),
                                                ),
                                          widget.attachment.isBlock == -1 ||
                                                  widget.changeState
                                                          .identifier ==
                                                      "-999" ||
                                                  widget.changeState
                                                      .isContactCenter
                                              ? PopupMenuItem(
                                                  child: Container())
                                              : PopupMenuItem(
                                                  value: 2,
                                                  child: Text(widget.attachment
                                                              .isBlock ==
                                                          1
                                                      ? "Unblock"
                                                      : "Block"),
                                                ),
                                          PopupMenuItem(
                                            value: 3,
                                            child: Text("Delete conversation"),
                                          )
                                        ],
                                        onSelected: (select) async {
                                          if (select == 1) {
                                            widget.attachment.isSearch =
                                                !widget.attachment.isSearch;
                                          } else if (select == 3) {
                                            if (FocusScope.of(context)
                                                .hasFocus) {
                                              FocusScope.of(context).unfocus();
                                              await Future.delayed(
                                                  Duration(milliseconds: 100));
                                            }
                                            showDialog(
                                                context: context,
                                                builder: (context) {
                                                  return CupertinoAlertDialog(
                                                      insetAnimationCurve:
                                                          Curves.easeInBack,
                                                      content: Container(
                                                        margin: EdgeInsets.only(
                                                            top: 10),
                                                        child: Text(
                                                            "Are you sure to delete all message in this conversation?"),
                                                      ),
                                                      actions: <Widget>[
                                                        CupertinoDialogAction(
                                                          onPressed: () =>
                                                              Navigator.pop(
                                                                  context),
                                                          child: Text(
                                                              "Cancel"
                                                                  .toUpperCase(),
                                                              style: TextStyle(
                                                                  color: Color(
                                                                      0xFF364656),
                                                                  fontSize:
                                                                      14)),
                                                        ),
                                                        CupertinoDialogAction(
                                                          onPressed: () async {
                                                            SharedPreferences
                                                                prefs =
                                                                await SharedPreferences
                                                                    .getInstance();
                                                            String idMe =
                                                                prefs.getString(
                                                                    "hasLogin")!;
                                                            await API.clearChat(
                                                                widget
                                                                    .changeState
                                                                    .identifier,
                                                                "",
                                                                idMe,
                                                                widget
                                                                    .changeState
                                                                    .identifier,
                                                                "3");
                                                            Navigator.pop(
                                                                context);
                                                            Navigator.pop(
                                                                context);
                                                          },
                                                          child: Text("Delete",
                                                              style: TextStyle(
                                                                  color: Color(
                                                                      0xFF364656),
                                                                  fontSize:
                                                                      14)),
                                                        )
                                                      ]);
                                                });
                                          } else {
                                            if (widget.attachment.isBlock ==
                                                1) {
                                              var resultBlock =
                                                  await API.unblockUser(
                                                      widget.changeState
                                                          .identifier,
                                                      "0");
                                              if (resultBlock == "00") {
                                                widget.attachment.isBlock = 0;
                                              }
                                            } else {
                                              var resultBlock =
                                                  await API.blockUser(
                                                      widget.changeState
                                                          .identifier,
                                                      "1");
                                              if (resultBlock == "00") {
                                                String text =
                                                    "You have blocked this user";
                                                widget.attachment.textBlock =
                                                    text;
                                                widget.attachment.isBlock = 1;
                                              }
                                            }
                                          }
                                        },
                                      )
          ],
        ),
        body: widget.attachment.loading
            ? Container()
            : Column(
                crossAxisAlignment: CrossAxisAlignment.end,
                mainAxisAlignment: MainAxisAlignment.spaceBetween,
                children: <Widget>[
                  Flexible(
                    child: Stack(
                      children: <Widget>[
                        GestureDetector(
                          onTap: () async {
                            print("skutt");
                            if (FocusScope.of(context).hasFocus) {
                              FocusScope.of(context).unfocus();
                              await Future.delayed(Duration(milliseconds: 100));
                            }
                          },
                          child: CustomScrollView(
                            controller: _scrollController,
                            reverse: true,
                            shrinkWrap: true,
                            slivers: <Widget>[
                              SliverList(
                                delegate: SliverChildBuilderDelegate(
                                    (context, index) {
                                  bool isShowDate = false;
                                  var data = widget.select.messageChat;
                                  String date = DateTime(
                                                  data[index].date.year,
                                                  data[index].date.month,
                                                  data[index].date.day)
                                              .difference(DateTime(
                                                  DateTime.now().year,
                                                  DateTime.now().month,
                                                  DateTime.now().day))
                                              .inDays ==
                                          0
                                      ? "Today"
                                      : DateTime(data[index].date.year, data[index].date.month, data[index].date.day)
                                                  .difference(DateTime(
                                                      DateTime.now().year,
                                                      DateTime.now().month,
                                                      DateTime.now().day))
                                                  .inDays ==
                                              -1
                                          ? "Yesterday"
                                          : DateTime(
                                                          data[index].date.year,
                                                          data[index]
                                                              .date
                                                              .month,
                                                          data[index].date.day)
                                                      .difference(DateTime(
                                                          DateTime.now().year,
                                                          DateTime.now().month,
                                                          DateTime.now().day))
                                                      .inDays ==
                                                  -2
                                              ? "2 days ago"
                                              : DateFormat('dd MMMM yyyy')
                                                  .format(data[index].date);
                                  if (data.length == 1) {
                                    isShowDate = true;
                                  } else {
                                    if (index == (data.length - 1)) {
                                      isShowDate = true;
                                    }
                                    if (index + 1 != data.length) {
                                      DateTime date1 = DateTime(
                                          data[index].date.year,
                                          data[index].date.month,
                                          data[index].date.day);
                                      DateTime date2 = DateTime(
                                          data[index + 1].date.year,
                                          data[index + 1].date.month,
                                          data[index + 1].date.day);
                                      if (date1 != date2) {
                                        isShowDate = true;
                                      }
                                    }
                                  }
                                  return AutoScrollTag(
                                    controller: _scrollController,
                                    index: index,
                                    child: Column(
                                      crossAxisAlignment:
                                          CrossAxisAlignment.stretch,
                                      children: <Widget>[
                                        isShowDate
                                            ? Center(
                                                child: Container(
                                                    child: Text(
                                                      date,
                                                      style: TextStyle(
                                                          fontSize: 10,
                                                          fontWeight:
                                                              FontWeight.bold),
                                                    ),
                                                    height: 24,
                                                    margin:
                                                        EdgeInsets.all(10.0),
                                                    padding:
                                                        EdgeInsets.all(5.0),
                                                    decoration: BoxDecoration(
                                                        border: Border.all(
                                                            color: Colors
                                                                .blueAccent),
                                                        borderRadius:
                                                            BorderRadius
                                                                .circular(
                                                                    3.0))),
                                              )
                                            : Container(),
                                        data[index].attachmentType == "12" ||
                                                data[index].attachmentType ==
                                                    "19"
                                            ? Container(
                                                alignment: Alignment.topCenter,
                                                margin: EdgeInsets.only(
                                                    bottom: 10.0),
                                                child: Container(
                                                  decoration: BoxDecoration(
                                                      color: data[index]
                                                                  .attachmentType ==
                                                              "12"
                                                          ? Color(0xFFc4d1e1)
                                                          : Colors.white70,
                                                      borderRadius:
                                                          BorderRadius.circular(
                                                              5.0)),
                                                  height: 60,
                                                  width: 200,
                                                  child: Row(
                                                    crossAxisAlignment:
                                                        CrossAxisAlignment
                                                            .center,
                                                    mainAxisAlignment:
                                                        MainAxisAlignment.start,
                                                    children: [
                                                      Expanded(
                                                        flex: 1,
                                                        child: Container(
                                                          margin:
                                                              EdgeInsets.only(
                                                                  left: 10.0),
                                                          child: Icon(
                                                              data[index].attachmentType ==
                                                                      "12"
                                                                  ? Icons
                                                                      .call_end
                                                                  : Icons
                                                                      .phone_missed,
                                                              color: data[index]
                                                                          .attachmentType ==
                                                                      "12"
                                                                  ? Colors.green
                                                                  : Colors.red,
                                                              size: 40),
                                                        ),
                                                      ),
                                                      Expanded(
                                                        flex: 3,
                                                        child: Container(
                                                          child: Wrap(
                                                            children: [
                                                              Container(
                                                                margin: EdgeInsets
                                                                    .only(
                                                                        left:
                                                                            10.0),
                                                                child: Text(
                                                                    !data[index]
                                                                            .isOriginator
                                                                        ? "${data[index].text}\nat ${data[index].time}"
                                                                        : data[index].text!.contains(
                                                                                "VoIP")
                                                                            ? "Outgoing Voip Call\nat ${data[index].time}"
                                                                            : "Outgoing Video Call\nat ${data[index].time}",
                                                                    style: TextStyle(
                                                                        color: Colors
                                                                            .grey[600])),
                                                              )
                                                            ],
                                                          ),
                                                        ),
                                                      )
                                                    ],
                                                  ),
                                                ),
                                              )
                                            : BubbleChatPersonal(
                                                isOriginator:
                                                    data[index].isOriginator,
                                                text: data[index].text,
                                                fileName: data[index].fileName,
                                                thumbName:
                                                    data[index].thumbName,
                                                attachmentType:
                                                    data[index].attachmentType,
                                                credential:
                                                    data[index].credential,
                                                messageId:
                                                    data[index].messageId,
                                                time: data[index].time,
                                                refId: data[index].refId,
                                                refFrom: data[index].refFrom,
                                                refType: data[index].refType,
                                                refText: data[index].refText,
                                                ack: data[index].ack,
                                                link:
                                                    getLink(data[index].text!),
                                                blogId: data[index].blog_id,
                                                isFavorite:
                                                    data[index].isFavorite,
                                                countCredential:
                                                    data[index].countCredential,
                                                progress: data[index].progress,
                                                refThumbLoc:
                                                    data[index].refThumbLoc,
                                                allContacts: widget
                                                    .attachment.getAllContacts,
                                                refThumbId:
                                                    data[index].refThumbId,
                                                statusRead:
                                                    data[index].statusRead,
                                                isSelected:
                                                    data[index].isSelected,
                                                isSearch:
                                                    widget.attachment.isSearch,
                                                textSearch: widget
                                                    .attachment.textSearch,
                                                onStartCount: () {
                                                  if (!data[index].runCount) {
                                                    startTimer(index);
                                                  }
                                                },
                                                onTapReply: () async {
                                                  if (widget
                                                          .selectChat
                                                          .getSelectedChat
                                                          .length ==
                                                      0) {
                                                    int idx = widget
                                                        .select.getChat
                                                        .indexOf(Chat(
                                                            messageId:
                                                                data[index]
                                                                    .refId));
                                                    if (idx != -1) {
                                                      _scrollController
                                                          .scrollToIndex(idx,
                                                              duration: Duration(
                                                                  milliseconds:
                                                                      500));
                                                      widget.select
                                                          .trueSelected = idx;
                                                      Future.delayed(
                                                          Duration(seconds: 1),
                                                          () {
                                                        widget.select
                                                                .falseSelected =
                                                            idx;
                                                      });
                                                    } else {
                                                      int idxDatabase = -1;
                                                      List<dynamic>
                                                          resultQuery =
                                                          await DBHelper()
                                                              .queryCustom(
                                                                  "SELECT * FROM MESSAGE where (f_pin='${widget.changeState.identifier}' or l_pin='${widget.changeState.identifier}') ${widget.changeState.isContactCenter ? "and is_call_center = 1 " : ''}order by server_date");
                                                      if (resultQuery.length !=
                                                          0) {
                                                        resultQuery.sort((b,
                                                                a) =>
                                                            a['server_date']
                                                                .compareTo(b[
                                                                    'server_date']));
                                                      }
                                                      for (var i = 0;
                                                          i <
                                                              resultQuery
                                                                  .length;
                                                          i++) {
                                                        if (resultQuery[i][
                                                                'message_id'] ==
                                                            data[index].refId) {
                                                          idxDatabase = i;
                                                          break;
                                                        }
                                                      }
                                                      await getChat(
                                                          widget.select,
                                                          widget.attachment,
                                                          (widget.select.getChat
                                                                  .length -
                                                              1),
                                                          end: (idxDatabase -
                                                                  (widget
                                                                          .select
                                                                          .getChat
                                                                          .length -
                                                                      1)) +
                                                              1);
                                                      idx = widget
                                                          .select.getChat
                                                          .indexOf(Chat(
                                                              messageId:
                                                                  data[index]
                                                                      .refId));
                                                      _scrollController
                                                          .scrollToIndex(idx,
                                                              duration: Duration(
                                                                  milliseconds:
                                                                      500));
                                                      widget.select
                                                          .trueSelected = idx;
                                                      Future.delayed(
                                                          Duration(seconds: 1),
                                                          () {
                                                        widget.select
                                                                .falseSelected =
                                                            idx;
                                                      });
                                                    }
                                                  } else {
                                                    if (!data[index]
                                                        .isSelected) {
                                                      if (widget
                                                              .selectChat
                                                              .getSelectedChat
                                                              .length >
                                                          0) {
                                                        bool different = widget
                                                            .selectChat
                                                            .getSelectedChat
                                                            .values
                                                            .elementAt(widget
                                                                    .selectChat
                                                                    .getSelectedChat
                                                                    .length -
                                                                1)
                                                            .isFavorite;
                                                        if (different !=
                                                            data[index]
                                                                .isFavorite) {
                                                          if (!widget.attachment
                                                              .disableFavoriteMessage) {
                                                            widget.attachment
                                                                    .disableFavoriteMessage =
                                                                true;
                                                          }
                                                        }
                                                      }
                                                      widget.select
                                                          .trueSelected = index;
                                                      widget.selectChat
                                                          .addList = {
                                                        "index": index,
                                                        "data": data[index]
                                                      };
                                                      if (data[index]
                                                                  .attachmentType ==
                                                              "11" ||
                                                          (data[index].attachmentType !=
                                                                  "11" &&
                                                              data[index]
                                                                      .attachmentType !=
                                                                  "0" &&
                                                              data[index]
                                                                      .attachmentType !=
                                                                  "3" &&
                                                              !File(widget
                                                                          .attachment
                                                                          .path
                                                                          .path +
                                                                      "/" +
                                                                      data[index]
                                                                          .fileName!)
                                                                  .existsSync())) {
                                                        widget.attachment
                                                            .cantForward = widget
                                                                .attachment
                                                                .cantForward +
                                                            1;
                                                      }
                                                      if (data[index]
                                                              .text!
                                                              .contains("🚫") ||
                                                          data[index]
                                                                  .credential ==
                                                              "1") {
                                                        widget.attachment
                                                            .justDelete = widget
                                                                .attachment
                                                                .justDelete +
                                                            1;
                                                      }
                                                    } else if (widget
                                                        .select
                                                        .messageChat[index]
                                                        .isSelected) {
                                                      widget.select
                                                              .falseSelected =
                                                          index;
                                                      widget.selectChat
                                                          .removeList = index;
                                                      if (widget
                                                              .selectChat
                                                              .getSelectedChat
                                                              .length >
                                                          0) {
                                                        if (widget
                                                                .selectChat
                                                                .getSelectedChat
                                                                .length ==
                                                            1) {
                                                          if (widget.attachment
                                                              .disableFavoriteMessage) {
                                                            widget.attachment
                                                                    .disableFavoriteMessage =
                                                                false;
                                                          }
                                                        } else {
                                                          bool different2 = widget
                                                              .selectChat
                                                              .getSelectedChat
                                                              .values
                                                              .elementAt(widget
                                                                      .selectChat
                                                                      .getSelectedChat
                                                                      .length -
                                                                  1)
                                                              .isFavorite;
                                                          bool different1 = widget
                                                              .selectChat
                                                              .getSelectedChat
                                                              .values
                                                              .elementAt(widget
                                                                      .selectChat
                                                                      .getSelectedChat
                                                                      .length -
                                                                  2)
                                                              .isFavorite;
                                                          if (different1 ==
                                                              different2) {
                                                            if (widget
                                                                .attachment
                                                                .disableFavoriteMessage) {
                                                              widget.attachment
                                                                      .disableFavoriteMessage =
                                                                  false;
                                                            }
                                                          }
                                                        }
                                                      }

                                                      if (data[index]
                                                                  .attachmentType ==
                                                              "11" ||
                                                          (data[index].attachmentType !=
                                                                  "11" &&
                                                              data[index]
                                                                      .attachmentType !=
                                                                  "0" &&
                                                              data[index]
                                                                      .attachmentType !=
                                                                  "3" &&
                                                              !File(widget
                                                                          .attachment
                                                                          .path
                                                                          .path +
                                                                      "/" +
                                                                      data[index]
                                                                          .fileName!)
                                                                  .existsSync())) {
                                                        widget.attachment
                                                            .cantForward = widget
                                                                .attachment
                                                                .cantForward -
                                                            1;
                                                      }
                                                      if ((data[index]
                                                                  .text!
                                                                  .contains(
                                                                      "🚫") ||
                                                              data[index]
                                                                      .credential ==
                                                                  "1") &&
                                                          widget.attachment
                                                                  .justDelete !=
                                                              0) {
                                                        widget.attachment
                                                            .justDelete = widget
                                                                .attachment
                                                                .justDelete -
                                                            1;
                                                      }
                                                    }
                                                  }
                                                },
                                                onLongPress: () {
                                                  if (widget
                                                      .attachment.isSearch) {
                                                    _controllerSearch.clear();
                                                    widget.attachment.isSuffix =
                                                        false;
                                                    widget.attachment.isSearch =
                                                        false;
                                                    widget.attachment
                                                        .textSearch = null;
                                                    widget.attachment
                                                        .indexLastSearch = 0;
                                                  }
                                                  if (!data[index].isSelected &&
                                                      widget.changeState
                                                              .identifier !=
                                                          "-999" &&
                                                      ((widget.changeState
                                                                  .isContactCenter &&
                                                              widget.changeState
                                                                  .isGoingCallCenter) ||
                                                          !widget.changeState
                                                              .isContactCenter)) {
                                                    if (widget
                                                            .selectChat
                                                            .getSelectedChat
                                                            .length >
                                                        0) {
                                                      bool different = widget
                                                          .selectChat
                                                          .getSelectedChat
                                                          .values
                                                          .elementAt(widget
                                                                  .selectChat
                                                                  .getSelectedChat
                                                                  .length -
                                                              1)
                                                          .isFavorite;
                                                      if (different !=
                                                          data[index]
                                                              .isFavorite) {
                                                        if (!widget.attachment
                                                            .disableFavoriteMessage) {
                                                          widget.attachment
                                                                  .disableFavoriteMessage =
                                                              true;
                                                        }
                                                      }
                                                    }
                                                    widget.select.trueSelected =
                                                        index;
                                                    widget.selectChat.addList =
                                                        {
                                                      "index": index,
                                                      "data": data[index]
                                                    };
                                                    if (data[index]
                                                                .attachmentType ==
                                                            "11" ||
                                                        (data[index].attachmentType !=
                                                                "11" &&
                                                            data[index]
                                                                    .attachmentType !=
                                                                "0" &&
                                                            data[index]
                                                                    .attachmentType !=
                                                                "3" &&
                                                            !File(widget
                                                                        .attachment
                                                                        .path
                                                                        .path +
                                                                    "/" +
                                                                    data[index]
                                                                        .fileName!)
                                                                .existsSync())) {
                                                      widget.attachment
                                                          .cantForward = widget
                                                              .attachment
                                                              .cantForward +
                                                          1;
                                                    }
                                                    if (data[index]
                                                            .text!
                                                            .contains("🚫") ||
                                                        data[index]
                                                                .credential ==
                                                            "1") {
                                                      widget.attachment
                                                          .justDelete = widget
                                                              .attachment
                                                              .justDelete +
                                                          1;
                                                    }
                                                    if (!data[index]
                                                        .isOriginator) {
                                                      widget.attachment
                                                          .cantDeleteForEveryone = widget
                                                              .attachment
                                                              .cantDeleteForEveryone +
                                                          1;
                                                    }
                                                  } else if (data[index]
                                                          .isSelected &&
                                                      widget.changeState
                                                              .identifier !=
                                                          "-999" &&
                                                      ((widget.changeState
                                                                  .isContactCenter &&
                                                              widget.changeState
                                                                  .isGoingCallCenter) ||
                                                          !widget.changeState
                                                              .isContactCenter)) {
                                                    widget.select
                                                        .falseSelected = index;
                                                    widget.selectChat
                                                        .removeList = index;
                                                    if (widget
                                                            .selectChat
                                                            .getSelectedChat
                                                            .length >
                                                        0) {
                                                      if (widget
                                                              .selectChat
                                                              .getSelectedChat
                                                              .length ==
                                                          1) {
                                                        if (widget.attachment
                                                            .disableFavoriteMessage) {
                                                          widget.attachment
                                                                  .disableFavoriteMessage =
                                                              false;
                                                        }
                                                      } else {
                                                        bool different2 = widget
                                                            .selectChat
                                                            .getSelectedChat
                                                            .values
                                                            .elementAt(widget
                                                                    .selectChat
                                                                    .getSelectedChat
                                                                    .length -
                                                                1)
                                                            .isFavorite;
                                                        bool different1 = widget
                                                            .selectChat
                                                            .getSelectedChat
                                                            .values
                                                            .elementAt(widget
                                                                    .selectChat
                                                                    .getSelectedChat
                                                                    .length -
                                                                2)
                                                            .isFavorite;
                                                        if (different1 ==
                                                            different2) {
                                                          if (widget.attachment
                                                              .disableFavoriteMessage) {
                                                            widget.attachment
                                                                    .disableFavoriteMessage =
                                                                false;
                                                          }
                                                        }
                                                      }
                                                    }
                                                    if (data[index]
                                                                .attachmentType ==
                                                            "11" ||
                                                        (data[index].attachmentType !=
                                                                "11" &&
                                                            data[index]
                                                                    .attachmentType !=
                                                                "0" &&
                                                            data[index]
                                                                    .attachmentType !=
                                                                "3" &&
                                                            !File(widget
                                                                        .attachment
                                                                        .path
                                                                        .path +
                                                                    "/" +
                                                                    data[index]
                                                                        .fileName!)
                                                                .existsSync())) {
                                                      widget.attachment
                                                          .cantForward = widget
                                                              .attachment
                                                              .cantForward -
                                                          1;
                                                    }
                                                    if ((data[index]
                                                                .text!
                                                                .contains(
                                                                    "🚫") ||
                                                            data[index]
                                                                    .credential ==
                                                                "1") &&
                                                        widget.attachment
                                                                .justDelete !=
                                                            0) {
                                                      widget.attachment
                                                          .justDelete = widget
                                                              .attachment
                                                              .justDelete -
                                                          1;
                                                    }
                                                    if (!data[index]
                                                        .isOriginator) {
                                                      widget.attachment
                                                          .cantDeleteForEveryone = widget
                                                              .attachment
                                                              .cantDeleteForEveryone -
                                                          1;
                                                    }
                                                  }
                                                },
                                                onTapPress: () async {
                                                  if (widget
                                                          .selectChat
                                                          .getSelectedChat
                                                          .length >
                                                      0) {
                                                    if (!data[index]
                                                        .isSelected) {
                                                      if (widget
                                                              .selectChat
                                                              .getSelectedChat
                                                              .length >
                                                          0) {
                                                        bool different = widget
                                                            .selectChat
                                                            .getSelectedChat
                                                            .values
                                                            .elementAt(widget
                                                                    .selectChat
                                                                    .getSelectedChat
                                                                    .length -
                                                                1)
                                                            .isFavorite;
                                                        if (different !=
                                                            data[index]
                                                                .isFavorite) {
                                                          if (!widget.attachment
                                                              .disableFavoriteMessage) {
                                                            widget.attachment
                                                                    .disableFavoriteMessage =
                                                                true;
                                                          }
                                                        }
                                                      }

                                                      widget.select
                                                          .trueSelected = index;
                                                      widget.selectChat
                                                          .addList = {
                                                        "index": index,
                                                        "data": data[index]
                                                      };
                                                      if (data[index]
                                                                  .attachmentType ==
                                                              "11" ||
                                                          (data[index].attachmentType !=
                                                                  "11" &&
                                                              data[index]
                                                                      .attachmentType !=
                                                                  "0" &&
                                                              data[index]
                                                                      .attachmentType !=
                                                                  "3" &&
                                                              !File(widget
                                                                          .attachment
                                                                          .path
                                                                          .path +
                                                                      "/" +
                                                                      data[index]
                                                                          .fileName!)
                                                                  .existsSync())) {
                                                        widget.attachment
                                                            .cantForward = widget
                                                                .attachment
                                                                .cantForward +
                                                            1;
                                                      }
                                                      if (data[index]
                                                              .text!
                                                              .contains("🚫") ||
                                                          data[index]
                                                                  .credential ==
                                                              "1") {
                                                        widget.attachment
                                                            .justDelete = widget
                                                                .attachment
                                                                .justDelete +
                                                            1;
                                                      }
                                                      if (!data[index]
                                                          .isOriginator) {
                                                        widget.attachment
                                                            .cantDeleteForEveryone = widget
                                                                .attachment
                                                                .cantDeleteForEveryone +
                                                            1;
                                                      }
                                                    } else if (widget
                                                        .select
                                                        .messageChat[index]
                                                        .isSelected) {
                                                      widget.select
                                                              .falseSelected =
                                                          index;
                                                      widget.selectChat
                                                          .removeList = index;
                                                      if (widget
                                                              .selectChat
                                                              .getSelectedChat
                                                              .length >
                                                          0) {
                                                        if (widget
                                                                .selectChat
                                                                .getSelectedChat
                                                                .length ==
                                                            1) {
                                                          if (widget.attachment
                                                              .disableFavoriteMessage) {
                                                            widget.attachment
                                                                    .disableFavoriteMessage =
                                                                false;
                                                          }
                                                        } else {
                                                          bool different2 = widget
                                                              .selectChat
                                                              .getSelectedChat
                                                              .values
                                                              .elementAt(widget
                                                                      .selectChat
                                                                      .getSelectedChat
                                                                      .length -
                                                                  1)
                                                              .isFavorite;
                                                          bool different1 = widget
                                                              .selectChat
                                                              .getSelectedChat
                                                              .values
                                                              .elementAt(widget
                                                                      .selectChat
                                                                      .getSelectedChat
                                                                      .length -
                                                                  2)
                                                              .isFavorite;
                                                          if (different1 ==
                                                              different2) {
                                                            if (widget
                                                                .attachment
                                                                .disableFavoriteMessage) {
                                                              widget.attachment
                                                                      .disableFavoriteMessage =
                                                                  false;
                                                            }
                                                          }
                                                        }
                                                      }

                                                      if (data[index]
                                                                  .attachmentType ==
                                                              "11" ||
                                                          (data[index].attachmentType !=
                                                                  "11" &&
                                                              data[index]
                                                                      .attachmentType !=
                                                                  "0" &&
                                                              data[index]
                                                                      .attachmentType !=
                                                                  "3" &&
                                                              !File(widget
                                                                          .attachment
                                                                          .path
                                                                          .path +
                                                                      "/" +
                                                                      data[index]
                                                                          .fileName!)
                                                                  .existsSync())) {
                                                        widget.attachment
                                                            .cantForward = widget
                                                                .attachment
                                                                .cantForward -
                                                            1;
                                                      }
                                                      if ((data[index]
                                                                  .text!
                                                                  .contains(
                                                                      "🚫") ||
                                                              data[index]
                                                                      .credential ==
                                                                  "1") &&
                                                          widget.attachment
                                                                  .justDelete !=
                                                              0) {
                                                        widget.attachment
                                                            .justDelete = widget
                                                                .attachment
                                                                .justDelete -
                                                            1;
                                                      }
                                                      if (!data[index]
                                                          .isOriginator) {
                                                        widget.attachment
                                                            .cantDeleteForEveryone = widget
                                                                .attachment
                                                                .cantDeleteForEveryone -
                                                            1;
                                                      }
                                                    }
                                                  } else if (data[index]
                                                              .fileName !=
                                                          null &&
                                                      data[index]
                                                          .fileName!
                                                          .isNotEmpty) {
                                                    if (data[index].attachmentType == "2" ||
                                                        data[index]
                                                                .attachmentType ==
                                                            "6" ||
                                                        data[index]
                                                                .attachmentType ==
                                                            "-1") {
                                                      if (!File(widget
                                                                      .attachment
                                                                      .path
                                                                      .path +
                                                                  "/" +
                                                                  data[index]
                                                                      .fileName!)
                                                              .existsSync() &&
                                                          data[index]
                                                                  .progress ==
                                                              null) {
                                                        Fluttertoast.showToast(
                                                            msg:
                                                                "Downloading...",
                                                            toastLength: Toast
                                                                .LENGTH_SHORT);
                                                        API.download(data[index]
                                                            .fileName!);
                                                      } else if (File(widget
                                                                  .attachment
                                                                  .path
                                                                  .path +
                                                              "/" +
                                                              data[index]
                                                                  .fileName!)
                                                          .existsSync()) {
                                                        OpenFile.open(widget
                                                                .attachment
                                                                .path
                                                                .path +
                                                            "/" +
                                                            data[index]
                                                                .fileName!);
                                                      }
                                                    } else if (data[index]
                                                            .attachmentType ==
                                                        "1") {
                                                      if (!File(widget
                                                                      .attachment
                                                                      .path
                                                                      .path +
                                                                  "/" +
                                                                  data[index]
                                                                      .fileName!)
                                                              .existsSync() &&
                                                          data[index]
                                                                  .progress ==
                                                              null) {
                                                        Fluttertoast.showToast(
                                                            msg:
                                                                "Downloading...",
                                                            toastLength: Toast
                                                                .LENGTH_SHORT);
                                                        API.download(data[index]
                                                            .fileName!);
                                                      } else if (File(widget
                                                                  .attachment
                                                                  .path
                                                                  .path +
                                                              "/" +
                                                              data[index]
                                                                  .fileName!)
                                                          .existsSync()) {
                                                        Navigator.push(
                                                            context,
                                                            PageTransition(
                                                                type:
                                                                    PageTransitionType
                                                                        .fade,
                                                                child: Stack(
                                                                  children: <
                                                                      Widget>[
                                                                    Center(
                                                                      child: PhotoView(
                                                                          imageProvider: FileImage(File(widget.attachment.path.path +
                                                                              "/" +
                                                                              data[index]
                                                                                  .fileName!)),
                                                                          backgroundDecoration:
                                                                              BoxDecoration(color: Colors.blueGrey)),
                                                                    ),
                                                                    Align(
                                                                      alignment:
                                                                          Alignment
                                                                              .topLeft,
                                                                      child:
                                                                          Container(
                                                                        child:
                                                                            Material(
                                                                          color:
                                                                              Colors.transparent,
                                                                          child:
                                                                              GestureDetector(
                                                                            child:
                                                                                Row(
                                                                              mainAxisAlignment: MainAxisAlignment.start,
                                                                              children: <Widget>[
                                                                                Icon(Icons.arrow_back_ios, color: Colors.white),
                                                                                Text("Back", style: TextStyle(color: Colors.white, fontSize: 18))
                                                                              ],
                                                                            ),
                                                                            onTap: () =>
                                                                                Navigator.pop(context),
                                                                          ),
                                                                        ),
                                                                        margin: EdgeInsets.only(
                                                                            top:
                                                                                40.0,
                                                                            left:
                                                                                5.0),
                                                                      ),
                                                                    )
                                                                  ],
                                                                )));
                                                      }
                                                    }
                                                  } else if (data[index]
                                                          .attachmentType ==
                                                      "3") {
                                                    String textDecode = Uri
                                                        .decodeQueryComponent(
                                                            Uri.decodeFull(
                                                                data[index]
                                                                    .text!));
                                                    int idx =
                                                        textDecode.indexOf("(");
                                                    var textLatLng = textDecode
                                                        .substring(
                                                            idx + 1,
                                                            textDecode
                                                                    .trim()
                                                                    .length -
                                                                1)
                                                        .split(",");
                                                    final url =
                                                        'https://www.google.com/maps/search/?api=1&query=${textLatLng[0]},${textLatLng[1].trimLeft()}';
                                                    if (await canLaunch(url)) {
                                                      await launch(url);
                                                    }
                                                  } else if (data[index]
                                                          .attachmentType ==
                                                      "25") {
                                                    String textM = data[index]
                                                        .blog_id!
                                                        .split("~")[1];

                                                    var parseVCRMessage =
                                                        json.decode(textM);
                                                    print("parser " +
                                                        parseVCRMessage
                                                            .toString());
                                                    var by =
                                                        parseVCRMessage['by'];
                                                    var title = parseVCRMessage[
                                                        'title'];
                                                    var times =
                                                        parseVCRMessage['time'];
                                                    List<dynamic> members =
                                                        jsonDecode(
                                                            parseVCRMessage[
                                                                'members']);
                                                    var member =
                                                        List<String>.from(
                                                            members);
                                                    DateTime dateTimes = DateTime
                                                        .fromMillisecondsSinceEpoch(
                                                            times);
                                                    if (DateTime.now()
                                                            .millisecondsSinceEpoch <
                                                        dateTimes
                                                            .millisecondsSinceEpoch) {
                                                      Fluttertoast.showToast(
                                                          msg:
                                                              "Conference Room Not Started Yet",
                                                          toastLength: Toast
                                                              .LENGTH_SHORT);
                                                    } else {
                                                      Navigator.push(
                                                          context,
                                                          PageTransition(
                                                              type:
                                                                  PageTransitionType
                                                                      .fade,
                                                              child:
                                                                  JoinConferenceRoom(
                                                                members: member,
                                                                title: title,
                                                                f_pin: by,
                                                                blog_id: data[
                                                                        index]
                                                                    .blog_id!
                                                                    .split(
                                                                        "~")[0],
                                                                time: times,
                                                              )));
                                                    }
                                                  } else if (data[index]
                                                          .attachmentType ==
                                                      "27") {
                                                    String textM = data[index]
                                                        .blog_id!
                                                        .split("~")
                                                        .sublist(1)
                                                        .join("~");
                                                    print("message : $textM");
                                                    var parseLSMessage =
                                                        json.decode(textM);
                                                    var title =
                                                        parseLSMessage['title'];
                                                    var desc = parseLSMessage[
                                                        'description'];
                                                    var by =
                                                        parseLSMessage['by'];
                                                    var times =
                                                        parseLSMessage['time'];
                                                    var type =
                                                        parseLSMessage['type'];
                                                    String? status;

                                                    List<dynamic> members =
                                                        jsonDecode(
                                                            parseLSMessage[
                                                                'members']);
                                                    DateTime dateTimes = DateTime
                                                        .fromMillisecondsSinceEpoch(
                                                            int.parse(times
                                                                    .toString()) +
                                                                240000);
                                                    DateTime endTimes = DateTime
                                                        .fromMillisecondsSinceEpoch(
                                                            int.parse(times
                                                                    .toString()) +
                                                                7440000);

                                                    var member =
                                                        List<String>.from(
                                                            members);

                                                    print(
                                                        "data ls $title $desc $by $times $type " +
                                                            member.toString() +
                                                            " " +
                                                            data[index]
                                                                .blog_id!
                                                                .split("~")[0]);

                                                    SharedPreferences prefs =
                                                        await SharedPreferences
                                                            .getInstance();
                                                    String idMe = prefs
                                                        .getString("hasLogin")!;
                                                    if (idMe != by.toString()) {
                                                      API
                                                          .isInitiatorJoin(
                                                              by.toString(),
                                                              "3",
                                                              data[index]
                                                                  .blog_id!
                                                                  .split(
                                                                      "~")[0])
                                                          .then((value) {
                                                        print(
                                                            "value status initiator ls $value");
                                                        if (value
                                                            .toString()
                                                            .contains("0")) {
                                                          status = "OK";
                                                        } else if (value
                                                                .toString() ==
                                                            "-1") {
                                                          status = "NS";
                                                        } else {
                                                          status = "NOK";
                                                        }

                                                        print(
                                                            "status : $status");
                                                        if (DateTime.now()
                                                                .millisecondsSinceEpoch <
                                                            dateTimes
                                                                .millisecondsSinceEpoch) {
                                                          Fluttertoast.showToast(
                                                              msg:
                                                                  "Live Video Promotion Not Started Yet",
                                                              toastLength: Toast
                                                                  .LENGTH_SHORT);
                                                        } else if (DateTime
                                                                    .now()
                                                                .millisecondsSinceEpoch >
                                                            endTimes
                                                                .millisecondsSinceEpoch) {
                                                          Fluttertoast.showToast(
                                                              msg:
                                                                  "Live Video Promotion session has expired..",
                                                              toastLength: Toast
                                                                  .LENGTH_SHORT);
                                                        } else if (status ==
                                                            "NS") {
                                                          Fluttertoast.showToast(
                                                              msg:
                                                                  "Live Video Promotion broadcaster has not started yet..",
                                                              toastLength: Toast
                                                                  .LENGTH_SHORT);
                                                        } else if (status ==
                                                            "NOK") {
                                                          Fluttertoast.showToast(
                                                              msg:
                                                                  "Unable to access servers. Try again later",
                                                              toastLength: Toast
                                                                  .LENGTH_SHORT);
                                                        } else {
                                                          Navigator.push(
                                                              context,
                                                              PageTransition(
                                                                  type:
                                                                      PageTransitionType
                                                                          .fade,
                                                                  child: ViewInfoLiveStreaming(
                                                                      title:
                                                                          title,
                                                                      desc:
                                                                          desc,
                                                                      fpin: by,
                                                                      time: int.parse(
                                                                          times
                                                                              .toString()),
                                                                      members:
                                                                          member,
                                                                      type:
                                                                          type)));
                                                        }
                                                      });
                                                    } else {
                                                      if (DateTime.now()
                                                              .millisecondsSinceEpoch <
                                                          dateTimes
                                                              .millisecondsSinceEpoch) {
                                                        Fluttertoast.showToast(
                                                            msg:
                                                                "Live Video Promotion Not Started Yet",
                                                            toastLength: Toast
                                                                .LENGTH_LONG);
                                                      } else if (DateTime.now()
                                                              .millisecondsSinceEpoch >
                                                          endTimes
                                                              .millisecondsSinceEpoch) {
                                                        Fluttertoast.showToast(
                                                            msg:
                                                                "Live Video Promotion session has expired..",
                                                            toastLength: Toast
                                                                .LENGTH_LONG);
                                                      } else {
                                                        Navigator.push(
                                                            context,
                                                            PageTransition(
                                                                type:
                                                                    PageTransitionType
                                                                        .fade,
                                                                child: ViewInfoLiveStreaming(
                                                                    title:
                                                                        title,
                                                                    desc: desc,
                                                                    fpin: by,
                                                                    time: int.parse(
                                                                        times
                                                                            .toString()),
                                                                    members:
                                                                        member,
                                                                    type: type,
                                                                    blog_id: data[
                                                                            index]
                                                                        .blog_id!
                                                                        .split(
                                                                            "~")[0])));
                                                      }
                                                    }
                                                  } else if (data[index]
                                                      .messageId!
                                                      .contains("REGSTU_")) {
                                                    print(
                                                        "request student: ${data[index].messageId}");
                                                    String requestId =
                                                        data[index]
                                                            .messageId!
                                                            .split("_")[2];
                                                    requestId =
                                                        "REGSTU_" + requestId;
                                                    print(
                                                        "requestId: $requestId");
                                                    // Navigator.push(
                                                    //     context,
                                                    //     PageTransition(
                                                    //       type: PageTransitionType
                                                    //           .fade,
                                                    //       child: ApprovalStudent(
                                                    //         formId: requestId,
                                                    //       ),
                                                    //     ));
                                                  } else if (data[index]
                                                      .messageId!
                                                      .contains('REGTEAC_')) {
                                                    print(
                                                        "request teacher: ${data[index].messageId}");
                                                    String requestId =
                                                        data[index]
                                                            .messageId!
                                                            .split("_")[2];
                                                    requestId =
                                                        "REGTEAC_" + requestId;
                                                    print(
                                                        "requestId: $requestId");
                                                    // Navigator.push(
                                                    //     context,
                                                    //     PageTransition(
                                                    //       type: PageTransitionType
                                                    //           .fade,
                                                    //       child: ApprovalTeacher(
                                                    //         formId: requestId,
                                                    //       ),
                                                    //     ));
                                                  }
                                                },
                                                onContactCenterSelect:
                                                    (int value) {
                                                  if (widget.changeState
                                                      .isChannelSelected) {
                                                    return;
                                                  }
                                                  if (value == 3) {
                                                  } else {
                                                    if (widget.changeState
                                                        .isRequestingCallCenter) {
                                                      Fluttertoast.showToast(
                                                          msg:
                                                              "You have made a contact center request. Please wait...",
                                                          toastLength: Toast
                                                              .LENGTH_SHORT);
                                                      return;
                                                    }
                                                    widget.changeState
                                                            .isRequestingCallCenter =
                                                        true;
                                                    widget.changeState
                                                            .isChannelSelected =
                                                        true;
                                                    DateFormat dateformat =
                                                        DateFormat(
                                                            "MM/dd/yy HH:mm");
                                                    String dateNow = dateformat
                                                        .format(DateTime.now());
                                                    String message =
                                                        "_< $dateNow >_\n_Please wait while we are connecting you to one of our customer service representatives..._";
                                                    var msg =
                                                        createMessageContactCenter(
                                                            message, "0");
                                                    addMessage(msg);
                                                    API
                                                        .requestCallCenter(
                                                            value)
                                                        .then((f_pin) {
                                                      if (f_pin == null) {
                                                        Fluttertoast.showToast(
                                                            msg:
                                                                "Check your internet connection and try again",
                                                            toastLength: Toast
                                                                .LENGTH_SHORT);
                                                        widget.changeState
                                                                .isRequestingCallCenter =
                                                            false;
                                                        return;
                                                      }
                                                      if (f_pin.isEmpty) {
                                                        widget.changeState
                                                            .isClickBusy = true;
                                                        String message =
                                                            "_ Sorry, currently all our representatives are busy helping other customers, do you want us to get back to you as soon as one of them is available? _";
                                                        var msg =
                                                            createMessageContactCenter(
                                                                message, "51");
                                                        addMessage(msg,
                                                            blogId: "$value");
                                                        return;
                                                      }
                                                      API.setLiveCenterSession(
                                                          f_pin, "1");
                                                      print(
                                                          "f_pin contact center: $f_pin");
                                                    });
                                                  }
                                                },
                                                onBusyContactCenter:
                                                    (String channel, int type) {
                                                  if (widget.changeState
                                                      .isBusySelected) {
                                                    return;
                                                  }
                                                  widget.changeState
                                                      .isBusySelected = true;
                                                  final listMessage =
                                                      Provider.of<ListMessage>(
                                                          context,
                                                          listen: false);
                                                  if (type == 0) {
                                                    String message =
                                                        "_Please wait while we are connecting you to one of our customer service representatives..._";
                                                    var msg =
                                                        createMessageContactCenter(
                                                            message, "0");
                                                    addMessage(msg);
                                                    API
                                                        .queuingCallCenter(
                                                            int.parse(channel))
                                                        .then((result) {
                                                      if (result != null) {
                                                        if (result.isNotEmpty) {
                                                          Fluttertoast.showToast(
                                                              msg:
                                                                  "Action Successful",
                                                              toastLength: Toast
                                                                  .LENGTH_SHORT);
                                                        } else {
                                                          Fluttertoast.showToast(
                                                              msg:
                                                                  "Check your internet connection and try again",
                                                              toastLength: Toast
                                                                  .LENGTH_SHORT);
                                                        }
                                                      } else {
                                                        Fluttertoast.showToast(
                                                            msg:
                                                                "Check your internet connection and try again",
                                                            toastLength: Toast
                                                                .LENGTH_SHORT);
                                                      }
                                                    });
                                                  } else {
                                                    widget.changeState
                                                            .isRequestingCallCenter =
                                                        false;
                                                    String message =
                                                        "_Thank you for being awesome, have a great day!_";
                                                    var msg =
                                                        createMessageContactCenter(
                                                            message, "0");
                                                    addMessage(msg);
                                                  }
                                                },
                                              )
                                      ],
                                    ),
                                  );
                                },
                                    childCount:
                                        widget.select.messageChat.length),
                              )
                            ],
                          ),
                        ),
                        ShowDate(widget.attachment.isShowDate,
                            widget.attachment.dateIndex),
                        TapToBottom(widget.attachment.isNotBottom, () {
                          _scrollController.animateTo(0.0,
                              duration: Duration(milliseconds: 1),
                              curve: Curves.easeOut);
                        }, widget.select.getNewMessages.length),
                      ],
                    ),
                  ),
                  Stack(
                    children: [
                      widget.changeState.identifier != "-999"
                          ? Column(
                              crossAxisAlignment: CrossAxisAlignment.end,
                              mainAxisSize: MainAxisSize.min,
                              children: <Widget>[
                                widget.attachment.textLink != null
                                    ? Container(
                                        padding: EdgeInsets.only(
                                            top: 5.0, bottom: 5.0),
                                        color: Colors.white,
                                        child: Stack(
                                          children: [
                                            widget.attachment.hitLink
                                                ? LinkPreviewer(
                                                    widget.attachment.textLink!,
                                                    true)
                                                : Container(
                                                    width: double.infinity,
                                                    decoration: BoxDecoration(
                                                        color: Colors.grey[100],
                                                        borderRadius:
                                                            BorderRadius
                                                                .circular(8.0)),
                                                    padding: EdgeInsets.only(
                                                        top: 10.0,
                                                        bottom: 10.0,
                                                        left: 5.0,
                                                        right: 5.0),
                                                    child: Text(widget
                                                        .attachment.textLink!),
                                                  ),
                                            Align(
                                              alignment: Alignment.topRight,
                                              child: Material(
                                                color: Colors.transparent,
                                                child: InkWell(
                                                  onTap: () {
                                                    widget.attachment.textLink =
                                                        null;
                                                    widget.attachment.hitLink =
                                                        false;
                                                  },
                                                  child: Icon(Icons.cancel,
                                                      color: Colors.grey
                                                          .withOpacity(0.5)),
                                                ),
                                              ),
                                            )
                                          ],
                                        ),
                                      )
                                    : Container(),
                                widget.attachment.getListImage.length > 0
                                    ? screenImageList(widget.attachment)
                                    : widget.attachment.getVideo != null
                                        ? screenVideo(widget.attachment)
                                        : Container(),
                                widget.attachment.isSearch
                                    ? Container()
                                    : clip(widget.attachment),
                                widget.attachment.isSearch
                                    ? Container()
                                    : _textComposerWidget(widget.attachment),
                                !widget.attachment.clickedSticker
                                    ? Container(width: 0.0, height: 0.0)
                                    : Container(
                                        height: 250,
                                        child: Sticker(
                                          stickerClicked: (sticker) async {
                                            print("STICKER $sticker");
                                            widget.attachment.clickedSticker =
                                                false;
                                            var resultSend = await API.sendMessage(
                                                lPin:
                                                    widget
                                                        .changeState.identifier,
                                                messageScopeId: "3",
                                                status: "2",
                                                reffId: widget.attachment
                                                            .getReplyContent !=
                                                        null
                                                    ? widget.attachment
                                                            .getReplyContent[
                                                        "message_id"]
                                                    : "",
                                                credential: widget.attachment
                                                        .getConfidentialActive
                                                    ? "1"
                                                    : "0",
                                                attachmentFlag: "11",
                                                readReceipts: widget
                                                        .attachment.getAckActive
                                                    ? "8"
                                                    : "",
                                                messageText: sticker);
                                            var formatTime =
                                                new DateFormat('Hm');
                                            String? refId,
                                                refName,
                                                refText,
                                                refType,
                                                refThumbId,
                                                refThumbLoc;
                                            if (widget.attachment
                                                    .getReplyContent !=
                                                null) {
                                              refId = widget.attachment
                                                      .getReplyContent[
                                                  "message_id"];
                                              refName = widget.attachment
                                                  .getReplyContent["fromName"];
                                              refText = widget.attachment
                                                                  .getReplyContent[
                                                              "attachment_type"] ==
                                                          "3" ||
                                                      widget.attachment
                                                                  .getReplyContent[
                                                              "attachment_type"] ==
                                                          "-1"
                                                  ? ""
                                                  : widget.attachment
                                                      .getReplyContent["text"];
                                              refType = widget.attachment
                                                      .getReplyContent[
                                                  "attachment_type"];
                                              refThumbId = widget.attachment
                                                  .getReplyContent["thumb_id"];
                                              refThumbLoc = widget.attachment
                                                      .getReplyContent[
                                                  "thumb_location"];
                                            }
                                            int countCredential = 0;
                                            String? credential;
                                            if (widget.attachment
                                                .getConfidentialActive) {
                                              credential = "1";
                                              countCredential = 60;
                                              SharedPreferences prefs =
                                                  await SharedPreferences
                                                      .getInstance();
                                              prefs.setInt(
                                                  resultSend,
                                                  DateTime.now()
                                                      .toUtc()
                                                      .millisecondsSinceEpoch);
                                            }
                                            widget.select.addChat = Chat(
                                                messageId: resultSend,
                                                lPin: widget
                                                    .changeState.identifier,
                                                isOriginator: true,
                                                text: sticker,
                                                statusRead: "1",
                                                attachmentType: "11",
                                                refFrom: refName,
                                                refType: refType,
                                                credential: credential,
                                                countCredential:
                                                    countCredential,
                                                ack: widget
                                                        .attachment.getAckActive
                                                    ? "8"
                                                    : "",
                                                runCount: false,
                                                refText: refText,
                                                refThumbLoc: refThumbLoc,
                                                refId: refId,
                                                refThumbId: refThumbId,
                                                time: formatTime
                                                    .format(DateTime.now()),
                                                date: DateTime.now());
                                            widget.attachment.refresh = true;
                                            widget.attachment.replyContent =
                                                null;
                                            _controllerEditor.clear();
                                            Future.delayed(
                                                Duration(milliseconds: 50), () {
                                              _scrollController.animateTo(0.0,
                                                  duration:
                                                      Duration(milliseconds: 1),
                                                  curve: Curves.easeOut);
                                            });
                                            if (widget.selectChat
                                                    .getSelectedChat.length >
                                                0) {
                                              widget.selectChat.getSelectedChat
                                                  .forEach((k, v) {
                                                int idx = widget.select.getChat
                                                    .indexWhere((element) =>
                                                        element.messageId ==
                                                        v.messageId);
                                                widget.select.falseSelected =
                                                    idx;
                                              });
                                              widget.attachment.justDelete = 0;
                                              widget.attachment.cantForward = 0;
                                              if (widget.attachment
                                                  .disableFavoriteMessage) {
                                                widget.attachment
                                                        .disableFavoriteMessage =
                                                    false;
                                              }
                                              widget.selectChat.clearList =
                                                  true;
                                            }
                                          },
                                        ),
                                      )
                              ],
                            )
                          : Align(
                              alignment: Alignment.bottomCenter,
                              child: Container(
                                alignment: Alignment.center,
                                width: double.infinity,
                                color: Colors.white.withOpacity(0.5),
                                padding:
                                    EdgeInsets.only(top: 20.0, bottom: 20.0),
                                child: Text(
                                  "Interactive Chatbot. Coming soon",
                                  style: TextStyle(fontWeight: FontWeight.bold),
                                ),
                              ),
                            ),
                      widget.attachment.isBlock == 1 ||
                              widget.attachment.isBlock == -1
                          ? Align(
                              alignment: Alignment.bottomCenter,
                              child: Container(
                                alignment: Alignment.center,
                                width: double.infinity,
                                color: Colors.white.withOpacity(0.5),
                                height: 115,
                                child: Text(
                                  widget.attachment.textBlock!,
                                  style: TextStyle(fontWeight: FontWeight.bold),
                                ),
                              ),
                            )
                          : Container(width: 0.0, height: 0.0)
                    ],
                  )
                ],
              ),
      ),
    );
  }

  Future<void> initQueryMe() async {
    SharedPreferences prefs = await SharedPreferences.getInstance();
    String idMe = prefs.getString("hasLogin")!;
    DBHelper()
        .queryCustom("SELECT * FROM BUDDY WHERE f_pin = '$idMe'")
        .then((value) {
      if (value.length > 0) {
        queryMe = value[0];
      }
    });
  }
}

class Chat {
  bool isOriginator, isSelected, runCount, isFavorite;
  String? text,
      fileName,
      thumbName,
      messageId,
      lPin,
      refId,
      refFrom,
      refText,
      refType,
      refThumbId,
      refThumbLoc,
      statusRead,
      time,
      attachmentType,
      credential,
      ack;
  int? countCredential;
  DateTime date;
  double? progress;
  String? blog_id, unDownloadThumb;

  Chat(
      {this.isOriginator = false,
      this.runCount = false,
      this.text,
      this.fileName,
      this.thumbName,
      this.messageId,
      this.lPin,
      this.refId,
      this.refFrom,
      this.refText,
      this.refType,
      this.refThumbId,
      this.refThumbLoc,
      this.statusRead,
      this.time,
      date,
      this.attachmentType,
      this.progress,
      this.countCredential,
      this.credential,
      this.ack,
      this.blog_id,
      this.unDownloadThumb,
      this.isSelected = false,
      this.isFavorite = false})
      : date = date ?? DateTime.now();

  @override
  bool operator ==(other) =>
      other is Chat &&
      (other.messageId == messageId ||
          (other.fileName == fileName &&
              other.fileName != '' &&
              other.fileName != null) ||
          (other.unDownloadThumb == unDownloadThumb &&
              other.unDownloadThumb != '' &&
              other.unDownloadThumb != null));

  @override
  int get hashCode => super.hashCode;
}

class ListMessage with ChangeNotifier {
  List<Chat> messageChat = [];
  List<Chat> newMessages = [];

  List<Chat> get getChat => messageChat;

  List<Chat> get getNewMessages => newMessages;

  set addChat(Chat value) {
    messageChat.insert(0, value);
    notifyListeners();
  }

  set insertAllChat(List<Chat> value) {
    messageChat.insertAll(0, value);
    notifyListeners();
  }

  set addNewMessages(Chat value) {
    newMessages.insert(0, value);
    notifyListeners();
  }

  void clearNewMessages() {
    newMessages.clear();
    notifyListeners();
  }

  set addChatAll(List<Chat> value) {
    messageChat.addAll(value);
    notifyListeners();
  }

  set insertChatAll(List<Chat> value) {
    messageChat.insertAll(0, value);
    notifyListeners();
  }

  set replaceChat(List<Chat> value) {
    messageChat = value;
    notifyListeners();
  }

  set removeChat(int value) {
    messageChat.removeAt(value);
    notifyListeners();
  }

  set updateProgress(var value) {
    messageChat[value["index"]].progress = value['value'];
    notifyListeners();
  }

  set updateThumbnail(var value) {
    messageChat[value["index"]].thumbName = value['value'];
    notifyListeners();
  }

  set updateStatus(var value) {
    messageChat[value["index"]].statusRead = value['value'];
    notifyListeners();
  }

  set updateFavoriteMessage(var value) {
    messageChat[value["index"]].isFavorite = value['value'];
    notifyListeners();
  }

  set updateStatusDelete(var value) {
    messageChat[value["index"]].text = value['value'];
    messageChat[value["index"]].attachmentType = value['flag'];
    notifyListeners();
  }

  set trueSelected(int i) {
    messageChat[i].isSelected = true;
    notifyListeners();
  }

  set falseSelected(int i) {
    messageChat[i].isSelected = false;
    notifyListeners();
  }

  set trueRunCount(int i) {
    messageChat[i].runCount = true;
    notifyListeners();
  }

  set countCredential(var value) {
    messageChat[value["index"]].countCredential = value["count"];
    notifyListeners();
  }

  set credential(var value) {
    messageChat[value["index"]].credential = value["credential"];
    notifyListeners();
  }
}

class SelectedChat with ChangeNotifier {
  Map<int, Chat> listSelectedChat = Map();

  Map<int, Chat> get getSelectedChat => listSelectedChat;

  set addList(var i) {
    listSelectedChat[i["index"]] = i["data"];
    notifyListeners();
  }

  set removeList(int i) {
    listSelectedChat.remove(i);
    notifyListeners();
  }

  set clearList(bool value) {
    listSelectedChat.clear();
    notifyListeners();
  }
}

class Attachment with ChangeNotifier {
  var _replyContent;
  bool _ackActive = false,
      _confidentialActive = false,
      _refresh = false,
      _loading = true,
      _isShowDate = false,
      _isSearch = false,
      _isSuffix = false,
      _isTyping = false,
      _connected = false,
      _clickedSticker = false,
      _isNotBottom = false,
      _hitLink = false,
      _disableFavoriteMessage = false;
  int _cantForward = 0,
      _indexLastSearch = 0,
      _justDelete = 0,
      _isBlock = 0,
      _cantDeleteForEveryone = 0;
  String? _dateIndex, _textSearch, _textLink, _textBlock;
  Directory? _path;
  List<File> _listImage = [];
  File? _video, _thumbnailVideo, _file;
  Map<String, String> _allContacts = Map();

  get getReplyContent => _replyContent;

  bool get getAckActive => _ackActive;

  bool get loading => _loading;

  bool get isShowDate => _isShowDate;

  bool get isSearch => _isSearch;

  bool get isSuffix => _isSuffix;

  bool get isTyping => _isTyping;

  bool get refresh => _refresh;

  bool get hitLink => _hitLink;

  bool get isNotBottom => _isNotBottom;

  bool get clickedSticker => _clickedSticker;

  bool get disableFavoriteMessage => _disableFavoriteMessage;

  bool get connected => _connected;

  int get cantForward => _cantForward;

  int get cantDeleteForEveryone => _cantDeleteForEveryone;

  int get justDelete => _justDelete;

  int get isBlock => _isBlock;

  int get indexLastSearch => _indexLastSearch;

  String? get dateIndex => _dateIndex;

  String? get textSearch => _textSearch;

  String? get textLink => _textLink;

  String? get textBlock => _textBlock;

  Directory get path => _path!;

  bool get getConfidentialActive => _confidentialActive;

  List<File> get getListImage => _listImage;

  Map<String, String> get getAllContacts => _allContacts;

  File? get getVideo => _video;

  File? get getThumbnailVideo => _thumbnailVideo;

  File? get getFile => _file;

  set replyContent(var value) {
    _replyContent = value;
    notifyListeners();
  }

  set ackActive(bool value) {
    _ackActive = value;
    notifyListeners();
  }

  set loading(bool value) {
    _loading = value;
    notifyListeners();
  }

  set disableFavoriteMessage(bool value) {
    _disableFavoriteMessage = value;
    notifyListeners();
  }

  set isShowDate(bool value) {
    _isShowDate = value;
    notifyListeners();
  }

  set isSearch(bool value) {
    _isSearch = value;
    notifyListeners();
  }

  set hitLink(bool value) {
    _hitLink = value;
    notifyListeners();
  }

  set clickedSticker(bool value) {
    _clickedSticker = value;
    notifyListeners();
  }

  set isBlock(int value) {
    _isBlock = value;
    notifyListeners();
  }

  set isTyping(bool value) {
    _isTyping = value;
    notifyListeners();
  }

  set connected(bool value) {
    _connected = value;
    notifyListeners();
  }

  set isSuffix(bool value) {
    _isSuffix = value;
    notifyListeners();
  }

  set isNotBottom(bool value) {
    _isNotBottom = value;
    notifyListeners();
  }

  set cantForward(int value) {
    _cantForward = value;
    notifyListeners();
  }

  set cantDeleteForEveryone(int value) {
    _cantDeleteForEveryone = value;
    notifyListeners();
  }

  set justDelete(int value) {
    _justDelete = value;
    notifyListeners();
  }

  set indexLastSearch(int value) {
    _indexLastSearch = value;
    notifyListeners();
  }

  set dateIndex(String? value) {
    _dateIndex = value;
    notifyListeners();
  }

  set textSearch(String? value) {
    _textSearch = value;
    notifyListeners();
  }

  set textBlock(String? value) {
    _textBlock = value;
    notifyListeners();
  }

  set textLink(String? value) {
    _textLink = value;
    notifyListeners();
  }

  set path(Directory value) {
    _path = value;
    notifyListeners();
  }

  set refresh(bool value) {
    _refresh = value;
    notifyListeners();
  }

  set confidentialActive(bool value) {
    _confidentialActive = value;
    notifyListeners();
  }

  set listImage(List<File> value) {
    _listImage.addAll(value);
    notifyListeners();
  }

  set addListImage(File value) {
    _listImage.add(value);
    notifyListeners();
  }

  set removeListImage(int index) {
    _listImage.removeAt(index);
    notifyListeners();
  }

  set clearListImage(bool value) {
    _listImage.clear();
    notifyListeners();
  }

  set video(File? value) {
    _video = value;
    notifyListeners();
  }

  set thumbnailVideo(File? value) {
    _thumbnailVideo = value;
    notifyListeners();
  }

  set file(File? value) {
    _file = value;
    notifyListeners();
  }

  set addAllContacts(Map<String, String> value) {
    _allContacts.addAll(value);
    notifyListeners();
  }
}
